/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.configuration;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class Activator implements BundleActivator {
    private ConfigurationServiceImpl cs;
    private FileConfigurationProvider fcp;

    public void start(final BundleContext ctx) throws Exception {
        cs = new ConfigurationServiceImpl(ctx);
        cs.start();        
        
        fcp = new FileConfigurationProvider(ctx);
    }

    public void stop(BundleContext ctx) throws Exception {
        fcp.shutdown();
        
        cs.shutdown();
    }
}
