/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.configgen.util;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;

public abstract class ModelObjectFactory {
    
    private Map<String, String> productResourcePath = new HashMap<String, String>();  
    public abstract URL getProductResourceURL(String resource);
    protected abstract String getDefaultResourcePath();

    protected final String getResourcePath(String product) {
        String path = productResourcePath.get(product);
        if (path != null) {
            return path;
        }
        return getDefaultResourcePath();
    }
    
    protected void setResourcePath(String product, String resourcePath) {
        productResourcePath.put(product, resourcePath);
    }
}
