/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.agentprovider.providers;

import java.util.HashMap;
import java.util.Map;

public class AgentFileProviderFactory implements IAgentFileProviderFactory {
    
    private static Map<String, IAgentFileProvider> agentFileProviders = 
        new HashMap<String, IAgentFileProvider>();
    
    public IAgentFileProvider getAgentFileProvider(String agentType) {
        return agentFileProviders.get(agentType);
    }
    
    public boolean registerAgentFileProvider(String agentType, IAgentFileProvider provider) {
        boolean success = false;
        if (agentFileProviders.put(agentType, provider) != null) {
            success = true;
        }
        return success;
    }
}
