/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.expression;

public enum Operator {
    ENV("env", 1, 1),
    AND("and", 2, Integer.MAX_VALUE), 
    EQUALS("equals", 2, 2),    
    IF("if", 2, Integer.MAX_VALUE),
    OR("or", 2, Integer.MAX_VALUE),
    NOT("not", 1, 1),
    IN("in", 2, 2),
    INSTANCEOF("instanceof", 2, 2),
    SELECT("select", 1, 2),
    REFERENCES("references", 1, Integer.MAX_VALUE),
    DANGLING_REFERENCES("dangling_references", 1, Integer.MAX_VALUE),
    ISNULL("isnull", 1, 1);

    final String literal;
    final int minOperands;
    final int maxOperands;

    Operator(String literal, int minOperands, int maxOperands) {
        this.literal = literal;
        this.minOperands = minOperands;
        this.maxOperands = maxOperands;
    }  
    
    public String getLiteral() {
        return literal;
    }
    
    public int getMinOperands() {
        return minOperands;
    }
    
    public int getMaxOperands() {
        return maxOperands;
    }
}
