/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.expression.runtime.model;

import java.util.Map;

import com.iona.soa.expression.Expression;
import com.iona.soa.expression.Operand;
import com.iona.soa.expression.Operator;
import com.iona.soa.expression.Term;
import com.iona.soa.expression.runtime.ExpressionRuntime;

public class Env implements ExpressionRuntime {

    @SuppressWarnings("unchecked")
    public void run(Expression op, Map context) {
        Term term = op.getOperands()[0];
        if (!(term instanceof Operand)) {
            throw new IllegalArgumentException("Illegal argument passed into function " 
                                           + Operator.ENV.getLiteral()
                                           + "; the argument has to be an operand; "
                                           + "argument: " + term.toString());
        }
        String value = ((Operand)term).toString();
        if (context.get(value) != null) {
            context.put(ContextKey.RESULT, context.get(value));
            return;
        }
        for (ContextKey key : ContextKey.values()) {
            if (key.getLiteral().equalsIgnoreCase(value) && context.get(key) != null) {
                context.put(ContextKey.RESULT, context.get(key));
                return;
            }
        }
        context.put(ContextKey.RESULT, Constants.NULL);
    }
}

