/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.expression.runtime.model;

import java.util.Map;

import com.iona.soa.expression.Expression;
import com.iona.soa.expression.Operator;
import com.iona.soa.expression.runtime.ExpressionRuntime;

public class Not implements ExpressionRuntime {
    
    @SuppressWarnings("unchecked")
    public void run(Expression exp, Map context) {
        Object result = Util.evaluate(exp.getOperands()[0], context);
        if (result != Boolean.FALSE && result != Boolean.TRUE) {
            throw new IllegalArgumentException("Illegal argument passed into function " 
                                               + Operator.NOT.getLiteral()
                                               + "; the argument has to resolve  "
                                               + " to a boolean type" 
                                               + "; Argument: " + exp.getOperands()[0].toString());
        }
        context.put(ContextKey.RESULT, (result == Boolean.TRUE) ? Boolean.FALSE : Boolean.TRUE);
    }
}
