/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository;

import com.iona.soa.resourceset.QueryResourceSet;

public interface Repository {    
    /**
     * Load the contents of the repository.  Recommended that implementations use
     * a lazy loading scheme, and only load proxies into the model as a result of this call.
     * @return the set of EMF resources loaded from the repository.
     * @throws Exception throws an arbitrary exception
     */
    QueryResourceSet getResourceSet() throws Exception;
    
    /**
     * Closes any connection and resources.
     * @throws Exception Depending on the type of repository used IOException or SQLExceptions may be thrown.
     */
    void close();
}
