/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository;

import java.io.IOException;
import java.util.Collection;

import com.iona.soa.resourceset.QueryResourceSet;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;

public interface SOARepository extends Repository {
    /**
     * Store the Object. 
     * @param soan The SOA Network to be stored. 
     * @throws Exception Depending on the type of repository used IOException or SQLExceptions may be thrown.
     */
    void persist(EObject eObject) throws IOException;
    
    QueryResourceSet getResourceSet() throws IOException;
    EObject getEObject(URI uri, boolean loadOnDemand);
    ModelRegistry getModelRegistry();

    void startRead(TransactionData txData);
    void endRead(boolean success);
    void startWrite(TransactionData txData);
    void endWrite(boolean success);
    void registerTransactionAdapter(TransactionAdapter ta);
    Collection<Adapter> getResourceAdapters();
}
