/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository;

import java.sql.Timestamp;

public class TransactionData {
    private String userId;
    private String ssoToken;
    private Timestamp timestamp;

    
    public TransactionData() {
        userId = null;
        ssoToken = null;
        timestamp = new Timestamp(System.currentTimeMillis());
    }
    
    public TransactionData(String user) {
        userId = user;
        ssoToken = null;
        timestamp = new Timestamp(System.currentTimeMillis());
    }
    
    public TransactionData(String user, String ssotok) {
        userId = user;
        ssoToken = ssotok;
        timestamp = new Timestamp(System.currentTimeMillis());
    }

    public String getUserId() {
        return userId;
    }

    public String getSsoToken() {
        return ssoToken;
    }

    public Timestamp getTimestamp() {
        return timestamp;
    }
}
