/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.resourceset;

public final class ResourceOptions {
    
    /**
     * Boolean value.
     * 
     * Defaults to false, i.e. once an object is fetched it is not refetched or
     * overwritten.
     */
    public static final String OPTION_ALWAYS_FETCH = "ALWAYS_FETCH";
    
    /**
     * List<EObject> value.
     */
    public static final String OPTION_FORCE_RELOAD = "FORCE_RELOAD";
    
    /*
     * The value to this options is a URI query string
     */
    public static final String OPTION_QUERY = "QUERY";
    
    private ResourceOptions() {
        // complete
    }
}
