/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.security;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

//TODO: this is a temporary workaround for accessing resource bundles within OSGi. 
//This will need to be changed to use the proper mechanism.

public class MessageBundle extends ResourceBundle {

    private static ResourceBundle instance = new MessageBundle();

    private static Map<String, String> messages;

    static {
        messages = new HashMap<String, String>();

        messages.put("AUTH_NO_DATA", "Request is missing authentication data");
        messages.put("AUTH_BAD_DATA", "Authentication data in request is invalid");
        messages.put("AUTH_BAD_USER_TOKEN", "Cannot get user from authentication token");
        messages.put("AUTH_BAD_TOKEN", "Authentication token in request is invalid");
        messages.put("AUTH_FAILED", "Authentication failed for user \"{0}\"");
        messages.put("AUTH_INTERNAL_TOKEN", "Invalid use of internal token");
        messages.put("AUTH_NO_SERVICE", "Cannot authenticate as security service is unavaliable");
        messages.put("AUTH_UNKNOWN_TYPE", "Unsupported authentication type \"{0}\"");
        messages.put("NOT_AUTHORIZED", "User \"{0}\" is not authorized to {1} this {2} ({3}).\n" 
                                       + "Please set the appropriate permission for security area {4}.");
        messages.put("NO_WRITE_TX", "Cannot modify repository. No write transaction in progress!");
    }

    public static ResourceBundle getInstance() {
        return instance;
    }

    @Override
    public Enumeration<String> getKeys() {
        return null;
    }

    @Override
    protected Object handleGetObject(String key) {
        String obj = messages.get(key);
        if (obj == null) {
            return "?";
        }
        return obj;
    }
}
