/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.jdbc;

import java.sql.Connection;

public class PooledConnection {
    private Connection connection;
    
    public PooledConnection(Connection conn) {
        connection = conn;
    }

    public Connection getConnection() {
        return connection;
    }
    
    @Override
    protected void finalize() throws Throwable {
        if (!connection.isClosed()) {
            connection.close();
        }
        super.finalize();
    }
}
