/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.jdbc.resource;

import java.sql.SQLException;
import java.util.List;

import com.iona.soa.repository.jdbc.JDBCResourceRepository;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;

public interface JDBCResource extends Resource {
    JDBCResourceRepository getRepository();
    
    void persist(EObject eobject) throws SQLException;
    void unPersist(EObject eobject, boolean removeXRefs) throws SQLException;
    
    // These operations work on a map that holds the objects that have been loaded by this resource.
    EObject findEObject(URI proxyURI);
    void registerEObject(URI proxyURI, EObject relObj);
    void unregisterEObject(URI proxyURI);
    
    EObject getEObject(EClass eClass, String id);
    
    List<EObject> queryObjects(EClass type, String sqlQuery) throws SQLException;
}
