/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.jdbc.resource;

import com.iona.soa.repository.jdbc.JDBCResourceRepository;
import com.iona.soa.resourceset.QueryHandlerRegistry;
import com.iona.soa.resourceset.handler.JDBCResourceQueryHandler;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceFactoryImpl;

public class JDBCResourceFactoryImpl extends ResourceFactoryImpl {    
    private final JDBCResourceRepository repository;
    
    public JDBCResourceFactoryImpl(JDBCResourceRepository rep) {
        QueryHandlerRegistry.getInstance()
                            .registerQueryHandler(JDBCResourceImpl.class, 
                                                  new JDBCResourceQueryHandler());
        repository = rep;
    }

    public Resource createResource(URI uri) {
        return new JDBCResourceImpl(uri, repository);
    }
} 
