/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.db.derby;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import com.iona.repository.db.DatabaseImpl;

public class EmbeddedDerby extends DatabaseImpl {

    static final String EMBEDDED_DERBY_DRIVER = "org.apache.derby.jdbc.EmbeddedDriver";

    public EmbeddedDerby() {
        super(EMBEDDED_DERBY_DRIVER);
    }

    public EmbeddedDerby(String driver, String url, String name, String passwd) {
        super(driver, url, name, passwd);
    }
  
    public void stop() {
        try { 
            DriverManager.getConnection("jdbc:derby:;shutdown=true");
            super.stop();
        } catch (SQLException ex) {
            LOG.warning("Exception while shutting down Apache Derby runtime");
        }

    }
    
    public void createDatabase() throws SQLException {
        if (-1 == dbUrl.indexOf("create=true")) {
            dbUrl += ";create=true";
        }
        Connection c = null;
        try {
            c = getConnection();
        } finally {
            if (null != c) {
                c.close();
            }
        }        
    }
}


