/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.index.taskservice;

import com.iona.repository.maven.osgi.IRepositoryMavenService;
import com.iona.repository.taskservice.TaskService;
import com.iona.soa.repository.TransactionData;

public final class SpiderTaskService implements TaskService {
    
    IRepositoryMavenService mavenService; // injected
    
    public IRepositoryMavenService getMavenService() {
        return mavenService;
    }

    public void setMavenService(IRepositoryMavenService ms) {
        mavenService = ms;
    }
    
    public String getTaskTypeID() {
        return SpiderTaskService.class.getName();
    }
    
    public void run(TransactionData transData, String... parameters) throws Exception {        
        
    }

    public String getTaskDescription() {
        return "SpiderTaskService";
    }


    public String getTaskName() {
        return "SpiderTaskService";
    }

    public String[] getExampleParameterList() {
        String[] paramList = new String[1];
        paramList[0] = "{GUID for the Maven Repo Being Indexed}";
        return paramList;
    }

    public void run(String user, String externalToken, String... parameters)
        throws Exception {
        mavenService.index(user, externalToken, parameters[0], false);
    }


}
