/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.maven.osgi;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import com.iona.soa.model.MavenRepository;

import org.apache.lucene.document.Document;
import org.apache.lucene.queryParser.ParseException;
import org.apache.maven.shared.dependency.tree.DependencyNode;

public interface IRepositoryMavenService {

    void index(String user, String externalToken, String id, boolean async) throws ParseException;
    void index(String user, 
               String externalToken, 
               String id, 
               String subDir, 
               boolean async) throws ParseException;
    void waitForIndexThreadToFinish(String mavenRepoguid);
    DependencyNode resolve(String groupid,
                           String artifactId,
                           String version,
                           String scope,
                           List<MavenRepository> repos) throws ParseException, IOException;
    Iterator<Document> search(String query, MavenRepository mavenRepo);
    
}
