/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.maven.resolve;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

import org.apache.maven.artifact.Artifact;
import org.apache.maven.artifact.repository.ArtifactRepository;
import org.apache.maven.artifact.resolver.ArtifactNotFoundException;
import org.apache.maven.artifact.resolver.ArtifactResolutionException;
import org.apache.maven.artifact.resolver.DefaultArtifactResolver;


public class SpiderArtifactResolver extends DefaultArtifactResolver {
    
    public void resolve(Artifact artifact,
                        List remoteRepositories,
                        ArtifactRepository localRepository) throws ArtifactResolutionException,
                                                                   ArtifactNotFoundException {
        
        resolveAlways(artifact, remoteRepositories, localRepository);
        
        File absoluteDir = artifact.getFile().getParentFile();
        File newFile = new File(absoluteDir.getAbsolutePath() + absoluteDir.separatorChar + "mavenUrl.txt");
        FileOutputStream fos;
        
        System.out.println(" ## resolving artifact : " + artifact.getArtifactId()
                           + " >> " + newFile.getAbsolutePath());
        try {
            fos = new FileOutputStream(newFile);
            fos.write(artifact.getRepository().getUrl().getBytes());
            fos.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        

    }
}
