/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.notification.jet;

import com.iona.repository.notification.JetArgumentForEMail;
import com.iona.soa.model.events.DataChangeFieldDelta;
import java.util.*;
import java.io.*;

public class CreatedEMailTextTemplate
{
  protected static String nl;
  public static synchronized CreatedEMailTextTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    CreatedEMailTextTemplate result = new CreatedEMailTextTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = "--" + NL + "  This message is automatically sent by Artix Repository";
  protected final String TEXT_3 = NL;

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    JetArgumentForEMail arg = (JetArgumentForEMail)argument;
    final String operationTypeStr="Created by";
         
    StringWriter w = new StringWriter();
    PrintWriter p = new PrintWriter(w, true);
    p.println();
    p.printf("%18s  %s%n", arg.getTargetObjectType(), arg.getTargetObjectName());
    p.printf("%18s  %s (%s)%n", operationTypeStr, arg.getUsername(), arg.getUserEMail());
    // day, month day, year, 24hr time
    p.printf("%18s  %2$tA, %2$tB %2$td, %2$tY %2tR%n", "On", arg.getChangeTimestamp());
    
    stringBuffer.append(w.toString());

    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(TEXT_3);
    return stringBuffer.toString();
  }
}
