/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.notification.jet;

import com.iona.repository.notification.JetArgumentForEMail;
import com.iona.soa.model.events.DataChangeFieldDelta;
import java.util.*;
import java.io.*;

public class UpdatedEMailHtmlTemplate
{
  protected static String nl;
  public static synchronized UpdatedEMailHtmlTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    UpdatedEMailHtmlTemplate result = new UpdatedEMailHtmlTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = "<table style=\"border-collapse: separate; border-spacing: 1em 0.5em\">" + NL + "<tr>" + NL + "<td style=\"font-weight: bold; text-align: right;\">";
  protected final String TEXT_3 = "</td>" + NL + "<td>";
  protected final String TEXT_4 = "</td>" + NL + "</tr>" + NL + "<tr>" + NL + "<td style=\"font-weight: bold; text-align: right;\">";
  protected final String TEXT_5 = "</td>" + NL + "<td>";
  protected final String TEXT_6 = " (";
  protected final String TEXT_7 = ")</td>" + NL + "</tr>" + NL + "<tr>" + NL + "<td style=\"font-weight: bold; text-align: right;\">On</td>" + NL + "<td>";
  protected final String TEXT_8 = NL + "</td>" + NL + "</tr>" + NL + "</table>";
  protected final String TEXT_9 = NL + "<p style=\"font-weight: bold;\">The following updates were made:</p>" + NL + "<table style=\"border-collapse: separate; border-spacing: 1.5em 0.5em\">" + NL + "<tr>" + NL + "<th style=\"text-align: left; font-weight: bold; vertical-align: baseline;\">Field</th>" + NL + "<th style=\"text-align: left; font-weight: bold; vertical-align: baseline;\">Updated to</th>" + NL + "<th style=\"text-align: left; font-weight: bold; vertical-align: baseline;\">From</th>" + NL + "</tr>";
  protected final String TEXT_10 = NL + "<tr>" + NL + "<td>";
  protected final String TEXT_11 = "</td>" + NL + "<td>";
  protected final String TEXT_12 = "</td>" + NL + "<td>";
  protected final String TEXT_13 = "</td>" + NL + "</tr>";
  protected final String TEXT_14 = NL + "</table>";
  protected final String TEXT_15 = NL + "<p style=\"font-weight: bold;\">";
  protected final String TEXT_16 = "</p>";
  protected final String TEXT_17 = NL + "<p>&quot;";
  protected final String TEXT_18 = "&quot;</p>";
  protected final String TEXT_19 = NL;
  protected final String TEXT_20 = "<hr/>" + NL + "This message is automatically sent by <a href=\"http://www.iona.com/products/artix/registry_repository/welcome.htm\">Artix Repository</a>";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    JetArgumentForEMail arg = (JetArgumentForEMail)argument;
    final String operationTypeStr="Updated by";
    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(arg.getTargetObjectType());
    stringBuffer.append(TEXT_3);
    stringBuffer.append(arg.getTargetObjectName());
    stringBuffer.append(TEXT_4);
    stringBuffer.append(operationTypeStr);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(arg.getUsername());
    stringBuffer.append(TEXT_6);
    stringBuffer.append(arg.getUserEMail());
    stringBuffer.append(TEXT_7);
         
    StringWriter w = new StringWriter();
    PrintWriter p = new PrintWriter(w, true);
    // day, month day, year, 24hr time
    p.printf("%1$tA, %1$tB %1$td, %1$tY %1tR", arg.getChangeTimestamp());
    stringBuffer.append(w.toString());

    stringBuffer.append(TEXT_8);
     List<DataChangeFieldDelta> deltas = arg.getUpdatedFields(); 
     if (!deltas.isEmpty()) {
    stringBuffer.append(TEXT_9);
    
    for (Iterator it = deltas.iterator(); it.hasNext();) {
        DataChangeFieldDelta delta = (DataChangeFieldDelta)it.next();
        String oldValue = "";
        String newValue = "";
        if (delta.getFieldDesc().isMany()) {        
            oldValue = arg.stringify(delta.getOldValues());
            newValue = arg.stringify(delta.getNewValues());
        } else {
            oldValue = delta.getOldValue() == null ? "&lt;no value&gt;" : delta.getOldValue();
            newValue = delta.getNewValue() == null ? "&lt;no value&gt;" : delta.getNewValue();
        }

    stringBuffer.append(TEXT_10);
    stringBuffer.append(delta.getFieldDesc().getName());
    stringBuffer.append(TEXT_11);
    stringBuffer.append(newValue);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(oldValue);
    stringBuffer.append(TEXT_13);
    }
    stringBuffer.append(TEXT_14);
    }
     List<String> comments = arg.getCommentsAdded(); 
     if (!comments.isEmpty()) {
    stringBuffer.append(TEXT_15);
    stringBuffer.append(comments.size() == 1 ? "Comment added:" : "Comments added:");
    stringBuffer.append(TEXT_16);
    
    for (Iterator it = comments.iterator(); it.hasNext();) {
        String comment = it.next().toString();

    stringBuffer.append(TEXT_17);
    stringBuffer.append(comment);
    stringBuffer.append(TEXT_18);
    }
    }
    stringBuffer.append(TEXT_19);
    stringBuffer.append(TEXT_20);
    return stringBuffer.toString();
  }
}
