/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest;

import java.util.Collection;

public interface RESTQuery {
    String ID = "id";

    // Query types
    String QUERY_SEARCH = "search";    
    String QUERY_EMFQL = "emfql";
    String QUERY_SQL = "sql";
    String QUERY_ROOT = "rootContents";
    String QUERY_ECLASS_FILTER = "eclass_filter";

    // System Queries
    String QUERY_MIN = "_min";
    String QUERY_MEDIA = "_media";
    String QUERY_COUNT = "_count";
    String QUERY_PAGE = "_page";
    String QUERY_FEED = "_feed";
    String QUERY_ORDERBY = "_orderBy";
    String QUERY_ASCENDING = "_ascending";
    
    // maven searches
    String QUERY_ACCPTED_REPOS = "_repos";
    String QUERY_MVN_GROUP_ID = "groupId";
    String QUERY_MVN_ARTIFACT_ID = "artifactId";
    String QUERY_MVN_VERSION = "version";
    String QUERY_MVN_REPOS_GUID = "mavenRepoGuid";
    String QUERY_MVN_SCOPE = "dependScope";
    
    String SEARCH_COLLECTION = "search";
    String START_SPIDER = "startSpider";
            
    String ROOT_FOLDERS = "roots";

    Collection<String> getParameterNames();
    String getParameter(String name);
    String getDecodedParameter(String name);
    int getIntParameter(String name, int defaultValue) throws RESTException;

    boolean isSet(String key);

}