/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.atom;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.abdera.Abdera;
import org.apache.abdera.factory.ExtensionFactory;
import org.apache.abdera.factory.Factory;
import org.apache.abdera.parser.NamedParser;
import org.apache.abdera.parser.Parser;
import org.apache.abdera.parser.ParserFactory;
import org.apache.abdera.util.AbderaConfiguration;
import org.apache.abdera.util.Configuration;
import org.apache.abdera.writer.NamedWriter;
import org.apache.abdera.writer.StreamWriter;
import org.apache.abdera.writer.Writer;
import org.apache.abdera.writer.WriterFactory;
import org.apache.abdera.xpath.XPath;

/**
 * This class is needed to workaround OSGi class loading issues.  An instance is used
 * when creating the Abdera instance used in the Server.  It simple hard codes the objects
 * created rather than looking them up in configuration.
 *
 * TODO: move this to the -rt module.
 */
public class AbderaOSGiConfig implements Configuration {

    private static final long serialVersionUID = -7298197934966438074L;

    private Configuration delegate = AbderaConfiguration.getDefault();
    
    public AbderaOSGiConfig() {
        // Complete
    }
    
    public String getConfigurationOption(String id) {
        return delegate.getConfigurationOption(id);
    }

    public String getConfigurationOption(String id, String def) {
        throw new UnsupportedOperationException();
    }

    public List<ExtensionFactory> getExtensionFactories() {
        return new ArrayList<ExtensionFactory>();
    }

    public Map<String, NamedParser> getNamedParsers() {
        return new HashMap<String, NamedParser>();
    }

    public Map<String, NamedWriter> getNamedWriters() {
        return new HashMap<String, NamedWriter>();
    }

    public Map<String, Class<? extends StreamWriter>> getStreamWriters() {
        return new HashMap<String, Class<? extends StreamWriter>>();
    }

    public Factory newFactoryInstance(Abdera abdera) {
        return new org.apache.abdera.parser.stax.FOMFactory(abdera);
    }

    public ParserFactory newParserFactoryInstance(Abdera abdera) {
        return new org.apache.abdera.parser.stax.FOMParserFactory(abdera);      
    }

    public Parser newParserInstance(Abdera abdera) {
        return new org.apache.abdera.parser.stax.FOMParser(abdera);
    }

    public StreamWriter newStreamWriterInstance(Abdera abdera) {
        return new org.apache.abdera.parser.stax.StaxStreamWriter();
    }

    public WriterFactory newWriterFactoryInstance(Abdera abdera) {
        return new org.apache.abdera.parser.stax.FOMWriterFactory(abdera);
    }

    public Writer newWriterInstance(Abdera abdera) {
        return new org.apache.abdera.parser.stax.FOMWriter(abdera);
    }

    public XPath newXPathInstance(Abdera abdera) {
        return new org.apache.abdera.parser.stax.FOMXPath();
    }
    
    public Object clone() {
        try {
            super.clone();
        } catch (CloneNotSupportedException e) {
            // Complete
        }
        throw new UnsupportedOperationException();
    }
}
