/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.atom;

import com.iona.repository.rest.resource.Resource;

import org.apache.abdera.model.Entry;

public interface AtomEntryFactory {

    /**
     * Returns an Abdera Entry document based off a resource object.
     * 
     * @param resource the resource object used to create the entry
     * @param baseUri the baseUri for the entry
     * @param path the context path for the entry
     * @return the Abdera Entry document.
     */
    Entry createEntry(Resource resource, String baseUri,
                      String path);

    /**
     * Returns an Abdera Entry document based off a resource object
     * @param resource the resource object used to create the entry
     * @param baseUri the baseUri for the entry
     * @param path the context path for the entry
     * @param options the options controlling the content of the entry
     * @return the Abdera Entry document.
     */
    Entry createEntry(Resource resource, String baseUri,
                      String path, AtomEntryOptions options);


}
