/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.osgi;

import com.iona.repository.rest.repo.EClassHandler;

import org.eclipse.emf.ecore.EClass;

public interface RESTCollectionService {
    /**
     * The name of the collection, this is generally also the context under which it
     * is registered. 
     * @return The name.
     */
    String getName();
    
    /**
     * The EClass in the EMF model that this collection represents. 
     * @return The EClass or <tt>null</tt> if this collection doesn't represent an EClass.
     */
    EClass getEClass();
    
    /**
     * The Handler for the collection. If you don't fancy writing one from 
     * scratch, you can try subclassing the 
     * {@link com.iona.repository.rest.rt.repo.DefaultEClassHandler}. 
     * @return The handler.
     */
    EClassHandler getHandler();
    
    /**
     * Specifies whether or not to include subclasses. This only applies if this collection
     * is representing a class hierarchy.  
     * @return Whether or not to include subclasses 
     */
    boolean includeSubclasses();
}
