/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.repo;

import java.util.Collection;

import com.iona.repository.rest.RESTContext;
import com.iona.repository.rest.RESTException;
import com.iona.repository.rest.resource.Resource;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EFactory;
import org.eclipse.emf.ecore.EObject;

public interface EClassHandler {

    String[] getAccepts();

    void addObjectToResource(RESTContext ctx, EObject eobject, Resource resource) throws RESTException;

    void getObjectChanges(RESTContext ctx, EObject eobject, Resource resource) throws RESTException;

    Collection<? extends EObject> createObjects(RESTContext ctx,
                                                EFactory efactory,
                                                EClass eclass, 
                                                Collection<Resource> resources,
                                                boolean persist) throws RESTException;
    
    EObject createObject(RESTContext ctx,
                         EFactory efactory,
                         EClass eclass, 
                         String name,
                         Resource resource,
                         boolean persist) throws RESTException;

    EObject createObjectWithMedia(RESTContext ctx, EFactory efactory, EClass eclass) throws RESTException;

    void deleteObject(RESTContext ctx, EObject eobject) throws RESTException;

    void getMedia(RESTContext ctx, EObject eobject) throws RESTException;
    
    EObject updateMedia(RESTContext ctx, EObject eobject) throws RESTException;

    @SuppressWarnings("unchecked")
    EList getContainedObjects(RESTContext ctx, EObject eobject, String refName) throws RESTException;

    EClass getContainedClass(RESTContext ctx,
                             EObject containingEObject,
                             String subcollection) throws RESTException;
    
    EObject createContainedObject(RESTContext ctx,
                                  EObject containingEObject,
                                  String subcollection) throws RESTException;
}
