/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.resource;

public class AttributeImpl extends BaseImpl implements Attribute {

    private boolean hidden;
    private boolean password;
    private boolean readonly;
    private Object  obj;
    
    protected AttributeImpl(String name) {
        super(name);
    }

    public boolean isHidden() {
        return hidden;
    }

    public boolean isReadonly() {
        return readonly;
    }

    public Attribute setHidden(boolean b) {
        hidden = b;
        return this;
    }

    public Attribute setReadonly(boolean b) {
        readonly = b;
        return this;
    }

    public Object getObject() {
        if (obj != null) {
            return obj;
        }
        return getText();
    }

    public Attribute setObject(Object o) {
        obj = o;
        return this;
    }
    
    @Override
    public String getText() {
        if (obj == null) {
            return super.getText();
        } 
        return obj.toString();
    }
    
    @Override
    public Base setText(String t) {
        obj = null;
        return super.setText(t);
    }

    public boolean isEditablePassword() {
        // TODO Auto-generated method stub
        return password;
    }

    public Attribute setEditablePassword(boolean b) {
        // TODO Auto-generated method stub
        password = b;
        return this;
    }
}
