/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.resource;

public class BaseImpl implements Base {

    private String baseUri;
    private String eclass;
    private String name;
    private String text;
    private String type;
    private int min = 1;
    private int max = 1;
    private Base parent;
    
    protected BaseImpl(String name) {
        this.name = name;
    }
    
    protected BaseImpl(String name, Base parent) {
        this.name = name;
        this.parent = parent;
    }
    
    public Base getParent() {
        return parent;
    }

    public String getName() {
        return name;
    }
    
    public String getBaseUri() {
        if (baseUri == null && parent != null) {
            return parent.getBaseUri();
        }
        return baseUri;
    }

    public String getEClass() {
        return eclass;
    }


    public String getText() {
        return text;
    }

    public String getType() {
        return type;
    }

    public int getMax() {
        return max;
    }

    public int getMin() {
        return min;
    }
    
    public Base setBaseUri(String uri) {
        baseUri = uri;
        return this;
    }

    public Base setEClass(String e) {
        this.eclass = e;
        return this;
    }

    public Base setName(String n) {
        this.name = n;
        return this;
    }

    public Base setText(String t) {
        this.text = t;
        return this;
    }

    public Base setType(String t) {
        this.type = t;
        return this;
    }

    public Base setParent(Base p) {
        this.parent = p;
        return this;
    }


    public Base setMax(int m) {
        max = m;
        return this;
    }

    public Base setMin(int m) {
        min = m;
        return this;
    }

}
