/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.resource;

public class ReferenceImpl extends BaseImpl implements Reference {

    private String href;
    private String collectionHref;
    private int size;
    private boolean readonly;
    
    protected ReferenceImpl(String name) {
        super(name);
    }

    protected ReferenceImpl(String name, Base parent) {
        super(name, parent);
    }
    
    public String getHref() {
        return href;
    }

    public Reference setHref(String u) {
        href = u;
        return this;
    }

    public String getCollectionHref() {
        return collectionHref;
    }

    public Reference setCollectionHref(String u) {
        collectionHref = u;
        return this;
    }

    public int getSize() {
        return size;
    }

    public Reference setSize(int v) {
        size = v;
        return this;
    }

    public boolean isReadonly() {
        return readonly;
    }

    public Reference setReadonly(boolean b) {
        readonly = b;
        return this;
    }
}
