/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.resource;

import java.util.List;

import javax.xml.namespace.QName;

public interface Resource extends Base {

    /**
     * Sent as id in a getResource request to obtain a new object that has
     * not been persisted but contains relevant default values and type information. 
     */
    String PROTOTYPE_RESOURCE_ID = "prototype";
    
    String NAMESPACE = "http://schemas.iona.com/repository/2008/02/resource";
    
    QName RESOURCE_QNAME = new QName(NAMESPACE, "resource");
    QName ATTRIBUTE_QNAME = new QName(NAMESPACE, "attribute");
    QName REFERENCE_QNAME = new QName(NAMESPACE, "reference");
    QName VERSION_QNAME = new QName(NAMESPACE, "version");

    QName HREF_QNAME = new QName(NAMESPACE, "href");
    QName NAME_QNAME = new QName(NAMESPACE, "name");
        
    String getId();
    
    Resource setId(String id);
    
    String getCollection();
    
    Resource setCollection(String c);
    
    List<Attribute> getAllAttributes();
    
    List<Attribute> getAttributes(String name);

    Attribute getFirstAttribute(String name);

    Attribute addAttribute(String name);
    
    Attribute addAttribute(Attribute att);
   
    List<Reference> getAllReferences();
    
    List<Reference> getReferences(String name);
    
    Reference getFirstReference(String string);
    
    Reference addReference(String name);

    Reference addReference(Reference ref);
    
    List<Resource> getResources();
    
    void addResource(Resource res);
    
    Object getProperty(String name);
    
    Resource setProperty(String name, Object value);

    boolean isEditable();
    void setEditable(boolean editable);
    boolean isDeletable();
    void setDeletable(boolean deletable);
    boolean isPrototype();
    void markAsPrototype();
}
