/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.atom;

import com.iona.repository.rest.Constants;
import com.iona.repository.rest.atom.AbderaUtil;

import org.apache.abdera.factory.Factory;
import org.apache.abdera.model.Feed;
import org.apache.abdera.model.Person;


/**
 * Class for creating Abdera Feed documents that include a resource object.
 *
 */
public  class ServerAtomFeedFactory implements AtomFeedFactory {

    protected Factory abderaFactory = AbderaUtil.getAbderaFactory();

    public ServerAtomFeedFactory() {
        // Complete.
    }
    
    public Feed createFeed(String baseUri, String path, String title) {
        Feed feed = abderaFactory.newFeed();
        // Workaround for Axiom bug WSCOMMONS-281.  Instead of calling setBaseUri()
        // set the xml:base attribute directly.        
        //feed.setBaseUri(baseUri);
        AbderaUtil.setBaseUri(feed, baseUri);
        feed.addAuthor(getAuthor(path));
        feed.setId(AbderaUtil.idToUrl(baseUri, getId(path)));
        feed.setTitle(getTitle(title, path));

        return feed;
    }

    protected String getId(String path) {
        // TODO: this needs to be globally unique when used inside an 
        // Atom <id> element.
        return "collection/" + path;
    }

    protected String getTitle(String title, String path) {
        if (title == null) {
            return path;
        } else {
            return title;
        }
    }

    protected Person getAuthor(String path) {
        Person author = abderaFactory.newAuthor();
        author.setName(Constants.ATOM_FEED_AUTHOR);
        return author;
    }
}
