/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.osgi;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

// TODO: this is a temporary workaround for accessing resource bundles within OSGi. 
// This will need to be changed to use the proper mechanism.

public class MessageBundle extends ResourceBundle {

    private static ResourceBundle instance = new MessageBundle();
    
    private static Map<String, String> messages;
    
    static {
        messages = new HashMap<String, String>();
        
        messages.put("BAD_INT_PARAM", "Query parameter \"{0}\" must have an integer value; was \"{1}\"");
        messages.put("BAD_OBJECT_REF", "Incorrect format for object reference \"{0}\"");
        messages.put("BAD_REFERENCE", "Reference \"{0}\" is not correctly formatted");
        messages.put("BAD_SUBCOLLECTION", "Bad sub-collection specified for method \"{0}\" on URI \"{1}\"");
        messages.put("BAD_VERSION", "The version \"{0}\" is incorrectly formatted");
        messages.put("COLLECTION_TITLE", "FUSE Depot Collections");
        messages.put("DEFAULT_AUTHOR", "FUSE Depot Repository");
        messages.put("EMFQL_BAD_TERM", "Bad EMFQL query \"{0}\"; only expressions are supported");
        messages.put("EMFQL_PARSE_ERROR", "Error parsing EMFQL query \"{0}\"");        
        messages.put("MISSING_CONFIG", "Cannot proceede as missing configuration for \"{0}\"");
        messages.put("MEDIA_NOT_SUPPORTED", "The collection \"{0}\" is not a media collection");
        messages.put("MEDIA_RESOURCE_NOT_FOUND", "The media resource \"{0}\" was not found");
        messages.put("MISSING_ATTRIBUTE", "Resource is missing attribute \"{0}\"");
        messages.put("MISSING_CTX", "Security context is missing from request");
        messages.put("MISSING_OBJECT", "The object referenced by \"{0}\" does not exist");
        messages.put("MISSING_RESOURCE_ID", "Missing resource ID for method \"{0}\" on URI \"{1}\"");
        messages.put("MULTIPART_MISSING_CONTENT", "Content missing from multipart/form-data exception");
        messages.put("MULTIPART_NOT_SUPPORTED", "Only multipart/form-data multipart messages are supported");
        messages.put("NOT_FOUND", "Resource \"{1}\" not found in collection \"{0}\"");
        messages.put("INTERNAL_ERROR", "Internal error: {0}");
        messages.put("NO_CATAGORIES", "Catagories are not implemented");
        messages.put("NO_COLLECTION", "No collection specified for method \"{0}\" on URI \"{1}\"");
        messages.put("NO_MEDIA_CONTENT", "No media content was sent with request");
        messages.put("NO_PARTS", "Mulitpart message with no parts");
        messages.put("NO_SUBCOLLECTION", "Subcollection \"{0}\" not found");
        messages.put("OBJECT_NOT_PERSIST", "EObject of type \"{0}\" is not persisted");
        messages.put("OP_NOT_IMPLEMENTED", "Operation \"{0}\" not implemented");
        messages.put("PUT_NOT_ALLOWED", "Method PUT is not allowed for the URI \"{0}\"");
        messages.put("RESOURCE_DELETED", "Resource \"{1}\" deleted from collection \"{0}\"");
        messages.put("RESOURCE_NOT_IN_ENTRY", "No resource meta-data found in Atom entry");
        messages.put("SUBCOLLECTION_ERROR", "Error getting subcollection \"{0}\"");
        messages.put("TOO_MANY_REFS", "Too many references given when updating reference \"{0}\"");
        messages.put("UNAUTH_READ", 
                "User \"{0}\" is not authorized to access object \"{1}\". "
                + "Please relogin or contact Administrator.");
        messages.put("UNAUTH_UPDATE", 
                "User \"{0}\" is not authorized to make this change. "
                + "Please relogin or contact Administrator.");
        messages.put("UNKNOWN_COLLECTION", "Repository does not have a collection called \"{0}\"");
        messages.put("UNKNOWN_COLLECTION_CLASS",
                "Repository does not have a collection for the eclass \"{0}\"");
        messages.put("UNKNOWN_REFERENCE_COLLECTION", "There is no collection for the reference \"{0}\"");
        messages.put("WORKSPACE_TITLE", "FUSE Depot");
        messages.put("ZERO_COUNT", "Query parameter _count cannot be zero");
        messages.put("INTERNAL_OBJECT", "Cannot {0} internal object: {1}");
        messages.put("READONLY_COLLECTION", "Cannot {0} read-only collection");
        messages.put("DUPLICATE_USERID", "A User with userid {0} already exists");
    }

    public static ResourceBundle getInstance() {
        return instance;
    }
    
    @Override
    public Enumeration<String> getKeys() {
        return null;
    }

    @Override
    protected Object handleGetObject(String key) {
        String obj = messages.get(key);
        if (obj == null) {
            return "?";
        }
        return obj;
    }



}
