/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.osgi;

import com.iona.soa.repository.model.util.ModelHelper;

import org.eclipse.emf.ecore.EClass;
import org.osgi.framework.BundleContext;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.osgi.context.BundleContextAware;

public class ModelCollectionServiceFactory implements InitializingBean, BundleContextAware {
    private BundleContext bundleContext;

    public void setBundleContext(BundleContext bc) {
        bundleContext = bc;
        System.out.println("Setting bundlecontext: " + bc);
    }
    
    public void afterPropertiesSet() throws Exception {
        for (EClass ecls : ModelHelper.getSOAModelRegistry().getAllEClasses()) {
            System.out.println("Registering service for EClass " + ecls.getName());
        }
    }
}
