/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.repo;

import java.io.IOException;

import com.iona.soa.model.MavenRepository;
import com.iona.soa.model.SOA_NetworkPackage;
import com.iona.soa.repository.EMFUtil;
import com.iona.soa.repository.SOARepository;
import com.iona.soa.search.SearchService;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;

public abstract class AbstractMavenQueryExecutor extends RESTQueryExecutor {
    
    public AbstractMavenQueryExecutor(SOARepository soaRepo,
                                      SearchService searchService) {
        super(soaRepo, searchService);
    }
    
    protected MavenRepository getMavenRepo(String id) {
        MavenRepository mavenRepo = null;
        
        EClass eclass = SOA_NetworkPackage.eINSTANCE.getMavenRepository();
        URI uri = EMFUtil.getProxyURI(eclass, id);
        try {
            mavenRepo = (MavenRepository)getSOARepository().getResourceSet().getEObject(uri, true);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return mavenRepo;
    }        
}
