/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.repo;

import com.iona.repository.rest.repo.EClassHandler;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

public class CollectionDescriptor {
    
    private String name;
    private EPackage epackage;
    private EClass eclass;
    private EClassHandler handler;
    private boolean isTopLevel;
    private boolean isResourceBased;
    private String collectionTitle;
    private RESTQueryExecutor queryExecutor;
    private boolean isFilterEnabled;
    private boolean isWritable = true;
    public CollectionDescriptor(String name) {
        this.name = name;
        collectionTitle = name.substring(0, 1).toUpperCase() 
                       + name.substring(1);
    }

    public String getName() {
        return name;
    }
    
    public EPackage getEPackage() {
        return epackage;
    }
    
    public CollectionDescriptor setEPackage(EPackage ep) {
        epackage = ep;
        return this;
    }
    
    public CollectionDescriptor setQueryExecutor(RESTQueryExecutor qe) {
        queryExecutor = qe;
        return this;
    }
    
    public RESTQueryExecutor getQueryExecutor() {
        return queryExecutor;
    }
    
    public EClass getEClass() {
        return eclass;
    }
    
    public CollectionDescriptor setEClass(EClass ec) {
        eclass = ec;
        return this;
    }
    
    public EClassHandler getHandler() {
        return handler;
    }
    
    public CollectionDescriptor setHandler(EClassHandler h) {
        handler = h;
        return this;
    }

    public boolean isTopLevel() {
        return isTopLevel;        
    }
    
    public CollectionDescriptor setIsTopLevel(boolean t) {
        isTopLevel = t;
        return this;
    }

    public boolean isResourceBased() {
        return isResourceBased;        
    }
    
    public CollectionDescriptor setIsResourceBased(boolean t) {
        isResourceBased = t;
        return this;
    }

    public String getCollectionTitle() {
        return collectionTitle;
    }

    public boolean isFilterEnabled() {
        return isFilterEnabled;
    }
    
    public CollectionDescriptor setFilterEnabled(boolean t) {
        isFilterEnabled = t;
        return this;
    }

    public boolean isWritable() {
        return isWritable;
    }

    public CollectionDescriptor setWritable(boolean writable) {
        isWritable = writable;
        return this;
    }
}
