/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.repo;

import com.iona.repository.rest.RESTContext;
import com.iona.repository.rest.RESTException;
import com.iona.repository.rest.resource.Resource;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;


public interface EFeatureHandler {
    
    void addFeatureToResource(String qualName, EStructuralFeature feature,                     
                              EObject eobject, Resource resource)
        throws RESTException;

    void getFeatureChanges(RESTContext ctx, String qualName, 
                           EStructuralFeature feature, EObject eobject, 
                           Resource resource)
        throws RESTException;
    
    @SuppressWarnings("unchecked")
    void getReferenceListChanges(RESTContext ctx, EReference ref,
                                 EObject eobject, EList<EObject> newList, 
                                 EList<EObject> oldList) 
        throws RESTException;
 
}
