/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.repo;


import com.iona.repository.rest.RESTContext;
import com.iona.repository.rest.RESTException;
import com.iona.repository.rest.repo.EClassHandler;
import com.iona.repository.rest.resource.Resource;
import com.iona.repository.rest.rt.server.RESTProvider;
import com.iona.soa.model.repository.Property;

import org.eclipse.emf.ecore.EObject;

public class PropertyHandler extends DefaultEClassHandler implements EClassHandler {
    
    private static final String TITLE_SEPARATOR = "=";

    public PropertyHandler(RESTProvider a) {
        super(a);
        // Complete
    }

    @Override
    public void addObjectToResource(RESTContext ctx,
                                    EObject eobject,
                                    Resource resource) throws RESTException {
        
        super.addObjectToResource(ctx, eobject, resource);
        
        // Set resource name to be "<name>=<value>"
        Property property = (Property) eobject;
        String name = property.getName();
        String value = property.getValue(); 
        String title = name == null ? "?" : name;
        title += TITLE_SEPARATOR;
        title += value == null ? "" : value;
        resource.setName(title);
    }



}
