/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.repo;

import java.util.Collection;

import com.iona.repository.rest.RESTContext;
import com.iona.repository.rest.RESTException;
import com.iona.repository.rest.repo.EClassHandler;
import com.iona.repository.rest.resource.Resource;
import com.iona.repository.rest.rt.server.RESTProvider;
import com.iona.soa.model.security.Role;
import com.iona.soa.model.security.SecurityArea;

import org.eclipse.emf.ecore.EObject;


public class RoleHandler extends DefaultEClassHandler implements
        EClassHandler {

    public RoleHandler(RESTProvider a) {
        super(a);
    }
   
    @Override
    public void getObjectChanges(RESTContext ctx,
            EObject eobject,
            Resource resource) throws RESTException {
        super.getObjectChanges(ctx, eobject, resource);
        
        Role role = (Role)eobject;

        // make sure that permission hierarchy is maintained
        Collection<SecurityArea> areas = role.getCanCreate();
        role.getCanUpdate().addAll(areas);

        areas = role.getCanUpdate();
        role.getCanDelete().addAll(areas);
        
        areas = role.getCanDelete();
        role.getCanRead().addAll(areas);
    }
}
