/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.repo;


import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import com.iona.repository.maven.osgi.IRepositoryMavenService;
import com.iona.repository.rest.RESTContext;
import com.iona.repository.rest.RESTException;
import com.iona.repository.rest.RESTQuery;
import com.iona.repository.rest.resource.Resource;
import com.iona.soa.model.MavenRepository;
import com.iona.soa.repository.SOARepository;
import com.iona.soa.repository.TransactionData;
import com.iona.soa.search.SearchService;

import org.apache.lucene.queryParser.ParseException;



public class SpiderActionExecutor extends AbstractMavenQueryExecutor {


    private IRepositoryMavenService mavenService;            
 
    public SpiderActionExecutor(SOARepository soaRepo, 
            SearchService searchService, 
            IRepositoryMavenService mavenService) {
        super(soaRepo, searchService);
        this.mavenService = mavenService;   
    }
    
    
    @Override
    public Collection<Resource> queryResources(RESTContext ctx,
                                               TransactionData trnsData,
                                               RESTQuery query) throws RESTException {

        String id = query.getDecodedParameter("mavenRepoGuid");
        MavenRepository mavenRepo = getMavenRepo(id);
        List<Resource> resourceList = new ArrayList<Resource>();
        
        try {
            // TODO There needs to be 
            if (mavenRepo != null) {
                mavenService.index(trnsData.getUserId(), trnsData.getSsoToken(), id, true);
                Resource resource = getResourceFactory().createResource("Scheduler");
                addAttribute(resource, "result", "successful", "xsd:normalizedString");
                addAttribute(resource, "id", "successful", "xsd:normalizedString");
                addAttribute(resource, "directory", null, "xsd:normalizedString");
                resourceList.add(resource);
            } else {
                Resource resource = getResourceFactory().createResource("Scheduler");
                addAttribute(resource, "result", "not a valid repository", "xsd:normalizedString");
                resourceList.add(resource);
            }
            return resourceList;
        } catch (ParseException pe) {
            throw new RESTException(RESTException.INTERNAL_SERVER_ERROR, pe);
        }
    }



    
        

}
