/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.server;

import com.iona.repository.rest.RESTException;
import com.iona.repository.rest.rt.repo.CollectionDescriptor;
import com.iona.repository.rest.rt.repo.EFeatureHandler;
import com.iona.repository.rest.rt.repo.RESTQueryExecutor;
import com.iona.soa.repository.SOARepository;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;

public interface RESTProvider {
    String getCollectionHref(String className);
    CollectionDescriptor getDescriptor(EClass refClass) throws RESTException;
    EClass getEClass(String string);
    EFeatureHandler getEFeatureHandler(String qualName);
    RESTQueryExecutor getQueryExecutor(String collection) throws RESTException;
    SOARepository getRepository();
    String getXsdType(EAttribute att) throws RESTException;
    
    void internalError(String string) throws RESTException;
    
    boolean isFeatureExcluded(String qualName);
    boolean isHidden(String qualName);
    boolean isReadonly(String qualName);
    boolean isReferenceable(String className);
}
