/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.server;

import com.iona.repository.rest.atom.AbderaUtil;

import org.apache.abdera.Abdera;
import org.apache.abdera.protocol.server.Provider;
import org.apache.abdera.protocol.server.servlet.AbderaServlet;


public class RepositoryServlet extends AbderaServlet {

    private static final long serialVersionUID = 5909237481370701709L;

    private Provider provider;

    public RepositoryServlet(Provider p) {
        provider = p;
    }

    @Override
    public Abdera getAbdera() {
        // Required for OSGi. 
        return AbderaUtil.getAbdera();
    }
    
    @Override
    protected Provider createProvider() {
        provider.init(AbderaUtil.getAbdera(), getProperties(getServletConfig()));
        return provider;
    }

}
