/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.rest.rt.server;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import java.util.logging.Logger;

import org.apache.abdera.model.Workspace;
import org.apache.abdera.protocol.server.CollectionInfo;
import org.apache.abdera.protocol.server.RequestContext;
import org.apache.abdera.protocol.server.WorkspaceInfo;

public class RepositoryWorkspaceInfo implements WorkspaceInfo, Serializable {

    private static final Logger LOG = Logger.getLogger(RepositoryWorkspaceInfo.class.getName());

    private static final long serialVersionUID = -5523393623156788076L;

    private String title;
    private Set<CollectionInfo> collections;

    public RepositoryWorkspaceInfo() {
        // Complete
    }

    public void setTitle(String title) {
        LOG.info("title: " + title);
        this.title = title;
    }

    public Workspace asWorkspaceElement(RequestContext request) {

        LOG.info("request: " + request);
        Workspace workspace = request.getAbdera().getFactory().newWorkspace();
        workspace.setTitle(title);
        for (CollectionInfo collection : this.collections) {
            LOG.info("adding collecction " + collection.getTitle(request));
            workspace.addCollection(collection.asCollectionElement(request));
        }
        return workspace;
    }

    public void addCollection(CollectionInfo ci) {
        getCollections().add(ci);
    }

    private Set<CollectionInfo> getCollections() {
        if (collections == null) {
            collections = new HashSet<CollectionInfo>();
        }
        return collections;
    }

    public Collection<CollectionInfo> getCollections(RequestContext request) {
        return collections;
    }

    public String getTitle(RequestContext requsest) {
        return title;
    }

}
