/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.security.impl;

import java.util.Map;

import com.iona.soa.repository.SOARepository;
import com.iona.soa.security.AuthenticationException;

public interface AuthenticationService {

    void setSoaRepo(SOARepository soaRepo);
    void setConfig(Map<String, String> config);

    String getUserId(String token) throws AuthenticationException;
    String authenticate(String token) throws AuthenticationException;
    String authenticate(String userId, String password) throws AuthenticationException;
    String authenticatePersistent(String userId, String password) throws AuthenticationException;
    boolean logout(String token);

}