/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.security.impl;

import java.util.Collection;
import java.util.Map;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.OperationType;
import com.iona.soa.repository.SOARepository;

public interface AuthorizationService {
    void setSoaRepo(SOARepository soaRepo);
    void setConfig(Map<String, String> config);

    boolean isAuthorized(String userId, OperationType operation, Collection<String> areaIds) 
        throws AuthorizationException;
    boolean isAuthorized(String userId, OperationType operation, ObjectPermission objPerm) 
        throws AuthorizationException;

    static class AuthorizationException extends Exception {
        private static final long serialVersionUID = -4754150131329702805L;
        public AuthorizationException(String msg) {
            super(msg);
        }
        public AuthorizationException(String message, Throwable cause) {
            super(message, cause);
        }
    }
}