/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.serialization;

import com.iona.soa.repository.ModelRegistry;

import org.eclipse.emf.common.util.URI;

public interface Deserializer extends Configurable {
    Option<URIConverter> OPTION_URL_CONVERTER = new Option<URIConverter>(null);
    Option<Boolean> OPTION_ENABLE_INTERNAL_URL_READER = new Option<Boolean>(true);
    Option<Boolean> OPTION_ALLOW_MODIFY_ON_ADD = new Option<Boolean>(false);
    
    void registerAttributeHandler(AttributeHandler handler);
    void setModelRegistry(ModelRegistry registry);

    void deserialize() throws XMLParseException;
    
    public interface URIConverter {
        URI convert(URI uri);
    }
}
