/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository;

public class EStructuralFeatureDescriptor extends EClassifierDescriptor {
    private String featureName;
    
    public EStructuralFeatureDescriptor(String packageNsURI, String name, String featureName) {
        super(packageNsURI, name);
        this.featureName = featureName;
    }
    public EStructuralFeatureDescriptor(EStructuralFeatureDescriptor rhs) {
        this(rhs.getPackageNsURI(), rhs.getName(), rhs.getFeatureName());
    }
    
    public String getFeatureName() {
        return featureName;
    }
    
    @Override
    public int hashCode() {
        return hashCode() + featureName == null ? 0 : featureName.hashCode();
    }
    
    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof EStructuralFeatureDescriptor) || !super.equals(obj))  {
            return false;
        }
        EStructuralFeatureDescriptor rhs = (EStructuralFeatureDescriptor)obj;
        return featureName == null ? rhs.featureName == null 
                                     : featureName.equals(rhs.featureName);
    }
}
