/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.security;

import java.util.logging.Logger;

public final class PasswordProviderHandler {
    
    private static final Logger LOG = Logger.getLogger("PasswordProviderHandler");
    
    private PasswordProviderHandler() {
        
    }
    
    public static String getPassword(String providerClassName) {
        if (providerClassName == null) {
            return null;
        }
        
        try {
            PasswordProvider provider = 
                (PasswordProvider)Class.forName(providerClassName).newInstance();
            return provider.getPassword();
        } catch (Exception ex) {
            LOG.severe("Error retrieving a password : " + ex.getMessage());
        }
        
        return null;
        
    }
}
