/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.status;

import java.util.Locale;
import java.util.ResourceBundle;

public final class MessageHelper {
    private static final ResourceBundle BUNDLE = ResourceBundle.getBundle(
            "com.iona.soa.repository.status.StatusMessages",
            Locale.getDefault());
    
    private MessageHelper() {
    }
    
    public static String getMessage(StatusType msg) {
        return getMessage(msg.name());
    }
    
    public static String getMessage(StatusMessage msg) {
        return getMessage(msg.name());
    }
    
    private static String getMessage(String msg) {
        String ret = BUNDLE.getString(msg);
        assert ret != null;
        return ret;
    }
}
