/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.status;

@SuppressWarnings("serial")
public class RepositoryInitializationException extends RepositoryException {

    public RepositoryInitializationException(Throwable t) {
        super(-1, new RepositoryStatus(MessageLevel.ERROR, 
                                       StatusType.INTERNAL_SERVER_ERROR, 
                                       new RepositoryStatusMessage(t)));
    }

    public RepositoryInitializationException(String trace, String msg) {
        super(-1, new RepositoryStatus(MessageLevel.ERROR, 
                                       StatusType.INTERNAL_SERVER_ERROR, 
                                       new RepositoryStatusMessage(trace, msg)));
    }

    public RepositoryInitializationException(StatusMessage msg, Object ... args) {
        super(-1, new RepositoryStatus(MessageLevel.ERROR, 
                                       StatusType.INTERNAL_SERVER_ERROR));
        getStatus().messages.add(new RepositoryStatusMessage(this, msg, args));
    }

    public RepositoryInitializationException(Throwable t, StatusMessage msg, Object ... args) {
        super(-1, new RepositoryStatus(MessageLevel.ERROR, 
                                       StatusType.INTERNAL_SERVER_ERROR,
                                       new RepositoryStatusMessage(t, msg, args)));
    }
}


