/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.status;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class RepositoryStatus {
    List<RepositoryStatusMessage> messages;
    private final MessageLevel level;
    private final String type;

    public RepositoryStatus(MessageLevel level) {
        this(level, (String)null, new RepositoryStatusMessage[0]);
    }

    public RepositoryStatus(MessageLevel level, StatusType type, RepositoryStatusMessage ... msgs) {
        this(level, type == null  ? null : type.getMessage(), msgs);
    }

    @SuppressWarnings("unchecked")
    public RepositoryStatus(MessageLevel level, String type, RepositoryStatusMessage ... msgs) {
        this(level, type, new ArrayList(Arrays.asList(msgs)));
    }

    public RepositoryStatus(MessageLevel level, StatusType type, List<RepositoryStatusMessage> msgs) {
        this(level, type == null  ? null : type.getMessage(), msgs);
    }

    @SuppressWarnings("unchecked")
    public RepositoryStatus(MessageLevel level, String type, List<RepositoryStatusMessage> msgs) {
        this.level = level;
        this.type = type;
        this.messages = msgs;
    }

    public MessageLevel getLevel() {
        return level;
    }
    
    public String getType() {
        return type;
    }

    public List<RepositoryStatusMessage> getMessages() {
        return messages;
    }
}
