/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.status;

import java.net.HttpURLConnection;
import java.util.Arrays;
import java.util.List;

@SuppressWarnings("serial")
public class ValidationException extends RepositoryException {
    public ValidationException(StatusMessage msg, Object ... args) {
        super(HttpURLConnection.HTTP_CONFLICT, 
              new RepositoryStatus(MessageLevel.ERROR, 
                                   StatusType.VALIDATION_ERROR, 
                                   new RepositoryStatusMessage(msg, args)));
    }

    public ValidationException(String uri, StatusMessage msg, Object ... args) {
        super(HttpURLConnection.HTTP_CONFLICT, 
              new RepositoryStatus(MessageLevel.ERROR, 
                                   StatusType.VALIDATION_ERROR, 
                                   new RepositoryStatusMessage(Arrays.asList(uri), msg, args)));
    }

//    public ValidationException(RepositoryStatus status) {
//        super(HttpURLConnection.HTTP_CONFLICT, status);
//    }

    public ValidationException(MessageLevel level, 
                               StatusType type,
                               List<String> uris, 
                               StatusMessage message, 
                               Object ... args) {
        super(HttpURLConnection.HTTP_CONFLICT, 
              new RepositoryStatus(level, type, new RepositoryStatusMessage(uris, message, args)));
    }


    public ValidationException(MessageLevel level, 
                               StatusType type,
                               List<RepositoryStatusMessage> messages) {
        super(HttpURLConnection.HTTP_CONFLICT, 
              new RepositoryStatus(level, type, messages));
    }
}
