/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.util;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

public final class CollectionsUtil {
    private CollectionsUtil() {
    }
    
    @SuppressWarnings("unchecked")
    public static <T> List<T> filter(Collection<? extends Object> values, Class<T> clazz) {
        List<T> ret = new LinkedList<T>();
        for (Object obj : values) {
            if (obj == null || clazz.isInstance(obj)) {
                ret.add((T)obj);
            }
        }
        return ret;
    }
}
