/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.repository.util;

public class Tuple<K, V> {
    private K lhs;
    private V rhs;
    public Tuple(K rhs, V lhs) {
        this.lhs = rhs;
        this.rhs = lhs;
    }
    
    public K getLhs() {
        return lhs;
    }
    
    public V getRhs() {
        return rhs;
    }
    
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append(super.toString());
        sb.append(" [lhs=");
        sb.append(lhs);
        sb.append(", rhs=");
        sb.append(rhs);
        sb.append("]");
        return sb.toString();
    }
    
    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Tuple)) {
            return false;
        }
        Tuple<?, ?> other = (Tuple<?, ?>)obj;
        if (!(lhs == other.lhs  || (lhs == null ? false : lhs.equals(other.lhs)))) {
            return false;
        }
        return rhs == other.rhs || (rhs == null ? false : rhs.equals(other.rhs));
    }
    
    @Override
    public int hashCode() {
        return (lhs == null ? 0 : lhs.hashCode())
             + (rhs == null ? 0 : rhs.hashCode());
    }
}
