/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.base.client.model;

/**
 * observer interface for the <code>ReposObjChangeNotifier</code> service  
 */
public interface IReposObjChangeListener {

    /**
     * notifies of the creation of a repos Obj
     * @param createdObj the new repos object as it appears just after its creation 
     * @param containingCollectionUrl TODO
     */
    void reposObjCreated(ReposObj createdObj, String containingCollectionUrl, int ndex);
    
    /**
     * notifies of the deletion of a repos Obj
     * @param deletedObj the disposed repos object as it appeared just before its deletion 
     */
    void reposObjDeleted(ReposObj deletedObj);

    /**
     * notifies of the update to a repos Obj
     * @param updatedObj the updated repos object as it appears just after its update 
     */
    void reposObjUpdated(ReposObj updatedObj);
}
