/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.base.client.model;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.xml.client.Node;

/**
 * represents a collection of generic ARR objects.
 * Note that the data object keeps a reference to the XML node that initially represented the collection (just
 * in case...)
 */
public class ReposObjCollection {
    
    protected Node representingNode;
    
    private String id;
    
    private String caption;

    private String timeStamp;

    private String baseLink;

    private String selfLink;

    private List<ReposObj> theObjs;
    
    private boolean isContainedList;

    private String containerLink;
    
    private int totalSize;
    private int paginationStartIndex;
    private int paginationPageSize;
    
    private boolean canCreate;

    public ReposObjCollection(Node aNode) {
        representingNode = aNode;
        theObjs = new ArrayList<ReposObj>();
    }

    public ReposObjCollection(Node aNode,
                              String aCaption,
                              String updated,
                              String baseLink,
                              List<ReposObj> feedItems) {
        
        representingNode = aNode;
        
        caption = aCaption;
        this.timeStamp = updated;
        this.baseLink = baseLink;
        theObjs = feedItems == null ? new ArrayList<ReposObj>() : feedItems;
    }

    public String getBaseLink() {
        return baseLink;
    }

    public void setBaseLink(String baseLink) {
        this.baseLink = baseLink;
    }

    public List<ReposObj> getTheReposObjs() {
        return theObjs;
    }

    public void setTheReposObjs(List<ReposObj> someReposObj) {
        theObjs = someReposObj;
    }

    public String getCaption() {
        return caption;
    }

    public void setCaption(String aCaption) {
        caption = aCaption;
    }

    public String getTimeStamp() {
        return timeStamp;
    }

    public void setTimeStamp(String aTimeStamp) {
        timeStamp = aTimeStamp;
    }

    public Node getRepresentingNode() {
        return representingNode;
    }

    public void setRepresentingNode(Node aNode) {
        representingNode = aNode;
    }

    public String getSelfLink() {
        return selfLink;
    }

    public void setSelfLink(String aLink) {
        selfLink = aLink;
        
    }
    
    

    public String getId() {
        return id;
    }

    public void setId(String anId) {
        id = anId;
    }

    public boolean isContainedList() {
        return isContainedList;
    }

    public void setContainedList(boolean isIt) {
        isContainedList = isIt;
    }

    public String getContainerLink() {
        return containerLink;
    }

    public void setContainerLink(String aLink) {
        containerLink = aLink;
    }

    public int getTotalSize() {
        return totalSize;
    }

    public void setTotalSize(int aSize) {
        totalSize = aSize;
    }

    public int getPaginationStartIndex() {
        return paginationStartIndex;
    }

    public void setPaginationStartIndex(int anIndex) {
        paginationStartIndex = anIndex;
    }

    public int getPaginationPageSize() {
        return paginationPageSize;
    }

    public void setPaginationPageSize(int aPageSize) {
        paginationPageSize = aPageSize;
    }

    public boolean isCreateAllowed() {
        return canCreate;
    }

    public void setCreateAllowed(boolean create) {
        canCreate = create;
    }
}
