/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.base.client.model.attributes;

import com.iona.soa.web.repository.base.client.model.ReposObj;
import com.iona.soa.web.repository.base.client.model.ReposObjAttribute;

public class MultiRefAttribute extends BaseRepoObjAttributeWrapper {

    MultiRefAttribute(ReposObjAttribute anAttr) {
        super(anAttr);
    }
    
    public String getEClass() {
        return theAtrr.getRefEClass();
    }

    public void setEClass(String eClass) {
        theAtrr.setRefEClass(eClass);
    }
    
    public String[] getAllHrefs() {
        return theAtrr.getValues();
    }

    public String getRefCaption(String href) {
        return theAtrr.getValueCaption(href);
    }

    public void addRef(ReposObj aRefObj) {
        theAtrr.addRefValue(aRefObj);
    }
    
    public void addRef(String href, String valueCaption) {
        theAtrr.addRefValue(href, valueCaption);
    }

    public void removeRef(String href) {
        theAtrr.removeValue(href);
    }

    public void removeRef(ReposObj aRefObj) {
        if (aRefObj == null) {
            return;
        }
        theAtrr.removeValue(aRefObj.getSelfLink());
    }

    public void clearAllRefs() {
        theAtrr.clearValues();
    }

}
