/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.base.client.model.attributes;

import com.iona.soa.web.repository.base.client.model.ReposObjAttribute;

public final class ReposObjAttributeWrapperFactory {

    private ReposObjAttributeWrapperFactory() { }
    
    public static boolean isContainedCollectionAttribute(ReposObjAttribute actualAttr) {
        return actualAttr != null && actualAttr.isReference() && actualAttr.isCollection();
    }
    
    public static boolean isMultiPrimitiveAttribute(ReposObjAttribute actualAttr) {
        return actualAttr != null && (!actualAttr.isReference()) && actualAttr.isMulti();
    }

    public static boolean isMultiRefAttribute(ReposObjAttribute actualAttr) {
        return actualAttr != null
                && actualAttr.isReference()
                && actualAttr.isMulti()
                && !actualAttr.isCollection();
    }

    public static boolean isSinglePrimitieAttribute(ReposObjAttribute actualAttr) {
        return actualAttr != null && (!actualAttr.isReference()) && !actualAttr.isMulti();
    }

    public static boolean isSingleRefAttribute(ReposObjAttribute actualAttr) {
        return actualAttr != null
                && actualAttr.isReference()
                && (!actualAttr.isMulti())
                && !actualAttr.isCollection();
    }

    public static ContainedCollectionAttribute getContainedCollectionAttribute(ReposObjAttribute actualAttr) {
        return new ContainedCollectionAttribute(actualAttr);
    }
    
    public static MultiPrimitiveAttribute getMultiPrimitiveAttribute(ReposObjAttribute actualAttr) {
        return new MultiPrimitiveAttribute(actualAttr);
    }

    public static MultiRefAttribute getMultiRefAttribute(ReposObjAttribute actualAttr) {
        return new MultiRefAttribute(actualAttr);
    }

    public static SinglePrimitieAttribute getSinglePrimitieAttribute(ReposObjAttribute actualAttr) {
        return new SinglePrimitieAttribute(actualAttr);
    }

    public static SingleRefAttribute getSingleRefAttribute(ReposObjAttribute actualAttr) {
        return new SingleRefAttribute(actualAttr);
    }

}
