/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.base.client.model.attributes;

import com.iona.soa.web.repository.base.client.model.ReposObj;
import com.iona.soa.web.repository.base.client.model.ReposObjAttribute;

public class SingleRefAttribute extends BaseRepoObjAttributeWrapper {

    SingleRefAttribute(ReposObjAttribute anAttr) {
        super(anAttr);
    }
    
    public String getEClass() {
        return theAtrr.getRefEClass();
    }

    public void setEClass(String eClass) {
        theAtrr.setRefEClass(eClass);
    }
    
    public String getHref() {
        String[] hrefs = theAtrr.getValues();
        return (hrefs == null || hrefs.length  == 0) ? null : hrefs[0];
    }

    public String getRefCaption() {
        String[] hrefs = theAtrr.getValues();
        return (hrefs == null || hrefs.length  == 0) ? null : theAtrr.getValueCaption(hrefs[0]);
    }

    public void clearRef() {
        theAtrr.clearValues();
    }

    public void setRef(ReposObj aRefObj) {
        theAtrr.setRefValue(aRefObj);
    }
    
    public void setRef(String href, String valueCaption) {
        theAtrr.setRefValue(href, valueCaption);
    }

}
