/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.base.client.remote;

/**
 * parent of all the call back interfaces of the remote client APIs.
 * only concerned with error handling for now
 */
public interface IRemoteErrorCallBack {

    int ERR_CODE_BAD_REQUEST = 400;
    int ERR_CODE_UNAUTHORIZED = 401;
    int ERR_CODE_NOT_FOUND = 404;
    int ERR_CODE_NOT_ALLOWED = 405;
    int ERR_CODE_INTERNAL_SERVER_ERROR = 500;
    
    /**
     * ... called when an ERROR response is received for a given request 
     * @param aList the parsed collection of ARR objects
     */
    void processResponseError(String anErrorCode, String anErrorMsg);
    
    /**
     * ... called when a an error occurs while trying to send a request
     * @param aList the parsed collection of ARR objects
     */
    void processConnectionError(Throwable e);
}
