/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.base.client.remote;

public class PagingInfo {

    public static final String SORT_BY_TITLE = "_sortByTitle";

    private int pageSize;
    private int pageNo;
    private String ordering;
    private boolean ascending;
    
    public PagingInfo(int pageNo, int pageSize, String ordering, boolean ascending) {
        super();
        this.ascending = ascending;
        this.ordering = ordering;
        this.pageNo = pageNo;
        this.pageSize = pageSize;
    }

    public int getPageSize() {
        return pageSize;
    }

    public int getPageNo() {
        return pageNo;
    }

    public String getOrdering() {
        return ordering;
    }

    public boolean isAscending() {
        return ascending;
    }
}
