/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * 
 */
package com.iona.soa.web.repository.base.client.remote;

import java.util.List;

import com.iona.soa.web.repository.base.client.model.ReposObj;

/**
 * An empty RemoteClient for sub-classing by those who don't need to 
 * implement the entire interface; for example unit tests.
 */
public class RemoteClientAdapter implements RemoteClient {

    public void createIndex(String reposBaseUrl, String mavenRepoGuid, ICollectionCallBack callBack) { }

    public void createReposObj(String baseUrl,
                               String collectionName,
                               ReposObj defaultValue,
                               IObjCallBack callBack) { }

    public void createReposObj(String fullUrl, ReposObj defaultValue, IObjCallBack callBack) { }

    public void createReposObjs(String baseUrl,
                                String collectionName,
                                List<ReposObj> theObjs,
                                ICollectionCallBack callBack) { }

    public void createReposObjs(String fullUrl, List<ReposObj> theObjs, ICollectionCallBack callBack) { }
    
    public void deleteReposObj(ReposObj deletedObj, IDeletionCallBack callBack) { }

    public void deleteReposObj(String objUrl, IDeletionCallBack callBack) { }

    public void deleteReposObjs(List<ReposObj> deletedObjs, IDeletionCallBack callBack) { }

    public void deleteReposObjs(String[] objUrls, IDeletionCallBack callBack) { }

    public void getReposObj(String fullUrl, IObjCallBack callBack) { }

    public void getReposObjList(String baseUrl,
                                String collectionName,
                                String filterQuery,
                                PagingInfo pagingInfo,
                                ICollectionCallBack callBack) { }

    public void getReposObjList(String fullUrl,
                                String filterQuery,
                                PagingInfo pagingInfo,
                                ICollectionCallBack callBack) { }

    public void getReposObjs(String[] fullUrls, ICollectionCallBack callBack) { }

    public Object parseServerMessage(String message) throws Exception {
        return null;
    }

    public void resolveMavenDependencies(String reposBaseUrl, 
                                         ReposObj artifact, 
                                         ICollectionCallBack callBack) { }

    public void searchReposObjList(String reposBaseUrl,
                                   String queryFilter,
                                   PagingInfo pagingInfo,
                                   ICollectionCallBack callBack) { }

    public void setSSOToken(String ssoToken) { }

    public void updateReposObj(ReposObj updatedObj, IObjCallBack callBack) { }

    public void updateReposObjs(List<ReposObj> updatedObjs, ICollectionCallBack callBack) { }
}