/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client;

import com.google.gwt.i18n.client.Messages;

/**
 * Provides centralised access to html snippets, typically used in custom 
 * grid renderer implementations. 
 */
public interface HtmlSnippets extends Messages {
    String tagWithCssCls(String tag,
                         String content, 
                         String tagCssCls);
    
    String tagWithCssClsAndAttributes(String tag,
                                      String content, 
                                      String tagCssCls,
                                      String attributes);
    
    String anchorTag(String content);
    
    String anchorTagWithCssCls(String content, String anchorCssCls);
    
    String imageTag(String imageUrl, String tooltip);
    
    String imageTagWithCssCls(String imageUrl, String tooltip, String cssCls);
    
    String captionColumnWithImage(String imageUrl, 
                                  String actionCssClass, 
                                  String caption);
    
    String captionColumnNoImage(String actionCssClass, String caption);
    
    String rssColumn(String feedSubscriptionUrl);
    
    String tooltipImage(String imageCssId);
    
    String expandedGridRowClass();

    String collapsedGridRowClass();
    
    
    String deploymentProfileNameColumn(String profileName,
                                       String publishStatus,
                                       String lastEditedBy);
    
    String deploymentProfileNameColumnWithCategory(String profileName,
                                                   String publishStatus,
                                                   String lastEditedBy,
                                                   String category);
    
    String deploymentProfileVersionsRow(String divCssId);
    
    String defaultPermissionsApply(String operationType);
    
    String customPermissionsApply(String operationType);

    String footerCopyrightNotice();
}