/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client;

/**
 * Interface to represent the messages contained in resource bundle:
 * 	/home/jlynch/checkouts/depot/gwtext_port/repository/web/com.iona.soa.web.repository.main/src/main/java/com/iona/soa/web/repository/main/client/UIMessages.properties'.
 */
public interface UIMessages extends com.google.gwt.i18n.client.Messages {
  
  /**
   * Translated "Cancel".
   * 
   * @return translated "Cancel"
   */
  @DefaultMessage("Cancel")
  @Key("cancelBtnText")
  String cancelBtnText();

  /**
   * Translated "{0} ({1})".
   * 
   * @return translated "{0} ({1})"
   */
  @DefaultMessage("{0} ({1})")
  @Key("collectionTitleByCategory")
  String collectionTitleByCategory(String arg0,  String arg1);

  /**
   * Translated "{0} (search results for \"{1}\")".
   * 
   * @return translated "{0} (search results for \"{1}\")"
   */
  @DefaultMessage("{0} (search results for \"{1}\")")
  @Key("collectionTitleByQuery")
  String collectionTitleByQuery(String arg0,  String arg1);

  /**
   * Translated "Configure access security for this {0}".
   * 
   * @return translated "Configure access security for this {0}"
   */
  @DefaultMessage("Configure access security for this {0}")
  @Key("configureAccessSecurity")
  String configureAccessSecurity(String arg0);

  /**
   * Translated "<span class=\"arr-object-permissions-desc\">Custom access has been specified for this {0}</span>".
   * 
   * @return translated "<span class=\"arr-object-permissions-desc\">Custom access has been specified for this {0}</span>"
   */
  @DefaultMessage("<span class=\"arr-object-permissions-desc\">Custom access has been specified for this {0}</span>")
  @Key("customAccessSpecified")
  String customAccessSpecified(String arg0);

  /**
   * Translated "<span class=\"arr-object-permissions-desc\">Default access permissions are being used</span>".
   * 
   * @return translated "<span class=\"arr-object-permissions-desc\">Default access permissions are being used</span>"
   */
  @DefaultMessage("<span class=\"arr-object-permissions-desc\">Default access permissions are being used</span>")
  @Key("defaultAccessInEffect")
  String defaultAccessInEffect();

  /**
   * Translated "Discard changes".
   * 
   * @return translated "Discard changes"
   */
  @DefaultMessage("Discard changes")
  @Key("discardChangesBtnText")
  String discardChangesBtnText();

  /**
   * Translated "<p>There are unsaved changes.</p><p>Discard changes?</p>".
   * 
   * @return translated "<p>There are unsaved changes.</p><p>Discard changes?</p>"
   */
  @DefaultMessage("<p>There are unsaved changes.</p><p>Discard changes?</p>")
  @Key("discardChangesMsg")
  String discardChangesMsg();

  /**
   * Translated "Unsaved changes".
   * 
   * @return translated "Unsaved changes"
   */
  @DefaultMessage("Unsaved changes")
  @Key("discardChangesTitle")
  String discardChangesTitle();

  /**
   * Translated "<h2>An error occurred</h2><p>{0}</p>".
   * 
   * @return translated "<h2>An error occurred</h2><p>{0}</p>"
   */
  @DefaultMessage("<h2>An error occurred</h2><p>{0}</p>")
  @Key("failedToLoadContent")
  String failedToLoadContent(String arg0);

  /**
   * Translated "I''m done configuring".
   * 
   * @return translated "I''m done configuring"
   */
  @DefaultMessage("I''m done configuring")
  @Key("iAmDoneConfiguring")
  String iAmDoneConfiguring();

  /**
   * Translated "Include dependencies".
   * 
   * @return translated "Include dependencies"
   */
  @DefaultMessage("Include dependencies")
  @Key("includeDependencies")
  String includeDependencies();

  /**
   * Translated "Manage repositories".
   * 
   * @return translated "Manage repositories"
   */
  @DefaultMessage("Manage repositories")
  @Key("manageRepositories")
  String manageRepositories();

  /**
   * Translated "There are unsaved changes.".
   * 
   * @return translated "There are unsaved changes."
   */
  @DefaultMessage("There are unsaved changes.")
  @Key("navigateAwayWhenUnsavedMsg")
  String navigateAwayWhenUnsavedMsg();

  /**
   * Translated "There are no indexed {0} available to search in.".
   * 
   * @return translated "There are no indexed {0} available to search in."
   */
  @DefaultMessage("There are no indexed {0} available to search in.")
  @Key("noIndexedRepositoriesAvailable")
  String noIndexedRepositoriesAvailable(String arg0);

  /**
   * Translated "Security".
   * 
   * @return translated "Security"
   */
  @DefaultMessage("Security")
  @Key("objectSecurityTitle")
  String objectSecurityTitle();

  /**
   * Translated "Restore default values".
   * 
   * @return translated "Restore default values"
   */
  @DefaultMessage("Restore default values")
  @Key("restoreDefaults")
  String restoreDefaults();

  /**
   * Translated "Configure access for roles ".
   * 
   * @return translated "Configure access for roles "
   */
  @DefaultMessage("Configure access for roles ")
  @Key("specifyRolesWithAccess")
  String specifyRolesWithAccess();

  /**
   * Translated "Grant additional access to specific users".
   * 
   * @return translated "Grant additional access to specific users"
   */
  @DefaultMessage("Grant additional access to specific users")
  @Key("specifyUsersWithAccess")
  String specifyUsersWithAccess();

  /**
   * Translated "Upload a file".
   * 
   * @return translated "Upload a file"
   */
  @DefaultMessage("Upload a file")
  @Key("uploadFile")
  String uploadFile();
    
    String defaultScheduleIndexTaskName(String mavenRepositoryName);
    
    String defaultSchedulePublishTaskName(String profileName);
}
