/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.admin;

import com.iona.soa.web.repository.main.client.base.EClassHelper;
import com.iona.soa.web.repository.main.client.base.ISubModule;

public class AdminSubModule implements ISubModule {
    protected static final String COLLECTION_USERS =
        EClassHelper.getContextForClass(EClassHelper.USER_ECLASS);

    public AdminSubModule() {
    }
    
    public String getURLParamId() {
        return "admin";
    }
    
    public String getTitle() {
        return "Administration";
    }
 
    public String getImageCs() {
        return "adminLogo-headerSmall";
    }
    
    public String getWelcomePageImagePath() {
        return "images/adminLogo_small.gif";
    }
    
    public String getApplicationIntroPageUrl() {
        return "docs/introPages/fuse-depot-home.html";
    }

    public String getApplicationToolTip() {
        return "The Admin application allows you to manage:"
                + "<br><ul><li> - the User accounts</li>"
                + "<li> - the Role definitions</li>"
                + "<li> - the data security settings</li>"
                + "<li> - ...</li>"
                + "</ul>";
    }

    public String[] getTypes() {
        return new String[] {EClassHelper.USER_ECLASS,
                             EClassHelper.ROLE_ECLASS,
                             EClassHelper.MAVENREPO_ECLASS,
                             EClassHelper.SCHEDULED_TASK_ECLASS,
        };
    }
}
