/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;


import com.extjs.gxt.ui.client.widget.Component;
import com.iona.soa.web.repository.base.client.model.ReposObjCollection;
import com.iona.soa.web.repository.base.client.remote.ICollectionCallBack;

public abstract class AbstractUiCollectionCallBack implements ICollectionCallBack {

    private Component maskedComponent;
    
    public AbstractUiCollectionCallBack() {
        // do nothing
    }
    
    public AbstractUiCollectionCallBack(Component maskedComp) {
        maskedComponent = maskedComp;
    }
    
    public abstract void processReposObjCollection(ReposObjCollection list);

    public void processConnectionError(Throwable e) {
        unmask();
        Utils.handleErrorMsg("unexpected error while connecting to the server: " + e.getMessage(), false);
    }
    
    public void processResponseError(String anErrorCode, String anErrorMsg) {
        unmask();
        Utils.handleErrorMsg("unexpected response from the server ("
                               + anErrorCode
                               + "): "
                               + anErrorMsg,
                               "401".equals(anErrorCode));
    }
    
    private void unmask() {
        if (maskedComponent != null) {
            maskedComponent.el().unmask();
        } else {
            Utils.closeWaitDialog();
        }
    }
}
