/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;

import java.util.List;


public interface IContextAreaContributor {
    
    IContextAction getCreateAction(ReposURL contextURL, ICollectionPanel contextPanel);
    
    /**
     * Return any actions other than the primary create action.
     * @param contextURL
     * @param contextPanel
     * @return
     */
    List<IContextAction> getCollectionActions(ReposURL contextURL, ICollectionPanel contextPanel);

    List<IContextAction> getEditorActions(ReposURL contextURL, IEditorPanel editorPanel);
    
    /**
     * replaces IContextHelpAble
     */
    String getHelpId(ReposURL contextURL);
}
