/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;

/**
 * @see IManagedForm
 */
public interface IFormPart {
    /**
     * @return true if the part has changed and is therefore "newer" that
     * the model.
     */
    boolean isDirty();
    
    /**
     * Write any change to the backing model object.
     */
    void commit();
    
    /**
     * Read the value from the model and reflect in the form part UI.
     */
    void refresh();
    
    /**
     * Invoked whenever the editor input is changed.  Implementations do <em>not</em>
     * have to refresh themselves, the framework will do it.
     * 
     * @param input the new form input.
     */
    void setFormInput(Object input);
}
