/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;


public interface ISubModule {

    
    /**
     * As supplied in a URL like ?section="admin"
     * @return
     */
    String getURLParamId();
    
    /**
     * the Main title of the submodule
     * @return
     */
    String getTitle();
    
    /**
     * returns the CS name identifying the icon/banner of the module 
     * @return
     */
    String getImageCs();

    /**
     * returns the path (NOT the CSS class) to the welcome page icon/banner of the module 
     * @return
     */
    String getWelcomePageImagePath();

    /**
     * returns the description of the application as it will appear in the welcome page
     * supports HTML tags for advanced text layouts 
     * @return
     */
    String getApplicationToolTip();
    
    /**
     * returns the URL to the web page containing introduction info for the sub-module/application
     * @return
     */
    String getApplicationIntroPageUrl();

    /**
     * returns String array of eClass names that this subModule displays, e.g.
     * "folder.IFolder", "security.User", "model.Artifact" etc.
     * @return
     */
    String[] getTypes();
}
