/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base;

public final class ReposHandle {
    
    public static final ReposHandle INSTANCE = new ReposHandle();
    
    private String serverBaseUrl;
    
    private ReposHandle() {
    }
    
    public boolean connect(String aServerUrl) {
        
        serverBaseUrl = aServerUrl;
        
        if (!serverBaseUrl.endsWith("/")) {
            serverBaseUrl = serverBaseUrl + "/";
        }
        
        return true;
    }

    // TODO - supply the RemoteClient implementation such that all calls to this method 
    // can be removed, plus hopefully getRelativeLink/getAbsoluteLink and finally this class.
    public String getServerBaseUrl() {
        return serverBaseUrl;
    }

    public boolean isConnected() {
        return serverBaseUrl != null;
    }
    
    public static String getRelativeLink(String objectLink) {
        if (isAbsoluteLink(objectLink)) {
            int index =
                objectLink.indexOf(INSTANCE.getServerBaseUrl()) + INSTANCE.getServerBaseUrl().length();
            return objectLink.substring(index);
        }
        return objectLink;
    }

    public static String getAbsoluteLink(String relativeLink) {
        if (relativeLink != null && !isAbsoluteLink(relativeLink)) {
            return INSTANCE.getServerBaseUrl() + relativeLink;
        }
        return relativeLink;
    }
    
    public static boolean isAbsoluteLink(String link) {
        return link != null && link.indexOf(INSTANCE.getServerBaseUrl()) > -1;
    }
}
