/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.gxtdatamodels;

import com.extjs.gxt.ui.client.data.BaseTreeModel;
import com.iona.soa.web.repository.base.client.model.ReposObj;

@SuppressWarnings("serial")
public class ReposObjTreeModel extends BaseTreeModel<ReposObjTreeModel> {

    public static final String FIELD_POJO = ReposObjDataModel.FIELD_POJO;
    public static final String FIELD_ECLASS = ReposObjDataModel.FIELD_ECLASS;
    public static final String FIELD_CAPTION = ReposObjDataModel.FIELD_CAPTION;
    public static final String FIELD_TIMESTAMP = ReposObjDataModel.FIELD_TIMESTAMP;
    public static final String FIELD_TIMESTAMP_IN_MS = ReposObjDataModel.FIELD_TIMESTAMP_IN_MS;
    public static final String FIELD_LAST_MODIFIED_BY = ReposObjDataModel.FIELD_LAST_MODIFIED_BY;
    public static final String FIELD_RSS_FEED = ReposObjDataModel.FIELD_RSS_FEED;
    public static final String FIELD_SELF_LINK = ReposObjDataModel.FIELD_SELF_LINK;
    public static final String FIELD_EDIT_LINK = ReposObjDataModel.FIELD_EDIT_LINK;
    
    public ReposObjTreeModel(ReposObj aReposObj) {
        super();
        setPOJO(aReposObj);
        ReposObjDataModel.initModelData(aReposObj, this);
    }
    
    public ReposObj getPOJO() {
        return (ReposObj) get(FIELD_POJO);
    }

    public void setPOJO(ReposObj value) {
        set(FIELD_POJO, value);
    }
    
    protected String getPojoAttrValue(String anAtrrName) {
        return getPOJO() == null ? null : getPOJO().getAttributeValue(anAtrrName);
    }
    
    protected void setPojoAttrValue(String anAtrrName, String aValue) {
        if (getPOJO() != null) {
            getPOJO().getAttribute(anAtrrName).setSimpleValue(aValue);
        }
    }
    
    public String toString() {
        return get(FIELD_CAPTION);
    }
}
