/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui;

import com.extjs.gxt.ui.client.widget.Component;
import com.iona.soa.web.repository.base.client.model.ReposObjCollection;
import com.iona.soa.web.repository.main.client.base.ICollectionPanel;
import com.iona.soa.web.repository.main.client.base.ISelectionSensitiveContextAction;
import com.iona.soa.web.repository.main.client.base.ICollectionPanel.ICollectionListener;

public abstract class AbstractCreateObjectAction implements ISelectionSensitiveContextAction, ICollectionListener {
    private Component renderedActionWidget;

    public AbstractCreateObjectAction(ICollectionPanel contextPanel) {
        contextPanel.addCollectionListener(this);
    }

    public void onCollectionLoaded(ReposObjCollection collection) {
        if (renderedActionWidget != null) {
            if (collection.isCreateAllowed()) {
                renderedActionWidget.enable();
            } else {
                renderedActionWidget.disable();
            }
        }
    }

    public void setRenderedWidget(Component widget) {
        renderedActionWidget = widget;
        renderedActionWidget.disable();
    }
}
