/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui;

import com.extjs.gxt.ui.client.data.DataProxy;
import com.extjs.gxt.ui.client.data.ListLoadConfig;
import com.extjs.gxt.ui.client.data.ListLoadResult;
import com.extjs.gxt.ui.client.data.SortInfo;
import com.iona.soa.web.repository.base.client.remote.RemoteClient;
import com.iona.soa.web.repository.main.client.base.ReposURL;

public abstract class AbstractRemoteDataProxy<A extends ListLoadConfig, B extends ListLoadResult<?>> implements DataProxy<A, B>{

    private RemoteClient remoteClient;
    private ReposURL url;
    private String filterQuery;
    private SortInfo sortInfo;

    public AbstractRemoteDataProxy(RemoteClient client) {
        remoteClient = client;
    }

    public final RemoteClient getRemoteClient() {
        return remoteClient;
    }

    public final ReposURL getResourceURL() {
        return url;
    }

    public final AbstractRemoteDataProxy<A, B> setResourceURL(ReposURL resourceURL) {
        url = resourceURL;
        return this;
    }

    public final AbstractRemoteDataProxy<A, B> setFilterQuery(String query) {
        filterQuery = query;
        return this;
    }
    
    public final String getFilterQuery() {
        return filterQuery;
    }

    public final SortInfo getSortInfo() {
        return sortInfo;
    }

    /**
     * Ability to configure the sort query sent to the server to be different
     * to what is applied locally.
     * 
     * @param sortState
     */
    public final void setSortInfo(SortInfo sortState) {
        sortInfo = sortState;
    }
}
