/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui;

import com.extjs.gxt.ui.client.widget.LayoutContainer;
import com.extjs.gxt.ui.client.widget.form.Field;
import com.extjs.gxt.ui.client.widget.layout.ColumnData;
import com.extjs.gxt.ui.client.widget.layout.ColumnLayout;
import com.extjs.gxt.ui.client.widget.layout.FormLayout;
import com.google.gwt.user.client.ui.Widget;



/**
 * This is a helper class that allows you to add multiple fields / widgets to a single row in a Form.
 *
 */
public class MultiFieldPanel extends LayoutContainer {

    /**
     * Create a new MultiFieldPanel.
     */
    public MultiFieldPanel() {
        setBorders(false);
        setAutoHeight(true);
        setAutoWidth(true);
        setStyleAttribute("padding", "0");
        setStyleAttribute("margin", "0");
        setLayout(new ColumnLayout());
    }

    /**
     * Add a Field with the specified width to the row.
     *
     * @param field the field
     * @param width the width to allocate to the field.
     */
    public void addToRow(Field field, int width) {
        LayoutContainer panel = new LayoutContainer();
        panel.setBorders(false);
        //panel.setWidth(width);
        
        FormLayout layout = new FormLayout();
        layout.setPadding(0);
        panel.setLayout(layout);

        panel.add(field);
        
        add(panel, new ColumnData(width));
    }

    /**
     * Add a Field to the row.
     *
     * @param field            the field to add
     * @param layoutData the column layout data
     */
    public void addToRow(Field field, ColumnData layoutData) {
        LayoutContainer panel = new LayoutContainer();
        panel.setBorders(false);
        
        FormLayout layout = new FormLayout();
        layout.setPadding(0);
        panel.setLayout(layout);

        panel.add(field);
        
        add(panel, layoutData != null ? layoutData : new ColumnData(1));
    }

    /**
     * Add a Widget with the specified width to the row.
     *
     * @param field the field to add
     * @param width the field width
     */
    public void addToRow(Widget field, int width) {
        /*LayoutContainer panel = new LayoutContainer();
        panel.setBorders(false);
        
        //panel.setWidth(width);
        panel.add(field);*/
        
        add(field, new ColumnData(width));
    }

    /**
     * Add a Widget to the row.
     *
     * @param field            the field to add
     * @param columnLayoutData the column layout data
     */
    public void addToRow(Widget field, ColumnData layoutData) {
        /*LayoutContainer panel = new LayoutContainer();
        panel.setBorders(false);
        
        panel.add(field);*/
        
        add(field, layoutData != null ? layoutData : new ColumnData(.95));
    }
}
