/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui.creationpanels;

import java.util.ArrayList;
import java.util.List;

import com.extjs.gxt.ui.client.widget.ContentPanel;
import com.iona.soa.web.repository.base.client.model.ReposObj;

public abstract class AbstractReposObjCreationPanel extends ContentPanel {
    
    private List<IValidationListener> validationListeners = new ArrayList<IValidationListener>();

    public abstract boolean validate();
    
    public abstract ReposObj getData();
    
    public abstract int getRequiredWidth();

    public abstract int getRequiredHeight();
    
    public void addValidationListener(IValidationListener aListener) {
        if (aListener != null && !validationListeners.contains(aListener)) {
            validationListeners.add(aListener);
        }
    }
    
    public void removeValidationListener(IValidationListener aListener) {
        if (aListener != null && validationListeners.contains(aListener)) {
            validationListeners.remove(aListener);
        }
    }
}
