/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui.creationpanels;

import com.iona.soa.web.repository.main.client.base.EClassHelper;
import com.iona.soa.web.repository.main.client.base.ui.creationpanels.panels.PropertyPanel;
import com.iona.soa.web.repository.main.client.base.ui.creationpanels.panels.ScheduledTaskPanel;
import com.iona.soa.web.repository.main.client.base.ui.creationpanels.panels.ScheduledTaskPanel.ScheduledTaskDefaults;


public final class CreationPanelRegistry {

    private CreationPanelRegistry() { /* not applicable */ }
    
    public static AbstractReposObjCreationPanel getPanel(String eClass, Object panelDefaults) {
        if (eClass == null || eClass.trim().length() == 0) {
            return null;

        } else if (EClassHelper.PROPERTY_ECLASS.equals(eClass)) {
            return new PropertyPanel(null, null);

        } else if (EClassHelper.SCHEDULED_TASK_ECLASS.equals(eClass)) {
            if (panelDefaults == null) {
                return new ScheduledTaskPanel();
        
            } else {
                return new ScheduledTaskPanel((ScheduledTaskDefaults)panelDefaults);
            }            
        }

        return null;
    }
    
    public static AbstractReposObjCreationPanel getPanel(String eClass) {
        
        return getPanel(eClass, null);
    }



}
