/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui.creationpanels;

import com.iona.soa.web.repository.base.client.model.ReposObj;
import com.iona.soa.web.repository.main.client.MainModule;
import com.iona.soa.web.repository.main.client.base.AbstractUiObjCallBack;
import com.iona.soa.web.repository.main.client.base.EClassHelper;
import com.iona.soa.web.repository.main.client.base.Utils;
import com.iona.soa.web.repository.main.client.base.ui.BaseObjectDialogWindow;

/**
 * A simple example of an 'about' dialog box.
 */
public class ObjectCreationDialog extends BaseObjectDialogWindow {

    public ObjectCreationDialog(String anEClass, AfterCreationCallBack callBack, Object panelDefaults) {
        super(anEClass, callBack, panelDefaults);
    }

    public ObjectCreationDialog(String class1, AfterCreationCallBack afterCreationCallBack) {
        super(class1, afterCreationCallBack);
    }

    protected String getTitleMessage(String objectName) {
        return "Create new " + objectName;
    }

    protected void onOkSelected(AbstractReposObjCreationPanel panel, final AfterCreationCallBack callback) {
        if (panel.validate()) {
            Utils.showWaitDialog();
            
            AbstractUiObjCallBack uiCallback = new AbstractUiObjCallBack() {
                public void processReposObj(ReposObj anObj) {
                    callback.onDialogClosure(anObj);
                    Utils.closeWaitDialog();
                    close();
                }
            };
            
            ReposObj value = panel.getData();
            String collectionUrl = EClassHelper.getCollectionLinkForClass(value.getEClass());
            MainModule.getRemoteClient().createReposObj(collectionUrl,
                                                        value,
                                                        uiCallback);
        }
    }
}
