/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui.creationpanels.panels;

import com.extjs.gxt.ui.client.widget.form.FormPanel;
import com.extjs.gxt.ui.client.widget.form.TextField;
import com.extjs.gxt.ui.client.widget.layout.AnchorData;
import com.extjs.gxt.ui.client.widget.layout.FitLayout;
import com.google.gwt.user.client.ui.Widget;
import com.iona.soa.web.repository.base.client.model.ReposObj;
import com.iona.soa.web.repository.base.client.model.ReposObjAttribute;
import com.iona.soa.web.repository.main.client.base.ui.creationpanels.AbstractReposObjCreationPanel;

public class ConstraintPanel extends AbstractReposObjCreationPanel {

    
    private TextField<String> fieldValue;
    private TextField<String> fieldName;

    public ConstraintPanel() {
        setLayout(new FitLayout());
        setMonitorResize(false);
        
        setHeaderVisible(false);
        setFrame(true);
        
        setStyleAttribute("padding", "5");
        FormPanel fp = new FormPanel();
        
        fp.setHeaderVisible(false);
        fp.setFrame(true);
        fp.setBodyBorder(false);
        fp.setStyleAttribute("padding", "0");
        
        fieldName = new TextField<String>();
        fieldName.setFieldLabel("Name");
        fieldName.setName("name");
        fieldName.setAllowBlank(false);
        fp.add(fieldName, new AnchorData("100%"));
        
        fieldValue = new TextField<String>();
        fieldValue.setFieldLabel("Value");
        fieldValue.setName("value");
        fieldValue.setAllowBlank(false);
        fp.add(fieldValue, new AnchorData("100%"));
        
        add(fp);
    }

    public ReposObj getData() {
        ReposObj data = new ReposObj();

        ReposObjAttribute propNameAttribute = new ReposObjAttribute();
        propNameAttribute.setName("name");
        propNameAttribute.setSimpleValue(fieldName.getValue());
        data.addAttribute(propNameAttribute);

        ReposObjAttribute propValAttribute = new ReposObjAttribute();
        propValAttribute.setName("value");
        propValAttribute.setSimpleValue(fieldValue.getValue());
        data.addAttribute(propValAttribute);

        return data;
    }

    public boolean validate() {
        // TODO Auto-generated method stub
        return false;
    }

    public boolean remove(Widget child) {
        // TODO Auto-generated method stub
        return false;
    }


    public int getRequiredHeight() {
        return 130;
    }

    public int getRequiredWidth() {
        return 300;
    }

}
