/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui.editor;


import com.iona.soa.web.repository.base.client.model.ReposObj;
import com.iona.soa.web.repository.base.client.remote.IObjCallBack;
import com.iona.soa.web.repository.main.client.MainModule;
import com.iona.soa.web.repository.main.client.base.AbstractUiObjCallBack;
import com.iona.soa.web.repository.main.client.base.Utils;
import com.iona.soa.web.repository.main.client.base.ui.BaseObjectDialogWindow;
import com.iona.soa.web.repository.main.client.base.ui.creationpanels.AbstractReposObjCreationPanel;

/**
 * A simple example of an 'about' dialog box.
 */
public class ObjectEditDialog extends BaseObjectDialogWindow {

	public ObjectEditDialog(String anEClass, AfterCreationCallBack callBack,
			Object panelDefaults) {
		super(anEClass, callBack, panelDefaults);
	}
	
	@Override
	protected String getTitleMessage(String objectName) {
		return "Edit " + objectName;
	}
	
    protected void onOkSelected(AbstractReposObjCreationPanel panel,
                                final AfterCreationCallBack callback) {
        if (panel.validate()) {
            Utils.showWaitDialog();
            
            IObjCallBack uiCallback = new AbstractUiObjCallBack() {
                public void processReposObj(ReposObj anObj) {
                    callback.onDialogClosure(anObj);
                    Utils.closeWaitDialog();
                    close();
                }
            };
            
            MainModule.getRemoteClient().updateReposObj(panel.getData(),
                                                        uiCallback);
            
        }
    }
}
