/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.base.ui.editor.widgets;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.Event;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.ClickListenerCollection;
import com.google.gwt.user.client.ui.HasHTML;
import com.google.gwt.user.client.ui.SourcesClickEvents;
import com.google.gwt.user.client.ui.Widget;

public class NoHistoryLink extends Widget implements HasHTML, SourcesClickEvents {

    private Element anchorElem;

    private ClickListenerCollection clickListeners;

    /**
     * Creates an empty NoHistoryLink.
     */
    public NoHistoryLink() {
        setElement(DOM.createDiv());
        anchorElem = DOM.createAnchor();
        DOM.appendChild(getElement(), anchorElem);
        sinkEvents(Event.ONCLICK);
        setStyleName("gwt-Hyperlink");
    }

    public NoHistoryLink(String text) {
        this();
        setText(text);
        DOM.setElementProperty(anchorElem, "href", "#_blank");
    }

    public void addClickListener(ClickListener listener) {
        if (clickListeners == null) {
            clickListeners = new ClickListenerCollection();
        }
        clickListeners.add(listener);
    }

    public String getHTML() {
        return DOM.getInnerHTML(anchorElem);
    }

    public String getText() {
        return DOM.getInnerText(anchorElem);
    }

    public void onBrowserEvent(Event event) {
        if (DOM.eventGetType(event) == Event.ONCLICK) {
            if (clickListeners != null) {
                clickListeners.fireClick(this);
            }
            DOM.eventPreventDefault(event);
        }
    }

    public void removeClickListener(ClickListener listener) {
        if (clickListeners != null) {
            clickListeners.remove(listener);
        }
    }

    public void setHTML(String html) {
        DOM.setInnerHTML(anchorElem, html);
    }

    public void setText(String text) {
        DOM.setInnerText(anchorElem, text);
    }
}
