/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.categories;

import com.extjs.gxt.ui.client.event.Listener;
import com.extjs.gxt.ui.client.event.MessageBoxEvent;
import com.extjs.gxt.ui.client.event.WindowEvent;
import com.extjs.gxt.ui.client.widget.Dialog;
import com.extjs.gxt.ui.client.widget.MessageBox;
import com.iona.soa.web.repository.base.client.model.ReposObj;
import com.iona.soa.web.repository.base.client.model.ReposObjAttribute;
import com.iona.soa.web.repository.base.client.model.ReposObjChangeNotifier;
import com.iona.soa.web.repository.base.client.remote.IObjCallBack;
import com.iona.soa.web.repository.main.client.MainModule;
import com.iona.soa.web.repository.main.client.base.AbstractUiObjCallBack;
import com.iona.soa.web.repository.main.client.base.EClassHelper;

public final class CategoryContextMenuHelper {
    private CategoryContextMenuHelper() {
    }
    
    static void createNewCategory(final String categoryEClass, final IObjCallBack createdCallback) {
    	String title = "Name";
    	String msg = "Please enter the new category name:";
        Listener<WindowEvent> callback = new Listener<WindowEvent>() {
			public void handleEvent(WindowEvent we) {
				if (Dialog.OK.equals(we.buttonClicked.getItemId())) {
		            MessageBoxEvent e = (MessageBoxEvent)we;
		            if (e.value != null && !"".equals(e.value.trim())) {
	                    String url = EClassHelper
								.getCollectionLinkForClass(EClassHelper.CATEGORY_ECLASS);
						ReposObj templateObj = new ReposObj();
						ReposObjAttribute nameAttr = new ReposObjAttribute();
						nameAttr.setName("name");
						nameAttr.setSimpleValue(e.value.trim());
						templateObj.addAttribute(nameAttr);
						ReposObjAttribute eClassAttr = new ReposObjAttribute();
						eClassAttr.setName("eClassName");
						eClassAttr.setSimpleValue(categoryEClass);
						templateObj.addAttribute(eClassAttr);

						MainModule.getRemoteClient().createReposObj(url,
								templateObj, createdCallback);
		            }
				}
			}
        };
    	MessageBox.prompt(title, msg, callback);
    }

    static void renameCategory(final ReposObj category) {
    	String title = "Name";
    	String msg = "Please enter the new category name:";
        Listener<WindowEvent> callback = new Listener<WindowEvent>() {
			public void handleEvent(WindowEvent we) {
				if (Dialog.OK.equals(we.buttonClicked.getItemId())) {
					MessageBoxEvent e = (MessageBoxEvent) we;
					if (e.value != null && !"".equals(e.value.trim())) {
						final String text = e.value.trim();

						final AbstractUiObjCallBack updatedCallback = new AbstractUiObjCallBack() {
							@Override
							public void processReposObj(ReposObj reloadedCategory) {
								// Allow listeners to realize that the category name was updated
								ReposObjChangeNotifier.INSTANCE.reposObjUpdated(reloadedCategory);
							}
						};						
						
						AbstractUiObjCallBack loadedCallback = new AbstractUiObjCallBack() {
							@Override
							public void processReposObj(ReposObj anObj) {
								anObj.getAttribute("name").setSimpleValue(text);
								MainModule.getRemoteClient().updateReposObj(
												anObj, updatedCallback);
							}
						};
						
						MainModule.getRemoteClient().getReposObj(
								category.getSelfLink(),
								loadedCallback);  
		            }
				}
			}
        };
    	MessageBox.prompt(title, msg, callback);
    }
}
