/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.provisioning;

import com.iona.soa.web.repository.main.client.base.EClassHelper;
import com.iona.soa.web.repository.main.client.base.ISubModule;

public class ProvisioningSubModule implements ISubModule {

    public String getURLParamId() {
        return "provisioning";
    }
    
    public String getTitle() {
        return "Provisioning";
    }
 
    public String getImageCs() {
        return "sample-headerSmall";
    }
    
    public String getWelcomePageImagePath() {
        return "images/sampleLogo_small.png";
    }

    public String getApplicationToolTip() {
        return "The Provisioning application allows you to:"
                + "<br><ul><li> - Define applications based on existing artefacts</li>"
                + "<li> - deploy them into a ServiceMix 4 grid</li>"
                + "</ul>";
    }
    
    public String getApplicationIntroPageUrl() {
        return "docs/introPages/fuse-depot-home.html";
    }

    public String[] getTypes() {
        return new String[] {EClassHelper.APPLICATION_ECLASS,
                             EClassHelper.DEPLOYMENT_PROFILE_ECLASS,
                             EClassHelper.CONTAINER_ECLASS,
                             EClassHelper.ARTIFACT_ECLASS};
    }
}
