/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.provisioning.actions;

import com.iona.soa.web.repository.main.client.MainModule;
import com.iona.soa.web.repository.main.client.base.ICollectionPanel;
import com.iona.soa.web.repository.main.client.base.IContextAction;
import com.iona.soa.web.repository.main.client.base.ReposURL;
import com.iona.soa.web.repository.main.client.base.ui.AbstractCreateObjectAction;
import com.iona.soa.web.repository.main.client.provisioning.actions.ResourceCreationDialog.AfterClosureCallBack;

public class UploadArtifactContextAction extends AbstractCreateObjectAction implements IContextAction {

    protected ReposURL contextURL;

    public UploadArtifactContextAction(ReposURL ctxURL, ICollectionPanel contextPanel) {
        super(contextPanel);
        contextURL = ctxURL;
    }
    
    public String getCaption() {
        return "Upload artifact";
    }

    public String getToolTip() {
        return "create a new entry for the 'Artifacts' collection";
    }

    public String getIconCs() {
        return "create-icon";
    }

    public void doIt() {
        
        AfterClosureCallBack callBack = new AfterClosureCallBack() {
            public void onDialogClosure(String createdResourceObjLink) {
                MainModule.get().getWorkspaceControl().openLink(createdResourceObjLink, true);
            }
        };
        
        ResourceCreationDialog dlg = new ResourceCreationDialog(contextURL.getURL(), callBack);

        dlg.show();
        dlg.center();
    }
}
