/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.provisioning.panels;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.extjs.gxt.ui.client.Events;
import com.extjs.gxt.ui.client.XDOM;
import com.extjs.gxt.ui.client.Style.SortDir;
import com.extjs.gxt.ui.client.core.El;
import com.extjs.gxt.ui.client.data.BaseListLoader;
import com.extjs.gxt.ui.client.data.BasePagingLoadConfig;
import com.extjs.gxt.ui.client.data.ListLoadConfig;
import com.extjs.gxt.ui.client.data.ListLoadResult;
import com.extjs.gxt.ui.client.data.ListLoader;
import com.extjs.gxt.ui.client.data.LoadEvent;
import com.extjs.gxt.ui.client.data.Loader;
import com.extjs.gxt.ui.client.data.ModelData;
import com.extjs.gxt.ui.client.event.ButtonEvent;
import com.extjs.gxt.ui.client.event.ComponentEvent;
import com.extjs.gxt.ui.client.event.FieldEvent;
import com.extjs.gxt.ui.client.event.GridEvent;
import com.extjs.gxt.ui.client.event.KeyListener;
import com.extjs.gxt.ui.client.event.Listener;
import com.extjs.gxt.ui.client.event.LoadListener;
import com.extjs.gxt.ui.client.event.TreeEvent;
import com.extjs.gxt.ui.client.store.ListStore;
import com.extjs.gxt.ui.client.store.Store;
import com.extjs.gxt.ui.client.store.StoreEvent;
import com.extjs.gxt.ui.client.store.StoreFilter;
import com.extjs.gxt.ui.client.util.TreeBuilder;
import com.extjs.gxt.ui.client.widget.ComponentHelper;
import com.extjs.gxt.ui.client.widget.ContentPanel;
import com.extjs.gxt.ui.client.widget.LayoutContainer;
import com.extjs.gxt.ui.client.widget.button.Button;
import com.extjs.gxt.ui.client.widget.form.ComboBox;
import com.extjs.gxt.ui.client.widget.form.TextField;
import com.extjs.gxt.ui.client.widget.form.ComboBox.TriggerAction;
import com.extjs.gxt.ui.client.widget.grid.CellEditor;
import com.extjs.gxt.ui.client.widget.grid.ColumnData;
import com.extjs.gxt.ui.client.widget.grid.EditorGrid;
import com.extjs.gxt.ui.client.widget.grid.GridCellRenderer;
import com.extjs.gxt.ui.client.widget.grid.EditorGrid.ClicksToEdit;
import com.extjs.gxt.ui.client.widget.layout.FitData;
import com.extjs.gxt.ui.client.widget.layout.FitLayout;
import com.extjs.gxt.ui.client.widget.layout.RowLayout;
import com.extjs.gxt.ui.client.widget.layout.TableLayout;
import com.extjs.gxt.ui.client.widget.tree.Tree;
import com.extjs.gxt.ui.client.widget.tree.TreeItem;
import com.extjs.gxt.ui.client.widget.tree.Tree.CheckCascade;
import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Element;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.KeyboardListener;
import com.google.gwt.user.client.ui.Widget;
import com.iona.soa.web.repository.base.client.model.ReposObj;
import com.iona.soa.web.repository.base.client.model.ReposObjAttribute;
import com.iona.soa.web.repository.base.client.model.ReposObjCollection;
import com.iona.soa.web.repository.base.client.remote.ICollectionCallBack;
import com.iona.soa.web.repository.base.client.remote.RemoteClient;
import com.iona.soa.web.repository.main.client.HtmlSnippets;
import com.iona.soa.web.repository.main.client.MainModule;
import com.iona.soa.web.repository.main.client.UIMessages;
import com.iona.soa.web.repository.main.client.base.EClassHelper;
import com.iona.soa.web.repository.main.client.base.IFormPart;
import com.iona.soa.web.repository.main.client.base.PaddedPanel;
import com.iona.soa.web.repository.main.client.base.ReposHandle;
import com.iona.soa.web.repository.main.client.base.ReposURL;
import com.iona.soa.web.repository.main.client.base.gxtdatamodels.ReposObjDataModel;
import com.iona.soa.web.repository.main.client.base.gxtdatamodels.ReposObjTreeModel;
import com.iona.soa.web.repository.main.client.base.ui.ActionColumnConfig;
import com.iona.soa.web.repository.main.client.base.ui.MultiFieldPanel;
import com.iona.soa.web.repository.main.client.base.ui.RemoteCollectionPanel;
import com.iona.soa.web.repository.main.client.base.ui.RemoteRestDataProxy;
import com.iona.soa.web.repository.main.client.base.ui.RemoteRestListDataProxy;
import com.iona.soa.web.repository.main.client.base.ui.SimpleGridConfigurator;
import com.iona.soa.web.repository.main.client.base.ui.ActionColumnConfig.ActionColumnCallback;

public class MavenRepoSearchAndResultsPanel extends LayoutContainer implements IFormPart {
    
    public static final String RSC_ATTR_DEPENDS_IDS = "dependsIDs";

    private static final HtmlSnippets SNIPPETS = GWT.create(HtmlSnippets.class);

    private static final UIMessages MESSAGES = GWT.create(UIMessages.class);
    
    private SearchPanel searchPanel;
    
    private RemoteCollectionPanel resultsPanel;
    
    private EditorGrid<ReposObjDataModel> bucketPanel;
    
    private SimpleGridConfigurator bucketGridConfig;
    
    private RemoteRestDataProxy searchProxy;
    
    private int resolvesInProgress;

    private final AddArtifactsCallback addCallback;
    
    private final ArtifactBucket artifactBucket = new ArtifactBucketImpl();
    
    
    /**
     * Note that we use the id of the attribute in returned ReposObj objects
     * as the column id.
     */
    private static final class ResultsColumnIds {
        private static final String ARTIFACT_ID = "name";
        private static final String GROUP_ID = "namespace";
        private static final String VERSION = "version";
        private static final String TYPE = "type";
        private static final String FOUND_IN = "foundIn";
        private static final String ADD = "add";
        private ResultsColumnIds() { }
    }

    private static final class BucketColumnIds {
        private static final String ARTIFACT_ID = "name";
        private static final String DEPENDENCIES = "dependencies";
        //private static final String REMOVE = "remove";
        private static final String RESOLVING_DEPENDENCIES = "resolvingDependencies";
        private static final String RESOLVE_ERROR = "resolveError"; // used as a field/attr id
        
        private BucketColumnIds() { }
    }
    
    public MavenRepoSearchAndResultsPanel(AddArtifactsCallback addCallback) {
        this.addCallback = addCallback;
        setBorders(false);
        
        addStyleName("arr-artifact-search-panel");

        setLayout(new RowLayout());
        // Widgets creates from bottom to top, as data driven from top down so 
        // top references widgets below.
        createBucketPanel();
        
        createSearchProxy();
        
        final ListStore<ReposObjDataModel> artifactTypesStore = createArtifactTypesStore();

        createResultsPanel(artifactTypesStore, addCallback);
        
        createSearchPanel(addCallback);
        
        LayoutContainer actionsPanel = createActionsPanel(addCallback);
        
        Button uploadFileBtn = new Button(MESSAGES.uploadFile());
        uploadFileBtn.addStyleName("arr-upload-file-btn");
        uploadFileBtn.disable();
        
        add(uploadFileBtn); // displayed inline and floated right
        add(new PaddedPanel(searchPanel, 12));
        
        ContentPanel resultsPanelWrapper = new ContentPanel(new FitLayout());
        resultsPanelWrapper.setBorders(true);
        resultsPanelWrapper.setHeaderVisible(false);
        resultsPanelWrapper.add(resultsPanel, new FitData(0));
        resultsPanelWrapper.setHeight(230);
        add(new PaddedPanel(resultsPanelWrapper, 12)); // t, l, r, b
        
        ContentPanel bucketPanelWrapper = new ContentPanel(new FitLayout());
        bucketPanelWrapper.setBorders(true);
        bucketPanelWrapper.setHeaderVisible(true);
        bucketPanelWrapper.getHeader().setText("Selected Artifacts");
        bucketPanelWrapper.add(bucketPanel, new FitData(0));
        bucketPanelWrapper.setHeight(180);
        add(new PaddedPanel(bucketPanelWrapper, 12)); 
        add(actionsPanel);
        
        addListener(Events.Render, new Listener<ComponentEvent>() {
                public void handleEvent(ComponentEvent be) {
                    artifactTypesStore.getLoader().load();
                }
            });
        
        DeferredCommand.addCommand(new Command() {
            public void execute() {
                searchPanel.queryField.focus();
            }
        });
    }

    // IFormPart implementation
    public boolean isDirty() {
        return !artifactBucket.isEmpty();
    }

    // IFormPart implementation
    public void commit() {
        // Do nothing - we commit to the input being edited via our
        // "Add artifacts" button in the actions panel.
    }

    // IFormPart implementation
    public void refresh() {
        // Do nothing - we don't take any state from the input being edited.
    }

    public void setFormInput(Object input) {
        // Do nothing - we don't take any state from the input being edited.
    }
    
    final TextField<String> getQueryField() {
        return searchPanel.queryField;
    }
    
    final ComboBox<ReposObjDataModel> getTargetRepositoryField() {
        return searchPanel.targetField;
    }
    
    final void runSearch() {
        searchPanel.runSearch();
    }
    
    final EditorGrid<ReposObjDataModel> getResultsPanel() {
        return resultsPanel.getGrid();
    }
    
    private void createBucketPanel() {
        // First create the destination bucket
        bucketGridConfig = new BucketGridConfig(artifactBucket, new Listener<TreeEvent>() {
            public void handleEvent(TreeEvent te) {
                filterResultsPanel();
            }
        });
        
        bucketPanel = new EditorGrid<ReposObjDataModel>(null, null);
        bucketGridConfig.configure(bucketPanel, null);
        //bucketPanel.getView().refresh(true); // empty
    }

    private void createResultsPanel(ListStore<ReposObjDataModel> artifactTypesStore,
                                    AddArtifactsCallback aCallback) {
        
        EditorGrid<ReposObjDataModel> grid = new EditorGrid<ReposObjDataModel>(null, null);
        ResultsPanelGridConfig resultsPanelConfig = new ResultsPanelGridConfig(artifactTypesStore,
                                                                               artifactBucket,
                                                                               aCallback);
        resultsPanelConfig.configure(grid, searchProxy);

        resultsPanel = new RemoteCollectionPanel(resultsPanelConfig, searchProxy) {
            @Override
            protected void doFirstLoad() {
                // do nothing - the user triggers loads via hitting the search button
            }
            @Override
            protected void attachStoreAndGridSynchronizer() {
                // do nothing
            }            
        };
        resultsPanel.getStore().getLoader().addLoadListener(new LoadListener() {
            @Override
            public void loaderLoad(LoadEvent le) {
                filterResultsPanel();
            }
        });
        
        resultsPanelConfig.attachPagingToolbar(grid, 
                                               resultsPanel,
                                               EClassHelper.ARTIFACT_ECLASS,
                                               10); // TODO page size
    }
    
    private void createSearchPanel(AddArtifactsCallback aCallback) {
        // Finally the search panel
        SearchHandler handler = new SearchHandler() {
            public void runSearch(String query, String targetRepoGuid) {
                if (targetRepoGuid != null) {
                    query = query + "&_repos=" + targetRepoGuid;
                }
                searchProxy.setFilterQuery(query);

                // don't do this when grouping by found in
                //resultsPanel.getGrid().getColumnModel().setHidden(ResultsColumnIds.FOUND_IN,
                //                                                  targetRepoGuid != null);
                resultsPanel.getStore().getLoader().load(new BasePagingLoadConfig(0, 10)); // TODO, paging nb
            }            
        };
        
        searchPanel = new SearchPanel(handler);
        searchPanel.addManageReposClickListener(aCallback);
    }
    
    private void createSearchProxy() {
        searchProxy = new RemoteRestDataProxy(MainModule.getRemoteClient());
        String mavenSearchUrl = ReposHandle.INSTANCE.getServerBaseUrl();
        mavenSearchUrl = mavenSearchUrl.endsWith("/") 
            ? mavenSearchUrl + "mavenreposearch"
                    : mavenSearchUrl + "/" + "mavenreposearch";
        searchProxy.setResourceURL(new ReposURL(mavenSearchUrl));
    }

    private LayoutContainer createActionsPanel(final AddArtifactsCallback aCallback) {
        LayoutContainer p = new LayoutContainer();
        p.addStyleName("arr-editor-actions-panel");
        p.setBorders(false);
        p.setLayout(new TableLayout(2));
        
        HTML cancelLink = new HTML(SNIPPETS.anchorTagWithCssCls("Cancel",
                                                                "arr-action-link arr-cancel-action-link"));
        cancelLink.addClickListener(new ClickListener() {
            public void onClick(Widget sender) {
                aCallback.cancel();
            }
        });
        
        final Button addBtn = new Button("Add artifacts"); // TODO get label from addCallback
        addBtn.addListener(Events.Select, new Listener<ButtonEvent>() {
            public void handleEvent(ButtonEvent be) {
                aCallback.add(artifactBucket.getArtifacts());
            }
        });
        addBtn.setEnabled(!artifactBucket.isEmpty());
        p.add(addBtn);
        p.add(cancelLink);
        
        bucketPanel.getStore().addListener(Store.Add, new Listener<StoreEvent<ReposObjDataModel>>() {
            public void handleEvent(StoreEvent<ReposObjDataModel> be) {
                addBtn.setEnabled(resolvesInProgress == 0 && be.store.getModels().size() > 0);
            }
        });

        bucketPanel.getStore().addListener(Store.Remove, new Listener<StoreEvent<ReposObjDataModel>>() {
            public void handleEvent(StoreEvent<ReposObjDataModel> be) {
                addBtn.setEnabled(resolvesInProgress == 0 && be.store.getModels().size() > 0);
            }
        });

        bucketPanel.getStore().addListener(Store.Update, new Listener<StoreEvent<ReposObjDataModel>>() {
            public void handleEvent(StoreEvent<ReposObjDataModel> be) {
                addBtn.setEnabled(resolvesInProgress == 0 && be.store.getModels().size() > 0);
            }
        });

        return p;
    }
    
    private ListStore<ReposObjDataModel> createArtifactTypesStore() {
        RemoteRestListDataProxy dataProxy = RemoteRestListDataProxy.createProxyForEClass(EClassHelper.ARTIFACT_TYPE_ECLASS);
        ListLoader<ListLoadConfig> loader =
            new BaseListLoader<ListLoadConfig, ListLoadResult<ReposObjDataModel>>(dataProxy);
        return new ListStore<ReposObjDataModel>(loader);
    }

    private void filterResultsPanel() {
        
        if (resultsPanel.getStore().getFilters() != null) {
            for (StoreFilter<?> filter: resultsPanel.getStore().getFilters()){
               if (filter instanceof AlreadyInBucketFilter) {
                   AlreadyInBucketFilter bucketFilter = (AlreadyInBucketFilter)filter;
                   bucketFilter.fillArtifactList();
               }
            }
        } else {
            resultsPanel.getStore().addFilter(new AlreadyInBucketFilter());  
        }
        resultsPanel.getStore().applyFilters("name");
    }
    
    private final class AlreadyInBucketFilter implements StoreFilter<ReposObjDataModel> {
        private final List<String> artifactNames = new ArrayList<String>();
        
        AlreadyInBucketFilter() {
            // Get the artifacts from the bucket once per store filter.
            // Need to use names as ReposObj in results and in dependencies
            // will be different, but matches will have same names
            fillArtifactList();
        }

        public void fillArtifactList(){
            artifactNames.clear();
            List<ReposObj>artifacts = artifactBucket.getArtifacts();
            for (ReposObj artifact : artifacts) {
                artifactNames.add(artifact.getAttributeValue("name"));
            }
        }
        public boolean select(Store store,
                              ReposObjDataModel parent,
                              ReposObjDataModel item,
                              String property) {
            return !artifactNames.contains(item.getPOJO().getAttributeValue("name"));
        }
    };
    
    
    private final class ArtifactBucketImpl implements ArtifactBucket {
        public void add(ReposObj artifact) {
            if (!addCallback.alreadyInUse(artifact)) {
                resolvesInProgress++;
                artifact.setUserValue(BucketColumnIds.RESOLVING_DEPENDENCIES, Boolean.TRUE);
                bucketPanel.getStore().add(new ReposObjDataModel(artifact));
                
                filterResultsPanel();
                
                resolveDependencies(artifact);
            }
        }
        
        public void remove(ReposObj artifact) {
            ReposObjDataModel toRemove =
                bucketPanel.getStore().findModel(ReposObjDataModel.FIELD_EDIT_LINK, artifact.getEditLink());
            artifact.clearUserValues();
            toRemove.getPOJO().clearUserValues();

            bucketPanel.getStore().remove(toRemove);

            filterResultsPanel();
        }

        public List<ReposObj> getArtifacts() {
            final List<ReposObj> artifacts = new ArrayList<ReposObj>();
            
            for (ReposObjDataModel rcd : bucketPanel.getStore().getModels()) {
                ReposObj artifact = rcd.getPOJO();                    
                artifacts.add(artifact);
                List<ReposObj> deps = (List<ReposObj>)artifact.getUserValue("completeDepList");
                if (deps != null) {
                    for (ReposObj dep : deps) {
                        if (Boolean.TRUE.equals(dep.getUserValue("checked"))
                                && !dep.getId().equals(artifact.getId())) {
                            artifacts.add(dep);
                        }
                    }
                }
            }
            
            
            return artifacts;
        }

        public boolean isEmpty() {
            return bucketPanel.getStore().getCount() == 0;
        }
        
        private void resolveDependencies(final ReposObj artifact) {
            // Records contain static copies to data in a ReposObj.
            ICollectionCallBack resolvedCallback = new ICollectionCallBack() {
                public void processReposObjCollection(ReposObjCollection dependenciesCol) {
                    List<ReposObj> deps = dependenciesCol.getTheReposObjs();
                    
                    if (deps == null || deps.isEmpty()) {
                        artifact.setUserValue(BucketColumnIds.DEPENDENCIES, (Object)null);
                        finished(getRecord(artifact));
                    } else {
                        ReposObj resolvedArtifact = buildArtifactTreeDataStructure(artifact, deps);
                        resolvedArtifact.setUserValue("completeDepList", deps);
                        
                        ReposObjDataModel basketRcd = getRecord(artifact);
                        basketRcd.set(ReposObjDataModel.FIELD_POJO, resolvedArtifact);
                        /*bucketPanel.getStore().remove(basketRcd);
                        
                        ReposObjToRecordMapper recordMapper = (ReposObjToRecordMapper)bucketGridConfig;
                        Object[] rcdData = recordMapper.createRecordData(resolvedArtifact);
                        Record artifactRecord = recordMapper.getRecordDef().createRecord(rcdData);
                        bucketPanel.getStore().add(artifactRecord);
                        */
                        finished(basketRcd);
                    }
                    
                }

                public void processConnectionError(Throwable e) {
                    artifact.setUserValue(BucketColumnIds.RESOLVE_ERROR, e.getMessage());
                    finished(getRecord(artifact));
                }

                public void processResponseError(String anErrorCode, String anErrorMsg) {
                    artifact.setUserValue(BucketColumnIds.RESOLVE_ERROR, anErrorMsg);
                    finished(getRecord(artifact));
                }
                
                private void finished(ReposObjDataModel model) {
                    resolvesInProgress--;
                    
                    ReposObj resolvedArtifact = model.getPOJO();
                    resolvedArtifact.setUserValue(BucketColumnIds.RESOLVING_DEPENDENCIES, Boolean.FALSE);
                    
                    bucketPanel.getStore().update(model);
                    bucketPanel.getStore().getRecord(model).setDirty(true);
                    bucketPanel.getView().refresh(false);
                    
                    filterResultsPanel();
                }
            };
            
            final RemoteClient client = MainModule.getRemoteClient();
            client.resolveMavenDependencies(ReposHandle.INSTANCE.getServerBaseUrl(), 
                                            artifact, 
                                            resolvedCallback);
        }

        private ReposObjDataModel getRecord(ReposObj artifact) {
            return bucketPanel.getStore().findModel(ReposObjDataModel.FIELD_SELF_LINK,
                                                    artifact.getSelfLink());
        }

        private ReposObj buildArtifactTreeDataStructure(final ReposObj artifact, List<ReposObj> deps) {
            Map<String, ReposObj> depsMap = new HashMap<String, ReposObj>(deps.size());
            for (ReposObj dep : deps) {
                if (dep.getUserValue("checked") == null){
                    dep.setUserValue("checked", true);
                }
                depsMap.put(dep.getId(), dep);
            }
            
            ReposObj topDep = depsMap.get(artifact.getId());
            
            for (ReposObj node : deps) {
                
                if (node.getAttribute("depRoot") != null) {
                    topDep = node;
                }

                ReposObjAttribute depsIdsAttr = node.getAttribute(RSC_ATTR_DEPENDS_IDS);
                if (depsIdsAttr != null && depsIdsAttr.getValues().length > 0) {
                    List<ReposObj> nodeDeps =
                        new ArrayList<ReposObj>(depsIdsAttr.getValues().length);
                    for (String depId : depsIdsAttr.getValues()) {
                        ReposObj nodeDep = depsMap.get(depId);
                        if (nodeDep != null) {
                            nodeDeps.add(nodeDep);    
                        }
                    }
                    node.setUserValue(BucketColumnIds.DEPENDENCIES, nodeDeps);
                }
                
            }
            
            /*if (artifact.getAttribute(RSC_ATTR_DEPENDS_IDS) == null) {
                ReposObjAttribute attr = new ReposObjAttribute();
                attr.setName(RSC_ATTR_DEPENDS_IDS);
                attr.setCollection(false);
                attr.setReference(true);
                attr.setMulti(true);
                artifact.addAttribute(attr);
            }*/
            
            return topDep;            
        }
    }
    
    // TODO - Move to ReposObjHelper ?
    private static boolean isPersistedArtifact(ReposObj artifact) {
        return artifact.getAttributeValue("guid") != null;            
    }

    /**
     * Observers are notified via this interface when the user 
     * selects "Add" for an artifact in the results panel.
     */
    public static interface AddArtifactsCallback {
        void add(List<ReposObj> artifacts);
        void cancel();
        boolean alreadyInUse(ReposObj artifact);
    }
    
    private static interface ArtifactBucket {
        void add(ReposObj artifact);
        void remove(ReposObj artifact);
        List<ReposObj> getArtifacts();
        boolean isEmpty();
    }
    
    private static interface SearchHandler {
        void runSearch(String query, String targetRepoGuid);
    }
    
    private static final class SearchPanel extends LayoutContainer {
        private static final class ArtifactFieldIds {
            private static final String NAME = ReposObjDataModel.FIELD_CAPTION;
            private static final String GUID = "guid";
            private static final String INDEX_STATE = "indexState";
            private ArtifactFieldIds() { }
        }
        
        private final TextField<String> queryField;
        private final ComboBox<ReposObjDataModel> targetField;
        private final SearchHandler searchHandler;
        private final HTML messageLabel;
        private final HTML manageReposLink;
        
        SearchPanel(SearchHandler handler) {
//            setLayout(new RowLayout());
            setAutoHeight(true);
            setBorders(false);
            searchHandler = handler;
            queryField = createQueryField();
            targetField = createTargetField();
            
            final Button searchBtn = new Button("Search");
            searchBtn.setEnabled(false);
            
            searchBtn.addListener(Events.Select, new Listener<ButtonEvent>() {
                public void handleEvent(ButtonEvent be) {
                    runSearch();
                }
            });
            queryField.addKeyListener(new KeyListener() {
                @Override
                public void componentKeyUp(ComponentEvent ce) {
                    String val = queryField.getValue();
                    if (val == null || "".equals(val)) {
                        searchBtn.setEnabled(false);
                    } else {
                        searchBtn.setEnabled(true);
                        if (ce.getKeyCode() == KeyboardListener.KEY_ENTER) {
                            runSearch();
                        }
                    }
                }
            });

            String manageLabel = MESSAGES.manageRepositories();
            manageReposLink =
                new HTML(SNIPPETS.anchorTagWithCssCls(manageLabel, 
                                                      "arr-action-link vertical-align-middle"));
            messageLabel = new HTML();
            
            /*final ContentPanel holder = new ContentPanel();
            holder.setBorders(false);
            holder.setAutoWidth(true);
            holder.setAutoHeight(true);*/

            
            MultiFieldPanel row1 = new MultiFieldPanel();
            row1.setBorders(false);
            row1.setStyleAttribute("paddingLeft", "12px");
            row1.addToRow(queryField, 320);
            row1.addToRow(searchBtn, new com.extjs.gxt.ui.client.widget.layout.ColumnData(-1));
            String searchTipUrl = "&nbsp;<a class='arr-action-link vertical-align-middle' " 
                + " target='_blank' href='" 
                + "/org.eclipse.help.webapp/index.jsp?topic=/guide/UGRepoProvSearchTips.html"
                + "'>Search Tips"
                + "</a>";
            row1.addToRow(new HTML(searchTipUrl), 
                          new com.extjs.gxt.ui.client.widget.layout.ColumnData(-1));
            //holder.add(row1);
            
            MultiFieldPanel row2 = new MultiFieldPanel();
            row2.setBorders(false);
            row2.setStyleAttribute("paddingLeft", "12px");
            row2.addToRow(targetField, 320);
            row2.addToRow(manageReposLink, new com.extjs.gxt.ui.client.widget.layout.ColumnData(-1));
            //holder.add(row2);
            
//            add(row1, new RowData(1 , 25, new Margins(0)));
//            add(row2, new RowData(1 , 25, new Margins(0)));
//            add(messageLabel, new RowData(1 , 25, new Margins(0)));
            add(row1);
            add(row2);
            add(messageLabel);
        }
        
        void addManageReposClickListener(final AddArtifactsCallback addCallback) {
            manageReposLink.addClickListener(new ClickListener() {
                public void onClick(Widget sender) {
                    addCallback.cancel();
                    String mavenURL = EClassHelper.getCollectionLinkForClass(EClassHelper.MAVENREPO_ECLASS);
                    MainModule.get().getWorkspaceControl().openLink(mavenURL, true);
                }
            });   
        }
        
        void setRepositoriesIndexed(boolean anyIndexed) {
            if (anyIndexed) {
                //messageLabel.addStyleName("x-hidden");
                messageLabel.setVisible(false);
            } else {
                // TODO - hoping to be able to make "repositories" a link
                String content = SNIPPETS.imageTag("images/icon-warning.gif", "Warning") 
                    + MESSAGES.noIndexedRepositoriesAvailable("repositories");
                messageLabel.setHTML(SNIPPETS.tagWithCssCls("div", 
                                                            content, 
                                                            "arr-no-indexed-repos-msg"));
                //messageLabel.removeStyleName("x-hidden");
                messageLabel.setVisible(true);
            }
        }

        void runSearch() {
            String targetRepoGuid = null;
            if (targetField.getSelection().size() == 1) {
                targetRepoGuid = targetField.getSelection().get(0).get(ArtifactFieldIds.GUID);
            } 
            
            searchHandler.runSearch(queryField.getValue(), targetRepoGuid);
        }
        
        private TextField<String> createQueryField() {
            final TextField<String> queryField = new TextField<String>();
            
            queryField.setFieldLabel("Find artifacts");
            queryField.setEmptyText("Enter query");
            return queryField;
        }
        
        private ComboBox<ReposObjDataModel> createTargetField() {
            final ComboBox<ReposObjDataModel> targetsField = new ComboBox<ReposObjDataModel>();
            
            targetsField.setForceSelection(true);
            targetsField.setEditable(false);
            targetsField.setFieldLabel("Where");
            targetsField.setDisplayField(ArtifactFieldIds.NAME);
            targetsField.setTriggerAction(TriggerAction.ALL);
            targetsField.setLoadingText("Loading search targets...");
            targetsField.setTypeAhead(true);
            targetsField.setSelectOnFocus(true);
            
            RemoteRestListDataProxy dataProxy = RemoteRestListDataProxy.createProxyForEClass(EClassHelper.MAVENREPO_ECLASS);
            ListLoader<ListLoadConfig> loader =
                new BaseListLoader<ListLoadConfig, ListLoadResult<ReposObjDataModel>>(dataProxy) {
                    @Override
                    protected void onLoadSuccess(ListLoadConfig loadConfig, ListLoadResult<ReposObjDataModel> data) {
                        boolean hasIndexedRepos = false;
                        for (Iterator<ReposObjDataModel> iter = data.getData().iterator(); iter.hasNext();) {
                            ReposObjDataModel rcd = iter.next();
                            if ("READY".equals(rcd.get(ArtifactFieldIds.INDEX_STATE))) {
                                hasIndexedRepos = true;
                            } else {
                                iter.remove();
                            }
                        }
                        setRepositoriesIndexed(hasIndexedRepos);
                        
                        // Insert special record
                        ReposObjDataModel specialRcd = new ReposObjDataModel(null);
                        specialRcd.set(ArtifactFieldIds.NAME, "Entire Depot");
                        specialRcd.set(ArtifactFieldIds.INDEX_STATE, "READY");
                        data.getData().add(0, specialRcd);
                        
                        super.onLoadSuccess(loadConfig, data);
                    }
                
            };
            
            ListStore<ReposObjDataModel> targetsStore = new ListStore<ReposObjDataModel>(loader);
            targetsField.setStore(targetsStore);
            targetsField.getView().disableEvents(true);

            targetsField.addListener(Events.Render, new Listener<ComponentEvent>() {
                public void handleEvent(ComponentEvent be) {
                    targetsField.doQuery("", true);
                }
            });

            targetsStore.getLoader().addListener(Loader.Load, new Listener<LoadEvent<?, ?>>() {
                public void handleEvent(LoadEvent<?, ?> be) {
                    List<ReposObjDataModel> selection = new ArrayList<ReposObjDataModel>(1);
                    selection.add(targetsField.getStore().getAt(0));
                    targetsField.setSelection(selection);
                }
            });

            return targetsField;
        }
    }
    
    private static final class ResultsPanelGridConfig extends SimpleGridConfigurator {
        
        private final ListStore<ReposObjDataModel> artifactTypesStore;
        private final ArtifactBucket artifactBucket;
        private final AddArtifactsCallback addCallback;
        
        ResultsPanelGridConfig(ListStore<ReposObjDataModel> artifactTypesStore,
                               ArtifactBucket artifactBucket,
                               AddArtifactsCallback addCallback) {
            this.artifactTypesStore = artifactTypesStore;
            this.artifactBucket = artifactBucket;
            this.addCallback = addCallback;
        }
        
        @Override
        public void configure(EditorGrid<ReposObjDataModel> grid, RemoteRestDataProxy dataProxy) {
            
            //setGroupingField(ResultsColumnIds.GROUP_ID);
            setSortInfo(ResultsColumnIds.ARTIFACT_ID, SortDir.ASC);
            super.configure(grid, dataProxy);
            
            //grid.setTitle("Search Results");
            grid.setAutoHeight(false);
            grid.setHeight(280);  // 10 rows? 
            
            
            grid.setAutoExpandColumn(ResultsColumnIds.FOUND_IN);
            grid.setBorders(true);
            grid.setTrackMouseOver(false);
                        
            if (grid instanceof EditorGrid) {
                EditorGrid<ReposObjDataModel> editorGrid = getGrid();
                editorGrid.setClicksToEdit(ClicksToEdit.ONE);

                EditListener listener = new EditListener(artifactTypesStore);
                editorGrid.addListener(Events.BeforeEdit, listener);
                editorGrid.addListener(Events.AfterEdit, listener);
            }
            
            grid.addListener(Events.RowDoubleClick, new Listener<GridEvent>() {
                public void handleEvent(GridEvent be) {
                    artifactBucket.add(((ReposObjDataModel)be.grid.getSelectionModel().getSelectedItem()).getPOJO());
                }
            });
            
//            GroupingView view = new GroupingView();
//            view.setHideGroupedColumn(true);
//            grid.setView(view);
        }

        @Override
        protected void addVisibleColumns() {
            SimpleColumnConfig nameColumn = new AttributeColumnConfig(ResultsColumnIds.ARTIFACT_ID,
                                                                      "Artifact Id",
                                                                      200);            
            SimpleColumnConfig groupIdColumn = new AttributeColumnConfig(ResultsColumnIds.GROUP_ID,
                                                                         "Group Id",
                                                                         120);
            SimpleColumnConfig typeColumn = createArtifactTypeColumn();
            
            nameColumn.setRenderer(new ArtifactNameColumnRenderer());
            //groupIdColumn.setHidden(true);
            typeColumn.setHidden(true);
            
            
            columns.add(nameColumn);
            columns.add(new AttributeColumnConfig(ResultsColumnIds.VERSION, "Version", 80));
            columns.add(groupIdColumn); // NOT- Initially grouped by this column
            columns.add(createFoundInColumn()); 
            columns.add(typeColumn);
            columns.add(new AddToBucketColumn(getGrid(), artifactBucket, addCallback));            
        }
        
        private SimpleColumnConfig createFoundInColumn() {
            SimpleColumnConfig foundInColumn = new SimpleColumnConfig(ResultsColumnIds.FOUND_IN, 
                                                                          "Found in", 
                                                                          160) {
                @Override
                public Object getCellData(ReposObj artifact) {
                    ReposObjAttribute foundIn = artifact.getAttribute(getId()); 
                    if (foundIn != null && foundIn.getValue() != null) {
                        return foundIn.getValueCaption(foundIn.getValue());
                    }
                    return null;
                }
            };
            
            return foundInColumn;
        }
        
        private SimpleColumnConfig createArtifactTypeColumn() {
            final AttributeColumnConfig typeColumn = new AttributeColumnConfig(ResultsColumnIds.TYPE, 
                                                                               "Type", 
                                                                               80);
            typeColumn.setRenderer(new ArtifactTypeColumnRenderer());
            
            ComboBox<ReposObjDataModel> cb = new ComboBox<ReposObjDataModel>();
            cb.setAllowBlank(false);
            cb.setEditable(false);
            cb.setForceSelection(true);
            cb.setHideLabel(true);
            cb.setDisplayField("name");
            //cb.setlMode(ComboBox.LOCAL);
            cb.setTriggerAction(TriggerAction.ALL);
            cb.setLoadingText("Loading types...");
            cb.setTypeAhead(true);
            cb.setSelectOnFocus(true);
            cb.setStore(artifactTypesStore);

            cb.addListener(Events.Show, new Listener<ComponentEvent>() {

                public void handleEvent(final ComponentEvent be) {
                    DeferredCommand.addCommand(new Command() {
                        public void execute() {
                            ((ComboBox<ReposObjDataModel>)be.component).expand();
                        }
                    });
                }
            });

            cb.addListener(Events.Select, new Listener<FieldEvent>() {
                public void handleEvent(FieldEvent be) {
                    DeferredCommand.addCommand(new Command() {
                        public void execute() {
                            ((EditorGrid)getGrid()).stopEditing();
                        }
                    });
                }
            });
            
            typeColumn.setEditor(new CellEditor(cb));
            return typeColumn;
        }
    }

    // Used to move artifacts from the results panel to the bucket panel
    //
    private static final class AddToBucketColumn extends ActionColumnConfig<ReposObjDataModel> {
        private final ArtifactBucket artifactBucket;
        
        private final AddArtifactsCallback addCallback;
        
        AddToBucketColumn(EditorGrid<ReposObjDataModel> grid,
                          ArtifactBucket artifactBucket,
                          AddArtifactsCallback addCallback) {
            super(grid, ResultsColumnIds.ADD);
            this.artifactBucket = artifactBucket;
            this.addCallback = addCallback;
            setActionLabel("Select");
            setWidth(60);         
            setActionCallback(new AddToBucketActionCallback());
        }
        
        @Override
        protected String getActionLabel(ReposObjDataModel record) {
            return addCallback.alreadyInUse(record.getPOJO()) 
                ? null : super.getActionLabel(record);
        }
        
        private class AddToBucketActionCallback implements ActionColumnCallback<ReposObjDataModel> {
            public void actionClicked(final ReposObjDataModel record, Element anchorElement) {
                artifactBucket.add(record.getPOJO());
            }
        }
    }

    private static final class ArtifactTypeColumnRenderer implements GridCellRenderer<ReposObjDataModel> {
        
        public String render(ReposObjDataModel model,
                             String property,
                             ColumnData config,
                             int rowIndex,
                             int colIndex,
                             ListStore<ReposObjDataModel> store) {
            
            config.cellAttr = "title=\"Type is required during deployment\"";
            ReposObj artifact = model.getPOJO();
            ReposObjAttribute typeAttr = artifact.getAttribute(ResultsColumnIds.TYPE);
            
            // Don't offer opportunity to change the type for persisted artifacts, 
            // otherwise we'll have to save them also. Wrong?
            if (isPersistedArtifact(artifact)) {
                return (typeAttr == null || typeAttr.getValue() == null)
                    ? "Not specified"
                            : typeAttr.getValueCaption(typeAttr.getValue());
            } else {
                return (typeAttr == null || typeAttr.getValue() == null)
                    ? SNIPPETS.anchorTagWithCssCls("Specify type", "arr-action-link") 
                            : typeAttr.getValueCaption(typeAttr.getValue());
            }
        }
    }
    
    private static final class ArtifactNameColumnRenderer implements GridCellRenderer<ReposObjDataModel> {
        
        public String render(ReposObjDataModel model,
                             String property,
                             ColumnData config,
                             int rowIndex,
                             int colIndex,
                             ListStore<ReposObjDataModel> store) {
            String tooltip = model.get(ResultsColumnIds.GROUP_ID);
            config.cellAttr = "title=\"Group Id: " + tooltip + "\"";
            return model.get(ResultsColumnIds.ARTIFACT_ID);
        }
    }
    
    private static final class EditListener implements Listener<GridEvent> {
        private final Store artifactTypesStore;
        
        EditListener(Store artifactTypesStore) {
            this.artifactTypesStore = artifactTypesStore;
        }
        
        public void handleEvent(GridEvent ge) {
            
            if (Events.BeforeEdit == ge.getEventType()) {
                ge.doit = doBeforeEdit(ge); 
            
            } else if (Events.AfterEdit == ge.getEventType()) {
                onAfterEdit(ge);
            }
        };

        public boolean doBeforeEdit(GridEvent ge) {
            if (ResultsColumnIds.TYPE.equals(ge.property)) {
                // Don't offer opportunity to change the type for persisted artifacts, 
                // otherwise we'll have to save them also. Wrong?
                return !isPersistedArtifact(((ReposObjDataModel)ge.model).getPOJO());
            }
            return false;
        }

        public void onAfterEdit(GridEvent ge) {
            if (ResultsColumnIds.TYPE.equals(ge.property)) {
                String artifactTypeName = (String)ge.value;
                ModelData idx = artifactTypesStore.findModel(ResultsColumnIds.ARTIFACT_ID, artifactTypeName);
                if (idx != null) {
                    ReposObj artifactType = ((ReposObjDataModel)idx).getPOJO();
                    ReposObj artifact = ((ReposObjDataModel)ge.model).getPOJO();
                    artifact.getAttribute(ResultsColumnIds.TYPE).setRefValue(artifactType);
                    
                    ge.grid.getStore().rejectChanges();
                    ge.grid.getView().refresh(false);
                }
            }
        }
    }

    private static final class BucketGridConfig extends SimpleGridConfigurator {
        private final ArtifactBucket artifactBucket;
        
        private final GridCellRenderer<ReposObjDataModel> dependencyColumnRenderer;
        
        BucketGridConfig(ArtifactBucket artifactBucket, 
                         Listener<TreeEvent> dependencyTreeListener) {
            this.artifactBucket = artifactBucket;
            dependencyColumnRenderer = new DependenciesRenderer(dependencyTreeListener);
        }
        
        @Override
        protected void addVisibleColumns() {
            SimpleColumnConfig nameColumn = new AttributeColumnConfig(BucketColumnIds.ARTIFACT_ID,
                                                                        "Artifact Id",
                                                                        200);
            nameColumn.setRenderer(new ArtifactNameColumnRenderer());

            SimpleColumnConfig dependenciesColumn = new SimpleColumnConfig(BucketColumnIds.DEPENDENCIES,
                                                                               "Dependencies",
                                                                               100) {
                    public Object getCellData(ReposObj artifact) {
                        return null; // dependencies set later - renderer knows this
                    }
                };
            dependenciesColumn.setRenderer(dependencyColumnRenderer);

            columns.add(nameColumn);
            columns.add(dependenciesColumn);
            columns.add(createRemoveAction());
        }

        @Override
        public void configure(EditorGrid<ReposObjDataModel> grid,
                              RemoteRestDataProxy dataProxy,
                              boolean includeCheckboxColumn) {
            
            setSortInfo(BucketColumnIds.ARTIFACT_ID, SortDir.ASC);
            super.configure(grid, dataProxy, includeCheckboxColumn);
            
            //grid.setBaseCls("bucket-panel"); // avoid x-panel styling of the editor
            grid.setAutoExpandColumn(BucketColumnIds.DEPENDENCIES);            
            grid.setTitle("Selected artifacts");
            grid.setAutoHeight(false);
            grid.setHeight(200);  // 8 rows? 
            grid.setTrackMouseOver(false);
        }
        
        private ActionColumnConfig<ReposObjDataModel> createRemoveAction() {
            ActionColumnConfig<ReposObjDataModel> removeColumn =
                new ActionColumnConfig<ReposObjDataModel>(getGrid(), "Remove");
            removeColumn.setActionLabel("Remove").setWidth(60);
            removeColumn.setActionCallback(new ActionColumnCallback<ReposObjDataModel>() {
                public void actionClicked(ReposObjDataModel record, Element anchorElement) {
                    artifactBucket.remove(record.getPOJO());
                }
            });          
            return removeColumn;
        }
    }

    private static final class DependenciesRenderer implements GridCellRenderer<ReposObjDataModel> {
        private final Listener<TreeEvent> dependencyTreeListener;
        
        DependenciesRenderer(Listener<TreeEvent> dependencyTreeListener) {
            this.dependencyTreeListener = dependencyTreeListener;
        }
        
        public String render(ReposObjDataModel model,
                             String property,
                             ColumnData config,
                             int rowIndex,
                             int colIndex,
                             ListStore<ReposObjDataModel> store) {
            ReposObj artifact = model.getPOJO();
            if (Boolean.TRUE.equals(artifact.getUserValue(BucketColumnIds.RESOLVING_DEPENDENCIES))) {
                return getResolvingRenderValue(config);
            } else {
                if (artifact.getUserValue(BucketColumnIds.RESOLVE_ERROR) != null) {
                    return getErrorRenderValue(config, model);
                } else if (artifact.getUserValue(BucketColumnIds.DEPENDENCIES) == null) {
                    return "No dependencies found";
                } else {
                    return getTreeRenderValue(config, model, rowIndex, colIndex);
                }
            }
        }
        
        private String getResolvingRenderValue(ColumnData cellMetadata) {
            cellMetadata.css = "resolving-dependencies";
            return "Resolving dependencies...";
        }
        
        private String getErrorRenderValue(ColumnData cellMetadata, ReposObjDataModel record) {
            cellMetadata.css = "resolving-dependencies-error";
            return (String)record.getPOJO().getUserValue(BucketColumnIds.RESOLVE_ERROR);
        }
        
        private String getTreeRenderValue(ColumnData cellMetadata,
                                          final ReposObjDataModel record,
                                          int rowIndex,
                                          int colNum) {
            final String divId = rowIndex + "-" + colNum + "-" + (new Date()).getTime();
            final Tree tree = getDependencyTree(record);
            DeferredCommand.addCommand(new Command() {
                public void execute() {
                    El anchorEl = new El(XDOM.getElementById(divId));
                    
                    tree.render(anchorEl.dom);
                    anchorEl.appendChild(tree.getElement());
                    ComponentHelper.doAttach(tree);
                }
            });
            return "<div id=\"" + divId + "\">" + "</div>";
        }
        
        private Tree getDependencyTree(ReposObjDataModel record) {
            
            Tree tree = new Tree();
            tree.setCheckable(true);  
            tree.getStyle().setLeafIconStyle("");  
            tree.setCheckStyle(CheckCascade.CHILDREN);
            
            tree.getRootItem().setText(MESSAGES.includeDependencies());
            tree.getRootItem().setChecked(true);
            
            TreeBuilder.buildTree(tree, fillDependencyTreeModel(record.getPOJO()));

            List<TreeItem> list = tree.getAllItems();
            Listener menuItemListener = new Listener<TreeEvent>() {  
                public void handleEvent(TreeEvent te) {  
                    TreeItem item = te.item;
                    if (item != null) {
                        ((ReposObjTreeModel)item.getModel()).getPOJO().setUserValue("checked",
                                                                                    item.isChecked());
                        
                    }
                }  
            };
            for (TreeItem item: list) {
                if ((ReposObjTreeModel)item.getModel() != null) {
                    Object val = ((ReposObjTreeModel)item.getModel()).getPOJO().getUserValue("checked");
                    if (val != null){
                        String isChecked = val.toString();
                        item.setChecked(isChecked.equals("true"));
                    }
                }
                item.addListener(Events.CheckChange, menuItemListener);
            }
            
            
            tree.addListener(Events.CheckChange, dependencyTreeListener);
            
            return tree;
        }
        
        @SuppressWarnings("unchecked")
        private ReposObjTreeModel fillDependencyTreeModel(ReposObj artifact) {
            
            //artifact.setUserValue("checked", Boolean.TRUE);
            ReposObjTreeModel root = new ReposObjTreeModel(artifact);
            
            Object deps = artifact.getUserValue(BucketColumnIds.DEPENDENCIES);
            if (deps != null) {
                for (ReposObj dep : (List<ReposObj>)deps) {
                    root.add(fillDependencyTreeModel(dep));
                }
            }
            
            return root;
        }
    }
}
