/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.web.repository.main.client.root;

import com.iona.soa.web.repository.main.client.base.EClassHelper;
import com.iona.soa.web.repository.main.client.base.IEditorPanel;
import com.iona.soa.web.repository.main.client.base.ReposURL;
import com.iona.soa.web.repository.main.client.base.ui.editor.BaseReposObjEditor;
import com.iona.soa.web.repository.main.client.base.ui.editor.custom.ApplicationEditor;
import com.iona.soa.web.repository.main.client.base.ui.editor.custom.DeploymentProfileEditor;

final class EditorFactory {
    private EditorFactory() {
    }
    
    static IEditorPanel getEditorPanel(ReposURL objURL) {
        
        IEditorPanel theEditor;        
        if (EClassHelper.DEPLOYMENT_PROFILE_ECLASS.equals(objURL.getEClass())
                || EClassHelper.VERSIONED_PROFILE_ECLASS.equals(objURL.getEClass())) {
            theEditor = new DeploymentProfileEditor(objURL);
        } else if (EClassHelper.APPLICATION_ECLASS.equals(objURL.getEClass())) {
            theEditor = new ApplicationEditor(objURL.getURL());
        } else {
            theEditor = new BaseReposObjEditor(objURL.getURL());        
        }
        
        return theEditor;
    }
}
