/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.sample.webapp;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class SampleServlet extends HttpServlet {

    private static final String TITLE = "Sample Depot WebApp";
    private static final String PROP1_NAME = "prop1";
    private static final String PROP2_NAME = "prop2";
    private static final String PROP3_NAME = "prop3";
    
    public void destroy() {
        System.out.println("\nSample webapp - servlet destroyed");
    }

    public ServletConfig getServletConfig() {
        return null;
    }

    public String getServletInfo() {
        return null;
    }

    public void init(ServletConfig config) throws ServletException {
        System.out.println("\nSample webapp - servlet initialised");
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        
        System.out.println("\nSample webapp - service request");

        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        StringBuilder sb = new StringBuilder()
            .append("<html><head><title>").append(TITLE).append("</title>\n")
            .append("</head><body>\n")
            .append("<h1>").append(TITLE).append("</h1>\n")
            .append("<p>This is the Depot Sample Web Application, request path is \"")
            .append(request.getPathInfo()).append("\"<p>\n")
            .append("<p>Properties:\n<ul>\n")
            .append("<li>").append(getPropertyText(PROP1_NAME)).append("</li>\n")
            .append("<li>").append(getPropertyText(PROP2_NAME)).append("</li>\n")
            .append("<li>").append(getPropertyText(PROP3_NAME)).append("</li>\n")
            .append("</ul></p></body></html>");

        out.println(sb.toString());
        out.close();
    }

    private String getPropertyText(String name) {
        String value = System.getProperty(name);
        if (value == null) {
            return "<b>" + name + "</b> is not set";
        }
        
        return "<b>" + name + "</b> is set to \"<i>" + value + "</i>\"";
    }

}
