/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import com.iona.soa.model.folder.ICategorizable;

import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.IVersionedObject;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Application</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.Application#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link com.iona.soa.model.Application#getEmbedded <em>Embedded</em>}</li>
 *   <li>{@link com.iona.soa.model.Application#getDepends <em>Depends</em>}</li>
 *   <li>{@link com.iona.soa.model.Application#getProfiles <em>Profiles</em>}</li>
 *   <li>{@link com.iona.soa.model.Application#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.SOA_NetworkPackage#getApplication()
 * @model annotation="securityHints area='Provisioning'"
 * @generated
 */
public interface Application extends IProtectedRepositoryObject, IVersionedObject, IConfiguration, IAttributes, ITagged, ICategorizable, IProperties, IDeploymentConstraint
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Artifacts</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.Artifact}.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.Artifact#getApplications <em>Applications</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Artifacts</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Artifacts</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getApplication_Artifacts()
   * @see com.iona.soa.model.Artifact#getApplications
   * @model opposite="applications"
   * @generated
   */
  EList<Artifact> getArtifacts();


  /**
   * Returns the value of the '<em><b>Embedded</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.Application}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Embedded</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Embedded</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getApplication_Embedded()
   * @model
   * @generated
   */
  EList<Application> getEmbedded();


  /**
   * Returns the value of the '<em><b>Depends</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.Application}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Depends</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Depends</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getApplication_Depends()
   * @model
   * @generated
   */
  EList<Application> getDepends();


  /**
   * Returns the value of the '<em><b>Profiles</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.VersionedProfile}.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.VersionedProfile#getApplications <em>Applications</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Profiles</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Profiles</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getApplication_Profiles()
   * @see com.iona.soa.model.VersionedProfile#getApplications
   * @model opposite="applications"
   * @generated
   */
  EList<VersionedProfile> getProfiles();


  /**
   * Returns the value of the '<em><b>Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' reference.
   * @see #setType(ApplicationType)
   * @see com.iona.soa.model.SOA_NetworkPackage#getApplication_Type()
   * @model
   * @generated
   */
  ApplicationType getType();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Application#getType <em>Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' reference.
   * @see #getType()
   * @generated
   */
  void setType(ApplicationType value);

} // Application


