/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import com.iona.soa.model.folder.IFolderContent;

import com.iona.soa.model.repository.IProperties;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;

import java.net.URI;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Artifact</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.Artifact#getApplications <em>Applications</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getUri <em>Uri</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getFileName <em>File Name</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getVersion <em>Version</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getType <em>Type</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getRelativeLocation <em>Relative Location</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#isSubstitution <em>Substitution</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getSubPrefix <em>Sub Prefix</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getSubPostfix <em>Sub Postfix</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getDepends <em>Depends</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#getFoundIn <em>Found In</em>}</li>
 *   <li>{@link com.iona.soa.model.Artifact#isExternal <em>External</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact()
 * @model annotation="securityHints area='Provisioning'"
 * @generated
 */
public interface Artifact extends IProtectedRepositoryObject, IConfiguration, IAttributes, ITagged, IProperties, IFolderContent
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Applications</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.Application}.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.Application#getArtifacts <em>Artifacts</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Applications</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Applications</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_Applications()
   * @see com.iona.soa.model.Application#getArtifacts
   * @model opposite="artifacts"
   * @generated
   */
  EList<Application> getApplications();


  /**
   * Returns the value of the '<em><b>Uri</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Uri</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Uri</em>' attribute.
   * @see #setUri(URI)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_Uri()
   * @model dataType="com.iona.soa.model.repository.URI" required="true"
   * @generated
   */
  URI getUri();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#getUri <em>Uri</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Uri</em>' attribute.
   * @see #getUri()
   * @generated
   */
  void setUri(URI value);

  /**
   * Returns the value of the '<em><b>File Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>File Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>File Name</em>' attribute.
   * @see #setFileName(String)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_FileName()
   * @model required="true"
   * @generated
   */
  String getFileName();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#getFileName <em>File Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>File Name</em>' attribute.
   * @see #getFileName()
   * @generated
   */
  void setFileName(String value);

  /**
   * Returns the value of the '<em><b>Version</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Version</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Version</em>' attribute.
   * @see #setVersion(String)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_Version()
   * @model required="true"
   * @generated
   */
  String getVersion();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#getVersion <em>Version</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Version</em>' attribute.
   * @see #getVersion()
   * @generated
   */
  void setVersion(String value);

  /**
   * Returns the value of the '<em><b>Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' reference.
   * @see #setType(ArtifactType)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_Type()
   * @model
   * @generated
   */
  ArtifactType getType();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#getType <em>Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' reference.
   * @see #getType()
   * @generated
   */
  void setType(ArtifactType value);

  /**
   * Returns the value of the '<em><b>Relative Location</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Relative Location</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Relative Location</em>' attribute.
   * @see #setRelativeLocation(String)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_RelativeLocation()
   * @model
   * @generated
   */
  String getRelativeLocation();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#getRelativeLocation <em>Relative Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Relative Location</em>' attribute.
   * @see #getRelativeLocation()
   * @generated
   */
  void setRelativeLocation(String value);

  /**
   * Returns the value of the '<em><b>Substitution</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Substitution</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Substitution</em>' attribute.
   * @see #setSubstitution(boolean)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_Substitution()
   * @model default="false"
   * @generated
   */
  boolean isSubstitution();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#isSubstitution <em>Substitution</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Substitution</em>' attribute.
   * @see #isSubstitution()
   * @generated
   */
  void setSubstitution(boolean value);

  /**
   * Returns the value of the '<em><b>Sub Prefix</b></em>' attribute.
   * The default value is <code>"${"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Sub Prefix</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Sub Prefix</em>' attribute.
   * @see #setSubPrefix(String)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_SubPrefix()
   * @model default="${"
   * @generated
   */
  String getSubPrefix();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#getSubPrefix <em>Sub Prefix</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Sub Prefix</em>' attribute.
   * @see #getSubPrefix()
   * @generated
   */
  void setSubPrefix(String value);

  /**
   * Returns the value of the '<em><b>Sub Postfix</b></em>' attribute.
   * The default value is <code>"}"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Sub Postfix</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Sub Postfix</em>' attribute.
   * @see #setSubPostfix(String)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_SubPostfix()
   * @model default="}"
   * @generated
   */
  String getSubPostfix();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#getSubPostfix <em>Sub Postfix</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Sub Postfix</em>' attribute.
   * @see #getSubPostfix()
   * @generated
   */
  void setSubPostfix(String value);

  /**
   * Returns the value of the '<em><b>Depends</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.Artifact}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Depends</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Depends</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_Depends()
   * @model
   * @generated
   */
  EList<Artifact> getDepends();


  /**
   * Returns the value of the '<em><b>Found In</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.ArtifactRepository}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Found In</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Found In</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_FoundIn()
   * @model
   * @generated
   */
  EList<ArtifactRepository> getFoundIn();


  /**
   * Returns the value of the '<em><b>External</b></em>' attribute.
   * The default value is <code>"true"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>External</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>External</em>' attribute.
   * @see #setExternal(boolean)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifact_External()
   * @model default="true" required="true"
   * @generated
   */
  boolean isExternal();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Artifact#isExternal <em>External</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>External</em>' attribute.
   * @see #isExternal()
   * @generated
   */
  void setExternal(boolean value);

} // Artifact


