/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import com.iona.soa.model.folder.ICategorizable;

import com.iona.soa.model.repository.IProperties;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;

import java.net.URI;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Artifact Repository</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.ArtifactRepository#getUrl <em>Url</em>}</li>
 *   <li>{@link com.iona.soa.model.ArtifactRepository#getMirrorOf <em>Mirror Of</em>}</li>
 *   <li>{@link com.iona.soa.model.ArtifactRepository#getOrderID <em>Order ID</em>}</li>
 *   <li>{@link com.iona.soa.model.ArtifactRepository#isExternal <em>External</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.SOA_NetworkPackage#getArtifactRepository()
 * @model abstract="true"
 *        annotation="dbhints hierarchy='topclass'"
 *        annotation="securityHints area='Repository'"
 * @generated
 */
public interface ArtifactRepository extends IProtectedRepositoryObject, ICategorizable, IAttributes, ITagged, IProperties
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Url</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Url</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Url</em>' attribute.
   * @see #setUrl(URI)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifactRepository_Url()
   * @model dataType="com.iona.soa.model.repository.URI" required="true"
   * @generated
   */
  URI getUrl();


  /**
   * Sets the value of the '{@link com.iona.soa.model.ArtifactRepository#getUrl <em>Url</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Url</em>' attribute.
   * @see #getUrl()
   * @generated
   */
  void setUrl(URI value);

  /**
   * Returns the value of the '<em><b>Mirror Of</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mirror Of</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mirror Of</em>' reference.
   * @see #setMirrorOf(ArtifactRepository)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifactRepository_MirrorOf()
   * @model
   * @generated
   */
  ArtifactRepository getMirrorOf();


  /**
   * Sets the value of the '{@link com.iona.soa.model.ArtifactRepository#getMirrorOf <em>Mirror Of</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mirror Of</em>' reference.
   * @see #getMirrorOf()
   * @generated
   */
  void setMirrorOf(ArtifactRepository value);

  /**
   * Returns the value of the '<em><b>Order ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Order ID</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Order ID</em>' attribute.
   * @see #setOrderID(int)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifactRepository_OrderID()
   * @model
   * @generated
   */
  int getOrderID();


  /**
   * Sets the value of the '{@link com.iona.soa.model.ArtifactRepository#getOrderID <em>Order ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Order ID</em>' attribute.
   * @see #getOrderID()
   * @generated
   */
  void setOrderID(int value);

  /**
   * Returns the value of the '<em><b>External</b></em>' attribute.
   * The default value is <code>"true"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>External</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>External</em>' attribute.
   * @see #setExternal(boolean)
   * @see com.iona.soa.model.SOA_NetworkPackage#getArtifactRepository_External()
   * @model default="true" required="true"
   * @generated
   */
  boolean isExternal();


  /**
   * Sets the value of the '{@link com.iona.soa.model.ArtifactRepository#isExternal <em>External</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>External</em>' attribute.
   * @see #isExternal()
   * @generated
   */
  void setExternal(boolean value);

} // ArtifactRepository


