/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import com.iona.soa.model.folder.ICategorizable;

import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.Property;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Container</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.Container#getSupportedPackageTypes <em>Supported Package Types</em>}</li>
 *   <li>{@link com.iona.soa.model.Container#getStatus <em>Status</em>}</li>
 *   <li>{@link com.iona.soa.model.Container#getApplications <em>Applications</em>}</li>
 *   <li>{@link com.iona.soa.model.Container#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link com.iona.soa.model.Container#getProfile <em>Profile</em>}</li>
 *   <li>{@link com.iona.soa.model.Container#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.SOA_NetworkPackage#getContainer()
 * @model annotation="securityHints area='Provisioning\r\nAgent'"
 * @generated
 */
public interface Container extends IProtectedRepositoryObject, ITagged, IAttributes, ICategorizable, IProperties
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Supported Package Types</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Supported Package Types</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Supported Package Types</em>' attribute list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getContainer_SupportedPackageTypes()
   * @model
   * @generated
   */
  EList<String> getSupportedPackageTypes();


  /**
   * Returns the value of the '<em><b>Status</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.repository.Property}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Status</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Status</em>' containment reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getContainer_Status()
   * @model containment="true"
   * @generated
   */
  EList<Property> getStatus();


  /**
   * Returns the value of the '<em><b>Applications</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.InstalledApplication}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Applications</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Applications</em>' containment reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getContainer_Applications()
   * @model containment="true"
   * @generated
   */
  EList<InstalledApplication> getApplications();


  /**
   * Returns the value of the '<em><b>Artifacts</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.InstalledArtifact}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Artifacts</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Artifacts</em>' containment reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getContainer_Artifacts()
   * @model containment="true"
   * @generated
   */
  EList<InstalledArtifact> getArtifacts();


  /**
   * Returns the value of the '<em><b>Profile</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Profile</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Profile</em>' reference.
   * @see #setProfile(DeploymentProfile)
   * @see com.iona.soa.model.SOA_NetworkPackage#getContainer_Profile()
   * @model
   * @generated
   */
  DeploymentProfile getProfile();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Container#getProfile <em>Profile</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Profile</em>' reference.
   * @see #getProfile()
   * @generated
   */
  void setProfile(DeploymentProfile value);

  /**
   * Returns the value of the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' attribute.
   * @see #setType(String)
   * @see com.iona.soa.model.SOA_NetworkPackage#getContainer_Type()
   * @model
   * @generated
   */
  String getType();


  /**
   * Sets the value of the '{@link com.iona.soa.model.Container#getType <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' attribute.
   * @see #getType()
   * @generated
   */
  void setType(String value);

} // Container


