/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import com.iona.soa.model.folder.ICategorizable;

import com.iona.soa.model.repository.VersionTracker;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Deployment Profile</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.DeploymentProfile#getActive <em>Active</em>}</li>
 *   <li>{@link com.iona.soa.model.DeploymentProfile#getVersionTracker <em>Version Tracker</em>}</li>
 *   <li>{@link com.iona.soa.model.DeploymentProfile#getVersions <em>Versions</em>}</li>
 *   <li>{@link com.iona.soa.model.DeploymentProfile#getCurrent <em>Current</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.SOA_NetworkPackage#getDeploymentProfile()
 * @model annotation="securityHints area='Provisioning\r\nAgent'"
 * @generated
 */
public interface DeploymentProfile extends IAttributes, ICategorizable, IProtectedRepositoryObject, ITagged
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Active</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Active</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Active</em>' reference.
   * @see #setActive(VersionedProfile)
   * @see com.iona.soa.model.SOA_NetworkPackage#getDeploymentProfile_Active()
   * @model
   * @generated
   */
  VersionedProfile getActive();


  /**
   * Sets the value of the '{@link com.iona.soa.model.DeploymentProfile#getActive <em>Active</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Active</em>' reference.
   * @see #getActive()
   * @generated
   */
  void setActive(VersionedProfile value);

  /**
   * Returns the value of the '<em><b>Version Tracker</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Version Tracker</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Version Tracker</em>' containment reference.
   * @see #setVersionTracker(VersionTracker)
   * @see com.iona.soa.model.SOA_NetworkPackage#getDeploymentProfile_VersionTracker()
   * @model containment="true" required="true"
   * @generated
   */
  VersionTracker getVersionTracker();


  /**
   * Sets the value of the '{@link com.iona.soa.model.DeploymentProfile#getVersionTracker <em>Version Tracker</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Version Tracker</em>' containment reference.
   * @see #getVersionTracker()
   * @generated
   */
  void setVersionTracker(VersionTracker value);

  /**
   * Returns the value of the '<em><b>Versions</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.VersionedProfile}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Versions</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Versions</em>' containment reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getDeploymentProfile_Versions()
   * @model containment="true"
   * @generated
   */
  EList<VersionedProfile> getVersions();


  /**
   * Returns the value of the '<em><b>Current</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Current</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Current</em>' reference.
   * @see #setCurrent(VersionedProfile)
   * @see com.iona.soa.model.SOA_NetworkPackage#getDeploymentProfile_Current()
   * @model required="true"
   * @generated
   */
  VersionedProfile getCurrent();


  /**
   * Sets the value of the '{@link com.iona.soa.model.DeploymentProfile#getCurrent <em>Current</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Current</em>' reference.
   * @see #getCurrent()
   * @generated
   */
  void setCurrent(VersionedProfile value);

} // DeploymentProfile


