/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import java.sql.Timestamp;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Maven Repository</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.MavenRepository#isSnapshots <em>Snapshots</em>}</li>
 *   <li>{@link com.iona.soa.model.MavenRepository#getLastIndexed <em>Last Indexed</em>}</li>
 *   <li>{@link com.iona.soa.model.MavenRepository#getNextIndex <em>Next Index</em>}</li>
 *   <li>{@link com.iona.soa.model.MavenRepository#isIndexed <em>Indexed</em>}</li>
 *   <li>{@link com.iona.soa.model.MavenRepository#getId <em>Id</em>}</li>
 *   <li>{@link com.iona.soa.model.MavenRepository#getIndexState <em>Index State</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.SOA_NetworkPackage#getMavenRepository()
 * @model
 * @generated
 */
public interface MavenRepository extends ArtifactRepository
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Snapshots</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Snapshots</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Snapshots</em>' attribute.
   * @see #setSnapshots(boolean)
   * @see com.iona.soa.model.SOA_NetworkPackage#getMavenRepository_Snapshots()
   * @model required="true"
   * @generated
   */
  boolean isSnapshots();


  /**
   * Sets the value of the '{@link com.iona.soa.model.MavenRepository#isSnapshots <em>Snapshots</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Snapshots</em>' attribute.
   * @see #isSnapshots()
   * @generated
   */
  void setSnapshots(boolean value);

  /**
   * Returns the value of the '<em><b>Last Indexed</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Last Indexed</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Last Indexed</em>' attribute.
   * @see #setLastIndexed(Timestamp)
   * @see com.iona.soa.model.SOA_NetworkPackage#getMavenRepository_LastIndexed()
   * @model dataType="com.iona.soa.model.repository.Timestamp"
   * @generated
   */
  Timestamp getLastIndexed();


  /**
   * Sets the value of the '{@link com.iona.soa.model.MavenRepository#getLastIndexed <em>Last Indexed</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Last Indexed</em>' attribute.
   * @see #getLastIndexed()
   * @generated
   */
  void setLastIndexed(Timestamp value);

  /**
   * Returns the value of the '<em><b>Next Index</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Next Index</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Next Index</em>' attribute.
   * @see #setNextIndex(Timestamp)
   * @see com.iona.soa.model.SOA_NetworkPackage#getMavenRepository_NextIndex()
   * @model dataType="com.iona.soa.model.repository.Timestamp"
   * @generated
   */
  Timestamp getNextIndex();


  /**
   * Sets the value of the '{@link com.iona.soa.model.MavenRepository#getNextIndex <em>Next Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Next Index</em>' attribute.
   * @see #getNextIndex()
   * @generated
   */
  void setNextIndex(Timestamp value);

  /**
   * Returns the value of the '<em><b>Indexed</b></em>' attribute.
   * The default value is <code>"true"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Indexed</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Indexed</em>' attribute.
   * @see #setIndexed(boolean)
   * @see com.iona.soa.model.SOA_NetworkPackage#getMavenRepository_Indexed()
   * @model default="true" required="true"
   * @generated
   */
  boolean isIndexed();


  /**
   * Sets the value of the '{@link com.iona.soa.model.MavenRepository#isIndexed <em>Indexed</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Indexed</em>' attribute.
   * @see #isIndexed()
   * @generated
   */
  void setIndexed(boolean value);

  /**
   * Returns the value of the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Id</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Id</em>' attribute.
   * @see #setId(String)
   * @see com.iona.soa.model.SOA_NetworkPackage#getMavenRepository_Id()
   * @model required="true"
   * @generated
   */
  String getId();


  /**
   * Sets the value of the '{@link com.iona.soa.model.MavenRepository#getId <em>Id</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Id</em>' attribute.
   * @see #getId()
   * @generated
   */
  void setId(String value);

  /**
   * Returns the value of the '<em><b>Index State</b></em>' attribute.
   * The literals are from the enumeration {@link com.iona.soa.model.IndexStates}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Index State</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Index State</em>' attribute.
   * @see com.iona.soa.model.IndexStates
   * @see #setIndexState(IndexStates)
   * @see com.iona.soa.model.SOA_NetworkPackage#getMavenRepository_IndexState()
   * @model required="true"
   * @generated
   */
  IndexStates getIndexState();


  /**
   * Sets the value of the '{@link com.iona.soa.model.MavenRepository#getIndexState <em>Index State</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Index State</em>' attribute.
   * @see com.iona.soa.model.IndexStates
   * @see #getIndexState()
   * @generated
   */
  void setIndexState(IndexStates value);

} // MavenRepository


