/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.userattributes.UserAttributesPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.SOA_NetworkFactory
 * @model kind="package"
 * @generated
 */
public interface SOA_NetworkPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "model";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itmodel";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  SOA_NetworkPackage eINSTANCE = com.iona.soa.model.impl.SOA_NetworkPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.ApplicationImpl <em>Application</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.ApplicationImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getApplication()
   * @generated
   */
  int APPLICATION = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Version</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__VERSION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Configuration</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__CONFIGURATION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__ATTRIBUTES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__TAGS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__CATEGORIES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__PROPERTIES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Constraints</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__CONSTRAINTS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>Artifacts</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__ARTIFACTS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 7;

  /**
   * The feature id for the '<em><b>Embedded</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__EMBEDDED = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 8;

  /**
   * The feature id for the '<em><b>Depends</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__DEPENDS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 9;

  /**
   * The feature id for the '<em><b>Profiles</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__PROFILES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 10;

  /**
   * The feature id for the '<em><b>Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION__TYPE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 11;

  /**
   * The number of structural features of the '<em>Application</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 12;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.ArtifactImpl <em>Artifact</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.ArtifactImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getArtifact()
   * @generated
   */
  int ARTIFACT = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Configuration</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__CONFIGURATION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__ATTRIBUTES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__TAGS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__PROPERTIES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Belongs To</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__BELONGS_TO = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Applications</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__APPLICATIONS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Uri</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__URI = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>File Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__FILE_NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 7;

  /**
   * The feature id for the '<em><b>Version</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__VERSION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 8;

  /**
   * The feature id for the '<em><b>Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__TYPE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 9;

  /**
   * The feature id for the '<em><b>Relative Location</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__RELATIVE_LOCATION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 10;

  /**
   * The feature id for the '<em><b>Substitution</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__SUBSTITUTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 11;

  /**
   * The feature id for the '<em><b>Sub Prefix</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__SUB_PREFIX = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 12;

  /**
   * The feature id for the '<em><b>Sub Postfix</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__SUB_POSTFIX = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 13;

  /**
   * The feature id for the '<em><b>Depends</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__DEPENDS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 14;

  /**
   * The feature id for the '<em><b>Found In</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__FOUND_IN = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 15;

  /**
   * The feature id for the '<em><b>External</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT__EXTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 16;

  /**
   * The number of structural features of the '<em>Artifact</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 17;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.StoredQueryImpl <em>Stored Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.StoredQueryImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getStoredQuery()
   * @generated
   */
  int STORED_QUERY = 2;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__TAGS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__ATTRIBUTES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__TYPE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Query</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__QUERY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Category</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY__CATEGORY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The number of structural features of the '<em>Stored Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STORED_QUERY_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.ContainerImpl <em>Container</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.ContainerImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getContainer()
   * @generated
   */
  int CONTAINER = 3;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__TAGS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__ATTRIBUTES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__CATEGORIES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__PROPERTIES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Supported Package Types</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__SUPPORTED_PACKAGE_TYPES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Status</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__STATUS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Applications</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__APPLICATIONS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>Artifacts</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__ARTIFACTS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 7;

  /**
   * The feature id for the '<em><b>Profile</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__PROFILE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 8;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER__TYPE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 9;

  /**
   * The number of structural features of the '<em>Container</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTAINER_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 10;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.IConfigurationImpl <em>IConfiguration</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.IConfigurationImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getIConfiguration()
   * @generated
   */
  int ICONFIGURATION = 4;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Configuration</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION__CONFIGURATION = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>IConfiguration</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICONFIGURATION_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.VersionedProfileImpl <em>Versioned Profile</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.VersionedProfileImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getVersionedProfile()
   * @generated
   */
  int VERSIONED_PROFILE = 5;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Version</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__VERSION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Applications</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__APPLICATIONS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Publish Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__PUBLISH_NOW = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Configuration Override</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE__CONFIGURATION_OVERRIDE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The number of structural features of the '<em>Versioned Profile</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSIONED_PROFILE_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.FolderImpl <em>Folder</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.FolderImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getFolder()
   * @generated
   */
  int FOLDER = 6;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Children</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__CHILDREN = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__PARENT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Content</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__CONTENT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Owner</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__OWNER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Subscribers</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__SUBSCRIBERS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Comments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER__COMMENTS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The number of structural features of the '<em>Folder</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOLDER_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 6;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.ArtifactRepositoryImpl <em>Artifact Repository</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.ArtifactRepositoryImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getArtifactRepository()
   * @generated
   */
  int ARTIFACT_REPOSITORY = 11;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__CATEGORIES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__ATTRIBUTES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__TAGS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__PROPERTIES = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Url</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__URL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Mirror Of</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__MIRROR_OF = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Order ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__ORDER_ID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>External</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY__EXTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 7;

  /**
   * The number of structural features of the '<em>Artifact Repository</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_REPOSITORY_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 8;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.MavenRepositoryImpl <em>Maven Repository</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.MavenRepositoryImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getMavenRepository()
   * @generated
   */
  int MAVEN_REPOSITORY = 7;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__GUID = ARTIFACT_REPOSITORY__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__GENERATION_NUMBER = ARTIFACT_REPOSITORY__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__MODIFIABLE = ARTIFACT_REPOSITORY__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__INTERNAL = ARTIFACT_REPOSITORY__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__LAST_EDITED_BY = ARTIFACT_REPOSITORY__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__TIMESTAMP = ARTIFACT_REPOSITORY__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__CREATED_BY = ARTIFACT_REPOSITORY__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__NAME = ARTIFACT_REPOSITORY__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__NAMESPACE = ARTIFACT_REPOSITORY__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__DESCRIPTION = ARTIFACT_REPOSITORY__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__OBJECT_CONTROL = ARTIFACT_REPOSITORY__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__CATEGORIES = ARTIFACT_REPOSITORY__CATEGORIES;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__ATTRIBUTES = ARTIFACT_REPOSITORY__ATTRIBUTES;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__TAGS = ARTIFACT_REPOSITORY__TAGS;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__PROPERTIES = ARTIFACT_REPOSITORY__PROPERTIES;

  /**
   * The feature id for the '<em><b>Url</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__URL = ARTIFACT_REPOSITORY__URL;

  /**
   * The feature id for the '<em><b>Mirror Of</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__MIRROR_OF = ARTIFACT_REPOSITORY__MIRROR_OF;

  /**
   * The feature id for the '<em><b>Order ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__ORDER_ID = ARTIFACT_REPOSITORY__ORDER_ID;

  /**
   * The feature id for the '<em><b>External</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__EXTERNAL = ARTIFACT_REPOSITORY__EXTERNAL;

  /**
   * The feature id for the '<em><b>Snapshots</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__SNAPSHOTS = ARTIFACT_REPOSITORY_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Last Indexed</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__LAST_INDEXED = ARTIFACT_REPOSITORY_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Next Index</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__NEXT_INDEX = ARTIFACT_REPOSITORY_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Indexed</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__INDEXED = ARTIFACT_REPOSITORY_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__ID = ARTIFACT_REPOSITORY_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Index State</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY__INDEX_STATE = ARTIFACT_REPOSITORY_FEATURE_COUNT + 5;

  /**
   * The number of structural features of the '<em>Maven Repository</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAVEN_REPOSITORY_FEATURE_COUNT = ARTIFACT_REPOSITORY_FEATURE_COUNT + 6;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.IDeploymentConstraintImpl <em>IDeployment Constraint</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.IDeploymentConstraintImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getIDeploymentConstraint()
   * @generated
   */
  int IDEPLOYMENT_CONSTRAINT = 8;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Constraints</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT__CONSTRAINTS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>IDeployment Constraint</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IDEPLOYMENT_CONSTRAINT_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.InstalledApplicationImpl <em>Installed Application</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.InstalledApplicationImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getInstalledApplication()
   * @generated
   */
  int INSTALLED_APPLICATION = 9;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__GUID = RepositoryPackage.IREPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__GENERATION_NUMBER = RepositoryPackage.IREPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__MODIFIABLE = RepositoryPackage.IREPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__INTERNAL = RepositoryPackage.IREPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__LAST_EDITED_BY = RepositoryPackage.IREPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__TIMESTAMP = RepositoryPackage.IREPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__CREATED_BY = RepositoryPackage.IREPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__NAME = RepositoryPackage.IREPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__NAMESPACE = RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__DESCRIPTION = RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Artifacts</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION__ARTIFACTS = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Installed Application</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_APPLICATION_FEATURE_COUNT = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.InstalledArtifactImpl <em>Installed Artifact</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.InstalledArtifactImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getInstalledArtifact()
   * @generated
   */
  int INSTALLED_ARTIFACT = 10;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__GUID = RepositoryPackage.IREPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__GENERATION_NUMBER = RepositoryPackage.IREPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__MODIFIABLE = RepositoryPackage.IREPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__INTERNAL = RepositoryPackage.IREPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__LAST_EDITED_BY = RepositoryPackage.IREPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__TIMESTAMP = RepositoryPackage.IREPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__CREATED_BY = RepositoryPackage.IREPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__NAME = RepositoryPackage.IREPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__NAMESPACE = RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT__DESCRIPTION = RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The number of structural features of the '<em>Installed Artifact</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTALLED_ARTIFACT_FEATURE_COUNT = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.DeploymentProfileImpl <em>Deployment Profile</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.DeploymentProfileImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getDeploymentProfile()
   * @generated
   */
  int DEPLOYMENT_PROFILE = 12;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__GUID = UserAttributesPackage.IATTRIBUTES__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__GENERATION_NUMBER = UserAttributesPackage.IATTRIBUTES__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__MODIFIABLE = UserAttributesPackage.IATTRIBUTES__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__INTERNAL = UserAttributesPackage.IATTRIBUTES__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__LAST_EDITED_BY = UserAttributesPackage.IATTRIBUTES__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__TIMESTAMP = UserAttributesPackage.IATTRIBUTES__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__CREATED_BY = UserAttributesPackage.IATTRIBUTES__CREATED_BY;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__ATTRIBUTES = UserAttributesPackage.IATTRIBUTES__ATTRIBUTES;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__CATEGORIES = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__NAME = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__NAMESPACE = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__DESCRIPTION = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__OBJECT_CONTROL = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__TAGS = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Active</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__ACTIVE = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>Version Tracker</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__VERSION_TRACKER = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 7;

  /**
   * The feature id for the '<em><b>Versions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__VERSIONS = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 8;

  /**
   * The feature id for the '<em><b>Current</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE__CURRENT = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 9;

  /**
   * The number of structural features of the '<em>Deployment Profile</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPLOYMENT_PROFILE_FEATURE_COUNT = UserAttributesPackage.IATTRIBUTES_FEATURE_COUNT + 10;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.ArtifactTypeImpl <em>Artifact Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.ArtifactTypeImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getArtifactType()
   * @generated
   */
  int ARTIFACT_TYPE = 13;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Markers</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE__MARKERS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Artifact Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARTIFACT_TYPE_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.ApplicationTypeImpl <em>Application Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.ApplicationTypeImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getApplicationType()
   * @generated
   */
  int APPLICATION_TYPE = 14;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The number of structural features of the '<em>Application Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int APPLICATION_TYPE_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.CategoryImpl <em>Category</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.CategoryImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getCategory()
   * @generated
   */
  int CATEGORY = 15;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Content</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__CONTENT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>EClass Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__ECLASS_NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Owner</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__OWNER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Subscribers</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__SUBSCRIBERS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Comments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY__COMMENTS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The number of structural features of the '<em>Category</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CATEGORY_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The meta object id for the '{@link com.iona.soa.model.impl.ConfigurationOverrideImpl <em>Configuration Override</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.impl.ConfigurationOverrideImpl
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getConfigurationOverride()
   * @generated
   */
  int CONFIGURATION_OVERRIDE = 16;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__GUID = ICONFIGURATION__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__GENERATION_NUMBER = ICONFIGURATION__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__MODIFIABLE = ICONFIGURATION__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__INTERNAL = ICONFIGURATION__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__LAST_EDITED_BY = ICONFIGURATION__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__TIMESTAMP = ICONFIGURATION__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__CREATED_BY = ICONFIGURATION__CREATED_BY;

  /**
   * The feature id for the '<em><b>Configuration</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__CONFIGURATION = ICONFIGURATION__CONFIGURATION;

  /**
   * The feature id for the '<em><b>Constraints</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__CONSTRAINTS = ICONFIGURATION_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__NAME = ICONFIGURATION_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__NAMESPACE = ICONFIGURATION_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__DESCRIPTION = ICONFIGURATION_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Application</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE__APPLICATION = ICONFIGURATION_FEATURE_COUNT + 4;

  /**
   * The number of structural features of the '<em>Configuration Override</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_OVERRIDE_FEATURE_COUNT = ICONFIGURATION_FEATURE_COUNT + 5;

  /**
   * The meta object id for the '{@link com.iona.soa.model.IndexStates <em>Index States</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.IndexStates
   * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getIndexStates()
   * @generated
   */
  int INDEX_STATES = 17;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.Application <em>Application</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Application</em>'.
   * @see com.iona.soa.model.Application
   * @generated
   */
  EClass getApplication();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.Application#getArtifacts <em>Artifacts</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Artifacts</em>'.
   * @see com.iona.soa.model.Application#getArtifacts()
   * @see #getApplication()
   * @generated
   */
  EReference getApplication_Artifacts();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.Application#getEmbedded <em>Embedded</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Embedded</em>'.
   * @see com.iona.soa.model.Application#getEmbedded()
   * @see #getApplication()
   * @generated
   */
  EReference getApplication_Embedded();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.Application#getDepends <em>Depends</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Depends</em>'.
   * @see com.iona.soa.model.Application#getDepends()
   * @see #getApplication()
   * @generated
   */
  EReference getApplication_Depends();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.Application#getProfiles <em>Profiles</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Profiles</em>'.
   * @see com.iona.soa.model.Application#getProfiles()
   * @see #getApplication()
   * @generated
   */
  EReference getApplication_Profiles();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.Application#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Type</em>'.
   * @see com.iona.soa.model.Application#getType()
   * @see #getApplication()
   * @generated
   */
  EReference getApplication_Type();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.Artifact <em>Artifact</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Artifact</em>'.
   * @see com.iona.soa.model.Artifact
   * @generated
   */
  EClass getArtifact();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.Artifact#getApplications <em>Applications</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Applications</em>'.
   * @see com.iona.soa.model.Artifact#getApplications()
   * @see #getArtifact()
   * @generated
   */
  EReference getArtifact_Applications();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#getUri <em>Uri</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Uri</em>'.
   * @see com.iona.soa.model.Artifact#getUri()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_Uri();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#getFileName <em>File Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>File Name</em>'.
   * @see com.iona.soa.model.Artifact#getFileName()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_FileName();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#getVersion <em>Version</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Version</em>'.
   * @see com.iona.soa.model.Artifact#getVersion()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_Version();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.Artifact#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Type</em>'.
   * @see com.iona.soa.model.Artifact#getType()
   * @see #getArtifact()
   * @generated
   */
  EReference getArtifact_Type();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#getRelativeLocation <em>Relative Location</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Relative Location</em>'.
   * @see com.iona.soa.model.Artifact#getRelativeLocation()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_RelativeLocation();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#isSubstitution <em>Substitution</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Substitution</em>'.
   * @see com.iona.soa.model.Artifact#isSubstitution()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_Substitution();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#getSubPrefix <em>Sub Prefix</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Sub Prefix</em>'.
   * @see com.iona.soa.model.Artifact#getSubPrefix()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_SubPrefix();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#getSubPostfix <em>Sub Postfix</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Sub Postfix</em>'.
   * @see com.iona.soa.model.Artifact#getSubPostfix()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_SubPostfix();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.Artifact#getDepends <em>Depends</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Depends</em>'.
   * @see com.iona.soa.model.Artifact#getDepends()
   * @see #getArtifact()
   * @generated
   */
  EReference getArtifact_Depends();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.Artifact#getFoundIn <em>Found In</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Found In</em>'.
   * @see com.iona.soa.model.Artifact#getFoundIn()
   * @see #getArtifact()
   * @generated
   */
  EReference getArtifact_FoundIn();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Artifact#isExternal <em>External</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>External</em>'.
   * @see com.iona.soa.model.Artifact#isExternal()
   * @see #getArtifact()
   * @generated
   */
  EAttribute getArtifact_External();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.StoredQuery <em>Stored Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Stored Query</em>'.
   * @see com.iona.soa.model.StoredQuery
   * @generated
   */
  EClass getStoredQuery();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.StoredQuery#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see com.iona.soa.model.StoredQuery#getType()
   * @see #getStoredQuery()
   * @generated
   */
  EAttribute getStoredQuery_Type();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.StoredQuery#getQuery <em>Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Query</em>'.
   * @see com.iona.soa.model.StoredQuery#getQuery()
   * @see #getStoredQuery()
   * @generated
   */
  EAttribute getStoredQuery_Query();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.StoredQuery#getCategory <em>Category</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Category</em>'.
   * @see com.iona.soa.model.StoredQuery#getCategory()
   * @see #getStoredQuery()
   * @generated
   */
  EAttribute getStoredQuery_Category();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.Container <em>Container</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Container</em>'.
   * @see com.iona.soa.model.Container
   * @generated
   */
  EClass getContainer();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.Container#getSupportedPackageTypes <em>Supported Package Types</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Supported Package Types</em>'.
   * @see com.iona.soa.model.Container#getSupportedPackageTypes()
   * @see #getContainer()
   * @generated
   */
  EAttribute getContainer_SupportedPackageTypes();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.Container#getStatus <em>Status</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Status</em>'.
   * @see com.iona.soa.model.Container#getStatus()
   * @see #getContainer()
   * @generated
   */
  EReference getContainer_Status();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.Container#getApplications <em>Applications</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Applications</em>'.
   * @see com.iona.soa.model.Container#getApplications()
   * @see #getContainer()
   * @generated
   */
  EReference getContainer_Applications();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.Container#getArtifacts <em>Artifacts</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Artifacts</em>'.
   * @see com.iona.soa.model.Container#getArtifacts()
   * @see #getContainer()
   * @generated
   */
  EReference getContainer_Artifacts();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.Container#getProfile <em>Profile</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Profile</em>'.
   * @see com.iona.soa.model.Container#getProfile()
   * @see #getContainer()
   * @generated
   */
  EReference getContainer_Profile();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.Container#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see com.iona.soa.model.Container#getType()
   * @see #getContainer()
   * @generated
   */
  EAttribute getContainer_Type();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.IConfiguration <em>IConfiguration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IConfiguration</em>'.
   * @see com.iona.soa.model.IConfiguration
   * @generated
   */
  EClass getIConfiguration();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.IConfiguration#getConfiguration <em>Configuration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Configuration</em>'.
   * @see com.iona.soa.model.IConfiguration#getConfiguration()
   * @see #getIConfiguration()
   * @generated
   */
  EReference getIConfiguration_Configuration();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.VersionedProfile <em>Versioned Profile</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Versioned Profile</em>'.
   * @see com.iona.soa.model.VersionedProfile
   * @generated
   */
  EClass getVersionedProfile();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.VersionedProfile#getApplications <em>Applications</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Applications</em>'.
   * @see com.iona.soa.model.VersionedProfile#getApplications()
   * @see #getVersionedProfile()
   * @generated
   */
  EReference getVersionedProfile_Applications();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.VersionedProfile#isPublishNow <em>Publish Now</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Publish Now</em>'.
   * @see com.iona.soa.model.VersionedProfile#isPublishNow()
   * @see #getVersionedProfile()
   * @generated
   */
  EAttribute getVersionedProfile_PublishNow();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.VersionedProfile#getConfigurationOverride <em>Configuration Override</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Configuration Override</em>'.
   * @see com.iona.soa.model.VersionedProfile#getConfigurationOverride()
   * @see #getVersionedProfile()
   * @generated
   */
  EReference getVersionedProfile_ConfigurationOverride();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.Folder <em>Folder</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Folder</em>'.
   * @see com.iona.soa.model.Folder
   * @generated
   */
  EClass getFolder();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.MavenRepository <em>Maven Repository</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Maven Repository</em>'.
   * @see com.iona.soa.model.MavenRepository
   * @generated
   */
  EClass getMavenRepository();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.MavenRepository#isSnapshots <em>Snapshots</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Snapshots</em>'.
   * @see com.iona.soa.model.MavenRepository#isSnapshots()
   * @see #getMavenRepository()
   * @generated
   */
  EAttribute getMavenRepository_Snapshots();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.MavenRepository#getLastIndexed <em>Last Indexed</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Last Indexed</em>'.
   * @see com.iona.soa.model.MavenRepository#getLastIndexed()
   * @see #getMavenRepository()
   * @generated
   */
  EAttribute getMavenRepository_LastIndexed();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.MavenRepository#getNextIndex <em>Next Index</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Next Index</em>'.
   * @see com.iona.soa.model.MavenRepository#getNextIndex()
   * @see #getMavenRepository()
   * @generated
   */
  EAttribute getMavenRepository_NextIndex();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.MavenRepository#isIndexed <em>Indexed</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Indexed</em>'.
   * @see com.iona.soa.model.MavenRepository#isIndexed()
   * @see #getMavenRepository()
   * @generated
   */
  EAttribute getMavenRepository_Indexed();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.MavenRepository#getId <em>Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Id</em>'.
   * @see com.iona.soa.model.MavenRepository#getId()
   * @see #getMavenRepository()
   * @generated
   */
  EAttribute getMavenRepository_Id();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.MavenRepository#getIndexState <em>Index State</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Index State</em>'.
   * @see com.iona.soa.model.MavenRepository#getIndexState()
   * @see #getMavenRepository()
   * @generated
   */
  EAttribute getMavenRepository_IndexState();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.IDeploymentConstraint <em>IDeployment Constraint</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IDeployment Constraint</em>'.
   * @see com.iona.soa.model.IDeploymentConstraint
   * @generated
   */
  EClass getIDeploymentConstraint();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.IDeploymentConstraint#getConstraints <em>Constraints</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Constraints</em>'.
   * @see com.iona.soa.model.IDeploymentConstraint#getConstraints()
   * @see #getIDeploymentConstraint()
   * @generated
   */
  EReference getIDeploymentConstraint_Constraints();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.InstalledApplication <em>Installed Application</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Installed Application</em>'.
   * @see com.iona.soa.model.InstalledApplication
   * @generated
   */
  EClass getInstalledApplication();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.InstalledApplication#getArtifacts <em>Artifacts</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Artifacts</em>'.
   * @see com.iona.soa.model.InstalledApplication#getArtifacts()
   * @see #getInstalledApplication()
   * @generated
   */
  EReference getInstalledApplication_Artifacts();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.InstalledArtifact <em>Installed Artifact</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Installed Artifact</em>'.
   * @see com.iona.soa.model.InstalledArtifact
   * @generated
   */
  EClass getInstalledArtifact();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.ArtifactRepository <em>Artifact Repository</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Artifact Repository</em>'.
   * @see com.iona.soa.model.ArtifactRepository
   * @generated
   */
  EClass getArtifactRepository();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.ArtifactRepository#getUrl <em>Url</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Url</em>'.
   * @see com.iona.soa.model.ArtifactRepository#getUrl()
   * @see #getArtifactRepository()
   * @generated
   */
  EAttribute getArtifactRepository_Url();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.ArtifactRepository#getMirrorOf <em>Mirror Of</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Mirror Of</em>'.
   * @see com.iona.soa.model.ArtifactRepository#getMirrorOf()
   * @see #getArtifactRepository()
   * @generated
   */
  EReference getArtifactRepository_MirrorOf();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.ArtifactRepository#getOrderID <em>Order ID</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Order ID</em>'.
   * @see com.iona.soa.model.ArtifactRepository#getOrderID()
   * @see #getArtifactRepository()
   * @generated
   */
  EAttribute getArtifactRepository_OrderID();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.ArtifactRepository#isExternal <em>External</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>External</em>'.
   * @see com.iona.soa.model.ArtifactRepository#isExternal()
   * @see #getArtifactRepository()
   * @generated
   */
  EAttribute getArtifactRepository_External();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.DeploymentProfile <em>Deployment Profile</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Deployment Profile</em>'.
   * @see com.iona.soa.model.DeploymentProfile
   * @generated
   */
  EClass getDeploymentProfile();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.DeploymentProfile#getActive <em>Active</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Active</em>'.
   * @see com.iona.soa.model.DeploymentProfile#getActive()
   * @see #getDeploymentProfile()
   * @generated
   */
  EReference getDeploymentProfile_Active();

  /**
   * Returns the meta object for the containment reference '{@link com.iona.soa.model.DeploymentProfile#getVersionTracker <em>Version Tracker</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Version Tracker</em>'.
   * @see com.iona.soa.model.DeploymentProfile#getVersionTracker()
   * @see #getDeploymentProfile()
   * @generated
   */
  EReference getDeploymentProfile_VersionTracker();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.DeploymentProfile#getVersions <em>Versions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Versions</em>'.
   * @see com.iona.soa.model.DeploymentProfile#getVersions()
   * @see #getDeploymentProfile()
   * @generated
   */
  EReference getDeploymentProfile_Versions();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.DeploymentProfile#getCurrent <em>Current</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Current</em>'.
   * @see com.iona.soa.model.DeploymentProfile#getCurrent()
   * @see #getDeploymentProfile()
   * @generated
   */
  EReference getDeploymentProfile_Current();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.ArtifactType <em>Artifact Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Artifact Type</em>'.
   * @see com.iona.soa.model.ArtifactType
   * @generated
   */
  EClass getArtifactType();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.ArtifactType#getMarkers <em>Markers</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Markers</em>'.
   * @see com.iona.soa.model.ArtifactType#getMarkers()
   * @see #getArtifactType()
   * @generated
   */
  EAttribute getArtifactType_Markers();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.ApplicationType <em>Application Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Application Type</em>'.
   * @see com.iona.soa.model.ApplicationType
   * @generated
   */
  EClass getApplicationType();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.Category <em>Category</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Category</em>'.
   * @see com.iona.soa.model.Category
   * @generated
   */
  EClass getCategory();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.ConfigurationOverride <em>Configuration Override</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Configuration Override</em>'.
   * @see com.iona.soa.model.ConfigurationOverride
   * @generated
   */
  EClass getConfigurationOverride();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.ConfigurationOverride#getApplication <em>Application</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Application</em>'.
   * @see com.iona.soa.model.ConfigurationOverride#getApplication()
   * @see #getConfigurationOverride()
   * @generated
   */
  EReference getConfigurationOverride_Application();

  /**
   * Returns the meta object for enum '{@link com.iona.soa.model.IndexStates <em>Index States</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Index States</em>'.
   * @see com.iona.soa.model.IndexStates
   * @generated
   */
  EEnum getIndexStates();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  SOA_NetworkFactory getSOA_NetworkFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.ApplicationImpl <em>Application</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.ApplicationImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getApplication()
     * @generated
     */
    EClass APPLICATION = eINSTANCE.getApplication();

    /**
     * The meta object literal for the '<em><b>Artifacts</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference APPLICATION__ARTIFACTS = eINSTANCE.getApplication_Artifacts();

    /**
     * The meta object literal for the '<em><b>Embedded</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference APPLICATION__EMBEDDED = eINSTANCE.getApplication_Embedded();

    /**
     * The meta object literal for the '<em><b>Depends</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference APPLICATION__DEPENDS = eINSTANCE.getApplication_Depends();

    /**
     * The meta object literal for the '<em><b>Profiles</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference APPLICATION__PROFILES = eINSTANCE.getApplication_Profiles();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference APPLICATION__TYPE = eINSTANCE.getApplication_Type();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.ArtifactImpl <em>Artifact</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.ArtifactImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getArtifact()
     * @generated
     */
    EClass ARTIFACT = eINSTANCE.getArtifact();

    /**
     * The meta object literal for the '<em><b>Applications</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ARTIFACT__APPLICATIONS = eINSTANCE.getArtifact_Applications();

    /**
     * The meta object literal for the '<em><b>Uri</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__URI = eINSTANCE.getArtifact_Uri();

    /**
     * The meta object literal for the '<em><b>File Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__FILE_NAME = eINSTANCE.getArtifact_FileName();

    /**
     * The meta object literal for the '<em><b>Version</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__VERSION = eINSTANCE.getArtifact_Version();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ARTIFACT__TYPE = eINSTANCE.getArtifact_Type();

    /**
     * The meta object literal for the '<em><b>Relative Location</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__RELATIVE_LOCATION = eINSTANCE.getArtifact_RelativeLocation();

    /**
     * The meta object literal for the '<em><b>Substitution</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__SUBSTITUTION = eINSTANCE.getArtifact_Substitution();

    /**
     * The meta object literal for the '<em><b>Sub Prefix</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__SUB_PREFIX = eINSTANCE.getArtifact_SubPrefix();

    /**
     * The meta object literal for the '<em><b>Sub Postfix</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__SUB_POSTFIX = eINSTANCE.getArtifact_SubPostfix();

    /**
     * The meta object literal for the '<em><b>Depends</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ARTIFACT__DEPENDS = eINSTANCE.getArtifact_Depends();

    /**
     * The meta object literal for the '<em><b>Found In</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ARTIFACT__FOUND_IN = eINSTANCE.getArtifact_FoundIn();

    /**
     * The meta object literal for the '<em><b>External</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT__EXTERNAL = eINSTANCE.getArtifact_External();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.StoredQueryImpl <em>Stored Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.StoredQueryImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getStoredQuery()
     * @generated
     */
    EClass STORED_QUERY = eINSTANCE.getStoredQuery();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute STORED_QUERY__TYPE = eINSTANCE.getStoredQuery_Type();

    /**
     * The meta object literal for the '<em><b>Query</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute STORED_QUERY__QUERY = eINSTANCE.getStoredQuery_Query();

    /**
     * The meta object literal for the '<em><b>Category</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute STORED_QUERY__CATEGORY = eINSTANCE.getStoredQuery_Category();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.ContainerImpl <em>Container</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.ContainerImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getContainer()
     * @generated
     */
    EClass CONTAINER = eINSTANCE.getContainer();

    /**
     * The meta object literal for the '<em><b>Supported Package Types</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONTAINER__SUPPORTED_PACKAGE_TYPES = eINSTANCE.getContainer_SupportedPackageTypes();

    /**
     * The meta object literal for the '<em><b>Status</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONTAINER__STATUS = eINSTANCE.getContainer_Status();

    /**
     * The meta object literal for the '<em><b>Applications</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONTAINER__APPLICATIONS = eINSTANCE.getContainer_Applications();

    /**
     * The meta object literal for the '<em><b>Artifacts</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONTAINER__ARTIFACTS = eINSTANCE.getContainer_Artifacts();

    /**
     * The meta object literal for the '<em><b>Profile</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONTAINER__PROFILE = eINSTANCE.getContainer_Profile();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONTAINER__TYPE = eINSTANCE.getContainer_Type();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.IConfigurationImpl <em>IConfiguration</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.IConfigurationImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getIConfiguration()
     * @generated
     */
    EClass ICONFIGURATION = eINSTANCE.getIConfiguration();

    /**
     * The meta object literal for the '<em><b>Configuration</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ICONFIGURATION__CONFIGURATION = eINSTANCE.getIConfiguration_Configuration();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.VersionedProfileImpl <em>Versioned Profile</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.VersionedProfileImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getVersionedProfile()
     * @generated
     */
    EClass VERSIONED_PROFILE = eINSTANCE.getVersionedProfile();

    /**
     * The meta object literal for the '<em><b>Applications</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference VERSIONED_PROFILE__APPLICATIONS = eINSTANCE.getVersionedProfile_Applications();

    /**
     * The meta object literal for the '<em><b>Publish Now</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSIONED_PROFILE__PUBLISH_NOW = eINSTANCE.getVersionedProfile_PublishNow();

    /**
     * The meta object literal for the '<em><b>Configuration Override</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference VERSIONED_PROFILE__CONFIGURATION_OVERRIDE = eINSTANCE.getVersionedProfile_ConfigurationOverride();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.FolderImpl <em>Folder</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.FolderImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getFolder()
     * @generated
     */
    EClass FOLDER = eINSTANCE.getFolder();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.MavenRepositoryImpl <em>Maven Repository</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.MavenRepositoryImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getMavenRepository()
     * @generated
     */
    EClass MAVEN_REPOSITORY = eINSTANCE.getMavenRepository();

    /**
     * The meta object literal for the '<em><b>Snapshots</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MAVEN_REPOSITORY__SNAPSHOTS = eINSTANCE.getMavenRepository_Snapshots();

    /**
     * The meta object literal for the '<em><b>Last Indexed</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MAVEN_REPOSITORY__LAST_INDEXED = eINSTANCE.getMavenRepository_LastIndexed();

    /**
     * The meta object literal for the '<em><b>Next Index</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MAVEN_REPOSITORY__NEXT_INDEX = eINSTANCE.getMavenRepository_NextIndex();

    /**
     * The meta object literal for the '<em><b>Indexed</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MAVEN_REPOSITORY__INDEXED = eINSTANCE.getMavenRepository_Indexed();

    /**
     * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MAVEN_REPOSITORY__ID = eINSTANCE.getMavenRepository_Id();

    /**
     * The meta object literal for the '<em><b>Index State</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MAVEN_REPOSITORY__INDEX_STATE = eINSTANCE.getMavenRepository_IndexState();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.IDeploymentConstraintImpl <em>IDeployment Constraint</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.IDeploymentConstraintImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getIDeploymentConstraint()
     * @generated
     */
    EClass IDEPLOYMENT_CONSTRAINT = eINSTANCE.getIDeploymentConstraint();

    /**
     * The meta object literal for the '<em><b>Constraints</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IDEPLOYMENT_CONSTRAINT__CONSTRAINTS = eINSTANCE.getIDeploymentConstraint_Constraints();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.InstalledApplicationImpl <em>Installed Application</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.InstalledApplicationImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getInstalledApplication()
     * @generated
     */
    EClass INSTALLED_APPLICATION = eINSTANCE.getInstalledApplication();

    /**
     * The meta object literal for the '<em><b>Artifacts</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INSTALLED_APPLICATION__ARTIFACTS = eINSTANCE.getInstalledApplication_Artifacts();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.InstalledArtifactImpl <em>Installed Artifact</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.InstalledArtifactImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getInstalledArtifact()
     * @generated
     */
    EClass INSTALLED_ARTIFACT = eINSTANCE.getInstalledArtifact();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.ArtifactRepositoryImpl <em>Artifact Repository</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.ArtifactRepositoryImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getArtifactRepository()
     * @generated
     */
    EClass ARTIFACT_REPOSITORY = eINSTANCE.getArtifactRepository();

    /**
     * The meta object literal for the '<em><b>Url</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT_REPOSITORY__URL = eINSTANCE.getArtifactRepository_Url();

    /**
     * The meta object literal for the '<em><b>Mirror Of</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ARTIFACT_REPOSITORY__MIRROR_OF = eINSTANCE.getArtifactRepository_MirrorOf();

    /**
     * The meta object literal for the '<em><b>Order ID</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT_REPOSITORY__ORDER_ID = eINSTANCE.getArtifactRepository_OrderID();

    /**
     * The meta object literal for the '<em><b>External</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT_REPOSITORY__EXTERNAL = eINSTANCE.getArtifactRepository_External();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.DeploymentProfileImpl <em>Deployment Profile</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.DeploymentProfileImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getDeploymentProfile()
     * @generated
     */
    EClass DEPLOYMENT_PROFILE = eINSTANCE.getDeploymentProfile();

    /**
     * The meta object literal for the '<em><b>Active</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPLOYMENT_PROFILE__ACTIVE = eINSTANCE.getDeploymentProfile_Active();

    /**
     * The meta object literal for the '<em><b>Version Tracker</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPLOYMENT_PROFILE__VERSION_TRACKER = eINSTANCE.getDeploymentProfile_VersionTracker();

    /**
     * The meta object literal for the '<em><b>Versions</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPLOYMENT_PROFILE__VERSIONS = eINSTANCE.getDeploymentProfile_Versions();

    /**
     * The meta object literal for the '<em><b>Current</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPLOYMENT_PROFILE__CURRENT = eINSTANCE.getDeploymentProfile_Current();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.ArtifactTypeImpl <em>Artifact Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.ArtifactTypeImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getArtifactType()
     * @generated
     */
    EClass ARTIFACT_TYPE = eINSTANCE.getArtifactType();

    /**
     * The meta object literal for the '<em><b>Markers</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARTIFACT_TYPE__MARKERS = eINSTANCE.getArtifactType_Markers();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.ApplicationTypeImpl <em>Application Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.ApplicationTypeImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getApplicationType()
     * @generated
     */
    EClass APPLICATION_TYPE = eINSTANCE.getApplicationType();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.CategoryImpl <em>Category</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.CategoryImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getCategory()
     * @generated
     */
    EClass CATEGORY = eINSTANCE.getCategory();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.impl.ConfigurationOverrideImpl <em>Configuration Override</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.impl.ConfigurationOverrideImpl
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getConfigurationOverride()
     * @generated
     */
    EClass CONFIGURATION_OVERRIDE = eINSTANCE.getConfigurationOverride();

    /**
     * The meta object literal for the '<em><b>Application</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONFIGURATION_OVERRIDE__APPLICATION = eINSTANCE.getConfigurationOverride_Application();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.IndexStates <em>Index States</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.IndexStates
     * @see com.iona.soa.model.impl.SOA_NetworkPackageImpl#getIndexStates()
     * @generated
     */
    EEnum INDEX_STATES = eINSTANCE.getIndexStates();

  }

} //SOA_NetworkPackage
