/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model;

import com.iona.soa.model.repository.IVersionedObject;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Versioned Profile</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.VersionedProfile#getApplications <em>Applications</em>}</li>
 *   <li>{@link com.iona.soa.model.VersionedProfile#isPublishNow <em>Publish Now</em>}</li>
 *   <li>{@link com.iona.soa.model.VersionedProfile#getConfigurationOverride <em>Configuration Override</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.SOA_NetworkPackage#getVersionedProfile()
 * @model
 * @generated
 */
public interface VersionedProfile extends IProtectedRepositoryObject, IVersionedObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Applications</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.Application}.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.Application#getProfiles <em>Profiles</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Applications</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Applications</em>' reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getVersionedProfile_Applications()
   * @see com.iona.soa.model.Application#getProfiles
   * @model opposite="profiles"
   * @generated
   */
  EList<Application> getApplications();


  /**
   * Returns the value of the '<em><b>Publish Now</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Publish Now</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Publish Now</em>' attribute.
   * @see #setPublishNow(boolean)
   * @see com.iona.soa.model.SOA_NetworkPackage#getVersionedProfile_PublishNow()
   * @model default="false" transient="true"
   * @generated
   */
  boolean isPublishNow();


  /**
   * Sets the value of the '{@link com.iona.soa.model.VersionedProfile#isPublishNow <em>Publish Now</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Publish Now</em>' attribute.
   * @see #isPublishNow()
   * @generated
   */
  void setPublishNow(boolean value);

  /**
   * Returns the value of the '<em><b>Configuration Override</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.ConfigurationOverride}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Configuration Override</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Configuration Override</em>' containment reference list.
   * @see com.iona.soa.model.SOA_NetworkPackage#getVersionedProfile_ConfigurationOverride()
   * @model containment="true"
   * @generated
   */
  EList<ConfigurationOverride> getConfigurationOverride();


} // VersionedProfile


