/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.collaboration;

import com.iona.soa.model.repository.RepositoryPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.collaboration.CollaborationFactory
 * @model kind="package"
 * @generated
 */
public interface CollaborationPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "collaboration";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.collaboration";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itcollaboration";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  CollaborationPackage eINSTANCE = com.iona.soa.model.collaboration.impl.CollaborationPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.collaboration.ICollaboration <em>ICollaboration</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.collaboration.ICollaboration
   * @see com.iona.soa.model.collaboration.impl.CollaborationPackageImpl#getICollaboration()
   * @generated
   */
  int ICOLLABORATION = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Owner</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__OWNER = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Subscribers</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__SUBSCRIBERS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Comments</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION__COMMENTS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>ICollaboration</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICOLLABORATION_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link com.iona.soa.model.collaboration.impl.CommentImpl <em>Comment</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.collaboration.impl.CommentImpl
   * @see com.iona.soa.model.collaboration.impl.CollaborationPackageImpl#getComment()
   * @generated
   */
  int COMMENT = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Contents</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__CONTENTS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>User Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT__USER_ID = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Comment</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COMMENT_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.collaboration.ICollaboration <em>ICollaboration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>ICollaboration</em>'.
   * @see com.iona.soa.model.collaboration.ICollaboration
   * @generated
   */
  EClass getICollaboration();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.collaboration.ICollaboration#getOwner <em>Owner</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Owner</em>'.
   * @see com.iona.soa.model.collaboration.ICollaboration#getOwner()
   * @see #getICollaboration()
   * @generated
   */
  EReference getICollaboration_Owner();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.collaboration.ICollaboration#getSubscribers <em>Subscribers</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Subscribers</em>'.
   * @see com.iona.soa.model.collaboration.ICollaboration#getSubscribers()
   * @see #getICollaboration()
   * @generated
   */
  EReference getICollaboration_Subscribers();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.collaboration.ICollaboration#getComments <em>Comments</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Comments</em>'.
   * @see com.iona.soa.model.collaboration.ICollaboration#getComments()
   * @see #getICollaboration()
   * @generated
   */
  EReference getICollaboration_Comments();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.collaboration.Comment <em>Comment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Comment</em>'.
   * @see com.iona.soa.model.collaboration.Comment
   * @generated
   */
  EClass getComment();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.collaboration.Comment#getContents <em>Contents</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Contents</em>'.
   * @see com.iona.soa.model.collaboration.Comment#getContents()
   * @see #getComment()
   * @generated
   */
  EAttribute getComment_Contents();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.collaboration.Comment#getUserId <em>User Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>User Id</em>'.
   * @see com.iona.soa.model.collaboration.Comment#getUserId()
   * @see #getComment()
   * @generated
   */
  EAttribute getComment_UserId();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  CollaborationFactory getCollaborationFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.collaboration.ICollaboration <em>ICollaboration</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.collaboration.ICollaboration
     * @see com.iona.soa.model.collaboration.impl.CollaborationPackageImpl#getICollaboration()
     * @generated
     */
    EClass ICOLLABORATION = eINSTANCE.getICollaboration();

    /**
     * The meta object literal for the '<em><b>Owner</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ICOLLABORATION__OWNER = eINSTANCE.getICollaboration_Owner();

    /**
     * The meta object literal for the '<em><b>Subscribers</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ICOLLABORATION__SUBSCRIBERS = eINSTANCE.getICollaboration_Subscribers();

    /**
     * The meta object literal for the '<em><b>Comments</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ICOLLABORATION__COMMENTS = eINSTANCE.getICollaboration_Comments();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.collaboration.impl.CommentImpl <em>Comment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.collaboration.impl.CommentImpl
     * @see com.iona.soa.model.collaboration.impl.CollaborationPackageImpl#getComment()
     * @generated
     */
    EClass COMMENT = eINSTANCE.getComment();

    /**
     * The meta object literal for the '<em><b>Contents</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMMENT__CONTENTS = eINSTANCE.getComment_Contents();

    /**
     * The meta object literal for the '<em><b>User Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COMMENT__USER_ID = eINSTANCE.getComment_UserId();

  }

} //CollaborationPackage
