/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.collaboration;

import com.iona.soa.model.repository.IPersistableObject;

import com.iona.soa.model.security.User;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>ICollaboration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.collaboration.ICollaboration#getOwner <em>Owner</em>}</li>
 *   <li>{@link com.iona.soa.model.collaboration.ICollaboration#getSubscribers <em>Subscribers</em>}</li>
 *   <li>{@link com.iona.soa.model.collaboration.ICollaboration#getComments <em>Comments</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.collaboration.CollaborationPackage#getICollaboration()
 * @model interface="true" abstract="true"
 *        annotation="searchHints comments='contents'"
 * @generated
 */
public interface ICollaboration extends IPersistableObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Owner</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Owner</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Owner</em>' reference.
   * @see #setOwner(User)
   * @see com.iona.soa.model.collaboration.CollaborationPackage#getICollaboration_Owner()
   * @model
   * @generated
   */
  User getOwner();


  /**
   * Sets the value of the '{@link com.iona.soa.model.collaboration.ICollaboration#getOwner <em>Owner</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Owner</em>' reference.
   * @see #getOwner()
   * @generated
   */
  void setOwner(User value);

  /**
   * Returns the value of the '<em><b>Subscribers</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.User}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Subscribers</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Subscribers</em>' reference list.
   * @see com.iona.soa.model.collaboration.CollaborationPackage#getICollaboration_Subscribers()
   * @model
   * @generated
   */
  EList<User> getSubscribers();


  /**
   * Returns the value of the '<em><b>Comments</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.collaboration.Comment}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Comments</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Comments</em>' containment reference list.
   * @see com.iona.soa.model.collaboration.CollaborationPackage#getICollaboration_Comments()
   * @model containment="true"
   * @generated
   */
  EList<Comment> getComments();


} // ICollaboration


