/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.events;

import java.sql.Timestamp;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Change Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getUserId <em>User Id</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getUserName <em>User Name</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getUserEMail <em>User EMail</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getChangeKind <em>Change Kind</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getTimestamp <em>Timestamp</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getTargetGuid <em>Target Guid</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getTargetType <em>Target Type</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getTargetName <em>Target Name</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getTargetNamespace <em>Target Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getUpdatedFields <em>Updated Fields</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeEvent#getUserToken <em>User Token</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent()
 * @model annotation="dbhints table='none'"
 * @generated
 */
public interface DataChangeEvent extends EObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>User Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>User Id</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>User Id</em>' attribute.
   * @see #setUserId(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_UserId()
   * @model required="true"
   * @generated
   */
  String getUserId();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getUserId <em>User Id</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>User Id</em>' attribute.
   * @see #getUserId()
   * @generated
   */
  void setUserId(String value);

  /**
   * Returns the value of the '<em><b>User Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>User Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>User Name</em>' attribute.
   * @see #setUserName(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_UserName()
   * @model
   * @generated
   */
  String getUserName();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getUserName <em>User Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>User Name</em>' attribute.
   * @see #getUserName()
   * @generated
   */
  void setUserName(String value);

  /**
   * Returns the value of the '<em><b>User EMail</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>User EMail</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>User EMail</em>' attribute.
   * @see #setUserEMail(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_UserEMail()
   * @model
   * @generated
   */
  String getUserEMail();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getUserEMail <em>User EMail</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>User EMail</em>' attribute.
   * @see #getUserEMail()
   * @generated
   */
  void setUserEMail(String value);

  /**
   * Returns the value of the '<em><b>Change Kind</b></em>' attribute.
   * The literals are from the enumeration {@link com.iona.soa.model.events.DataChangeKind}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Change Kind</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Change Kind</em>' attribute.
   * @see com.iona.soa.model.events.DataChangeKind
   * @see #setChangeKind(DataChangeKind)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_ChangeKind()
   * @model required="true"
   * @generated
   */
  DataChangeKind getChangeKind();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getChangeKind <em>Change Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Change Kind</em>' attribute.
   * @see com.iona.soa.model.events.DataChangeKind
   * @see #getChangeKind()
   * @generated
   */
  void setChangeKind(DataChangeKind value);

  /**
   * Returns the value of the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Timestamp</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Timestamp</em>' attribute.
   * @see #setTimestamp(Timestamp)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_Timestamp()
   * @model dataType="com.iona.soa.model.repository.Timestamp" required="true"
   * @generated
   */
  Timestamp getTimestamp();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getTimestamp <em>Timestamp</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Timestamp</em>' attribute.
   * @see #getTimestamp()
   * @generated
   */
  void setTimestamp(Timestamp value);

  /**
   * Returns the value of the '<em><b>Target Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Guid</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Guid</em>' attribute.
   * @see #setTargetGuid(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_TargetGuid()
   * @model required="true"
   * @generated
   */
  String getTargetGuid();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getTargetGuid <em>Target Guid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Guid</em>' attribute.
   * @see #getTargetGuid()
   * @generated
   */
  void setTargetGuid(String value);

  /**
   * Returns the value of the '<em><b>Target Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Type</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Type</em>' reference.
   * @see #setTargetType(EClass)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_TargetType()
   * @model required="true"
   * @generated
   */
  EClass getTargetType();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getTargetType <em>Target Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Type</em>' reference.
   * @see #getTargetType()
   * @generated
   */
  void setTargetType(EClass value);

  /**
   * Returns the value of the '<em><b>Target Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Name</em>' attribute.
   * @see #setTargetName(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_TargetName()
   * @model
   * @generated
   */
  String getTargetName();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getTargetName <em>Target Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Name</em>' attribute.
   * @see #getTargetName()
   * @generated
   */
  void setTargetName(String value);

  /**
   * Returns the value of the '<em><b>Target Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Namespace</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Namespace</em>' attribute.
   * @see #setTargetNamespace(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_TargetNamespace()
   * @model
   * @generated
   */
  String getTargetNamespace();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getTargetNamespace <em>Target Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Namespace</em>' attribute.
   * @see #getTargetNamespace()
   * @generated
   */
  void setTargetNamespace(String value);

  /**
   * Returns the value of the '<em><b>Updated Fields</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.events.DataChangeFieldDelta}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Updated Fields</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Updated Fields</em>' reference list.
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_UpdatedFields()
   * @model
   * @generated
   */
  EList<DataChangeFieldDelta> getUpdatedFields();


  /**
   * Returns the value of the '<em><b>User Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>User Token</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>User Token</em>' attribute.
   * @see #setUserToken(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeEvent_UserToken()
   * @model required="true"
   * @generated
   */
  String getUserToken();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeEvent#getUserToken <em>User Token</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>User Token</em>' attribute.
   * @see #getUserToken()
   * @generated
   */
  void setUserToken(String value);

} // DataChangeEvent


