/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.events;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Change Field Delta</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.events.DataChangeFieldDelta#getFieldDesc <em>Field Desc</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeFieldDelta#getOldValue <em>Old Value</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeFieldDelta#getNewValue <em>New Value</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeFieldDelta#getOldValues <em>Old Values</em>}</li>
 *   <li>{@link com.iona.soa.model.events.DataChangeFieldDelta#getNewValues <em>New Values</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.events.EventsPackage#getDataChangeFieldDelta()
 * @model annotation="dbhints table='none'"
 * @generated
 */
public interface DataChangeFieldDelta extends EObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Field Desc</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Field Desc</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Field Desc</em>' reference.
   * @see #setFieldDesc(EStructuralFeature)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeFieldDelta_FieldDesc()
   * @model required="true"
   * @generated
   */
  EStructuralFeature getFieldDesc();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeFieldDelta#getFieldDesc <em>Field Desc</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Field Desc</em>' reference.
   * @see #getFieldDesc()
   * @generated
   */
  void setFieldDesc(EStructuralFeature value);

  /**
   * Returns the value of the '<em><b>Old Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Old Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Old Value</em>' attribute.
   * @see #setOldValue(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeFieldDelta_OldValue()
   * @model
   * @generated
   */
  String getOldValue();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeFieldDelta#getOldValue <em>Old Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Old Value</em>' attribute.
   * @see #getOldValue()
   * @generated
   */
  void setOldValue(String value);

  /**
   * Returns the value of the '<em><b>New Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>New Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>New Value</em>' attribute.
   * @see #setNewValue(String)
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeFieldDelta_NewValue()
   * @model
   * @generated
   */
  String getNewValue();


  /**
   * Sets the value of the '{@link com.iona.soa.model.events.DataChangeFieldDelta#getNewValue <em>New Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>New Value</em>' attribute.
   * @see #getNewValue()
   * @generated
   */
  void setNewValue(String value);

  /**
   * Returns the value of the '<em><b>Old Values</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Old Values</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Old Values</em>' attribute list.
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeFieldDelta_OldValues()
   * @model
   * @generated
   */
  EList<String> getOldValues();


  /**
   * Returns the value of the '<em><b>New Values</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>New Values</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>New Values</em>' attribute list.
   * @see com.iona.soa.model.events.EventsPackage#getDataChangeFieldDelta_NewValues()
   * @model
   * @generated
   */
  EList<String> getNewValues();


} // DataChangeFieldDelta


