/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.events;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.events.EventsFactory
 * @model kind="package"
 * @generated
 */
public interface EventsPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "events";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.events";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itevents";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  EventsPackage eINSTANCE = com.iona.soa.model.events.impl.EventsPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.events.impl.DataChangeEventImpl <em>Data Change Event</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.events.impl.DataChangeEventImpl
   * @see com.iona.soa.model.events.impl.EventsPackageImpl#getDataChangeEvent()
   * @generated
   */
  int DATA_CHANGE_EVENT = 0;

  /**
   * The feature id for the '<em><b>User Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__USER_ID = 0;

  /**
   * The feature id for the '<em><b>User Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__USER_NAME = 1;

  /**
   * The feature id for the '<em><b>User EMail</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__USER_EMAIL = 2;

  /**
   * The feature id for the '<em><b>Change Kind</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__CHANGE_KIND = 3;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__TIMESTAMP = 4;

  /**
   * The feature id for the '<em><b>Target Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__TARGET_GUID = 5;

  /**
   * The feature id for the '<em><b>Target Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__TARGET_TYPE = 6;

  /**
   * The feature id for the '<em><b>Target Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__TARGET_NAME = 7;

  /**
   * The feature id for the '<em><b>Target Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__TARGET_NAMESPACE = 8;

  /**
   * The feature id for the '<em><b>Updated Fields</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__UPDATED_FIELDS = 9;

  /**
   * The feature id for the '<em><b>User Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT__USER_TOKEN = 10;

  /**
   * The number of structural features of the '<em>Data Change Event</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_EVENT_FEATURE_COUNT = 11;

  /**
   * The meta object id for the '{@link com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl <em>Data Change Field Delta</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl
   * @see com.iona.soa.model.events.impl.EventsPackageImpl#getDataChangeFieldDelta()
   * @generated
   */
  int DATA_CHANGE_FIELD_DELTA = 1;

  /**
   * The feature id for the '<em><b>Field Desc</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_FIELD_DELTA__FIELD_DESC = 0;

  /**
   * The feature id for the '<em><b>Old Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_FIELD_DELTA__OLD_VALUE = 1;

  /**
   * The feature id for the '<em><b>New Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_FIELD_DELTA__NEW_VALUE = 2;

  /**
   * The feature id for the '<em><b>Old Values</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_FIELD_DELTA__OLD_VALUES = 3;

  /**
   * The feature id for the '<em><b>New Values</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_FIELD_DELTA__NEW_VALUES = 4;

  /**
   * The number of structural features of the '<em>Data Change Field Delta</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DATA_CHANGE_FIELD_DELTA_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link com.iona.soa.model.events.DataChangeKind <em>Data Change Kind</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.events.DataChangeKind
   * @see com.iona.soa.model.events.impl.EventsPackageImpl#getDataChangeKind()
   * @generated
   */
  int DATA_CHANGE_KIND = 2;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.events.DataChangeEvent <em>Data Change Event</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Data Change Event</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent
   * @generated
   */
  EClass getDataChangeEvent();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getUserId <em>User Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>User Id</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getUserId()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_UserId();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getUserName <em>User Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>User Name</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getUserName()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_UserName();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getUserEMail <em>User EMail</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>User EMail</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getUserEMail()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_UserEMail();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getChangeKind <em>Change Kind</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Change Kind</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getChangeKind()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_ChangeKind();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getTimestamp <em>Timestamp</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Timestamp</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getTimestamp()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_Timestamp();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getTargetGuid <em>Target Guid</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Guid</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getTargetGuid()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_TargetGuid();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.events.DataChangeEvent#getTargetType <em>Target Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Target Type</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getTargetType()
   * @see #getDataChangeEvent()
   * @generated
   */
  EReference getDataChangeEvent_TargetType();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getTargetName <em>Target Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Name</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getTargetName()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_TargetName();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getTargetNamespace <em>Target Namespace</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Namespace</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getTargetNamespace()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_TargetNamespace();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.events.DataChangeEvent#getUpdatedFields <em>Updated Fields</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Updated Fields</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getUpdatedFields()
   * @see #getDataChangeEvent()
   * @generated
   */
  EReference getDataChangeEvent_UpdatedFields();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeEvent#getUserToken <em>User Token</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>User Token</em>'.
   * @see com.iona.soa.model.events.DataChangeEvent#getUserToken()
   * @see #getDataChangeEvent()
   * @generated
   */
  EAttribute getDataChangeEvent_UserToken();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.events.DataChangeFieldDelta <em>Data Change Field Delta</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Data Change Field Delta</em>'.
   * @see com.iona.soa.model.events.DataChangeFieldDelta
   * @generated
   */
  EClass getDataChangeFieldDelta();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.events.DataChangeFieldDelta#getFieldDesc <em>Field Desc</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Field Desc</em>'.
   * @see com.iona.soa.model.events.DataChangeFieldDelta#getFieldDesc()
   * @see #getDataChangeFieldDelta()
   * @generated
   */
  EReference getDataChangeFieldDelta_FieldDesc();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeFieldDelta#getOldValue <em>Old Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Old Value</em>'.
   * @see com.iona.soa.model.events.DataChangeFieldDelta#getOldValue()
   * @see #getDataChangeFieldDelta()
   * @generated
   */
  EAttribute getDataChangeFieldDelta_OldValue();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.events.DataChangeFieldDelta#getNewValue <em>New Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>New Value</em>'.
   * @see com.iona.soa.model.events.DataChangeFieldDelta#getNewValue()
   * @see #getDataChangeFieldDelta()
   * @generated
   */
  EAttribute getDataChangeFieldDelta_NewValue();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.events.DataChangeFieldDelta#getOldValues <em>Old Values</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Old Values</em>'.
   * @see com.iona.soa.model.events.DataChangeFieldDelta#getOldValues()
   * @see #getDataChangeFieldDelta()
   * @generated
   */
  EAttribute getDataChangeFieldDelta_OldValues();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.events.DataChangeFieldDelta#getNewValues <em>New Values</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>New Values</em>'.
   * @see com.iona.soa.model.events.DataChangeFieldDelta#getNewValues()
   * @see #getDataChangeFieldDelta()
   * @generated
   */
  EAttribute getDataChangeFieldDelta_NewValues();

  /**
   * Returns the meta object for enum '{@link com.iona.soa.model.events.DataChangeKind <em>Data Change Kind</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Data Change Kind</em>'.
   * @see com.iona.soa.model.events.DataChangeKind
   * @generated
   */
  EEnum getDataChangeKind();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  EventsFactory getEventsFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.events.impl.DataChangeEventImpl <em>Data Change Event</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.events.impl.DataChangeEventImpl
     * @see com.iona.soa.model.events.impl.EventsPackageImpl#getDataChangeEvent()
     * @generated
     */
    EClass DATA_CHANGE_EVENT = eINSTANCE.getDataChangeEvent();

    /**
     * The meta object literal for the '<em><b>User Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__USER_ID = eINSTANCE.getDataChangeEvent_UserId();

    /**
     * The meta object literal for the '<em><b>User Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__USER_NAME = eINSTANCE.getDataChangeEvent_UserName();

    /**
     * The meta object literal for the '<em><b>User EMail</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__USER_EMAIL = eINSTANCE.getDataChangeEvent_UserEMail();

    /**
     * The meta object literal for the '<em><b>Change Kind</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__CHANGE_KIND = eINSTANCE.getDataChangeEvent_ChangeKind();

    /**
     * The meta object literal for the '<em><b>Timestamp</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__TIMESTAMP = eINSTANCE.getDataChangeEvent_Timestamp();

    /**
     * The meta object literal for the '<em><b>Target Guid</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__TARGET_GUID = eINSTANCE.getDataChangeEvent_TargetGuid();

    /**
     * The meta object literal for the '<em><b>Target Type</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DATA_CHANGE_EVENT__TARGET_TYPE = eINSTANCE.getDataChangeEvent_TargetType();

    /**
     * The meta object literal for the '<em><b>Target Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__TARGET_NAME = eINSTANCE.getDataChangeEvent_TargetName();

    /**
     * The meta object literal for the '<em><b>Target Namespace</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__TARGET_NAMESPACE = eINSTANCE.getDataChangeEvent_TargetNamespace();

    /**
     * The meta object literal for the '<em><b>Updated Fields</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DATA_CHANGE_EVENT__UPDATED_FIELDS = eINSTANCE.getDataChangeEvent_UpdatedFields();

    /**
     * The meta object literal for the '<em><b>User Token</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_EVENT__USER_TOKEN = eINSTANCE.getDataChangeEvent_UserToken();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl <em>Data Change Field Delta</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl
     * @see com.iona.soa.model.events.impl.EventsPackageImpl#getDataChangeFieldDelta()
     * @generated
     */
    EClass DATA_CHANGE_FIELD_DELTA = eINSTANCE.getDataChangeFieldDelta();

    /**
     * The meta object literal for the '<em><b>Field Desc</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DATA_CHANGE_FIELD_DELTA__FIELD_DESC = eINSTANCE.getDataChangeFieldDelta_FieldDesc();

    /**
     * The meta object literal for the '<em><b>Old Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_FIELD_DELTA__OLD_VALUE = eINSTANCE.getDataChangeFieldDelta_OldValue();

    /**
     * The meta object literal for the '<em><b>New Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_FIELD_DELTA__NEW_VALUE = eINSTANCE.getDataChangeFieldDelta_NewValue();

    /**
     * The meta object literal for the '<em><b>Old Values</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_FIELD_DELTA__OLD_VALUES = eINSTANCE.getDataChangeFieldDelta_OldValues();

    /**
     * The meta object literal for the '<em><b>New Values</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DATA_CHANGE_FIELD_DELTA__NEW_VALUES = eINSTANCE.getDataChangeFieldDelta_NewValues();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.events.DataChangeKind <em>Data Change Kind</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.events.DataChangeKind
     * @see com.iona.soa.model.events.impl.EventsPackageImpl#getDataChangeKind()
     * @generated
     */
    EEnum DATA_CHANGE_KIND = eINSTANCE.getDataChangeKind();

  }

} //EventsPackage
