/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.events.impl;

import com.iona.soa.model.datatypes.DanglingProxyAdapter;

import com.iona.soa.model.events.DataChangeEvent;
import com.iona.soa.model.events.DataChangeFieldDelta;
import com.iona.soa.model.events.DataChangeKind;
import com.iona.soa.model.events.EventsPackage;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

import java.sql.Timestamp;

import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.resource.Resource;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Change Event</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getUserId <em>User Id</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getUserName <em>User Name</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getUserEMail <em>User EMail</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getChangeKind <em>Change Kind</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getTimestamp <em>Timestamp</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getTargetGuid <em>Target Guid</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getTargetType <em>Target Type</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getTargetName <em>Target Name</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getTargetNamespace <em>Target Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getUpdatedFields <em>Updated Fields</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeEventImpl#getUserToken <em>User Token</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DataChangeEventImpl extends EObjectImpl implements DataChangeEvent
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getUserId() <em>User Id</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserId()
   * @generated
   * @ordered
   */
  protected static final String USER_ID_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getUserId() <em>User Id</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserId()
   * @generated
   * @ordered
   */
  protected String userId = USER_ID_EDEFAULT;

  /**
   * The default value of the '{@link #getUserName() <em>User Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserName()
   * @generated
   * @ordered
   */
  protected static final String USER_NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getUserName() <em>User Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserName()
   * @generated
   * @ordered
   */
  protected String userName = USER_NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getUserEMail() <em>User EMail</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserEMail()
   * @generated
   * @ordered
   */
  protected static final String USER_EMAIL_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getUserEMail() <em>User EMail</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserEMail()
   * @generated
   * @ordered
   */
  protected String userEMail = USER_EMAIL_EDEFAULT;

  /**
   * The default value of the '{@link #getChangeKind() <em>Change Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getChangeKind()
   * @generated
   * @ordered
   */
  protected static final DataChangeKind CHANGE_KIND_EDEFAULT = DataChangeKind.ADD_LITERAL;

  /**
   * The cached value of the '{@link #getChangeKind() <em>Change Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getChangeKind()
   * @generated
   * @ordered
   */
  protected DataChangeKind changeKind = CHANGE_KIND_EDEFAULT;

  /**
   * The default value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimestamp()
   * @generated
   * @ordered
   */
  protected static final Timestamp TIMESTAMP_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimestamp()
   * @generated
   * @ordered
   */
  protected Timestamp timestamp = TIMESTAMP_EDEFAULT;

  /**
   * The default value of the '{@link #getTargetGuid() <em>Target Guid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetGuid()
   * @generated
   * @ordered
   */
  protected static final String TARGET_GUID_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getTargetGuid() <em>Target Guid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetGuid()
   * @generated
   * @ordered
   */
  protected String targetGuid = TARGET_GUID_EDEFAULT;

  /**
   * The cached value of the '{@link #getTargetType() <em>Target Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetType()
   * @generated
   * @ordered
   */
  protected EClass targetType;

  /**
   * The default value of the '{@link #getTargetName() <em>Target Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetName()
   * @generated
   * @ordered
   */
  protected static final String TARGET_NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getTargetName() <em>Target Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetName()
   * @generated
   * @ordered
   */
  protected String targetName = TARGET_NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getTargetNamespace() <em>Target Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetNamespace()
   * @generated
   * @ordered
   */
  protected static final String TARGET_NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getTargetNamespace() <em>Target Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetNamespace()
   * @generated
   * @ordered
   */
  protected String targetNamespace = TARGET_NAMESPACE_EDEFAULT;

  /**
   * The cached value of the '{@link #getUpdatedFields() <em>Updated Fields</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUpdatedFields()
   * @generated
   * @ordered
   */
  protected EList<DataChangeFieldDelta> updatedFields;

  /**
   * The default value of the '{@link #getUserToken() <em>User Token</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserToken()
   * @generated
   * @ordered
   */
  protected static final String USER_TOKEN_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getUserToken() <em>User Token</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserToken()
   * @generated
   * @ordered
   */
  protected String userToken = USER_TOKEN_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DataChangeEventImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return EventsPackage.Literals.DATA_CHANGE_EVENT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUserId() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_ID);
    return _basicGetUserId();
  }
  
  private final String _basicGetUserId() {
    return userId;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUserId(String newUserId)
  {
    
    String oldUserId = userId;
    userId = newUserId;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__USER_ID, oldUserId, userId));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUserName() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_NAME);
    return _basicGetUserName();
  }
  
  private final String _basicGetUserName() {
    return userName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUserName(String newUserName)
  {
    
    String oldUserName = userName;
    userName = newUserName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__USER_NAME, oldUserName, userName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUserEMail() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_EMAIL);
    return _basicGetUserEMail();
  }
  
  private final String _basicGetUserEMail() {
    return userEMail;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUserEMail(String newUserEMail)
  {
    
    String oldUserEMail = userEMail;
    userEMail = newUserEMail;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__USER_EMAIL, oldUserEMail, userEMail));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DataChangeKind getChangeKind() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__CHANGE_KIND);
    return _basicGetChangeKind();
  }
  
  private final DataChangeKind _basicGetChangeKind() {
    return changeKind;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setChangeKind(DataChangeKind newChangeKind)
  {
    
    DataChangeKind oldChangeKind = changeKind;
    changeKind = newChangeKind == null ? CHANGE_KIND_EDEFAULT : newChangeKind;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__CHANGE_KIND, oldChangeKind, changeKind));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp getTimestamp() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TIMESTAMP);
    return _basicGetTimestamp();
  }
  
  private final Timestamp _basicGetTimestamp() {
    return timestamp;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTimestamp(Timestamp newTimestamp)
  {
    
    Timestamp oldTimestamp = timestamp;
    timestamp = newTimestamp;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__TIMESTAMP, oldTimestamp, timestamp));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetGuid() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_GUID);
    return _basicGetTargetGuid();
  }
  
  private final String _basicGetTargetGuid() {
    return targetGuid;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetGuid(String newTargetGuid)
  {
    
    String oldTargetGuid = targetGuid;
    targetGuid = newTargetGuid;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__TARGET_GUID, oldTargetGuid, targetGuid));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getTargetType() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_TYPE);
    return _basicGetTargetType();
  }
  
  private final EClass _basicGetTargetType() {
    if (targetType != null && targetType.eIsProxy())
    {
      InternalEObject oldTargetType = (InternalEObject)targetType;
      targetType = (EClass)eResolveProxy(oldTargetType);
      if (targetType != oldTargetType)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, EventsPackage.DATA_CHANGE_EVENT__TARGET_TYPE, oldTargetType, targetType));
      }
    }
    return targetType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass basicGetTargetType()
  {
    return targetType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetType(EClass newTargetType)
  {
    
    EClass oldTargetType = targetType;
    targetType = newTargetType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__TARGET_TYPE, oldTargetType, targetType));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetName() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_NAME);
    return _basicGetTargetName();
  }
  
  private final String _basicGetTargetName() {
    return targetName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetName(String newTargetName)
  {
    
    String oldTargetName = targetName;
    targetName = newTargetName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__TARGET_NAME, oldTargetName, targetName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTargetNamespace() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_NAMESPACE);
    return _basicGetTargetNamespace();
  }
  
  private final String _basicGetTargetNamespace() {
    return targetNamespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetNamespace(String newTargetNamespace)
  {
    
    String oldTargetNamespace = targetNamespace;
    targetNamespace = newTargetNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__TARGET_NAMESPACE, oldTargetNamespace, targetNamespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<DataChangeFieldDelta> getUpdatedFields() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__UPDATED_FIELDS);
    return _basicGetUpdatedFields();
  }
  
  private final EList<DataChangeFieldDelta> _basicGetUpdatedFields() {
    if (updatedFields == null)
    {
      updatedFields = new EObjectResolvingEList<DataChangeFieldDelta>(DataChangeFieldDelta.class, this, EventsPackage.DATA_CHANGE_EVENT__UPDATED_FIELDS);
    }
    return updatedFields;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUserToken() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_TOKEN);
    return _basicGetUserToken();
  }
  
  private final String _basicGetUserToken() {
    return userToken;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUserToken(String newUserToken)
  {
    
    String oldUserToken = userToken;
    userToken = newUserToken;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_EVENT__USER_TOKEN, oldUserToken, userToken));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case EventsPackage.DATA_CHANGE_EVENT__USER_ID:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_ID); }
        return _basicGetUserId();
      case EventsPackage.DATA_CHANGE_EVENT__USER_NAME:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_NAME); }
        return _basicGetUserName();
      case EventsPackage.DATA_CHANGE_EVENT__USER_EMAIL:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_EMAIL); }
        return _basicGetUserEMail();
      case EventsPackage.DATA_CHANGE_EVENT__CHANGE_KIND:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__CHANGE_KIND); }
        return _basicGetChangeKind();
      case EventsPackage.DATA_CHANGE_EVENT__TIMESTAMP:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TIMESTAMP); }
        return _basicGetTimestamp();
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_GUID:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_GUID); }
        return _basicGetTargetGuid();
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_TYPE:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_TYPE); }
        if (resolve) return getTargetType();
        return _basicGetTargetType();
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAME:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_NAME); }
        return _basicGetTargetName();
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAMESPACE:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__TARGET_NAMESPACE); }
        return _basicGetTargetNamespace();
      case EventsPackage.DATA_CHANGE_EVENT__UPDATED_FIELDS:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__UPDATED_FIELDS); }
        return _basicGetUpdatedFields();
      case EventsPackage.DATA_CHANGE_EVENT__USER_TOKEN:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_EVENT__USER_TOKEN); }
        return _basicGetUserToken();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case EventsPackage.DATA_CHANGE_EVENT__USER_ID:
        setUserId((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__USER_NAME:
        setUserName((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__USER_EMAIL:
        setUserEMail((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__CHANGE_KIND:
        setChangeKind((DataChangeKind)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__TIMESTAMP:
        setTimestamp((Timestamp)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_GUID:
        setTargetGuid((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_TYPE:
        setTargetType((EClass)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAME:
        setTargetName((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAMESPACE:
        setTargetNamespace((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__UPDATED_FIELDS:
        _basicGetUpdatedFields().clear();
        _basicGetUpdatedFields().addAll((Collection<? extends DataChangeFieldDelta>)newValue);
        return;
      case EventsPackage.DATA_CHANGE_EVENT__USER_TOKEN:
        setUserToken((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case EventsPackage.DATA_CHANGE_EVENT__USER_ID:
      setUserId(USER_ID_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__USER_NAME:
      setUserName(USER_NAME_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__USER_EMAIL:
      setUserEMail(USER_EMAIL_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__CHANGE_KIND:
      setChangeKind(CHANGE_KIND_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__TIMESTAMP:
      setTimestamp(TIMESTAMP_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__TARGET_GUID:
      setTargetGuid(TARGET_GUID_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__TARGET_TYPE:
      setTargetType((EClass)null);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAME:
      setTargetName(TARGET_NAME_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAMESPACE:
      setTargetNamespace(TARGET_NAMESPACE_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_EVENT__UPDATED_FIELDS:
      _basicGetUpdatedFields().clear();
      return;
    case EventsPackage.DATA_CHANGE_EVENT__USER_TOKEN:
      setUserToken(USER_TOKEN_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case EventsPackage.DATA_CHANGE_EVENT__USER_ID:
        return USER_ID_EDEFAULT == null ? userId != null : !USER_ID_EDEFAULT.equals(userId);
      case EventsPackage.DATA_CHANGE_EVENT__USER_NAME:
        return USER_NAME_EDEFAULT == null ? userName != null : !USER_NAME_EDEFAULT.equals(userName);
      case EventsPackage.DATA_CHANGE_EVENT__USER_EMAIL:
        return USER_EMAIL_EDEFAULT == null ? userEMail != null : !USER_EMAIL_EDEFAULT.equals(userEMail);
      case EventsPackage.DATA_CHANGE_EVENT__CHANGE_KIND:
        return changeKind != CHANGE_KIND_EDEFAULT;
      case EventsPackage.DATA_CHANGE_EVENT__TIMESTAMP:
        return TIMESTAMP_EDEFAULT == null ? timestamp != null : !TIMESTAMP_EDEFAULT.equals(timestamp);
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_GUID:
        return TARGET_GUID_EDEFAULT == null ? targetGuid != null : !TARGET_GUID_EDEFAULT.equals(targetGuid);
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_TYPE:
        return targetType != null;
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAME:
        return TARGET_NAME_EDEFAULT == null ? targetName != null : !TARGET_NAME_EDEFAULT.equals(targetName);
      case EventsPackage.DATA_CHANGE_EVENT__TARGET_NAMESPACE:
        return TARGET_NAMESPACE_EDEFAULT == null ? targetNamespace != null : !TARGET_NAMESPACE_EDEFAULT.equals(targetNamespace);
      case EventsPackage.DATA_CHANGE_EVENT__UPDATED_FIELDS:
        return updatedFields != null && !updatedFields.isEmpty();
      case EventsPackage.DATA_CHANGE_EVENT__USER_TOKEN:
        return USER_TOKEN_EDEFAULT == null ? userToken != null : !USER_TOKEN_EDEFAULT.equals(userToken);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (userId: ");
    result.append(userId);
    result.append(", userName: ");
    result.append(userName);
    result.append(", userEMail: ");
    result.append(userEMail);
    result.append(", changeKind: ");
    result.append(changeKind);
    result.append(", timestamp: ");
    result.append(timestamp);
    result.append(", targetGuid: ");
    result.append(targetGuid);
    result.append(", targetName: ");
    result.append(targetName);
    result.append(", targetNamespace: ");
    result.append(targetNamespace);
    result.append(", userToken: ");
    result.append(userToken);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */
  
  
  
  
  /* begin IONA modification*/
  
  public final void setNameFieldSetByFactory (boolean isSet) { nameFieldSetByFactory = isSet; }
  
  public final void setNsFieldSetByFactory (boolean isSet) { nsFieldSetByFactory = isSet; }
  
  /** model impl classes require a proper equals(...) method to support the current 'auto-resolving' 
   * proxy mechanism. See <code>com.iona.soa.model.util.EObjectInvocationProxy</code> for details
   * @generated
   */
  @Override
  public final boolean equals(Object obj) {
    return (obj instanceof java.lang.reflect.Proxy) ? obj.equals(this) : super.equals(obj);
  }
  
  private boolean nameFieldSetByFactory = false;
  private boolean nsFieldSetByFactory = false;

  /**
   * attempts to auto resolve the current proxy object if and when appropriate...
   * @generated
   */
  protected final void autoResolveEProxy(org.eclipse.emf.ecore.EStructuralFeature feature) {
      if (!eIsProxy()) {
          return;
      }
    
      
    // If the field is already set to a value different from the default specified 
    // in the ecore then it means that the proxy already contains a meaningful 
    // value for this feature.  Therefore there is no need to resolve yet.
    //
    // The factory code ovewrites the default value (set by the ecore) of 
    // the "name" and "namespace" fields - so we need to check these seperately.
    //
      if (eClass().getEIDAttribute().getFeatureID() == feature.getFeatureID()) {
          // We always have the ID
          return;
      } else if ("name".equals(feature.getName()) && nameFieldSetByFactory) {
      // resolve it
    } else if ("namespace".equals(feature.getName()) && nsFieldSetByFactory) {
      // resolve it
    } else if (eIsSet(feature)) {
        // this check must come after the name and namespace checks above
      return;
    }
    
    // resolve...
      Resource context = this.eResource();
      if (context == null) {
          // System.err.println("ERROR: Failed to find eResource for " + this + ", cannot resolve");
          return;
      }
  
    EObject resolvedObj = EcoreUtil.resolve(this, context);
  
    // in case the resultion didn't simply update the current object, copy all the relevant data back from the produced entity
    	// TODO - can we simply use eGet(feature, false) for all features???
    if (resolvedObj != null && resolvedObj != this) {
      String getterPrefix = "get";
      for (Method getter : this.getClass().getMethods()) {
    
        if (getter.getName().startsWith(getterPrefix)
            && !(getter.getDeclaringClass().isAssignableFrom(EObject.class)
           		|| getter.getDeclaringClass().isAssignableFrom(InternalEObject.class))) {

          // figure out the name of the related attribute
          StringBuilder sb = new StringBuilder();
          sb.append(Character.toLowerCase(getter.getName().charAt(3)));
          if (getter.getName().length() > 4) {
            sb.append(getter.getName().substring(4));
          }
          String attributeName = sb.toString().intern();

          try {
            Object[] args = null;
            Object fieldValue = getter.invoke(resolvedObj, args);
            /*
            // disable notification
            if (fieldValue instanceof EObject) {
              ((EObject)fieldValue).eSetDeliver(false);
            } else if (fieldValue instanceof Collection) {
              for (Object collectionItem : (Collection)fieldValue) {
                if (fieldValue instanceof EObject) {
                  ((EObject)collectionItem).eSetDeliver(false);
                }
              }
            }
            
            Method setter = this.getClass().getDeclaredMethod(getter.getName().replaceFirst("g", "s"),
                                                              new Class[] {getter.getReturnType()});
            setter.invoke(this, new Object[] {fieldValue});
            
            // re-enable notification
            if (fieldValue instanceof EObject) {
              ((EObject)fieldValue).eSetDeliver(true);
            } else if (fieldValue instanceof Collection) {
              for (Object collectionItem : (Collection)fieldValue) {
                if (fieldValue instanceof EObject) {
                  ((EObject)collectionItem).eSetDeliver(true);
                }
              }
            }*/

            Field field = findClassField(attributeName);
            boolean accessibility = field.isAccessible();
            field.setAccessible(true);
            field.set(this, fieldValue);
            field.setAccessible(accessibility);

          } catch (SecurityException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
          } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
          }
        }
      }

      // remove the proxy flag
      ((InternalEObject) this).eSetProxyURI(null);
    }
  }

    @Override
    public Resource eResource() {
    Resource resource = super.eResource();
    if (resource == null && this.eBasicAdapters() != null && !this.eBasicAdapters().isEmpty()) {
      		Adapter[] adapters = (Adapter[])this.eBasicAdapters().toArray();
      for (int i = 0; i < adapters.length; i++) {
          if (adapters[i] instanceof DanglingProxyAdapter) {
              resource = ((DanglingProxyAdapter)adapters[i]).eResource();
          if (((Resource.Internal)resource).isLoading()) {
              // Don't facillitate any resolution that would not 
              // previously have succeeded while loading
          			resource = null;
      			}
              break;
          }
      }
    }
    
      return resource;    
    }
    
  private Field findClassField(String targetedFieldName){
    
    if (targetedFieldName == null) {
      return null;
    }
    
    java.lang.Class class1 = this.getClass();

    while (class1 != null && !class1.equals(Object.class)) {
      try {
        return class1.getDeclaredField(targetedFieldName);
      } catch (Exception e) {
        // TODO Auto-generated catch block
      }
      class1 = class1.getSuperclass();
    }
  
    return null;
  }
  /* end IONA modification */
} //DataChangeEventImpl


