/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.events.impl;

import com.iona.soa.model.datatypes.DanglingProxyAdapter;

import com.iona.soa.model.events.DataChangeFieldDelta;
import com.iona.soa.model.events.EventsPackage;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.resource.Resource;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Change Field Delta</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl#getFieldDesc <em>Field Desc</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl#getOldValue <em>Old Value</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl#getNewValue <em>New Value</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl#getOldValues <em>Old Values</em>}</li>
 *   <li>{@link com.iona.soa.model.events.impl.DataChangeFieldDeltaImpl#getNewValues <em>New Values</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DataChangeFieldDeltaImpl extends EObjectImpl implements DataChangeFieldDelta
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached value of the '{@link #getFieldDesc() <em>Field Desc</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFieldDesc()
   * @generated
   * @ordered
   */
  protected EStructuralFeature fieldDesc;

  /**
   * The default value of the '{@link #getOldValue() <em>Old Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOldValue()
   * @generated
   * @ordered
   */
  protected static final String OLD_VALUE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getOldValue() <em>Old Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOldValue()
   * @generated
   * @ordered
   */
  protected String oldValue = OLD_VALUE_EDEFAULT;

  /**
   * The default value of the '{@link #getNewValue() <em>New Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNewValue()
   * @generated
   * @ordered
   */
  protected static final String NEW_VALUE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNewValue() <em>New Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNewValue()
   * @generated
   * @ordered
   */
  protected String newValue = NEW_VALUE_EDEFAULT;

  /**
   * The cached value of the '{@link #getOldValues() <em>Old Values</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOldValues()
   * @generated
   * @ordered
   */
  protected EList<String> oldValues;

  /**
   * The cached value of the '{@link #getNewValues() <em>New Values</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNewValues()
   * @generated
   * @ordered
   */
  protected EList<String> newValues;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DataChangeFieldDeltaImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature getFieldDesc() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__FIELD_DESC);
    return _basicGetFieldDesc();
  }
  
  private final EStructuralFeature _basicGetFieldDesc() {
    if (fieldDesc != null && fieldDesc.eIsProxy())
    {
      InternalEObject oldFieldDesc = (InternalEObject)fieldDesc;
      fieldDesc = (EStructuralFeature)eResolveProxy(oldFieldDesc);
      if (fieldDesc != oldFieldDesc)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, EventsPackage.DATA_CHANGE_FIELD_DELTA__FIELD_DESC, oldFieldDesc, fieldDesc));
      }
    }
    return fieldDesc;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EStructuralFeature basicGetFieldDesc()
  {
    return fieldDesc;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFieldDesc(EStructuralFeature newFieldDesc)
  {
    
    EStructuralFeature oldFieldDesc = fieldDesc;
    fieldDesc = newFieldDesc;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_FIELD_DELTA__FIELD_DESC, oldFieldDesc, fieldDesc));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getOldValue() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__OLD_VALUE);
    return _basicGetOldValue();
  }
  
  private final String _basicGetOldValue() {
    return oldValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOldValue(String newOldValue)
  {
    
    String oldOldValue = oldValue;
    oldValue = newOldValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUE, oldOldValue, oldValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNewValue() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__NEW_VALUE);
    return _basicGetNewValue();
  }
  
  private final String _basicGetNewValue() {
    return newValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNewValue(String newNewValue)
  {
    
    String oldNewValue = newValue;
    newValue = newNewValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUE, oldNewValue, newValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getOldValues() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__OLD_VALUES);
    return _basicGetOldValues();
  }
  
  private final EList<String> _basicGetOldValues() {
    if (oldValues == null)
    {
      oldValues = new EDataTypeUniqueEList<String>(String.class, this, EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUES);
    }
    return oldValues;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getNewValues() {
    autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__NEW_VALUES);
    return _basicGetNewValues();
  }
  
  private final EList<String> _basicGetNewValues() {
    if (newValues == null)
    {
      newValues = new EDataTypeUniqueEList<String>(String.class, this, EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUES);
    }
    return newValues;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__FIELD_DESC:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__FIELD_DESC); }
        if (resolve) return getFieldDesc();
        return _basicGetFieldDesc();
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUE:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__OLD_VALUE); }
        return _basicGetOldValue();
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUE:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__NEW_VALUE); }
        return _basicGetNewValue();
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUES:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__OLD_VALUES); }
        return _basicGetOldValues();
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUES:
      if (resolve) { autoResolveEProxy(EventsPackage.Literals.DATA_CHANGE_FIELD_DELTA__NEW_VALUES); }
        return _basicGetNewValues();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__FIELD_DESC:
        setFieldDesc((EStructuralFeature)newValue);
        return;
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUE:
        setOldValue((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUE:
        setNewValue((String)newValue);
        return;
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUES:
        _basicGetOldValues().clear();
        _basicGetOldValues().addAll((Collection<? extends String>)newValue);
        return;
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUES:
        _basicGetNewValues().clear();
        _basicGetNewValues().addAll((Collection<? extends String>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case EventsPackage.DATA_CHANGE_FIELD_DELTA__FIELD_DESC:
      setFieldDesc((EStructuralFeature)null);
      return;
    case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUE:
      setOldValue(OLD_VALUE_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUE:
      setNewValue(NEW_VALUE_EDEFAULT);
      return;
    case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUES:
      _basicGetOldValues().clear();
      return;
    case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUES:
      _basicGetNewValues().clear();
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__FIELD_DESC:
        return fieldDesc != null;
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUE:
        return OLD_VALUE_EDEFAULT == null ? oldValue != null : !OLD_VALUE_EDEFAULT.equals(oldValue);
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUE:
        return NEW_VALUE_EDEFAULT == null ? newValue != null : !NEW_VALUE_EDEFAULT.equals(newValue);
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__OLD_VALUES:
        return oldValues != null && !oldValues.isEmpty();
      case EventsPackage.DATA_CHANGE_FIELD_DELTA__NEW_VALUES:
        return newValues != null && !newValues.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (oldValue: ");
    result.append(oldValue);
    result.append(", newValue: ");
    result.append(newValue);
    result.append(", oldValues: ");
    result.append(oldValues);
    result.append(", newValues: ");
    result.append(newValues);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */
  
  
  
  
  /* begin IONA modification*/
  
  public final void setNameFieldSetByFactory (boolean isSet) { nameFieldSetByFactory = isSet; }
  
  public final void setNsFieldSetByFactory (boolean isSet) { nsFieldSetByFactory = isSet; }
  
  /** model impl classes require a proper equals(...) method to support the current 'auto-resolving' 
   * proxy mechanism. See <code>com.iona.soa.model.util.EObjectInvocationProxy</code> for details
   * @generated
   */
  @Override
  public final boolean equals(Object obj) {
    return (obj instanceof java.lang.reflect.Proxy) ? obj.equals(this) : super.equals(obj);
  }
  
  private boolean nameFieldSetByFactory = false;
  private boolean nsFieldSetByFactory = false;

  /**
   * attempts to auto resolve the current proxy object if and when appropriate...
   * @generated
   */
  protected final void autoResolveEProxy(org.eclipse.emf.ecore.EStructuralFeature feature) {
      if (!eIsProxy()) {
          return;
      }
    
      
    // If the field is already set to a value different from the default specified 
    // in the ecore then it means that the proxy already contains a meaningful 
    // value for this feature.  Therefore there is no need to resolve yet.
    //
    // The factory code ovewrites the default value (set by the ecore) of 
    // the "name" and "namespace" fields - so we need to check these seperately.
    //
      if (eClass().getEIDAttribute().getFeatureID() == feature.getFeatureID()) {
          // We always have the ID
          return;
      } else if ("name".equals(feature.getName()) && nameFieldSetByFactory) {
      // resolve it
    } else if ("namespace".equals(feature.getName()) && nsFieldSetByFactory) {
      // resolve it
    } else if (eIsSet(feature)) {
        // this check must come after the name and namespace checks above
      return;
    }
    
    // resolve...
      Resource context = this.eResource();
      if (context == null) {
          // System.err.println("ERROR: Failed to find eResource for " + this + ", cannot resolve");
          return;
      }
  
    EObject resolvedObj = EcoreUtil.resolve(this, context);
  
    // in case the resultion didn't simply update the current object, copy all the relevant data back from the produced entity
    	// TODO - can we simply use eGet(feature, false) for all features???
    if (resolvedObj != null && resolvedObj != this) {
      String getterPrefix = "get";
      for (Method getter : this.getClass().getMethods()) {
    
        if (getter.getName().startsWith(getterPrefix)
            && !(getter.getDeclaringClass().isAssignableFrom(EObject.class)
           		|| getter.getDeclaringClass().isAssignableFrom(InternalEObject.class))) {

          // figure out the name of the related attribute
          StringBuilder sb = new StringBuilder();
          sb.append(Character.toLowerCase(getter.getName().charAt(3)));
          if (getter.getName().length() > 4) {
            sb.append(getter.getName().substring(4));
          }
          String attributeName = sb.toString().intern();

          try {
            Object[] args = null;
            Object fieldValue = getter.invoke(resolvedObj, args);
            /*
            // disable notification
            if (fieldValue instanceof EObject) {
              ((EObject)fieldValue).eSetDeliver(false);
            } else if (fieldValue instanceof Collection) {
              for (Object collectionItem : (Collection)fieldValue) {
                if (fieldValue instanceof EObject) {
                  ((EObject)collectionItem).eSetDeliver(false);
                }
              }
            }
            
            Method setter = this.getClass().getDeclaredMethod(getter.getName().replaceFirst("g", "s"),
                                                              new Class[] {getter.getReturnType()});
            setter.invoke(this, new Object[] {fieldValue});
            
            // re-enable notification
            if (fieldValue instanceof EObject) {
              ((EObject)fieldValue).eSetDeliver(true);
            } else if (fieldValue instanceof Collection) {
              for (Object collectionItem : (Collection)fieldValue) {
                if (fieldValue instanceof EObject) {
                  ((EObject)collectionItem).eSetDeliver(true);
                }
              }
            }*/

            Field field = findClassField(attributeName);
            boolean accessibility = field.isAccessible();
            field.setAccessible(true);
            field.set(this, fieldValue);
            field.setAccessible(accessibility);

          } catch (SecurityException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
          } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
          }
        }
      }

      // remove the proxy flag
      ((InternalEObject) this).eSetProxyURI(null);
    }
  }

    @Override
    public Resource eResource() {
    Resource resource = super.eResource();
    if (resource == null && this.eBasicAdapters() != null && !this.eBasicAdapters().isEmpty()) {
      		Adapter[] adapters = (Adapter[])this.eBasicAdapters().toArray();
      for (int i = 0; i < adapters.length; i++) {
          if (adapters[i] instanceof DanglingProxyAdapter) {
              resource = ((DanglingProxyAdapter)adapters[i]).eResource();
          if (((Resource.Internal)resource).isLoading()) {
              // Don't facillitate any resolution that would not 
              // previously have succeeded while loading
          			resource = null;
      			}
              break;
          }
      }
    }
    
      return resource;    
    }
    
  private Field findClassField(String targetedFieldName){
    
    if (targetedFieldName == null) {
      return null;
    }
    
    java.lang.Class class1 = this.getClass();

    while (class1 != null && !class1.equals(Object.class)) {
      try {
        return class1.getDeclaredField(targetedFieldName);
      } catch (Exception e) {
        // TODO Auto-generated catch block
      }
      class1 = class1.getSuperclass();
    }
  
    return null;
  }
  /* end IONA modification */
} //DataChangeFieldDeltaImpl


