/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.events.impl;

import com.iona.soa.model.events.*;

import java.lang.reflect.Method;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class EventsFactoryImpl extends EFactoryImpl implements EventsFactory
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

/* begin IONA modification */
  private String defaultNamespace = "http://www.example.org/";

  public final void setDefaultNamespace(String namespace) {
    this.defaultNamespace = namespace;
  }

/* end IONA modification */
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static EventsFactory init()
  {
    try
    {
      EventsFactory theEventsFactory = (EventsFactory)EPackage.Registry.INSTANCE.getEFactory("http://com.iona.soa.model.events"); 
      if (theEventsFactory != null)
      {
        return theEventsFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new EventsFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EventsFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case EventsPackage.DATA_CHANGE_EVENT: return createDataChangeEvent();
      case EventsPackage.DATA_CHANGE_FIELD_DELTA: return createDataChangeFieldDelta();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case EventsPackage.DATA_CHANGE_KIND:
        return createDataChangeKindFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case EventsPackage.DATA_CHANGE_KIND:
        return convertDataChangeKindToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DataChangeEvent createDataChangeEvent()
  {
       	/* begin IONA modification */
    	//DataChangeEventImpl dataChangeEvent = new DataChangeEventImpl();
    	DataChangeEvent dataChangeEvent = new DataChangeEventImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = dataChangeEvent.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(dataChangeEvent, new Object[] {"DataChangeEvent-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = dataChangeEvent.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(dataChangeEvent, new Object[] {"DataChangeEvent"});
            Method factoryFlagSetter = dataChangeEvent.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(dataChangeEvent, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = dataChangeEvent.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(dataChangeEvent, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = dataChangeEvent.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(dataChangeEvent, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return dataChangeEvent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DataChangeFieldDelta createDataChangeFieldDelta()
  {
       	/* begin IONA modification */
    	//DataChangeFieldDeltaImpl dataChangeFieldDelta = new DataChangeFieldDeltaImpl();
    	DataChangeFieldDelta dataChangeFieldDelta = new DataChangeFieldDeltaImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = dataChangeFieldDelta.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(dataChangeFieldDelta, new Object[] {"DataChangeFieldDelta-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = dataChangeFieldDelta.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(dataChangeFieldDelta, new Object[] {"DataChangeFieldDelta"});
            Method factoryFlagSetter = dataChangeFieldDelta.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(dataChangeFieldDelta, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = dataChangeFieldDelta.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(dataChangeFieldDelta, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = dataChangeFieldDelta.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(dataChangeFieldDelta, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return dataChangeFieldDelta;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DataChangeKind createDataChangeKindFromString(EDataType eDataType, String initialValue)
  {
    DataChangeKind result = DataChangeKind.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertDataChangeKindToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EventsPackage getEventsPackage()
  {
    return (EventsPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static EventsPackage getPackage()
  {
    return EventsPackage.eINSTANCE;
  }

} //EventsFactoryImpl


