/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.events.impl;

import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.collaboration.CollaborationPackage;

import com.iona.soa.model.collaboration.impl.CollaborationPackageImpl;

import com.iona.soa.model.events.DataChangeEvent;
import com.iona.soa.model.events.DataChangeFieldDelta;
import com.iona.soa.model.events.DataChangeKind;
import com.iona.soa.model.events.EventsFactory;
import com.iona.soa.model.events.EventsPackage;

import com.iona.soa.model.folder.FolderPackage;

import com.iona.soa.model.folder.impl.FolderPackageImpl;

import com.iona.soa.model.impl.SOA_NetworkPackageImpl;

import com.iona.soa.model.notification.NotificationPackage;

import com.iona.soa.model.notification.impl.NotificationPackageImpl;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.RepositoryPackageImpl;

import com.iona.soa.model.scheduling.SchedulingPackage;

import com.iona.soa.model.scheduling.impl.SchedulingPackageImpl;

import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.security.impl.SecurityPackageImpl;

import com.iona.soa.model.userattributes.UserAttributesPackage;

import com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class EventsPackageImpl extends EPackageImpl implements EventsPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass dataChangeEventEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass dataChangeFieldDeltaEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum dataChangeKindEEnum = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see com.iona.soa.model.events.EventsPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private EventsPackageImpl()
  {
    super(eNS_URI, EventsFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this
   * model, and for any others upon which it depends.  Simple
   * dependencies are satisfied by calling this method on all
   * dependent packages before doing anything else.  This method drives
   * initialization for interdependent packages directly, in parallel
   * with this package, itself.
   * <p>Of this package and its interdependencies, all packages which
   * have not yet been registered by their URI values are first created
   * and registered.  The packages are then initialized in two steps:
   * meta-model objects for all of the packages are created before any
   * are initialized, since one package's meta-model objects may refer to
   * those of another.
   * <p>Invocation of this method will not affect any packages that have
   * already been initialized.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static EventsPackage init()
  {
    if (isInited) return (EventsPackage)EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI);

    // Obtain or create and register package
    EventsPackageImpl theEventsPackage = (EventsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof EventsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new EventsPackageImpl());

    isInited = true;

    // Obtain or create and register interdependencies
    SOA_NetworkPackageImpl theSOA_NetworkPackage = (SOA_NetworkPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) instanceof SOA_NetworkPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) : SOA_NetworkPackage.eINSTANCE);
    RepositoryPackageImpl theRepositoryPackage = (RepositoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) instanceof RepositoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) : RepositoryPackage.eINSTANCE);
    SecurityPackageImpl theSecurityPackage = (SecurityPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) instanceof SecurityPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) : SecurityPackage.eINSTANCE);
    UserAttributesPackageImpl theUserAttributesPackage = (UserAttributesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) instanceof UserAttributesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) : UserAttributesPackage.eINSTANCE);
    NotificationPackageImpl theNotificationPackage = (NotificationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) instanceof NotificationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) : NotificationPackage.eINSTANCE);
    CollaborationPackageImpl theCollaborationPackage = (CollaborationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) instanceof CollaborationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) : CollaborationPackage.eINSTANCE);
    FolderPackageImpl theFolderPackage = (FolderPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) instanceof FolderPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) : FolderPackage.eINSTANCE);
    SchedulingPackageImpl theSchedulingPackage = (SchedulingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) instanceof SchedulingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) : SchedulingPackage.eINSTANCE);

    // Create package meta-data objects
    theEventsPackage.createPackageContents();
    theSOA_NetworkPackage.createPackageContents();
    theRepositoryPackage.createPackageContents();
    theSecurityPackage.createPackageContents();
    theUserAttributesPackage.createPackageContents();
    theNotificationPackage.createPackageContents();
    theCollaborationPackage.createPackageContents();
    theFolderPackage.createPackageContents();
    theSchedulingPackage.createPackageContents();

    // Initialize created meta-data
    theEventsPackage.initializePackageContents();
    theSOA_NetworkPackage.initializePackageContents();
    theRepositoryPackage.initializePackageContents();
    theSecurityPackage.initializePackageContents();
    theUserAttributesPackage.initializePackageContents();
    theNotificationPackage.initializePackageContents();
    theCollaborationPackage.initializePackageContents();
    theFolderPackage.initializePackageContents();
    theSchedulingPackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theEventsPackage.freeze();

    return theEventsPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getDataChangeEvent()
  {
    return dataChangeEventEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_UserId()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_UserName()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_UserEMail()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_ChangeKind()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_Timestamp()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_TargetGuid()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDataChangeEvent_TargetType()
  {
    return (EReference)dataChangeEventEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_TargetName()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(7);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_TargetNamespace()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(8);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDataChangeEvent_UpdatedFields()
  {
    return (EReference)dataChangeEventEClass.getEStructuralFeatures().get(9);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeEvent_UserToken()
  {
    return (EAttribute)dataChangeEventEClass.getEStructuralFeatures().get(10);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getDataChangeFieldDelta()
  {
    return dataChangeFieldDeltaEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDataChangeFieldDelta_FieldDesc()
  {
    return (EReference)dataChangeFieldDeltaEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeFieldDelta_OldValue()
  {
    return (EAttribute)dataChangeFieldDeltaEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeFieldDelta_NewValue()
  {
    return (EAttribute)dataChangeFieldDeltaEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeFieldDelta_OldValues()
  {
    return (EAttribute)dataChangeFieldDeltaEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDataChangeFieldDelta_NewValues()
  {
    return (EAttribute)dataChangeFieldDeltaEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EEnum getDataChangeKind()
  {
    return dataChangeKindEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EventsFactory getEventsFactory()
  {
    return (EventsFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    dataChangeEventEClass = createEClass(DATA_CHANGE_EVENT);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__USER_ID);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__USER_NAME);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__USER_EMAIL);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__CHANGE_KIND);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__TIMESTAMP);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__TARGET_GUID);
    createEReference(dataChangeEventEClass, DATA_CHANGE_EVENT__TARGET_TYPE);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__TARGET_NAME);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__TARGET_NAMESPACE);
    createEReference(dataChangeEventEClass, DATA_CHANGE_EVENT__UPDATED_FIELDS);
    createEAttribute(dataChangeEventEClass, DATA_CHANGE_EVENT__USER_TOKEN);

    dataChangeFieldDeltaEClass = createEClass(DATA_CHANGE_FIELD_DELTA);
    createEReference(dataChangeFieldDeltaEClass, DATA_CHANGE_FIELD_DELTA__FIELD_DESC);
    createEAttribute(dataChangeFieldDeltaEClass, DATA_CHANGE_FIELD_DELTA__OLD_VALUE);
    createEAttribute(dataChangeFieldDeltaEClass, DATA_CHANGE_FIELD_DELTA__NEW_VALUE);
    createEAttribute(dataChangeFieldDeltaEClass, DATA_CHANGE_FIELD_DELTA__OLD_VALUES);
    createEAttribute(dataChangeFieldDeltaEClass, DATA_CHANGE_FIELD_DELTA__NEW_VALUES);

    // Create enums
    dataChangeKindEEnum = createEEnum(DATA_CHANGE_KIND);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes

    // Initialize classes and features; add operations and parameters
    initEClass(dataChangeEventEClass, DataChangeEvent.class, "DataChangeEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getDataChangeEvent_UserId(), ecorePackage.getEString(), "userId", null, 1, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_UserName(), ecorePackage.getEString(), "userName", null, 0, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_UserEMail(), ecorePackage.getEString(), "userEMail", null, 0, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_ChangeKind(), this.getDataChangeKind(), "changeKind", null, 1, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_Timestamp(), theRepositoryPackage.getTimestamp(), "timestamp", null, 1, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_TargetGuid(), ecorePackage.getEString(), "targetGuid", null, 1, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getDataChangeEvent_TargetType(), ecorePackage.getEClass(), null, "targetType", null, 1, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_TargetName(), ecorePackage.getEString(), "targetName", null, 0, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_TargetNamespace(), ecorePackage.getEString(), "targetNamespace", null, 0, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getDataChangeEvent_UpdatedFields(), this.getDataChangeFieldDelta(), null, "updatedFields", null, 0, -1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeEvent_UserToken(), ecorePackage.getEString(), "userToken", null, 1, 1, DataChangeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(dataChangeFieldDeltaEClass, DataChangeFieldDelta.class, "DataChangeFieldDelta", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getDataChangeFieldDelta_FieldDesc(), ecorePackage.getEStructuralFeature(), null, "fieldDesc", null, 1, 1, DataChangeFieldDelta.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeFieldDelta_OldValue(), ecorePackage.getEString(), "oldValue", null, 0, 1, DataChangeFieldDelta.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeFieldDelta_NewValue(), ecorePackage.getEString(), "newValue", null, 0, 1, DataChangeFieldDelta.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeFieldDelta_OldValues(), ecorePackage.getEString(), "oldValues", null, 0, -1, DataChangeFieldDelta.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDataChangeFieldDelta_NewValues(), ecorePackage.getEString(), "newValues", null, 0, -1, DataChangeFieldDelta.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    // Initialize enums and add enum literals
    initEEnum(dataChangeKindEEnum, DataChangeKind.class, "DataChangeKind");
    addEEnumLiteral(dataChangeKindEEnum, DataChangeKind.ADD_LITERAL);
    addEEnumLiteral(dataChangeKindEEnum, DataChangeKind.REMOVE_LITERAL);
    addEEnumLiteral(dataChangeKindEEnum, DataChangeKind.MODIFY_LITERAL);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // dbhints
    createDbhintsAnnotations();
  }

  /**
   * Initializes the annotations for <b>dbhints</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createDbhintsAnnotations()
  {
    String source = "dbhints";		
    addAnnotation
      (dataChangeEventEClass, 
       source, 
       new String[] 
       {
       "table", "none"
       });		
    addAnnotation
      (dataChangeFieldDeltaEClass, 
       source, 
       new String[] 
       {
       "table", "none"
       });
  }

} //EventsPackageImpl
