/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.folder;

import com.iona.soa.model.repository.RepositoryPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.folder.FolderFactory
 * @model kind="package"
 * @generated
 */
public interface FolderPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "folder";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.folder";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itfolder";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  FolderPackage eINSTANCE = com.iona.soa.model.folder.impl.FolderPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.folder.IFolder <em>IFolder</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.folder.IFolder
   * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getIFolder()
   * @generated
   */
  int IFOLDER = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Children</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__CHILDREN = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__PARENT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Content</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER__CONTENT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>IFolder</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link com.iona.soa.model.folder.IFolderContent <em>IFolder Content</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.folder.IFolderContent
   * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getIFolderContent()
   * @generated
   */
  int IFOLDER_CONTENT = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Belongs To</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT__BELONGS_TO = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>IFolder Content</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IFOLDER_CONTENT_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.folder.ICategory <em>ICategory</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.folder.ICategory
   * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getICategory()
   * @generated
   */
  int ICATEGORY = 2;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Content</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__CONTENT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>EClass Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY__ECLASS_NAME = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>ICategory</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORY_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.folder.ICategorizable <em>ICategorizable</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.folder.ICategorizable
   * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getICategorizable()
   * @generated
   */
  int ICATEGORIZABLE = 3;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE__CATEGORIES = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>ICategorizable</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ICATEGORIZABLE_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.folder.IFolder <em>IFolder</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IFolder</em>'.
   * @see com.iona.soa.model.folder.IFolder
   * @generated
   */
  EClass getIFolder();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.folder.IFolder#getChildren <em>Children</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Children</em>'.
   * @see com.iona.soa.model.folder.IFolder#getChildren()
   * @see #getIFolder()
   * @generated
   */
  EReference getIFolder_Children();

  /**
   * Returns the meta object for the container reference '{@link com.iona.soa.model.folder.IFolder#getParent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Parent</em>'.
   * @see com.iona.soa.model.folder.IFolder#getParent()
   * @see #getIFolder()
   * @generated
   */
  EReference getIFolder_Parent();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.folder.IFolder#getContent <em>Content</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Content</em>'.
   * @see com.iona.soa.model.folder.IFolder#getContent()
   * @see #getIFolder()
   * @generated
   */
  EReference getIFolder_Content();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.folder.IFolderContent <em>IFolder Content</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IFolder Content</em>'.
   * @see com.iona.soa.model.folder.IFolderContent
   * @generated
   */
  EClass getIFolderContent();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.folder.IFolderContent#getBelongsTo <em>Belongs To</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Belongs To</em>'.
   * @see com.iona.soa.model.folder.IFolderContent#getBelongsTo()
   * @see #getIFolderContent()
   * @generated
   */
  EReference getIFolderContent_BelongsTo();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.folder.ICategory <em>ICategory</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>ICategory</em>'.
   * @see com.iona.soa.model.folder.ICategory
   * @generated
   */
  EClass getICategory();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.folder.ICategory#getContent <em>Content</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Content</em>'.
   * @see com.iona.soa.model.folder.ICategory#getContent()
   * @see #getICategory()
   * @generated
   */
  EReference getICategory_Content();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.folder.ICategory#getEClassName <em>EClass Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>EClass Name</em>'.
   * @see com.iona.soa.model.folder.ICategory#getEClassName()
   * @see #getICategory()
   * @generated
   */
  EAttribute getICategory_EClassName();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.folder.ICategorizable <em>ICategorizable</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>ICategorizable</em>'.
   * @see com.iona.soa.model.folder.ICategorizable
   * @generated
   */
  EClass getICategorizable();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.folder.ICategorizable#getCategories <em>Categories</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Categories</em>'.
   * @see com.iona.soa.model.folder.ICategorizable#getCategories()
   * @see #getICategorizable()
   * @generated
   */
  EReference getICategorizable_Categories();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  FolderFactory getFolderFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.folder.IFolder <em>IFolder</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.folder.IFolder
     * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getIFolder()
     * @generated
     */
    EClass IFOLDER = eINSTANCE.getIFolder();

    /**
     * The meta object literal for the '<em><b>Children</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IFOLDER__CHILDREN = eINSTANCE.getIFolder_Children();

    /**
     * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IFOLDER__PARENT = eINSTANCE.getIFolder_Parent();

    /**
     * The meta object literal for the '<em><b>Content</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IFOLDER__CONTENT = eINSTANCE.getIFolder_Content();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.folder.IFolderContent <em>IFolder Content</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.folder.IFolderContent
     * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getIFolderContent()
     * @generated
     */
    EClass IFOLDER_CONTENT = eINSTANCE.getIFolderContent();

    /**
     * The meta object literal for the '<em><b>Belongs To</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IFOLDER_CONTENT__BELONGS_TO = eINSTANCE.getIFolderContent_BelongsTo();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.folder.ICategory <em>ICategory</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.folder.ICategory
     * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getICategory()
     * @generated
     */
    EClass ICATEGORY = eINSTANCE.getICategory();

    /**
     * The meta object literal for the '<em><b>Content</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ICATEGORY__CONTENT = eINSTANCE.getICategory_Content();

    /**
     * The meta object literal for the '<em><b>EClass Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ICATEGORY__ECLASS_NAME = eINSTANCE.getICategory_EClassName();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.folder.ICategorizable <em>ICategorizable</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.folder.ICategorizable
     * @see com.iona.soa.model.folder.impl.FolderPackageImpl#getICategorizable()
     * @generated
     */
    EClass ICATEGORIZABLE = eINSTANCE.getICategorizable();

    /**
     * The meta object literal for the '<em><b>Categories</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ICATEGORIZABLE__CATEGORIES = eINSTANCE.getICategorizable_Categories();

  }

} //FolderPackage
