/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.folder;

import com.iona.soa.model.repository.IPersistableObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>ICategory</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.folder.ICategory#getContent <em>Content</em>}</li>
 *   <li>{@link com.iona.soa.model.folder.ICategory#getEClassName <em>EClass Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.folder.FolderPackage#getICategory()
 * @model interface="true" abstract="true"
 *        annotation="delete predicate='equals(modifiable, true)'"
 * @generated
 */
public interface ICategory extends IPersistableObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Content</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.folder.ICategorizable}.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.folder.ICategorizable#getCategories <em>Categories</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Content</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Content</em>' reference list.
   * @see com.iona.soa.model.folder.FolderPackage#getICategory_Content()
   * @see com.iona.soa.model.folder.ICategorizable#getCategories
   * @model opposite="categories"
   * @generated
   */
  EList<ICategorizable> getContent();


  /**
   * Returns the value of the '<em><b>EClass Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>EClass Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>EClass Name</em>' attribute.
   * @see #setEClassName(String)
   * @see com.iona.soa.model.folder.FolderPackage#getICategory_EClassName()
   * @model required="true"
   * @generated
   */
  String getEClassName();


  /**
   * Sets the value of the '{@link com.iona.soa.model.folder.ICategory#getEClassName <em>EClass Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>EClass Name</em>' attribute.
   * @see #getEClassName()
   * @generated
   */
  void setEClassName(String value);

} // ICategory


