/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.folder;

import com.iona.soa.model.repository.IPersistableObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>IFolder</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.folder.IFolder#getChildren <em>Children</em>}</li>
 *   <li>{@link com.iona.soa.model.folder.IFolder#getParent <em>Parent</em>}</li>
 *   <li>{@link com.iona.soa.model.folder.IFolder#getContent <em>Content</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.folder.FolderPackage#getIFolder()
 * @model interface="true" abstract="true"
 *        annotation="delete predicate='equals(modifiable, true)'"
 * @generated
 */
public interface IFolder extends IPersistableObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Children</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.folder.IFolder}.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.folder.IFolder#getParent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Children</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Children</em>' containment reference list.
   * @see com.iona.soa.model.folder.FolderPackage#getIFolder_Children()
   * @see com.iona.soa.model.folder.IFolder#getParent
   * @model opposite="parent" containment="true"
   * @generated
   */
  EList<IFolder> getChildren();


  /**
   * Returns the value of the '<em><b>Parent</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.folder.IFolder#getChildren <em>Children</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parent</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parent</em>' container reference.
   * @see #setParent(IFolder)
   * @see com.iona.soa.model.folder.FolderPackage#getIFolder_Parent()
   * @see com.iona.soa.model.folder.IFolder#getChildren
   * @model opposite="children" transient="false"
   * @generated
   */
  IFolder getParent();


  /**
   * Sets the value of the '{@link com.iona.soa.model.folder.IFolder#getParent <em>Parent</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Parent</em>' container reference.
   * @see #getParent()
   * @generated
   */
  void setParent(IFolder value);

  /**
   * Returns the value of the '<em><b>Content</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.folder.IFolderContent}.
   * It is bidirectional and its opposite is '{@link com.iona.soa.model.folder.IFolderContent#getBelongsTo <em>Belongs To</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Content</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Content</em>' reference list.
   * @see com.iona.soa.model.folder.FolderPackage#getIFolder_Content()
   * @see com.iona.soa.model.folder.IFolderContent#getBelongsTo
   * @model opposite="belongsTo"
   * @generated
   */
  EList<IFolderContent> getContent();


} // IFolder


