/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.folder.impl;

import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.collaboration.CollaborationPackage;

import com.iona.soa.model.collaboration.impl.CollaborationPackageImpl;

import com.iona.soa.model.events.EventsPackage;

import com.iona.soa.model.events.impl.EventsPackageImpl;

import com.iona.soa.model.folder.FolderFactory;
import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;
import com.iona.soa.model.folder.IFolder;
import com.iona.soa.model.folder.IFolderContent;

import com.iona.soa.model.impl.SOA_NetworkPackageImpl;

import com.iona.soa.model.notification.NotificationPackage;

import com.iona.soa.model.notification.impl.NotificationPackageImpl;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.RepositoryPackageImpl;

import com.iona.soa.model.scheduling.SchedulingPackage;

import com.iona.soa.model.scheduling.impl.SchedulingPackageImpl;

import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.security.impl.SecurityPackageImpl;

import com.iona.soa.model.userattributes.UserAttributesPackage;

import com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class FolderPackageImpl extends EPackageImpl implements FolderPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iFolderEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iFolderContentEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iCategoryEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iCategorizableEClass = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see com.iona.soa.model.folder.FolderPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private FolderPackageImpl()
  {
    super(eNS_URI, FolderFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this
   * model, and for any others upon which it depends.  Simple
   * dependencies are satisfied by calling this method on all
   * dependent packages before doing anything else.  This method drives
   * initialization for interdependent packages directly, in parallel
   * with this package, itself.
   * <p>Of this package and its interdependencies, all packages which
   * have not yet been registered by their URI values are first created
   * and registered.  The packages are then initialized in two steps:
   * meta-model objects for all of the packages are created before any
   * are initialized, since one package's meta-model objects may refer to
   * those of another.
   * <p>Invocation of this method will not affect any packages that have
   * already been initialized.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static FolderPackage init()
  {
    if (isInited) return (FolderPackage)EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI);

    // Obtain or create and register package
    FolderPackageImpl theFolderPackage = (FolderPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof FolderPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new FolderPackageImpl());

    isInited = true;

    // Obtain or create and register interdependencies
    SOA_NetworkPackageImpl theSOA_NetworkPackage = (SOA_NetworkPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) instanceof SOA_NetworkPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) : SOA_NetworkPackage.eINSTANCE);
    RepositoryPackageImpl theRepositoryPackage = (RepositoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) instanceof RepositoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) : RepositoryPackage.eINSTANCE);
    SecurityPackageImpl theSecurityPackage = (SecurityPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) instanceof SecurityPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) : SecurityPackage.eINSTANCE);
    UserAttributesPackageImpl theUserAttributesPackage = (UserAttributesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) instanceof UserAttributesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) : UserAttributesPackage.eINSTANCE);
    EventsPackageImpl theEventsPackage = (EventsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) instanceof EventsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) : EventsPackage.eINSTANCE);
    NotificationPackageImpl theNotificationPackage = (NotificationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) instanceof NotificationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) : NotificationPackage.eINSTANCE);
    CollaborationPackageImpl theCollaborationPackage = (CollaborationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) instanceof CollaborationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) : CollaborationPackage.eINSTANCE);
    SchedulingPackageImpl theSchedulingPackage = (SchedulingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) instanceof SchedulingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) : SchedulingPackage.eINSTANCE);

    // Create package meta-data objects
    theFolderPackage.createPackageContents();
    theSOA_NetworkPackage.createPackageContents();
    theRepositoryPackage.createPackageContents();
    theSecurityPackage.createPackageContents();
    theUserAttributesPackage.createPackageContents();
    theEventsPackage.createPackageContents();
    theNotificationPackage.createPackageContents();
    theCollaborationPackage.createPackageContents();
    theSchedulingPackage.createPackageContents();

    // Initialize created meta-data
    theFolderPackage.initializePackageContents();
    theSOA_NetworkPackage.initializePackageContents();
    theRepositoryPackage.initializePackageContents();
    theSecurityPackage.initializePackageContents();
    theUserAttributesPackage.initializePackageContents();
    theEventsPackage.initializePackageContents();
    theNotificationPackage.initializePackageContents();
    theCollaborationPackage.initializePackageContents();
    theSchedulingPackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theFolderPackage.freeze();

    return theFolderPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIFolder()
  {
    return iFolderEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIFolder_Children()
  {
    return (EReference)iFolderEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIFolder_Parent()
  {
    return (EReference)iFolderEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIFolder_Content()
  {
    return (EReference)iFolderEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIFolderContent()
  {
    return iFolderContentEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIFolderContent_BelongsTo()
  {
    return (EReference)iFolderContentEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getICategory()
  {
    return iCategoryEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getICategory_Content()
  {
    return (EReference)iCategoryEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getICategory_EClassName()
  {
    return (EAttribute)iCategoryEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getICategorizable()
  {
    return iCategorizableEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getICategorizable_Categories()
  {
    return (EReference)iCategorizableEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FolderFactory getFolderFactory()
  {
    return (FolderFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    iFolderEClass = createEClass(IFOLDER);
    createEReference(iFolderEClass, IFOLDER__CHILDREN);
    createEReference(iFolderEClass, IFOLDER__PARENT);
    createEReference(iFolderEClass, IFOLDER__CONTENT);

    iFolderContentEClass = createEClass(IFOLDER_CONTENT);
    createEReference(iFolderContentEClass, IFOLDER_CONTENT__BELONGS_TO);

    iCategoryEClass = createEClass(ICATEGORY);
    createEReference(iCategoryEClass, ICATEGORY__CONTENT);
    createEAttribute(iCategoryEClass, ICATEGORY__ECLASS_NAME);

    iCategorizableEClass = createEClass(ICATEGORIZABLE);
    createEReference(iCategorizableEClass, ICATEGORIZABLE__CATEGORIES);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    iFolderEClass.getESuperTypes().add(theRepositoryPackage.getIPersistableObject());
    iFolderContentEClass.getESuperTypes().add(theRepositoryPackage.getIPersistableObject());
    iCategoryEClass.getESuperTypes().add(theRepositoryPackage.getIPersistableObject());
    iCategorizableEClass.getESuperTypes().add(theRepositoryPackage.getIPersistableObject());

    // Initialize classes and features; add operations and parameters
    initEClass(iFolderEClass, IFolder.class, "IFolder", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getIFolder_Children(), this.getIFolder(), this.getIFolder_Parent(), "children", null, 0, -1, IFolder.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getIFolder_Parent(), this.getIFolder(), this.getIFolder_Children(), "parent", null, 0, 1, IFolder.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getIFolder_Content(), this.getIFolderContent(), this.getIFolderContent_BelongsTo(), "content", null, 0, -1, IFolder.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iFolderContentEClass, IFolderContent.class, "IFolderContent", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getIFolderContent_BelongsTo(), this.getIFolder(), this.getIFolder_Content(), "belongsTo", null, 0, 1, IFolderContent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iCategoryEClass, ICategory.class, "ICategory", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getICategory_Content(), this.getICategorizable(), this.getICategorizable_Categories(), "content", null, 0, -1, ICategory.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getICategory_EClassName(), ecorePackage.getEString(), "eClassName", null, 1, 1, ICategory.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iCategorizableEClass, ICategorizable.class, "ICategorizable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getICategorizable_Categories(), this.getICategory(), this.getICategory_Content(), "categories", null, 0, -1, ICategorizable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // delete
    createDeleteAnnotations();
  }

  /**
   * Initializes the annotations for <b>delete</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createDeleteAnnotations()
  {
    String source = "delete";		
    addAnnotation
      (iFolderEClass, 
       source, 
       new String[] 
       {
       "predicate", "equals(modifiable, true)"
       });		
    addAnnotation
      (iCategoryEClass, 
       source, 
       new String[] 
       {
       "predicate", "equals(modifiable, true)"
       });
  }

} //FolderPackageImpl
