/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.Application;
import com.iona.soa.model.ApplicationType;
import com.iona.soa.model.Artifact;
import com.iona.soa.model.IConfiguration;
import com.iona.soa.model.IDeploymentConstraint;
import com.iona.soa.model.SOA_NetworkPackage;
import com.iona.soa.model.VersionedProfile;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;

import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.IVersionedObject;
import com.iona.soa.model.repository.Property;
import com.iona.soa.model.repository.RepositoryPackage;
import com.iona.soa.model.repository.Version;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;
import com.iona.soa.model.userattributes.UserAttributeDefinition;
import com.iona.soa.model.userattributes.UserAttributeValue;
import com.iona.soa.model.userattributes.UserAttributesPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Application</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getConfiguration <em>Configuration</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getTags <em>Tags</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getCategories <em>Categories</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getEmbedded <em>Embedded</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getDepends <em>Depends</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getProfiles <em>Profiles</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ApplicationImpl#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ApplicationImpl extends IPersistableObjectImpl implements Application
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getVersion() <em>Version</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVersion()
   * @generated
   * @ordered
   */
  protected Version version;

  /**
   * The cached value of the '{@link #getConfiguration() <em>Configuration</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConfiguration()
   * @generated
   * @ordered
   */
  protected EList<Property> configuration;

  /**
   * The cached value of the '{@link #getAttributes() <em>Attributes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttributes()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeValue> attributes;

  /**
   * The cached value of the '{@link #getTags() <em>Tags</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTags()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeDefinition> tags;

  /**
   * The cached value of the '{@link #getCategories() <em>Categories</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategories()
   * @generated
   * @ordered
   */
  protected EList<ICategory> categories;

  /**
   * The cached value of the '{@link #getProperties() <em>Properties</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperties()
   * @generated
   * @ordered
   */
  protected EList<Property> properties;

  /**
   * The cached value of the '{@link #getConstraints() <em>Constraints</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConstraints()
   * @generated
   * @ordered
   */
  protected EList<Property> constraints;

  /**
   * The cached value of the '{@link #getArtifacts() <em>Artifacts</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getArtifacts()
   * @generated
   * @ordered
   */
  protected EList<Artifact> artifacts;

  /**
   * The cached value of the '{@link #getEmbedded() <em>Embedded</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEmbedded()
   * @generated
   * @ordered
   */
  protected EList<Application> embedded;

  /**
   * The cached value of the '{@link #getDepends() <em>Depends</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDepends()
   * @generated
   * @ordered
   */
  protected EList<Application> depends;

  /**
   * The cached value of the '{@link #getProfiles() <em>Profiles</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProfiles()
   * @generated
   * @ordered
   */
  protected EList<VersionedProfile> profiles;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected ApplicationType type;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ApplicationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.APPLICATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Version getVersion() {
    autoResolveEProxy(RepositoryPackage.Literals.IVERSIONED_OBJECT__VERSION);
    return _basicGetVersion();
  }
  
  private final Version _basicGetVersion() {
    return version;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetVersion(Version newVersion, NotificationChain msgs)
  {
    Version oldVersion = version;
    version = newVersion;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__VERSION, oldVersion, newVersion);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVersion(Version newVersion)
  {
    
    if (newVersion != version)
    {
      NotificationChain msgs = null;
      if (version != null)
        msgs = ((InternalEObject)version).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.APPLICATION__VERSION, null, msgs);
      if (newVersion != null)
        msgs = ((InternalEObject)newVersion).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.APPLICATION__VERSION, null, msgs);
      msgs = basicSetVersion(newVersion, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__VERSION, newVersion, newVersion));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getConfiguration() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ICONFIGURATION__CONFIGURATION);
    return _basicGetConfiguration();
  }
  
  private final EList<Property> _basicGetConfiguration() {
    if (configuration == null)
    {
      configuration = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.APPLICATION__CONFIGURATION);
    }
    return configuration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeValue> getAttributes() {
    autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES);
    return _basicGetAttributes();
  }
  
  private final EList<UserAttributeValue> _basicGetAttributes() {
    if (attributes == null)
    {
      attributes = new EObjectContainmentEList<UserAttributeValue>(UserAttributeValue.class, this, SOA_NetworkPackage.APPLICATION__ATTRIBUTES);
    }
    return attributes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeDefinition> getTags() {
    autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS);
    return _basicGetTags();
  }
  
  private final EList<UserAttributeDefinition> _basicGetTags() {
    if (tags == null)
    {
      tags = new EObjectResolvingEList<UserAttributeDefinition>(UserAttributeDefinition.class, this, SOA_NetworkPackage.APPLICATION__TAGS);
    }
    return tags;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ICategory> getCategories() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES);
    return _basicGetCategories();
  }
  
  private final EList<ICategory> _basicGetCategories() {
    if (categories == null)
    {
      categories = new EObjectWithInverseResolvingEList.ManyInverse<ICategory>(ICategory.class, this, SOA_NetworkPackage.APPLICATION__CATEGORIES, FolderPackage.ICATEGORY__CONTENT);
    }
    return categories;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getProperties() {
    autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES);
    return _basicGetProperties();
  }
  
  private final EList<Property> _basicGetProperties() {
    if (properties == null)
    {
      properties = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.APPLICATION__PROPERTIES);
    }
    return properties;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getConstraints() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS);
    return _basicGetConstraints();
  }
  
  private final EList<Property> _basicGetConstraints() {
    if (constraints == null)
    {
      constraints = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.APPLICATION__CONSTRAINTS);
    }
    return constraints;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Artifact> getArtifacts() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__ARTIFACTS);
    return _basicGetArtifacts();
  }
  
  private final EList<Artifact> _basicGetArtifacts() {
    if (artifacts == null)
    {
      artifacts = new EObjectWithInverseResolvingEList.ManyInverse<Artifact>(Artifact.class, this, SOA_NetworkPackage.APPLICATION__ARTIFACTS, SOA_NetworkPackage.ARTIFACT__APPLICATIONS);
    }
    return artifacts;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Application> getEmbedded() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__EMBEDDED);
    return _basicGetEmbedded();
  }
  
  private final EList<Application> _basicGetEmbedded() {
    if (embedded == null)
    {
      embedded = new EObjectResolvingEList<Application>(Application.class, this, SOA_NetworkPackage.APPLICATION__EMBEDDED);
    }
    return embedded;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Application> getDepends() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__DEPENDS);
    return _basicGetDepends();
  }
  
  private final EList<Application> _basicGetDepends() {
    if (depends == null)
    {
      depends = new EObjectResolvingEList<Application>(Application.class, this, SOA_NetworkPackage.APPLICATION__DEPENDS);
    }
    return depends;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<VersionedProfile> getProfiles() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__PROFILES);
    return _basicGetProfiles();
  }
  
  private final EList<VersionedProfile> _basicGetProfiles() {
    if (profiles == null)
    {
      profiles = new EObjectWithInverseResolvingEList.ManyInverse<VersionedProfile>(VersionedProfile.class, this, SOA_NetworkPackage.APPLICATION__PROFILES, SOA_NetworkPackage.VERSIONED_PROFILE__APPLICATIONS);
    }
    return profiles;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ApplicationType getType() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__TYPE);
    return _basicGetType();
  }
  
  private final ApplicationType _basicGetType() {
    if (type != null && type.eIsProxy())
    {
      InternalEObject oldType = (InternalEObject)type;
      type = (ApplicationType)eResolveProxy(oldType);
      if (type != oldType)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.APPLICATION__TYPE, oldType, type));
      }
    }
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ApplicationType basicGetType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(ApplicationType newType)
  {
    
    ApplicationType oldType = type;
    type = newType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.APPLICATION__TYPE, oldType, type));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.APPLICATION__CATEGORIES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetCategories()).basicAdd(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__ARTIFACTS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetArtifacts()).basicAdd(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__PROFILES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetProfiles()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.APPLICATION__VERSION:
        return basicSetVersion(null, msgs);
      case SOA_NetworkPackage.APPLICATION__CONFIGURATION:
        return ((InternalEList<?>)_basicGetConfiguration()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__ATTRIBUTES:
        return ((InternalEList<?>)_basicGetAttributes()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__CATEGORIES:
        return ((InternalEList<?>)_basicGetCategories()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__PROPERTIES:
        return ((InternalEList<?>)_basicGetProperties()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__CONSTRAINTS:
        return ((InternalEList<?>)_basicGetConstraints()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__ARTIFACTS:
        return ((InternalEList<?>)_basicGetArtifacts()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.APPLICATION__PROFILES:
        return ((InternalEList<?>)_basicGetProfiles()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.APPLICATION__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.APPLICATION__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.APPLICATION__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.APPLICATION__VERSION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IVERSIONED_OBJECT__VERSION); }
        return _basicGetVersion();
      case SOA_NetworkPackage.APPLICATION__CONFIGURATION:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ICONFIGURATION__CONFIGURATION); }
        return _basicGetConfiguration();
      case SOA_NetworkPackage.APPLICATION__ATTRIBUTES:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES); }
        return _basicGetAttributes();
      case SOA_NetworkPackage.APPLICATION__TAGS:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS); }
        return _basicGetTags();
      case SOA_NetworkPackage.APPLICATION__CATEGORIES:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES); }
        return _basicGetCategories();
      case SOA_NetworkPackage.APPLICATION__PROPERTIES:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES); }
        return _basicGetProperties();
      case SOA_NetworkPackage.APPLICATION__CONSTRAINTS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS); }
        return _basicGetConstraints();
      case SOA_NetworkPackage.APPLICATION__ARTIFACTS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__ARTIFACTS); }
        return _basicGetArtifacts();
      case SOA_NetworkPackage.APPLICATION__EMBEDDED:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__EMBEDDED); }
        return _basicGetEmbedded();
      case SOA_NetworkPackage.APPLICATION__DEPENDS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__DEPENDS); }
        return _basicGetDepends();
      case SOA_NetworkPackage.APPLICATION__PROFILES:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__PROFILES); }
        return _basicGetProfiles();
      case SOA_NetworkPackage.APPLICATION__TYPE:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.APPLICATION__TYPE); }
        if (resolve) return getType();
        return _basicGetType();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.APPLICATION__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__VERSION:
        setVersion((Version)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__CONFIGURATION:
        _basicGetConfiguration().clear();
        _basicGetConfiguration().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__ATTRIBUTES:
        _basicGetAttributes().clear();
        _basicGetAttributes().addAll((Collection<? extends UserAttributeValue>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__TAGS:
        _basicGetTags().clear();
        _basicGetTags().addAll((Collection<? extends UserAttributeDefinition>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__CATEGORIES:
        _basicGetCategories().clear();
        _basicGetCategories().addAll((Collection<? extends ICategory>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__PROPERTIES:
        _basicGetProperties().clear();
        _basicGetProperties().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__CONSTRAINTS:
        _basicGetConstraints().clear();
        _basicGetConstraints().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__ARTIFACTS:
        _basicGetArtifacts().clear();
        _basicGetArtifacts().addAll((Collection<? extends Artifact>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__EMBEDDED:
        _basicGetEmbedded().clear();
        _basicGetEmbedded().addAll((Collection<? extends Application>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__DEPENDS:
        _basicGetDepends().clear();
        _basicGetDepends().addAll((Collection<? extends Application>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__PROFILES:
        _basicGetProfiles().clear();
        _basicGetProfiles().addAll((Collection<? extends VersionedProfile>)newValue);
        return;
      case SOA_NetworkPackage.APPLICATION__TYPE:
        setType((ApplicationType)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.APPLICATION__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.APPLICATION__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.APPLICATION__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.APPLICATION__VERSION:
      setVersion((Version)null);
      return;
    case SOA_NetworkPackage.APPLICATION__CONFIGURATION:
      _basicGetConfiguration().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__ATTRIBUTES:
      _basicGetAttributes().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__TAGS:
      _basicGetTags().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__CATEGORIES:
      _basicGetCategories().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__PROPERTIES:
      _basicGetProperties().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__CONSTRAINTS:
      _basicGetConstraints().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__ARTIFACTS:
      _basicGetArtifacts().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__EMBEDDED:
      _basicGetEmbedded().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__DEPENDS:
      _basicGetDepends().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__PROFILES:
      _basicGetProfiles().clear();
      return;
    case SOA_NetworkPackage.APPLICATION__TYPE:
      setType((ApplicationType)null);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.APPLICATION__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.APPLICATION__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.APPLICATION__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.APPLICATION__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.APPLICATION__VERSION:
        return version != null;
      case SOA_NetworkPackage.APPLICATION__CONFIGURATION:
        return configuration != null && !configuration.isEmpty();
      case SOA_NetworkPackage.APPLICATION__ATTRIBUTES:
        return attributes != null && !attributes.isEmpty();
      case SOA_NetworkPackage.APPLICATION__TAGS:
        return tags != null && !tags.isEmpty();
      case SOA_NetworkPackage.APPLICATION__CATEGORIES:
        return categories != null && !categories.isEmpty();
      case SOA_NetworkPackage.APPLICATION__PROPERTIES:
        return properties != null && !properties.isEmpty();
      case SOA_NetworkPackage.APPLICATION__CONSTRAINTS:
        return constraints != null && !constraints.isEmpty();
      case SOA_NetworkPackage.APPLICATION__ARTIFACTS:
        return artifacts != null && !artifacts.isEmpty();
      case SOA_NetworkPackage.APPLICATION__EMBEDDED:
        return embedded != null && !embedded.isEmpty();
      case SOA_NetworkPackage.APPLICATION__DEPENDS:
        return depends != null && !depends.isEmpty();
      case SOA_NetworkPackage.APPLICATION__PROFILES:
        return profiles != null && !profiles.isEmpty();
      case SOA_NetworkPackage.APPLICATION__TYPE:
        return type != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == IVersionedObject.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.APPLICATION__VERSION: return RepositoryPackage.IVERSIONED_OBJECT__VERSION;
        default: return -1;
      }
    }
    if (baseClass == IConfiguration.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.APPLICATION__CONFIGURATION: return SOA_NetworkPackage.ICONFIGURATION__CONFIGURATION;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.APPLICATION__ATTRIBUTES: return UserAttributesPackage.IATTRIBUTES__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.APPLICATION__TAGS: return UserAttributesPackage.ITAGGED__TAGS;
        default: return -1;
      }
    }
    if (baseClass == ICategorizable.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.APPLICATION__CATEGORIES: return FolderPackage.ICATEGORIZABLE__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.APPLICATION__PROPERTIES: return RepositoryPackage.IPROPERTIES__PROPERTIES;
        default: return -1;
      }
    }
    if (baseClass == IDeploymentConstraint.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.APPLICATION__CONSTRAINTS: return SOA_NetworkPackage.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == IVersionedObject.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IVERSIONED_OBJECT__VERSION: return SOA_NetworkPackage.APPLICATION__VERSION;
        default: return -1;
      }
    }
    if (baseClass == IConfiguration.class)
    {
      switch (baseFeatureID)
      {
        case SOA_NetworkPackage.ICONFIGURATION__CONFIGURATION: return SOA_NetworkPackage.APPLICATION__CONFIGURATION;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.IATTRIBUTES__ATTRIBUTES: return SOA_NetworkPackage.APPLICATION__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.ITAGGED__TAGS: return SOA_NetworkPackage.APPLICATION__TAGS;
        default: return -1;
      }
    }
    if (baseClass == ICategorizable.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.ICATEGORIZABLE__CATEGORIES: return SOA_NetworkPackage.APPLICATION__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IPROPERTIES__PROPERTIES: return SOA_NetworkPackage.APPLICATION__PROPERTIES;
        default: return -1;
      }
    }
    if (baseClass == IDeploymentConstraint.class)
    {
      switch (baseFeatureID)
      {
        case SOA_NetworkPackage.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS: return SOA_NetworkPackage.APPLICATION__CONSTRAINTS;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //ApplicationImpl


