/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.Application;
import com.iona.soa.model.Artifact;
import com.iona.soa.model.ArtifactRepository;
import com.iona.soa.model.ArtifactType;
import com.iona.soa.model.IConfiguration;
import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.IFolder;
import com.iona.soa.model.folder.IFolderContent;

import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.Property;
import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;
import com.iona.soa.model.userattributes.UserAttributeDefinition;
import com.iona.soa.model.userattributes.UserAttributeValue;
import com.iona.soa.model.userattributes.UserAttributesPackage;

import java.net.URI;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Artifact</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getConfiguration <em>Configuration</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getTags <em>Tags</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getBelongsTo <em>Belongs To</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getApplications <em>Applications</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getUri <em>Uri</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getFileName <em>File Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getRelativeLocation <em>Relative Location</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#isSubstitution <em>Substitution</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getSubPrefix <em>Sub Prefix</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getSubPostfix <em>Sub Postfix</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getDepends <em>Depends</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#getFoundIn <em>Found In</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactImpl#isExternal <em>External</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ArtifactImpl extends IPersistableObjectImpl implements Artifact
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getConfiguration() <em>Configuration</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConfiguration()
   * @generated
   * @ordered
   */
  protected EList<Property> configuration;

  /**
   * The cached value of the '{@link #getAttributes() <em>Attributes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttributes()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeValue> attributes;

  /**
   * The cached value of the '{@link #getTags() <em>Tags</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTags()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeDefinition> tags;

  /**
   * The cached value of the '{@link #getProperties() <em>Properties</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperties()
   * @generated
   * @ordered
   */
  protected EList<Property> properties;

  /**
   * The cached value of the '{@link #getBelongsTo() <em>Belongs To</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBelongsTo()
   * @generated
   * @ordered
   */
  protected IFolder belongsTo;

  /**
   * The cached value of the '{@link #getApplications() <em>Applications</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getApplications()
   * @generated
   * @ordered
   */
  protected EList<Application> applications;

  /**
   * The default value of the '{@link #getUri() <em>Uri</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUri()
   * @generated
   * @ordered
   */
  protected static final URI URI_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getUri() <em>Uri</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUri()
   * @generated
   * @ordered
   */
  protected URI uri = URI_EDEFAULT;

  /**
   * The default value of the '{@link #getFileName() <em>File Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFileName()
   * @generated
   * @ordered
   */
  protected static final String FILE_NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getFileName() <em>File Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFileName()
   * @generated
   * @ordered
   */
  protected String fileName = FILE_NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVersion()
   * @generated
   * @ordered
   */
  protected static final String VERSION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVersion()
   * @generated
   * @ordered
   */
  protected String version = VERSION_EDEFAULT;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected ArtifactType type;

  /**
   * The default value of the '{@link #getRelativeLocation() <em>Relative Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRelativeLocation()
   * @generated
   * @ordered
   */
  protected static final String RELATIVE_LOCATION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getRelativeLocation() <em>Relative Location</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRelativeLocation()
   * @generated
   * @ordered
   */
  protected String relativeLocation = RELATIVE_LOCATION_EDEFAULT;

  /**
   * The default value of the '{@link #isSubstitution() <em>Substitution</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSubstitution()
   * @generated
   * @ordered
   */
  protected static final boolean SUBSTITUTION_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isSubstitution() <em>Substitution</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSubstitution()
   * @generated
   * @ordered
   */
  protected boolean substitution = SUBSTITUTION_EDEFAULT;

  /**
   * The default value of the '{@link #getSubPrefix() <em>Sub Prefix</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSubPrefix()
   * @generated
   * @ordered
   */
  protected static final String SUB_PREFIX_EDEFAULT = "${";

  /**
   * The cached value of the '{@link #getSubPrefix() <em>Sub Prefix</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSubPrefix()
   * @generated
   * @ordered
   */
  protected String subPrefix = SUB_PREFIX_EDEFAULT;

  /**
   * The default value of the '{@link #getSubPostfix() <em>Sub Postfix</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSubPostfix()
   * @generated
   * @ordered
   */
  protected static final String SUB_POSTFIX_EDEFAULT = "}";

  /**
   * The cached value of the '{@link #getSubPostfix() <em>Sub Postfix</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSubPostfix()
   * @generated
   * @ordered
   */
  protected String subPostfix = SUB_POSTFIX_EDEFAULT;

  /**
   * The cached value of the '{@link #getDepends() <em>Depends</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDepends()
   * @generated
   * @ordered
   */
  protected EList<Artifact> depends;

  /**
   * The cached value of the '{@link #getFoundIn() <em>Found In</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFoundIn()
   * @generated
   * @ordered
   */
  protected EList<ArtifactRepository> foundIn;

  /**
   * The default value of the '{@link #isExternal() <em>External</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isExternal()
   * @generated
   * @ordered
   */
  protected static final boolean EXTERNAL_EDEFAULT = true;

  /**
   * The cached value of the '{@link #isExternal() <em>External</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isExternal()
   * @generated
   * @ordered
   */
  protected boolean external = EXTERNAL_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ArtifactImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.ARTIFACT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getConfiguration() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ICONFIGURATION__CONFIGURATION);
    return _basicGetConfiguration();
  }
  
  private final EList<Property> _basicGetConfiguration() {
    if (configuration == null)
    {
      configuration = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.ARTIFACT__CONFIGURATION);
    }
    return configuration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeValue> getAttributes() {
    autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES);
    return _basicGetAttributes();
  }
  
  private final EList<UserAttributeValue> _basicGetAttributes() {
    if (attributes == null)
    {
      attributes = new EObjectContainmentEList<UserAttributeValue>(UserAttributeValue.class, this, SOA_NetworkPackage.ARTIFACT__ATTRIBUTES);
    }
    return attributes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeDefinition> getTags() {
    autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS);
    return _basicGetTags();
  }
  
  private final EList<UserAttributeDefinition> _basicGetTags() {
    if (tags == null)
    {
      tags = new EObjectResolvingEList<UserAttributeDefinition>(UserAttributeDefinition.class, this, SOA_NetworkPackage.ARTIFACT__TAGS);
    }
    return tags;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getProperties() {
    autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES);
    return _basicGetProperties();
  }
  
  private final EList<Property> _basicGetProperties() {
    if (properties == null)
    {
      properties = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.ARTIFACT__PROPERTIES);
    }
    return properties;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IFolder getBelongsTo() {
    autoResolveEProxy(FolderPackage.Literals.IFOLDER_CONTENT__BELONGS_TO);
    return _basicGetBelongsTo();
  }
  
  private final IFolder _basicGetBelongsTo() {
    if (belongsTo != null && belongsTo.eIsProxy())
    {
      InternalEObject oldBelongsTo = (InternalEObject)belongsTo;
      belongsTo = (IFolder)eResolveProxy(oldBelongsTo);
      if (belongsTo != oldBelongsTo)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.ARTIFACT__BELONGS_TO, oldBelongsTo, belongsTo));
      }
    }
    return belongsTo;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IFolder basicGetBelongsTo()
  {
    return belongsTo;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetBelongsTo(IFolder newBelongsTo, NotificationChain msgs)
  {
    IFolder oldBelongsTo = belongsTo;
    belongsTo = newBelongsTo;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__BELONGS_TO, oldBelongsTo, newBelongsTo);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBelongsTo(IFolder newBelongsTo)
  {
    
    if (newBelongsTo != belongsTo)
    {
      NotificationChain msgs = null;
      if (belongsTo != null)
        msgs = ((InternalEObject)belongsTo).eInverseRemove(this, FolderPackage.IFOLDER__CONTENT, IFolder.class, msgs);
      if (newBelongsTo != null)
        msgs = ((InternalEObject)newBelongsTo).eInverseAdd(this, FolderPackage.IFOLDER__CONTENT, IFolder.class, msgs);
      msgs = basicSetBelongsTo(newBelongsTo, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__BELONGS_TO, newBelongsTo, newBelongsTo));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Application> getApplications() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__APPLICATIONS);
    return _basicGetApplications();
  }
  
  private final EList<Application> _basicGetApplications() {
    if (applications == null)
    {
      applications = new EObjectWithInverseResolvingEList.ManyInverse<Application>(Application.class, this, SOA_NetworkPackage.ARTIFACT__APPLICATIONS, SOA_NetworkPackage.APPLICATION__ARTIFACTS);
    }
    return applications;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public URI getUri() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__URI);
    return _basicGetUri();
  }
  
  private final URI _basicGetUri() {
    return uri;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUri(URI newUri)
  {
    
    URI oldUri = uri;
    uri = newUri;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__URI, oldUri, uri));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getFileName() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__FILE_NAME);
    return _basicGetFileName();
  }
  
  private final String _basicGetFileName() {
    return fileName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFileName(String newFileName)
  {
    
    String oldFileName = fileName;
    fileName = newFileName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__FILE_NAME, oldFileName, fileName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getVersion() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__VERSION);
    return _basicGetVersion();
  }
  
  private final String _basicGetVersion() {
    return version;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVersion(String newVersion)
  {
    
    String oldVersion = version;
    version = newVersion;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__VERSION, oldVersion, version));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArtifactType getType() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__TYPE);
    return _basicGetType();
  }
  
  private final ArtifactType _basicGetType() {
    if (type != null && type.eIsProxy())
    {
      InternalEObject oldType = (InternalEObject)type;
      type = (ArtifactType)eResolveProxy(oldType);
      if (type != oldType)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.ARTIFACT__TYPE, oldType, type));
      }
    }
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArtifactType basicGetType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(ArtifactType newType)
  {
    
    ArtifactType oldType = type;
    type = newType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__TYPE, oldType, type));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRelativeLocation() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__RELATIVE_LOCATION);
    return _basicGetRelativeLocation();
  }
  
  private final String _basicGetRelativeLocation() {
    return relativeLocation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRelativeLocation(String newRelativeLocation)
  {
    
    String oldRelativeLocation = relativeLocation;
    relativeLocation = newRelativeLocation;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__RELATIVE_LOCATION, oldRelativeLocation, relativeLocation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSubstitution() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__SUBSTITUTION);
    return _basicGetSubstitution();
  }
  
  private final boolean _basicGetSubstitution() {
    return substitution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSubstitution(boolean newSubstitution)
  {
    
    boolean oldSubstitution = substitution;
    substitution = newSubstitution;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__SUBSTITUTION, oldSubstitution, substitution));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSubPrefix() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__SUB_PREFIX);
    return _basicGetSubPrefix();
  }
  
  private final String _basicGetSubPrefix() {
    return subPrefix;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSubPrefix(String newSubPrefix)
  {
    
    String oldSubPrefix = subPrefix;
    subPrefix = newSubPrefix;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__SUB_PREFIX, oldSubPrefix, subPrefix));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSubPostfix() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__SUB_POSTFIX);
    return _basicGetSubPostfix();
  }
  
  private final String _basicGetSubPostfix() {
    return subPostfix;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSubPostfix(String newSubPostfix)
  {
    
    String oldSubPostfix = subPostfix;
    subPostfix = newSubPostfix;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__SUB_POSTFIX, oldSubPostfix, subPostfix));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Artifact> getDepends() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__DEPENDS);
    return _basicGetDepends();
  }
  
  private final EList<Artifact> _basicGetDepends() {
    if (depends == null)
    {
      depends = new EObjectResolvingEList<Artifact>(Artifact.class, this, SOA_NetworkPackage.ARTIFACT__DEPENDS);
    }
    return depends;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ArtifactRepository> getFoundIn() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__FOUND_IN);
    return _basicGetFoundIn();
  }
  
  private final EList<ArtifactRepository> _basicGetFoundIn() {
    if (foundIn == null)
    {
      foundIn = new EObjectResolvingEList<ArtifactRepository>(ArtifactRepository.class, this, SOA_NetworkPackage.ARTIFACT__FOUND_IN);
    }
    return foundIn;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isExternal() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__EXTERNAL);
    return _basicGetExternal();
  }
  
  private final boolean _basicGetExternal() {
    return external;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExternal(boolean newExternal)
  {
    
    boolean oldExternal = external;
    external = newExternal;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT__EXTERNAL, oldExternal, external));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT__BELONGS_TO:
        if (belongsTo != null)
          msgs = ((InternalEObject)belongsTo).eInverseRemove(this, FolderPackage.IFOLDER__CONTENT, IFolder.class, msgs);
        return basicSetBelongsTo((IFolder)otherEnd, msgs);
      case SOA_NetworkPackage.ARTIFACT__APPLICATIONS:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetApplications()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.ARTIFACT__CONFIGURATION:
        return ((InternalEList<?>)_basicGetConfiguration()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.ARTIFACT__ATTRIBUTES:
        return ((InternalEList<?>)_basicGetAttributes()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.ARTIFACT__PROPERTIES:
        return ((InternalEList<?>)_basicGetProperties()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.ARTIFACT__BELONGS_TO:
        return basicSetBelongsTo(null, msgs);
      case SOA_NetworkPackage.ARTIFACT__APPLICATIONS:
        return ((InternalEList<?>)_basicGetApplications()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.ARTIFACT__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.ARTIFACT__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.ARTIFACT__CONFIGURATION:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ICONFIGURATION__CONFIGURATION); }
        return _basicGetConfiguration();
      case SOA_NetworkPackage.ARTIFACT__ATTRIBUTES:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES); }
        return _basicGetAttributes();
      case SOA_NetworkPackage.ARTIFACT__TAGS:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS); }
        return _basicGetTags();
      case SOA_NetworkPackage.ARTIFACT__PROPERTIES:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES); }
        return _basicGetProperties();
      case SOA_NetworkPackage.ARTIFACT__BELONGS_TO:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.IFOLDER_CONTENT__BELONGS_TO); }
        if (resolve) return getBelongsTo();
        return _basicGetBelongsTo();
      case SOA_NetworkPackage.ARTIFACT__APPLICATIONS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__APPLICATIONS); }
        return _basicGetApplications();
      case SOA_NetworkPackage.ARTIFACT__URI:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__URI); }
        return _basicGetUri();
      case SOA_NetworkPackage.ARTIFACT__FILE_NAME:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__FILE_NAME); }
        return _basicGetFileName();
      case SOA_NetworkPackage.ARTIFACT__VERSION:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__VERSION); }
        return _basicGetVersion();
      case SOA_NetworkPackage.ARTIFACT__TYPE:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__TYPE); }
        if (resolve) return getType();
        return _basicGetType();
      case SOA_NetworkPackage.ARTIFACT__RELATIVE_LOCATION:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__RELATIVE_LOCATION); }
        return _basicGetRelativeLocation();
      case SOA_NetworkPackage.ARTIFACT__SUBSTITUTION:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__SUBSTITUTION); }
        return _basicGetSubstitution() ? Boolean.TRUE : Boolean.FALSE;
      case SOA_NetworkPackage.ARTIFACT__SUB_PREFIX:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__SUB_PREFIX); }
        return _basicGetSubPrefix();
      case SOA_NetworkPackage.ARTIFACT__SUB_POSTFIX:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__SUB_POSTFIX); }
        return _basicGetSubPostfix();
      case SOA_NetworkPackage.ARTIFACT__DEPENDS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__DEPENDS); }
        return _basicGetDepends();
      case SOA_NetworkPackage.ARTIFACT__FOUND_IN:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__FOUND_IN); }
        return _basicGetFoundIn();
      case SOA_NetworkPackage.ARTIFACT__EXTERNAL:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT__EXTERNAL); }
        return _basicGetExternal() ? Boolean.TRUE : Boolean.FALSE;
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__CONFIGURATION:
        _basicGetConfiguration().clear();
        _basicGetConfiguration().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__ATTRIBUTES:
        _basicGetAttributes().clear();
        _basicGetAttributes().addAll((Collection<? extends UserAttributeValue>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__TAGS:
        _basicGetTags().clear();
        _basicGetTags().addAll((Collection<? extends UserAttributeDefinition>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__PROPERTIES:
        _basicGetProperties().clear();
        _basicGetProperties().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__BELONGS_TO:
        setBelongsTo((IFolder)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__APPLICATIONS:
        _basicGetApplications().clear();
        _basicGetApplications().addAll((Collection<? extends Application>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__URI:
        setUri((URI)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__FILE_NAME:
        setFileName((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__VERSION:
        setVersion((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__TYPE:
        setType((ArtifactType)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__RELATIVE_LOCATION:
        setRelativeLocation((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__SUBSTITUTION:
        setSubstitution(((Boolean)newValue).booleanValue());
        return;
      case SOA_NetworkPackage.ARTIFACT__SUB_PREFIX:
        setSubPrefix((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__SUB_POSTFIX:
        setSubPostfix((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__DEPENDS:
        _basicGetDepends().clear();
        _basicGetDepends().addAll((Collection<? extends Artifact>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__FOUND_IN:
        _basicGetFoundIn().clear();
        _basicGetFoundIn().addAll((Collection<? extends ArtifactRepository>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT__EXTERNAL:
        setExternal(((Boolean)newValue).booleanValue());
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.ARTIFACT__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.ARTIFACT__CONFIGURATION:
      _basicGetConfiguration().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT__ATTRIBUTES:
      _basicGetAttributes().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT__TAGS:
      _basicGetTags().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT__PROPERTIES:
      _basicGetProperties().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT__BELONGS_TO:
      setBelongsTo((IFolder)null);
      return;
    case SOA_NetworkPackage.ARTIFACT__APPLICATIONS:
      _basicGetApplications().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT__URI:
      setUri(URI_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__FILE_NAME:
      setFileName(FILE_NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__VERSION:
      setVersion(VERSION_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__TYPE:
      setType((ArtifactType)null);
      return;
    case SOA_NetworkPackage.ARTIFACT__RELATIVE_LOCATION:
      setRelativeLocation(RELATIVE_LOCATION_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__SUBSTITUTION:
      setSubstitution(SUBSTITUTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__SUB_PREFIX:
      setSubPrefix(SUB_PREFIX_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__SUB_POSTFIX:
      setSubPostfix(SUB_POSTFIX_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT__DEPENDS:
      _basicGetDepends().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT__FOUND_IN:
      _basicGetFoundIn().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT__EXTERNAL:
      setExternal(EXTERNAL_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.ARTIFACT__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.ARTIFACT__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.ARTIFACT__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.ARTIFACT__CONFIGURATION:
        return configuration != null && !configuration.isEmpty();
      case SOA_NetworkPackage.ARTIFACT__ATTRIBUTES:
        return attributes != null && !attributes.isEmpty();
      case SOA_NetworkPackage.ARTIFACT__TAGS:
        return tags != null && !tags.isEmpty();
      case SOA_NetworkPackage.ARTIFACT__PROPERTIES:
        return properties != null && !properties.isEmpty();
      case SOA_NetworkPackage.ARTIFACT__BELONGS_TO:
        return belongsTo != null;
      case SOA_NetworkPackage.ARTIFACT__APPLICATIONS:
        return applications != null && !applications.isEmpty();
      case SOA_NetworkPackage.ARTIFACT__URI:
        return URI_EDEFAULT == null ? uri != null : !URI_EDEFAULT.equals(uri);
      case SOA_NetworkPackage.ARTIFACT__FILE_NAME:
        return FILE_NAME_EDEFAULT == null ? fileName != null : !FILE_NAME_EDEFAULT.equals(fileName);
      case SOA_NetworkPackage.ARTIFACT__VERSION:
        return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals(version);
      case SOA_NetworkPackage.ARTIFACT__TYPE:
        return type != null;
      case SOA_NetworkPackage.ARTIFACT__RELATIVE_LOCATION:
        return RELATIVE_LOCATION_EDEFAULT == null ? relativeLocation != null : !RELATIVE_LOCATION_EDEFAULT.equals(relativeLocation);
      case SOA_NetworkPackage.ARTIFACT__SUBSTITUTION:
        return substitution != SUBSTITUTION_EDEFAULT;
      case SOA_NetworkPackage.ARTIFACT__SUB_PREFIX:
        return SUB_PREFIX_EDEFAULT == null ? subPrefix != null : !SUB_PREFIX_EDEFAULT.equals(subPrefix);
      case SOA_NetworkPackage.ARTIFACT__SUB_POSTFIX:
        return SUB_POSTFIX_EDEFAULT == null ? subPostfix != null : !SUB_POSTFIX_EDEFAULT.equals(subPostfix);
      case SOA_NetworkPackage.ARTIFACT__DEPENDS:
        return depends != null && !depends.isEmpty();
      case SOA_NetworkPackage.ARTIFACT__FOUND_IN:
        return foundIn != null && !foundIn.isEmpty();
      case SOA_NetworkPackage.ARTIFACT__EXTERNAL:
        return external != EXTERNAL_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == IConfiguration.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT__CONFIGURATION: return SOA_NetworkPackage.ICONFIGURATION__CONFIGURATION;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT__ATTRIBUTES: return UserAttributesPackage.IATTRIBUTES__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT__TAGS: return UserAttributesPackage.ITAGGED__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT__PROPERTIES: return RepositoryPackage.IPROPERTIES__PROPERTIES;
        default: return -1;
      }
    }
    if (baseClass == IFolderContent.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT__BELONGS_TO: return FolderPackage.IFOLDER_CONTENT__BELONGS_TO;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == IConfiguration.class)
    {
      switch (baseFeatureID)
      {
        case SOA_NetworkPackage.ICONFIGURATION__CONFIGURATION: return SOA_NetworkPackage.ARTIFACT__CONFIGURATION;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.IATTRIBUTES__ATTRIBUTES: return SOA_NetworkPackage.ARTIFACT__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.ITAGGED__TAGS: return SOA_NetworkPackage.ARTIFACT__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IPROPERTIES__PROPERTIES: return SOA_NetworkPackage.ARTIFACT__PROPERTIES;
        default: return -1;
      }
    }
    if (baseClass == IFolderContent.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.IFOLDER_CONTENT__BELONGS_TO: return SOA_NetworkPackage.ARTIFACT__BELONGS_TO;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(", uri: ");
    result.append(uri);
    result.append(", fileName: ");
    result.append(fileName);
    result.append(", version: ");
    result.append(version);
    result.append(", relativeLocation: ");
    result.append(relativeLocation);
    result.append(", substitution: ");
    result.append(substitution);
    result.append(", subPrefix: ");
    result.append(subPrefix);
    result.append(", subPostfix: ");
    result.append(subPostfix);
    result.append(", external: ");
    result.append(external);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //ArtifactImpl


