/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.ArtifactRepository;
import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;

import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.Property;
import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;
import com.iona.soa.model.userattributes.UserAttributeDefinition;
import com.iona.soa.model.userattributes.UserAttributeValue;
import com.iona.soa.model.userattributes.UserAttributesPackage;

import java.net.URI;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Artifact Repository</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getCategories <em>Categories</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getTags <em>Tags</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getUrl <em>Url</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getMirrorOf <em>Mirror Of</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#getOrderID <em>Order ID</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ArtifactRepositoryImpl#isExternal <em>External</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ArtifactRepositoryImpl extends IPersistableObjectImpl implements ArtifactRepository
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getCategories() <em>Categories</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategories()
   * @generated
   * @ordered
   */
  protected EList<ICategory> categories;

  /**
   * The cached value of the '{@link #getAttributes() <em>Attributes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttributes()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeValue> attributes;

  /**
   * The cached value of the '{@link #getTags() <em>Tags</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTags()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeDefinition> tags;

  /**
   * The cached value of the '{@link #getProperties() <em>Properties</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperties()
   * @generated
   * @ordered
   */
  protected EList<Property> properties;

  /**
   * The default value of the '{@link #getUrl() <em>Url</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUrl()
   * @generated
   * @ordered
   */
  protected static final URI URL_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getUrl() <em>Url</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUrl()
   * @generated
   * @ordered
   */
  protected URI url = URL_EDEFAULT;

  /**
   * The cached value of the '{@link #getMirrorOf() <em>Mirror Of</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMirrorOf()
   * @generated
   * @ordered
   */
  protected ArtifactRepository mirrorOf;

  /**
   * The default value of the '{@link #getOrderID() <em>Order ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOrderID()
   * @generated
   * @ordered
   */
  protected static final int ORDER_ID_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getOrderID() <em>Order ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOrderID()
   * @generated
   * @ordered
   */
  protected int orderID = ORDER_ID_EDEFAULT;

  /**
   * The default value of the '{@link #isExternal() <em>External</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isExternal()
   * @generated
   * @ordered
   */
  protected static final boolean EXTERNAL_EDEFAULT = true;

  /**
   * The cached value of the '{@link #isExternal() <em>External</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isExternal()
   * @generated
   * @ordered
   */
  protected boolean external = EXTERNAL_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ArtifactRepositoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ICategory> getCategories() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES);
    return _basicGetCategories();
  }
  
  private final EList<ICategory> _basicGetCategories() {
    if (categories == null)
    {
      categories = new EObjectWithInverseResolvingEList.ManyInverse<ICategory>(ICategory.class, this, SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES, FolderPackage.ICATEGORY__CONTENT);
    }
    return categories;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeValue> getAttributes() {
    autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES);
    return _basicGetAttributes();
  }
  
  private final EList<UserAttributeValue> _basicGetAttributes() {
    if (attributes == null)
    {
      attributes = new EObjectContainmentEList<UserAttributeValue>(UserAttributeValue.class, this, SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES);
    }
    return attributes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeDefinition> getTags() {
    autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS);
    return _basicGetTags();
  }
  
  private final EList<UserAttributeDefinition> _basicGetTags() {
    if (tags == null)
    {
      tags = new EObjectResolvingEList<UserAttributeDefinition>(UserAttributeDefinition.class, this, SOA_NetworkPackage.ARTIFACT_REPOSITORY__TAGS);
    }
    return tags;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getProperties() {
    autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES);
    return _basicGetProperties();
  }
  
  private final EList<Property> _basicGetProperties() {
    if (properties == null)
    {
      properties = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES);
    }
    return properties;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public URI getUrl() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__URL);
    return _basicGetUrl();
  }
  
  private final URI _basicGetUrl() {
    return url;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUrl(URI newUrl)
  {
    
    URI oldUrl = url;
    url = newUrl;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__URL, oldUrl, url));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArtifactRepository getMirrorOf() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__MIRROR_OF);
    return _basicGetMirrorOf();
  }
  
  private final ArtifactRepository _basicGetMirrorOf() {
    if (mirrorOf != null && mirrorOf.eIsProxy())
    {
      InternalEObject oldMirrorOf = (InternalEObject)mirrorOf;
      mirrorOf = (ArtifactRepository)eResolveProxy(oldMirrorOf);
      if (mirrorOf != oldMirrorOf)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.ARTIFACT_REPOSITORY__MIRROR_OF, oldMirrorOf, mirrorOf));
      }
    }
    return mirrorOf;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArtifactRepository basicGetMirrorOf()
  {
    return mirrorOf;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMirrorOf(ArtifactRepository newMirrorOf)
  {
    
    ArtifactRepository oldMirrorOf = mirrorOf;
    mirrorOf = newMirrorOf;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__MIRROR_OF, oldMirrorOf, mirrorOf));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getOrderID() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__ORDER_ID);
    return _basicGetOrderID();
  }
  
  private final int _basicGetOrderID() {
    return orderID;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOrderID(int newOrderID)
  {
    
    int oldOrderID = orderID;
    orderID = newOrderID;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__ORDER_ID, oldOrderID, orderID));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isExternal() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__EXTERNAL);
    return _basicGetExternal();
  }
  
  private final boolean _basicGetExternal() {
    return external;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExternal(boolean newExternal)
  {
    
    boolean oldExternal = external;
    external = newExternal;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.ARTIFACT_REPOSITORY__EXTERNAL, oldExternal, external));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetCategories()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES:
        return ((InternalEList<?>)_basicGetCategories()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES:
        return ((InternalEList<?>)_basicGetAttributes()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES:
        return ((InternalEList<?>)_basicGetProperties()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES); }
        return _basicGetCategories();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES); }
        return _basicGetAttributes();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__TAGS:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS); }
        return _basicGetTags();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES); }
        return _basicGetProperties();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__URL:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__URL); }
        return _basicGetUrl();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__MIRROR_OF:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__MIRROR_OF); }
        if (resolve) return getMirrorOf();
        return _basicGetMirrorOf();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ORDER_ID:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__ORDER_ID); }
        return new Integer(_basicGetOrderID());
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__EXTERNAL:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.ARTIFACT_REPOSITORY__EXTERNAL); }
        return _basicGetExternal() ? Boolean.TRUE : Boolean.FALSE;
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES:
        _basicGetCategories().clear();
        _basicGetCategories().addAll((Collection<? extends ICategory>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES:
        _basicGetAttributes().clear();
        _basicGetAttributes().addAll((Collection<? extends UserAttributeValue>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__TAGS:
        _basicGetTags().clear();
        _basicGetTags().addAll((Collection<? extends UserAttributeDefinition>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES:
        _basicGetProperties().clear();
        _basicGetProperties().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__URL:
        setUrl((URI)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__MIRROR_OF:
        setMirrorOf((ArtifactRepository)newValue);
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ORDER_ID:
        setOrderID(((Integer)newValue).intValue());
        return;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__EXTERNAL:
        setExternal(((Boolean)newValue).booleanValue());
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES:
      _basicGetCategories().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES:
      _basicGetAttributes().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__TAGS:
      _basicGetTags().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES:
      _basicGetProperties().clear();
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__URL:
      setUrl(URL_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__MIRROR_OF:
      setMirrorOf((ArtifactRepository)null);
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ORDER_ID:
      setOrderID(ORDER_ID_EDEFAULT);
      return;
    case SOA_NetworkPackage.ARTIFACT_REPOSITORY__EXTERNAL:
      setExternal(EXTERNAL_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES:
        return categories != null && !categories.isEmpty();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES:
        return attributes != null && !attributes.isEmpty();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__TAGS:
        return tags != null && !tags.isEmpty();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES:
        return properties != null && !properties.isEmpty();
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__URL:
        return URL_EDEFAULT == null ? url != null : !URL_EDEFAULT.equals(url);
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__MIRROR_OF:
        return mirrorOf != null;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ORDER_ID:
        return orderID != ORDER_ID_EDEFAULT;
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY__EXTERNAL:
        return external != EXTERNAL_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES: return FolderPackage.ICATEGORIZABLE__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES: return UserAttributesPackage.IATTRIBUTES__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT_REPOSITORY__TAGS: return UserAttributesPackage.ITAGGED__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES: return RepositoryPackage.IPROPERTIES__PROPERTIES;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.ICATEGORIZABLE__CATEGORIES: return SOA_NetworkPackage.ARTIFACT_REPOSITORY__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.IATTRIBUTES__ATTRIBUTES: return SOA_NetworkPackage.ARTIFACT_REPOSITORY__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.ITAGGED__TAGS: return SOA_NetworkPackage.ARTIFACT_REPOSITORY__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IPROPERTIES__PROPERTIES: return SOA_NetworkPackage.ARTIFACT_REPOSITORY__PROPERTIES;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(", url: ");
    result.append(url);
    result.append(", orderID: ");
    result.append(orderID);
    result.append(", external: ");
    result.append(external);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //ArtifactRepositoryImpl


