/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.Category;
import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.collaboration.CollaborationPackage;
import com.iona.soa.model.collaboration.Comment;
import com.iona.soa.model.collaboration.ICollaboration;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;
import com.iona.soa.model.security.User;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Category</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getContent <em>Content</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getEClassName <em>EClass Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getOwner <em>Owner</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getSubscribers <em>Subscribers</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.CategoryImpl#getComments <em>Comments</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CategoryImpl extends IPersistableObjectImpl implements Category
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getContent() <em>Content</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContent()
   * @generated
   * @ordered
   */
  protected EList<ICategorizable> content;

  /**
   * The default value of the '{@link #getEClassName() <em>EClass Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEClassName()
   * @generated
   * @ordered
   */
  protected static final String ECLASS_NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getEClassName() <em>EClass Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEClassName()
   * @generated
   * @ordered
   */
  protected String eClassName = ECLASS_NAME_EDEFAULT;

  /**
   * The cached value of the '{@link #getOwner() <em>Owner</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOwner()
   * @generated
   * @ordered
   */
  protected User owner;

  /**
   * The cached value of the '{@link #getSubscribers() <em>Subscribers</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSubscribers()
   * @generated
   * @ordered
   */
  protected EList<User> subscribers;

  /**
   * The cached value of the '{@link #getComments() <em>Comments</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComments()
   * @generated
   * @ordered
   */
  protected EList<Comment> comments;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CategoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.CATEGORY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CATEGORY__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CATEGORY__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CATEGORY__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ICategorizable> getContent() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORY__CONTENT);
    return _basicGetContent();
  }
  
  private final EList<ICategorizable> _basicGetContent() {
    if (content == null)
    {
      content = new EObjectWithInverseResolvingEList.ManyInverse<ICategorizable>(ICategorizable.class, this, SOA_NetworkPackage.CATEGORY__CONTENT, FolderPackage.ICATEGORIZABLE__CATEGORIES);
    }
    return content;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getEClassName() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORY__ECLASS_NAME);
    return _basicGetEClassName();
  }
  
  private final String _basicGetEClassName() {
    return eClassName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEClassName(String newEClassName)
  {
    
    String oldEClassName = eClassName;
    eClassName = newEClassName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CATEGORY__ECLASS_NAME, oldEClassName, eClassName));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public User getOwner() {
    autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__OWNER);
    return _basicGetOwner();
  }
  
  private final User _basicGetOwner() {
    if (owner != null && owner.eIsProxy())
    {
      InternalEObject oldOwner = (InternalEObject)owner;
      owner = (User)eResolveProxy(oldOwner);
      if (owner != oldOwner)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.CATEGORY__OWNER, oldOwner, owner));
      }
    }
    return owner;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public User basicGetOwner()
  {
    return owner;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOwner(User newOwner)
  {
    
    User oldOwner = owner;
    owner = newOwner;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CATEGORY__OWNER, oldOwner, owner));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<User> getSubscribers() {
    autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__SUBSCRIBERS);
    return _basicGetSubscribers();
  }
  
  private final EList<User> _basicGetSubscribers() {
    if (subscribers == null)
    {
      subscribers = new EObjectResolvingEList<User>(User.class, this, SOA_NetworkPackage.CATEGORY__SUBSCRIBERS);
    }
    return subscribers;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Comment> getComments() {
    autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__COMMENTS);
    return _basicGetComments();
  }
  
  private final EList<Comment> _basicGetComments() {
    if (comments == null)
    {
      comments = new EObjectContainmentEList<Comment>(Comment.class, this, SOA_NetworkPackage.CATEGORY__COMMENTS);
    }
    return comments;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CATEGORY__CONTENT:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetContent()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.CATEGORY__CONTENT:
        return ((InternalEList<?>)_basicGetContent()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.CATEGORY__COMMENTS:
        return ((InternalEList<?>)_basicGetComments()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CATEGORY__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.CATEGORY__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.CATEGORY__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.CATEGORY__CONTENT:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORY__CONTENT); }
        return _basicGetContent();
      case SOA_NetworkPackage.CATEGORY__ECLASS_NAME:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORY__ECLASS_NAME); }
        return _basicGetEClassName();
      case SOA_NetworkPackage.CATEGORY__OWNER:
      if (resolve) { autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__OWNER); }
        if (resolve) return getOwner();
        return _basicGetOwner();
      case SOA_NetworkPackage.CATEGORY__SUBSCRIBERS:
      if (resolve) { autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__SUBSCRIBERS); }
        return _basicGetSubscribers();
      case SOA_NetworkPackage.CATEGORY__COMMENTS:
      if (resolve) { autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__COMMENTS); }
        return _basicGetComments();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CATEGORY__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__CONTENT:
        _basicGetContent().clear();
        _basicGetContent().addAll((Collection<? extends ICategorizable>)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__ECLASS_NAME:
        setEClassName((String)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__OWNER:
        setOwner((User)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__SUBSCRIBERS:
        _basicGetSubscribers().clear();
        _basicGetSubscribers().addAll((Collection<? extends User>)newValue);
        return;
      case SOA_NetworkPackage.CATEGORY__COMMENTS:
        _basicGetComments().clear();
        _basicGetComments().addAll((Collection<? extends Comment>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.CATEGORY__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.CATEGORY__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.CATEGORY__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.CATEGORY__CONTENT:
      _basicGetContent().clear();
      return;
    case SOA_NetworkPackage.CATEGORY__ECLASS_NAME:
      setEClassName(ECLASS_NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.CATEGORY__OWNER:
      setOwner((User)null);
      return;
    case SOA_NetworkPackage.CATEGORY__SUBSCRIBERS:
      _basicGetSubscribers().clear();
      return;
    case SOA_NetworkPackage.CATEGORY__COMMENTS:
      _basicGetComments().clear();
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CATEGORY__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.CATEGORY__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.CATEGORY__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.CATEGORY__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.CATEGORY__CONTENT:
        return content != null && !content.isEmpty();
      case SOA_NetworkPackage.CATEGORY__ECLASS_NAME:
        return ECLASS_NAME_EDEFAULT == null ? eClassName != null : !ECLASS_NAME_EDEFAULT.equals(eClassName);
      case SOA_NetworkPackage.CATEGORY__OWNER:
        return owner != null;
      case SOA_NetworkPackage.CATEGORY__SUBSCRIBERS:
        return subscribers != null && !subscribers.isEmpty();
      case SOA_NetworkPackage.CATEGORY__COMMENTS:
        return comments != null && !comments.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategory.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CATEGORY__CONTENT: return FolderPackage.ICATEGORY__CONTENT;
        case SOA_NetworkPackage.CATEGORY__ECLASS_NAME: return FolderPackage.ICATEGORY__ECLASS_NAME;
        default: return -1;
      }
    }
    if (baseClass == ICollaboration.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CATEGORY__OWNER: return CollaborationPackage.ICOLLABORATION__OWNER;
        case SOA_NetworkPackage.CATEGORY__SUBSCRIBERS: return CollaborationPackage.ICOLLABORATION__SUBSCRIBERS;
        case SOA_NetworkPackage.CATEGORY__COMMENTS: return CollaborationPackage.ICOLLABORATION__COMMENTS;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategory.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.ICATEGORY__CONTENT: return SOA_NetworkPackage.CATEGORY__CONTENT;
        case FolderPackage.ICATEGORY__ECLASS_NAME: return SOA_NetworkPackage.CATEGORY__ECLASS_NAME;
        default: return -1;
      }
    }
    if (baseClass == ICollaboration.class)
    {
      switch (baseFeatureID)
      {
        case CollaborationPackage.ICOLLABORATION__OWNER: return SOA_NetworkPackage.CATEGORY__OWNER;
        case CollaborationPackage.ICOLLABORATION__SUBSCRIBERS: return SOA_NetworkPackage.CATEGORY__SUBSCRIBERS;
        case CollaborationPackage.ICOLLABORATION__COMMENTS: return SOA_NetworkPackage.CATEGORY__COMMENTS;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(", eClassName: ");
    result.append(eClassName);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //CategoryImpl


