/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.Application;
import com.iona.soa.model.ConfigurationOverride;
import com.iona.soa.model.IDeploymentConstraint;
import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.repository.IRepositoryObject;
import com.iona.soa.model.repository.Property;
import com.iona.soa.model.repository.RepositoryPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Configuration Override</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.ConfigurationOverrideImpl#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ConfigurationOverrideImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ConfigurationOverrideImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ConfigurationOverrideImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ConfigurationOverrideImpl#getApplication <em>Application</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ConfigurationOverrideImpl extends IConfigurationImpl implements ConfigurationOverride
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached value of the '{@link #getConstraints() <em>Constraints</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConstraints()
   * @generated
   * @ordered
   */
  protected EList<Property> constraints;

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getApplication() <em>Application</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getApplication()
   * @generated
   * @ordered
   */
  protected Application application;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConfigurationOverrideImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.CONFIGURATION_OVERRIDE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getConstraints() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS);
    return _basicGetConstraints();
  }
  
  private final EList<Property> _basicGetConstraints() {
    if (constraints == null)
    {
      constraints = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS);
    }
    return constraints;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONFIGURATION_OVERRIDE__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Application getApplication() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.CONFIGURATION_OVERRIDE__APPLICATION);
    return _basicGetApplication();
  }
  
  private final Application _basicGetApplication() {
    if (application != null && application.eIsProxy())
    {
      InternalEObject oldApplication = (InternalEObject)application;
      application = (Application)eResolveProxy(oldApplication);
      if (application != oldApplication)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.CONFIGURATION_OVERRIDE__APPLICATION, oldApplication, application));
      }
    }
    return application;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Application basicGetApplication()
  {
    return application;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setApplication(Application newApplication)
  {
    
    Application oldApplication = application;
    application = newApplication;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONFIGURATION_OVERRIDE__APPLICATION, oldApplication, application));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS:
        return ((InternalEList<?>)_basicGetConstraints()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS); }
        return _basicGetConstraints();
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__APPLICATION:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.CONFIGURATION_OVERRIDE__APPLICATION); }
        if (resolve) return getApplication();
        return _basicGetApplication();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS:
        _basicGetConstraints().clear();
        _basicGetConstraints().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__APPLICATION:
        setApplication((Application)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS:
      _basicGetConstraints().clear();
      return;
    case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__APPLICATION:
      setApplication((Application)null);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS:
        return constraints != null && !constraints.isEmpty();
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__APPLICATION:
        return application != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == IDeploymentConstraint.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS: return SOA_NetworkPackage.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS;
        default: return -1;
      }
    }
    if (baseClass == IRepositoryObject.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAME: return RepositoryPackage.IREPOSITORY_OBJECT__NAME;
        case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAMESPACE: return RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;
        case SOA_NetworkPackage.CONFIGURATION_OVERRIDE__DESCRIPTION: return RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == IDeploymentConstraint.class)
    {
      switch (baseFeatureID)
      {
        case SOA_NetworkPackage.IDEPLOYMENT_CONSTRAINT__CONSTRAINTS: return SOA_NetworkPackage.CONFIGURATION_OVERRIDE__CONSTRAINTS;
        default: return -1;
      }
    }
    if (baseClass == IRepositoryObject.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IREPOSITORY_OBJECT__NAME: return SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAME;
        case RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE: return SOA_NetworkPackage.CONFIGURATION_OVERRIDE__NAMESPACE;
        case RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION: return SOA_NetworkPackage.CONFIGURATION_OVERRIDE__DESCRIPTION;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //ConfigurationOverrideImpl


