/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.Container;
import com.iona.soa.model.DeploymentProfile;
import com.iona.soa.model.InstalledApplication;
import com.iona.soa.model.InstalledArtifact;
import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;

import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.Property;
import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;
import com.iona.soa.model.userattributes.UserAttributeDefinition;
import com.iona.soa.model.userattributes.UserAttributeValue;
import com.iona.soa.model.userattributes.UserAttributesPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Container</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getTags <em>Tags</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getCategories <em>Categories</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getSupportedPackageTypes <em>Supported Package Types</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getStatus <em>Status</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getApplications <em>Applications</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getProfile <em>Profile</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.ContainerImpl#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ContainerImpl extends IPersistableObjectImpl implements Container
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getTags() <em>Tags</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTags()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeDefinition> tags;

  /**
   * The cached value of the '{@link #getAttributes() <em>Attributes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttributes()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeValue> attributes;

  /**
   * The cached value of the '{@link #getCategories() <em>Categories</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategories()
   * @generated
   * @ordered
   */
  protected EList<ICategory> categories;

  /**
   * The cached value of the '{@link #getProperties() <em>Properties</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperties()
   * @generated
   * @ordered
   */
  protected EList<Property> properties;

  /**
   * The cached value of the '{@link #getSupportedPackageTypes() <em>Supported Package Types</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSupportedPackageTypes()
   * @generated
   * @ordered
   */
  protected EList<String> supportedPackageTypes;

  /**
   * The cached value of the '{@link #getStatus() <em>Status</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStatus()
   * @generated
   * @ordered
   */
  protected EList<Property> status;

  /**
   * The cached value of the '{@link #getApplications() <em>Applications</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getApplications()
   * @generated
   * @ordered
   */
  protected EList<InstalledApplication> applications;

  /**
   * The cached value of the '{@link #getArtifacts() <em>Artifacts</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getArtifacts()
   * @generated
   * @ordered
   */
  protected EList<InstalledArtifact> artifacts;

  /**
   * The cached value of the '{@link #getProfile() <em>Profile</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProfile()
   * @generated
   * @ordered
   */
  protected DeploymentProfile profile;

  /**
   * The default value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected static final String TYPE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected String type = TYPE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ContainerImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.CONTAINER;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONTAINER__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONTAINER__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONTAINER__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeDefinition> getTags() {
    autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS);
    return _basicGetTags();
  }
  
  private final EList<UserAttributeDefinition> _basicGetTags() {
    if (tags == null)
    {
      tags = new EObjectResolvingEList<UserAttributeDefinition>(UserAttributeDefinition.class, this, SOA_NetworkPackage.CONTAINER__TAGS);
    }
    return tags;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeValue> getAttributes() {
    autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES);
    return _basicGetAttributes();
  }
  
  private final EList<UserAttributeValue> _basicGetAttributes() {
    if (attributes == null)
    {
      attributes = new EObjectContainmentEList<UserAttributeValue>(UserAttributeValue.class, this, SOA_NetworkPackage.CONTAINER__ATTRIBUTES);
    }
    return attributes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ICategory> getCategories() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES);
    return _basicGetCategories();
  }
  
  private final EList<ICategory> _basicGetCategories() {
    if (categories == null)
    {
      categories = new EObjectWithInverseResolvingEList.ManyInverse<ICategory>(ICategory.class, this, SOA_NetworkPackage.CONTAINER__CATEGORIES, FolderPackage.ICATEGORY__CONTENT);
    }
    return categories;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getProperties() {
    autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES);
    return _basicGetProperties();
  }
  
  private final EList<Property> _basicGetProperties() {
    if (properties == null)
    {
      properties = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.CONTAINER__PROPERTIES);
    }
    return properties;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getSupportedPackageTypes() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__SUPPORTED_PACKAGE_TYPES);
    return _basicGetSupportedPackageTypes();
  }
  
  private final EList<String> _basicGetSupportedPackageTypes() {
    if (supportedPackageTypes == null)
    {
      supportedPackageTypes = new EDataTypeUniqueEList<String>(String.class, this, SOA_NetworkPackage.CONTAINER__SUPPORTED_PACKAGE_TYPES);
    }
    return supportedPackageTypes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getStatus() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__STATUS);
    return _basicGetStatus();
  }
  
  private final EList<Property> _basicGetStatus() {
    if (status == null)
    {
      status = new EObjectContainmentEList<Property>(Property.class, this, SOA_NetworkPackage.CONTAINER__STATUS);
    }
    return status;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<InstalledApplication> getApplications() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__APPLICATIONS);
    return _basicGetApplications();
  }
  
  private final EList<InstalledApplication> _basicGetApplications() {
    if (applications == null)
    {
      applications = new EObjectContainmentEList<InstalledApplication>(InstalledApplication.class, this, SOA_NetworkPackage.CONTAINER__APPLICATIONS);
    }
    return applications;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<InstalledArtifact> getArtifacts() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__ARTIFACTS);
    return _basicGetArtifacts();
  }
  
  private final EList<InstalledArtifact> _basicGetArtifacts() {
    if (artifacts == null)
    {
      artifacts = new EObjectContainmentEList<InstalledArtifact>(InstalledArtifact.class, this, SOA_NetworkPackage.CONTAINER__ARTIFACTS);
    }
    return artifacts;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DeploymentProfile getProfile() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__PROFILE);
    return _basicGetProfile();
  }
  
  private final DeploymentProfile _basicGetProfile() {
    if (profile != null && profile.eIsProxy())
    {
      InternalEObject oldProfile = (InternalEObject)profile;
      profile = (DeploymentProfile)eResolveProxy(oldProfile);
      if (profile != oldProfile)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.CONTAINER__PROFILE, oldProfile, profile));
      }
    }
    return profile;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DeploymentProfile basicGetProfile()
  {
    return profile;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setProfile(DeploymentProfile newProfile)
  {
    
    DeploymentProfile oldProfile = profile;
    profile = newProfile;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONTAINER__PROFILE, oldProfile, profile));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getType() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__TYPE);
    return _basicGetType();
  }
  
  private final String _basicGetType() {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(String newType)
  {
    
    String oldType = type;
    type = newType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.CONTAINER__TYPE, oldType, type));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONTAINER__CATEGORIES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetCategories()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.CONTAINER__ATTRIBUTES:
        return ((InternalEList<?>)_basicGetAttributes()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.CONTAINER__CATEGORIES:
        return ((InternalEList<?>)_basicGetCategories()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.CONTAINER__PROPERTIES:
        return ((InternalEList<?>)_basicGetProperties()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.CONTAINER__STATUS:
        return ((InternalEList<?>)_basicGetStatus()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.CONTAINER__APPLICATIONS:
        return ((InternalEList<?>)_basicGetApplications()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.CONTAINER__ARTIFACTS:
        return ((InternalEList<?>)_basicGetArtifacts()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONTAINER__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.CONTAINER__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.CONTAINER__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.CONTAINER__TAGS:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS); }
        return _basicGetTags();
      case SOA_NetworkPackage.CONTAINER__ATTRIBUTES:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES); }
        return _basicGetAttributes();
      case SOA_NetworkPackage.CONTAINER__CATEGORIES:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES); }
        return _basicGetCategories();
      case SOA_NetworkPackage.CONTAINER__PROPERTIES:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES); }
        return _basicGetProperties();
      case SOA_NetworkPackage.CONTAINER__SUPPORTED_PACKAGE_TYPES:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__SUPPORTED_PACKAGE_TYPES); }
        return _basicGetSupportedPackageTypes();
      case SOA_NetworkPackage.CONTAINER__STATUS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__STATUS); }
        return _basicGetStatus();
      case SOA_NetworkPackage.CONTAINER__APPLICATIONS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__APPLICATIONS); }
        return _basicGetApplications();
      case SOA_NetworkPackage.CONTAINER__ARTIFACTS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__ARTIFACTS); }
        return _basicGetArtifacts();
      case SOA_NetworkPackage.CONTAINER__PROFILE:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__PROFILE); }
        if (resolve) return getProfile();
        return _basicGetProfile();
      case SOA_NetworkPackage.CONTAINER__TYPE:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.CONTAINER__TYPE); }
        return _basicGetType();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONTAINER__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__TAGS:
        _basicGetTags().clear();
        _basicGetTags().addAll((Collection<? extends UserAttributeDefinition>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__ATTRIBUTES:
        _basicGetAttributes().clear();
        _basicGetAttributes().addAll((Collection<? extends UserAttributeValue>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__CATEGORIES:
        _basicGetCategories().clear();
        _basicGetCategories().addAll((Collection<? extends ICategory>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__PROPERTIES:
        _basicGetProperties().clear();
        _basicGetProperties().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__SUPPORTED_PACKAGE_TYPES:
        _basicGetSupportedPackageTypes().clear();
        _basicGetSupportedPackageTypes().addAll((Collection<? extends String>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__STATUS:
        _basicGetStatus().clear();
        _basicGetStatus().addAll((Collection<? extends Property>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__APPLICATIONS:
        _basicGetApplications().clear();
        _basicGetApplications().addAll((Collection<? extends InstalledApplication>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__ARTIFACTS:
        _basicGetArtifacts().clear();
        _basicGetArtifacts().addAll((Collection<? extends InstalledArtifact>)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__PROFILE:
        setProfile((DeploymentProfile)newValue);
        return;
      case SOA_NetworkPackage.CONTAINER__TYPE:
        setType((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.CONTAINER__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.CONTAINER__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.CONTAINER__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.CONTAINER__TAGS:
      _basicGetTags().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__ATTRIBUTES:
      _basicGetAttributes().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__CATEGORIES:
      _basicGetCategories().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__PROPERTIES:
      _basicGetProperties().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__SUPPORTED_PACKAGE_TYPES:
      _basicGetSupportedPackageTypes().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__STATUS:
      _basicGetStatus().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__APPLICATIONS:
      _basicGetApplications().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__ARTIFACTS:
      _basicGetArtifacts().clear();
      return;
    case SOA_NetworkPackage.CONTAINER__PROFILE:
      setProfile((DeploymentProfile)null);
      return;
    case SOA_NetworkPackage.CONTAINER__TYPE:
      setType(TYPE_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.CONTAINER__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.CONTAINER__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.CONTAINER__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.CONTAINER__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.CONTAINER__TAGS:
        return tags != null && !tags.isEmpty();
      case SOA_NetworkPackage.CONTAINER__ATTRIBUTES:
        return attributes != null && !attributes.isEmpty();
      case SOA_NetworkPackage.CONTAINER__CATEGORIES:
        return categories != null && !categories.isEmpty();
      case SOA_NetworkPackage.CONTAINER__PROPERTIES:
        return properties != null && !properties.isEmpty();
      case SOA_NetworkPackage.CONTAINER__SUPPORTED_PACKAGE_TYPES:
        return supportedPackageTypes != null && !supportedPackageTypes.isEmpty();
      case SOA_NetworkPackage.CONTAINER__STATUS:
        return status != null && !status.isEmpty();
      case SOA_NetworkPackage.CONTAINER__APPLICATIONS:
        return applications != null && !applications.isEmpty();
      case SOA_NetworkPackage.CONTAINER__ARTIFACTS:
        return artifacts != null && !artifacts.isEmpty();
      case SOA_NetworkPackage.CONTAINER__PROFILE:
        return profile != null;
      case SOA_NetworkPackage.CONTAINER__TYPE:
        return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == ITagged.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CONTAINER__TAGS: return UserAttributesPackage.ITAGGED__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CONTAINER__ATTRIBUTES: return UserAttributesPackage.IATTRIBUTES__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ICategorizable.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CONTAINER__CATEGORIES: return FolderPackage.ICATEGORIZABLE__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.CONTAINER__PROPERTIES: return RepositoryPackage.IPROPERTIES__PROPERTIES;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == ITagged.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.ITAGGED__TAGS: return SOA_NetworkPackage.CONTAINER__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.IATTRIBUTES__ATTRIBUTES: return SOA_NetworkPackage.CONTAINER__ATTRIBUTES;
        default: return -1;
      }
    }
    if (baseClass == ICategorizable.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.ICATEGORIZABLE__CATEGORIES: return SOA_NetworkPackage.CONTAINER__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IProperties.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IPROPERTIES__PROPERTIES: return SOA_NetworkPackage.CONTAINER__PROPERTIES;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(", supportedPackageTypes: ");
    result.append(supportedPackageTypes);
    result.append(", type: ");
    result.append(type);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //ContainerImpl


