/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.DeploymentProfile;
import com.iona.soa.model.SOA_NetworkPackage;
import com.iona.soa.model.VersionedProfile;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;

import com.iona.soa.model.repository.IRepositoryObject;
import com.iona.soa.model.repository.RepositoryPackage;
import com.iona.soa.model.repository.VersionTracker;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.IProtectedRepositoryObject;
import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.userattributes.ITagged;
import com.iona.soa.model.userattributes.UserAttributeDefinition;
import com.iona.soa.model.userattributes.UserAttributeValue;
import com.iona.soa.model.userattributes.UserAttributesPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Deployment Profile</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getCategories <em>Categories</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getTags <em>Tags</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getActive <em>Active</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getVersionTracker <em>Version Tracker</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getVersions <em>Versions</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.DeploymentProfileImpl#getCurrent <em>Current</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DeploymentProfileImpl extends IPersistableObjectImpl implements DeploymentProfile
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached value of the '{@link #getAttributes() <em>Attributes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttributes()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeValue> attributes;

  /**
   * The cached value of the '{@link #getCategories() <em>Categories</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategories()
   * @generated
   * @ordered
   */
  protected EList<ICategory> categories;

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getTags() <em>Tags</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTags()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeDefinition> tags;

  /**
   * The cached value of the '{@link #getActive() <em>Active</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getActive()
   * @generated
   * @ordered
   */
  protected VersionedProfile active;

  /**
   * The cached value of the '{@link #getVersionTracker() <em>Version Tracker</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVersionTracker()
   * @generated
   * @ordered
   */
  protected VersionTracker versionTracker;

  /**
   * The cached value of the '{@link #getVersions() <em>Versions</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVersions()
   * @generated
   * @ordered
   */
  protected EList<VersionedProfile> versions;

  /**
   * The cached value of the '{@link #getCurrent() <em>Current</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCurrent()
   * @generated
   * @ordered
   */
  protected VersionedProfile current;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DeploymentProfileImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeValue> getAttributes() {
    autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES);
    return _basicGetAttributes();
  }
  
  private final EList<UserAttributeValue> _basicGetAttributes() {
    if (attributes == null)
    {
      attributes = new EObjectContainmentEList<UserAttributeValue>(UserAttributeValue.class, this, SOA_NetworkPackage.DEPLOYMENT_PROFILE__ATTRIBUTES);
    }
    return attributes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ICategory> getCategories() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES);
    return _basicGetCategories();
  }
  
  private final EList<ICategory> _basicGetCategories() {
    if (categories == null)
    {
      categories = new EObjectWithInverseResolvingEList.ManyInverse<ICategory>(ICategory.class, this, SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES, FolderPackage.ICATEGORY__CONTENT);
    }
    return categories;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeDefinition> getTags() {
    autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS);
    return _basicGetTags();
  }
  
  private final EList<UserAttributeDefinition> _basicGetTags() {
    if (tags == null)
    {
      tags = new EObjectResolvingEList<UserAttributeDefinition>(UserAttributeDefinition.class, this, SOA_NetworkPackage.DEPLOYMENT_PROFILE__TAGS);
    }
    return tags;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionedProfile getActive() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__ACTIVE);
    return _basicGetActive();
  }
  
  private final VersionedProfile _basicGetActive() {
    if (active != null && active.eIsProxy())
    {
      InternalEObject oldActive = (InternalEObject)active;
      active = (VersionedProfile)eResolveProxy(oldActive);
      if (active != oldActive)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.DEPLOYMENT_PROFILE__ACTIVE, oldActive, active));
      }
    }
    return active;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionedProfile basicGetActive()
  {
    return active;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setActive(VersionedProfile newActive)
  {
    
    VersionedProfile oldActive = active;
    active = newActive;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__ACTIVE, oldActive, active));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionTracker getVersionTracker() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__VERSION_TRACKER);
    return _basicGetVersionTracker();
  }
  
  private final VersionTracker _basicGetVersionTracker() {
    return versionTracker;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetVersionTracker(VersionTracker newVersionTracker, NotificationChain msgs)
  {
    VersionTracker oldVersionTracker = versionTracker;
    versionTracker = newVersionTracker;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER, oldVersionTracker, newVersionTracker);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVersionTracker(VersionTracker newVersionTracker)
  {
    
    if (newVersionTracker != versionTracker)
    {
      NotificationChain msgs = null;
      if (versionTracker != null)
        msgs = ((InternalEObject)versionTracker).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER, null, msgs);
      if (newVersionTracker != null)
        msgs = ((InternalEObject)newVersionTracker).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER, null, msgs);
      msgs = basicSetVersionTracker(newVersionTracker, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER, newVersionTracker, newVersionTracker));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<VersionedProfile> getVersions() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__VERSIONS);
    return _basicGetVersions();
  }
  
  private final EList<VersionedProfile> _basicGetVersions() {
    if (versions == null)
    {
      versions = new EObjectContainmentEList<VersionedProfile>(VersionedProfile.class, this, SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSIONS);
    }
    return versions;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionedProfile getCurrent() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__CURRENT);
    return _basicGetCurrent();
  }
  
  private final VersionedProfile _basicGetCurrent() {
    if (current != null && current.eIsProxy())
    {
      InternalEObject oldCurrent = (InternalEObject)current;
      current = (VersionedProfile)eResolveProxy(oldCurrent);
      if (current != oldCurrent)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.DEPLOYMENT_PROFILE__CURRENT, oldCurrent, current));
      }
    }
    return current;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionedProfile basicGetCurrent()
  {
    return current;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCurrent(VersionedProfile newCurrent)
  {
    
    VersionedProfile oldCurrent = current;
    current = newCurrent;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.DEPLOYMENT_PROFILE__CURRENT, oldCurrent, current));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetCategories()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ATTRIBUTES:
        return ((InternalEList<?>)_basicGetAttributes()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES:
        return ((InternalEList<?>)_basicGetCategories()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER:
        return basicSetVersionTracker(null, msgs);
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSIONS:
        return ((InternalEList<?>)_basicGetVersions()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ATTRIBUTES:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES); }
        return _basicGetAttributes();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES); }
        return _basicGetCategories();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__TAGS:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS); }
        return _basicGetTags();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ACTIVE:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__ACTIVE); }
        if (resolve) return getActive();
        return _basicGetActive();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__VERSION_TRACKER); }
        return _basicGetVersionTracker();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSIONS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__VERSIONS); }
        return _basicGetVersions();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CURRENT:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.DEPLOYMENT_PROFILE__CURRENT); }
        if (resolve) return getCurrent();
        return _basicGetCurrent();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ATTRIBUTES:
        _basicGetAttributes().clear();
        _basicGetAttributes().addAll((Collection<? extends UserAttributeValue>)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES:
        _basicGetCategories().clear();
        _basicGetCategories().addAll((Collection<? extends ICategory>)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__TAGS:
        _basicGetTags().clear();
        _basicGetTags().addAll((Collection<? extends UserAttributeDefinition>)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ACTIVE:
        setActive((VersionedProfile)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER:
        setVersionTracker((VersionTracker)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSIONS:
        _basicGetVersions().clear();
        _basicGetVersions().addAll((Collection<? extends VersionedProfile>)newValue);
        return;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CURRENT:
        setCurrent((VersionedProfile)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ATTRIBUTES:
      _basicGetAttributes().clear();
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES:
      _basicGetCategories().clear();
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__TAGS:
      _basicGetTags().clear();
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ACTIVE:
      setActive((VersionedProfile)null);
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER:
      setVersionTracker((VersionTracker)null);
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSIONS:
      _basicGetVersions().clear();
      return;
    case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CURRENT:
      setCurrent((VersionedProfile)null);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ATTRIBUTES:
        return attributes != null && !attributes.isEmpty();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES:
        return categories != null && !categories.isEmpty();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__TAGS:
        return tags != null && !tags.isEmpty();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__ACTIVE:
        return active != null;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSION_TRACKER:
        return versionTracker != null;
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__VERSIONS:
        return versions != null && !versions.isEmpty();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CURRENT:
        return current != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES: return FolderPackage.ICATEGORIZABLE__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IRepositoryObject.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAME: return RepositoryPackage.IREPOSITORY_OBJECT__NAME;
        case SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAMESPACE: return RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;
        case SOA_NetworkPackage.DEPLOYMENT_PROFILE__DESCRIPTION: return RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;
        default: return -1;
      }
    }
    if (baseClass == IProtectedRepositoryObject.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL: return SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.DEPLOYMENT_PROFILE__TAGS: return UserAttributesPackage.ITAGGED__TAGS;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.ICATEGORIZABLE__CATEGORIES: return SOA_NetworkPackage.DEPLOYMENT_PROFILE__CATEGORIES;
        default: return -1;
      }
    }
    if (baseClass == IRepositoryObject.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IREPOSITORY_OBJECT__NAME: return SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAME;
        case RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE: return SOA_NetworkPackage.DEPLOYMENT_PROFILE__NAMESPACE;
        case RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION: return SOA_NetworkPackage.DEPLOYMENT_PROFILE__DESCRIPTION;
        default: return -1;
      }
    }
    if (baseClass == IProtectedRepositoryObject.class)
    {
      switch (baseFeatureID)
      {
        case SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL: return SOA_NetworkPackage.DEPLOYMENT_PROFILE__OBJECT_CONTROL;
        default: return -1;
      }
    }
    if (baseClass == ITagged.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.ITAGGED__TAGS: return SOA_NetworkPackage.DEPLOYMENT_PROFILE__TAGS;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //DeploymentProfileImpl


