/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.Folder;
import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.collaboration.CollaborationPackage;
import com.iona.soa.model.collaboration.Comment;
import com.iona.soa.model.collaboration.ICollaboration;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.IFolder;
import com.iona.soa.model.folder.IFolderContent;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;
import com.iona.soa.model.security.User;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Folder</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getChildren <em>Children</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getParent <em>Parent</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getContent <em>Content</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getOwner <em>Owner</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getSubscribers <em>Subscribers</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.FolderImpl#getComments <em>Comments</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FolderImpl extends IPersistableObjectImpl implements Folder
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getChildren() <em>Children</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getChildren()
   * @generated
   * @ordered
   */
  protected EList<IFolder> children;

  /**
   * The cached value of the '{@link #getContent() <em>Content</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContent()
   * @generated
   * @ordered
   */
  protected EList<IFolderContent> content;

  /**
   * The cached value of the '{@link #getOwner() <em>Owner</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOwner()
   * @generated
   * @ordered
   */
  protected User owner;

  /**
   * The cached value of the '{@link #getSubscribers() <em>Subscribers</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSubscribers()
   * @generated
   * @ordered
   */
  protected EList<User> subscribers;

  /**
   * The cached value of the '{@link #getComments() <em>Comments</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComments()
   * @generated
   * @ordered
   */
  protected EList<Comment> comments;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FolderImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.FOLDER;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.FOLDER__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.FOLDER__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.FOLDER__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.FOLDER__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.FOLDER__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.FOLDER__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.FOLDER__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<IFolder> getChildren() {
    autoResolveEProxy(FolderPackage.Literals.IFOLDER__CHILDREN);
    return _basicGetChildren();
  }
  
  private final EList<IFolder> _basicGetChildren() {
    if (children == null)
    {
      children = new EObjectContainmentWithInverseEList<IFolder>(IFolder.class, this, SOA_NetworkPackage.FOLDER__CHILDREN, FolderPackage.IFOLDER__PARENT);
    }
    return children;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IFolder getParent() {
    autoResolveEProxy(FolderPackage.Literals.IFOLDER__PARENT);
    return _basicGetParent();
  }
  
  private final IFolder _basicGetParent() {
    if (eContainerFeatureID != SOA_NetworkPackage.FOLDER__PARENT) return null;
    return (IFolder)eContainer();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetParent(IFolder newParent, NotificationChain msgs)
  {
    msgs = eBasicSetContainer((InternalEObject)newParent, SOA_NetworkPackage.FOLDER__PARENT, msgs);
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParent(IFolder newParent)
  {
    
    if (newParent != eInternalContainer() || (eContainerFeatureID != SOA_NetworkPackage.FOLDER__PARENT && newParent != null))
    {
      if (EcoreUtil.isAncestor(this, newParent))
        throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
      NotificationChain msgs = null;
      if (eInternalContainer() != null)
        msgs = eBasicRemoveFromContainer(msgs);
      if (newParent != null)
        msgs = ((InternalEObject)newParent).eInverseAdd(this, FolderPackage.IFOLDER__CHILDREN, IFolder.class, msgs);
      msgs = basicSetParent(newParent, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.FOLDER__PARENT, newParent, newParent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<IFolderContent> getContent() {
    autoResolveEProxy(FolderPackage.Literals.IFOLDER__CONTENT);
    return _basicGetContent();
  }
  
  private final EList<IFolderContent> _basicGetContent() {
    if (content == null)
    {
      content = new EObjectWithInverseResolvingEList<IFolderContent>(IFolderContent.class, this, SOA_NetworkPackage.FOLDER__CONTENT, FolderPackage.IFOLDER_CONTENT__BELONGS_TO);
    }
    return content;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public User getOwner() {
    autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__OWNER);
    return _basicGetOwner();
  }
  
  private final User _basicGetOwner() {
    if (owner != null && owner.eIsProxy())
    {
      InternalEObject oldOwner = (InternalEObject)owner;
      owner = (User)eResolveProxy(oldOwner);
      if (owner != oldOwner)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SOA_NetworkPackage.FOLDER__OWNER, oldOwner, owner));
      }
    }
    return owner;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public User basicGetOwner()
  {
    return owner;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOwner(User newOwner)
  {
    
    User oldOwner = owner;
    owner = newOwner;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.FOLDER__OWNER, oldOwner, owner));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<User> getSubscribers() {
    autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__SUBSCRIBERS);
    return _basicGetSubscribers();
  }
  
  private final EList<User> _basicGetSubscribers() {
    if (subscribers == null)
    {
      subscribers = new EObjectResolvingEList<User>(User.class, this, SOA_NetworkPackage.FOLDER__SUBSCRIBERS);
    }
    return subscribers;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Comment> getComments() {
    autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__COMMENTS);
    return _basicGetComments();
  }
  
  private final EList<Comment> _basicGetComments() {
    if (comments == null)
    {
      comments = new EObjectContainmentEList<Comment>(Comment.class, this, SOA_NetworkPackage.FOLDER__COMMENTS);
    }
    return comments;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.FOLDER__CHILDREN:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetChildren()).basicAdd(otherEnd, msgs);
      case SOA_NetworkPackage.FOLDER__PARENT:
        if (eInternalContainer() != null)
          msgs = eBasicRemoveFromContainer(msgs);
        return basicSetParent((IFolder)otherEnd, msgs);
      case SOA_NetworkPackage.FOLDER__CONTENT:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetContent()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.FOLDER__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.FOLDER__CHILDREN:
        return ((InternalEList<?>)_basicGetChildren()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.FOLDER__PARENT:
        return basicSetParent(null, msgs);
      case SOA_NetworkPackage.FOLDER__CONTENT:
        return ((InternalEList<?>)_basicGetContent()).basicRemove(otherEnd, msgs);
      case SOA_NetworkPackage.FOLDER__COMMENTS:
        return ((InternalEList<?>)_basicGetComments()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
  {
    switch (eContainerFeatureID)
    {
      case SOA_NetworkPackage.FOLDER__PARENT:
        return eInternalContainer().eInverseRemove(this, FolderPackage.IFOLDER__CHILDREN, IFolder.class, msgs);
    }
    return super.eBasicRemoveFromContainerFeature(msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.FOLDER__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.FOLDER__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.FOLDER__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.FOLDER__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.FOLDER__CHILDREN:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.IFOLDER__CHILDREN); }
        return _basicGetChildren();
      case SOA_NetworkPackage.FOLDER__PARENT:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.IFOLDER__PARENT); }
        return _basicGetParent();
      case SOA_NetworkPackage.FOLDER__CONTENT:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.IFOLDER__CONTENT); }
        return _basicGetContent();
      case SOA_NetworkPackage.FOLDER__OWNER:
      if (resolve) { autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__OWNER); }
        if (resolve) return getOwner();
        return _basicGetOwner();
      case SOA_NetworkPackage.FOLDER__SUBSCRIBERS:
      if (resolve) { autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__SUBSCRIBERS); }
        return _basicGetSubscribers();
      case SOA_NetworkPackage.FOLDER__COMMENTS:
      if (resolve) { autoResolveEProxy(CollaborationPackage.Literals.ICOLLABORATION__COMMENTS); }
        return _basicGetComments();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.FOLDER__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__CHILDREN:
        _basicGetChildren().clear();
        _basicGetChildren().addAll((Collection<? extends IFolder>)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__PARENT:
        setParent((IFolder)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__CONTENT:
        _basicGetContent().clear();
        _basicGetContent().addAll((Collection<? extends IFolderContent>)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__OWNER:
        setOwner((User)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__SUBSCRIBERS:
        _basicGetSubscribers().clear();
        _basicGetSubscribers().addAll((Collection<? extends User>)newValue);
        return;
      case SOA_NetworkPackage.FOLDER__COMMENTS:
        _basicGetComments().clear();
        _basicGetComments().addAll((Collection<? extends Comment>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.FOLDER__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.FOLDER__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.FOLDER__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.FOLDER__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.FOLDER__CHILDREN:
      _basicGetChildren().clear();
      return;
    case SOA_NetworkPackage.FOLDER__PARENT:
      setParent((IFolder)null);
      return;
    case SOA_NetworkPackage.FOLDER__CONTENT:
      _basicGetContent().clear();
      return;
    case SOA_NetworkPackage.FOLDER__OWNER:
      setOwner((User)null);
      return;
    case SOA_NetworkPackage.FOLDER__SUBSCRIBERS:
      _basicGetSubscribers().clear();
      return;
    case SOA_NetworkPackage.FOLDER__COMMENTS:
      _basicGetComments().clear();
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.FOLDER__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.FOLDER__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.FOLDER__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.FOLDER__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.FOLDER__CHILDREN:
        return children != null && !children.isEmpty();
      case SOA_NetworkPackage.FOLDER__PARENT:
        return getParent() != null;
      case SOA_NetworkPackage.FOLDER__CONTENT:
        return content != null && !content.isEmpty();
      case SOA_NetworkPackage.FOLDER__OWNER:
        return owner != null;
      case SOA_NetworkPackage.FOLDER__SUBSCRIBERS:
        return subscribers != null && !subscribers.isEmpty();
      case SOA_NetworkPackage.FOLDER__COMMENTS:
        return comments != null && !comments.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == IFolder.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.FOLDER__CHILDREN: return FolderPackage.IFOLDER__CHILDREN;
        case SOA_NetworkPackage.FOLDER__PARENT: return FolderPackage.IFOLDER__PARENT;
        case SOA_NetworkPackage.FOLDER__CONTENT: return FolderPackage.IFOLDER__CONTENT;
        default: return -1;
      }
    }
    if (baseClass == ICollaboration.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.FOLDER__OWNER: return CollaborationPackage.ICOLLABORATION__OWNER;
        case SOA_NetworkPackage.FOLDER__SUBSCRIBERS: return CollaborationPackage.ICOLLABORATION__SUBSCRIBERS;
        case SOA_NetworkPackage.FOLDER__COMMENTS: return CollaborationPackage.ICOLLABORATION__COMMENTS;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == IFolder.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.IFOLDER__CHILDREN: return SOA_NetworkPackage.FOLDER__CHILDREN;
        case FolderPackage.IFOLDER__PARENT: return SOA_NetworkPackage.FOLDER__PARENT;
        case FolderPackage.IFOLDER__CONTENT: return SOA_NetworkPackage.FOLDER__CONTENT;
        default: return -1;
      }
    }
    if (baseClass == ICollaboration.class)
    {
      switch (baseFeatureID)
      {
        case CollaborationPackage.ICOLLABORATION__OWNER: return SOA_NetworkPackage.FOLDER__OWNER;
        case CollaborationPackage.ICOLLABORATION__SUBSCRIBERS: return SOA_NetworkPackage.FOLDER__SUBSCRIBERS;
        case CollaborationPackage.ICOLLABORATION__COMMENTS: return SOA_NetworkPackage.FOLDER__COMMENTS;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //FolderImpl


