/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.InstalledApplication;
import com.iona.soa.model.InstalledArtifact;
import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Installed Application</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.InstalledApplicationImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.InstalledApplicationImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.InstalledApplicationImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.InstalledApplicationImpl#getArtifacts <em>Artifacts</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InstalledApplicationImpl extends IPersistableObjectImpl implements InstalledApplication
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getArtifacts() <em>Artifacts</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getArtifacts()
   * @generated
   * @ordered
   */
  protected EList<InstalledArtifact> artifacts;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InstalledApplicationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.INSTALLED_APPLICATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.INSTALLED_APPLICATION__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.INSTALLED_APPLICATION__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.INSTALLED_APPLICATION__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<InstalledArtifact> getArtifacts() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.INSTALLED_APPLICATION__ARTIFACTS);
    return _basicGetArtifacts();
  }
  
  private final EList<InstalledArtifact> _basicGetArtifacts() {
    if (artifacts == null)
    {
      artifacts = new EObjectResolvingEList<InstalledArtifact>(InstalledArtifact.class, this, SOA_NetworkPackage.INSTALLED_APPLICATION__ARTIFACTS);
    }
    return artifacts;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.INSTALLED_APPLICATION__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.INSTALLED_APPLICATION__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.INSTALLED_APPLICATION__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.INSTALLED_APPLICATION__ARTIFACTS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.INSTALLED_APPLICATION__ARTIFACTS); }
        return _basicGetArtifacts();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.INSTALLED_APPLICATION__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.INSTALLED_APPLICATION__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.INSTALLED_APPLICATION__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.INSTALLED_APPLICATION__ARTIFACTS:
        _basicGetArtifacts().clear();
        _basicGetArtifacts().addAll((Collection<? extends InstalledArtifact>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.INSTALLED_APPLICATION__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.INSTALLED_APPLICATION__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.INSTALLED_APPLICATION__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.INSTALLED_APPLICATION__ARTIFACTS:
      _basicGetArtifacts().clear();
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.INSTALLED_APPLICATION__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.INSTALLED_APPLICATION__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.INSTALLED_APPLICATION__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.INSTALLED_APPLICATION__ARTIFACTS:
        return artifacts != null && !artifacts.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //InstalledApplicationImpl


