/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.IndexStates;
import com.iona.soa.model.MavenRepository;
import com.iona.soa.model.SOA_NetworkPackage;

import java.sql.Timestamp;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Maven Repository</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.MavenRepositoryImpl#isSnapshots <em>Snapshots</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.MavenRepositoryImpl#getLastIndexed <em>Last Indexed</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.MavenRepositoryImpl#getNextIndex <em>Next Index</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.MavenRepositoryImpl#isIndexed <em>Indexed</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.MavenRepositoryImpl#getId <em>Id</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.MavenRepositoryImpl#getIndexState <em>Index State</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MavenRepositoryImpl extends ArtifactRepositoryImpl implements MavenRepository
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #isSnapshots() <em>Snapshots</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSnapshots()
   * @generated
   * @ordered
   */
  protected static final boolean SNAPSHOTS_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isSnapshots() <em>Snapshots</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSnapshots()
   * @generated
   * @ordered
   */
  protected boolean snapshots = SNAPSHOTS_EDEFAULT;

  /**
   * The default value of the '{@link #getLastIndexed() <em>Last Indexed</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLastIndexed()
   * @generated
   * @ordered
   */
  protected static final Timestamp LAST_INDEXED_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getLastIndexed() <em>Last Indexed</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLastIndexed()
   * @generated
   * @ordered
   */
  protected Timestamp lastIndexed = LAST_INDEXED_EDEFAULT;

  /**
   * The default value of the '{@link #getNextIndex() <em>Next Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNextIndex()
   * @generated
   * @ordered
   */
  protected static final Timestamp NEXT_INDEX_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNextIndex() <em>Next Index</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNextIndex()
   * @generated
   * @ordered
   */
  protected Timestamp nextIndex = NEXT_INDEX_EDEFAULT;

  /**
   * The default value of the '{@link #isIndexed() <em>Indexed</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isIndexed()
   * @generated
   * @ordered
   */
  protected static final boolean INDEXED_EDEFAULT = true;

  /**
   * The cached value of the '{@link #isIndexed() <em>Indexed</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isIndexed()
   * @generated
   * @ordered
   */
  protected boolean indexed = INDEXED_EDEFAULT;

  /**
   * The default value of the '{@link #getId() <em>Id</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getId()
   * @generated
   * @ordered
   */
  protected static final String ID_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getId()
   * @generated
   * @ordered
   */
  protected String id = ID_EDEFAULT;

  /**
   * The default value of the '{@link #getIndexState() <em>Index State</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIndexState()
   * @generated
   * @ordered
   */
  protected static final IndexStates INDEX_STATE_EDEFAULT = IndexStates.UNINDEXED;

  /**
   * The cached value of the '{@link #getIndexState() <em>Index State</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIndexState()
   * @generated
   * @ordered
   */
  protected IndexStates indexState = INDEX_STATE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MavenRepositoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.MAVEN_REPOSITORY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSnapshots() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__SNAPSHOTS);
    return _basicGetSnapshots();
  }
  
  private final boolean _basicGetSnapshots() {
    return snapshots;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSnapshots(boolean newSnapshots)
  {
    
    boolean oldSnapshots = snapshots;
    snapshots = newSnapshots;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.MAVEN_REPOSITORY__SNAPSHOTS, oldSnapshots, snapshots));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp getLastIndexed() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__LAST_INDEXED);
    return _basicGetLastIndexed();
  }
  
  private final Timestamp _basicGetLastIndexed() {
    return lastIndexed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLastIndexed(Timestamp newLastIndexed)
  {
    
    Timestamp oldLastIndexed = lastIndexed;
    lastIndexed = newLastIndexed;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.MAVEN_REPOSITORY__LAST_INDEXED, oldLastIndexed, lastIndexed));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp getNextIndex() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__NEXT_INDEX);
    return _basicGetNextIndex();
  }
  
  private final Timestamp _basicGetNextIndex() {
    return nextIndex;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNextIndex(Timestamp newNextIndex)
  {
    
    Timestamp oldNextIndex = nextIndex;
    nextIndex = newNextIndex;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.MAVEN_REPOSITORY__NEXT_INDEX, oldNextIndex, nextIndex));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isIndexed() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__INDEXED);
    return _basicGetIndexed();
  }
  
  private final boolean _basicGetIndexed() {
    return indexed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIndexed(boolean newIndexed)
  {
    
    boolean oldIndexed = indexed;
    indexed = newIndexed;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.MAVEN_REPOSITORY__INDEXED, oldIndexed, indexed));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getId() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__ID);
    return _basicGetId();
  }
  
  private final String _basicGetId() {
    return id;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setId(String newId)
  {
    
    String oldId = id;
    id = newId;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.MAVEN_REPOSITORY__ID, oldId, id));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IndexStates getIndexState() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__INDEX_STATE);
    return _basicGetIndexState();
  }
  
  private final IndexStates _basicGetIndexState() {
    return indexState;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIndexState(IndexStates newIndexState)
  {
    
    IndexStates oldIndexState = indexState;
    indexState = newIndexState == null ? INDEX_STATE_EDEFAULT : newIndexState;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.MAVEN_REPOSITORY__INDEX_STATE, oldIndexState, indexState));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.MAVEN_REPOSITORY__SNAPSHOTS:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__SNAPSHOTS); }
        return _basicGetSnapshots() ? Boolean.TRUE : Boolean.FALSE;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__LAST_INDEXED:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__LAST_INDEXED); }
        return _basicGetLastIndexed();
      case SOA_NetworkPackage.MAVEN_REPOSITORY__NEXT_INDEX:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__NEXT_INDEX); }
        return _basicGetNextIndex();
      case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEXED:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__INDEXED); }
        return _basicGetIndexed() ? Boolean.TRUE : Boolean.FALSE;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__ID:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__ID); }
        return _basicGetId();
      case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEX_STATE:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.MAVEN_REPOSITORY__INDEX_STATE); }
        return _basicGetIndexState();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.MAVEN_REPOSITORY__SNAPSHOTS:
        setSnapshots(((Boolean)newValue).booleanValue());
        return;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__LAST_INDEXED:
        setLastIndexed((Timestamp)newValue);
        return;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__NEXT_INDEX:
        setNextIndex((Timestamp)newValue);
        return;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEXED:
        setIndexed(((Boolean)newValue).booleanValue());
        return;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__ID:
        setId((String)newValue);
        return;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEX_STATE:
        setIndexState((IndexStates)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.MAVEN_REPOSITORY__SNAPSHOTS:
      setSnapshots(SNAPSHOTS_EDEFAULT);
      return;
    case SOA_NetworkPackage.MAVEN_REPOSITORY__LAST_INDEXED:
      setLastIndexed(LAST_INDEXED_EDEFAULT);
      return;
    case SOA_NetworkPackage.MAVEN_REPOSITORY__NEXT_INDEX:
      setNextIndex(NEXT_INDEX_EDEFAULT);
      return;
    case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEXED:
      setIndexed(INDEXED_EDEFAULT);
      return;
    case SOA_NetworkPackage.MAVEN_REPOSITORY__ID:
      setId(ID_EDEFAULT);
      return;
    case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEX_STATE:
      setIndexState(INDEX_STATE_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.MAVEN_REPOSITORY__SNAPSHOTS:
        return snapshots != SNAPSHOTS_EDEFAULT;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__LAST_INDEXED:
        return LAST_INDEXED_EDEFAULT == null ? lastIndexed != null : !LAST_INDEXED_EDEFAULT.equals(lastIndexed);
      case SOA_NetworkPackage.MAVEN_REPOSITORY__NEXT_INDEX:
        return NEXT_INDEX_EDEFAULT == null ? nextIndex != null : !NEXT_INDEX_EDEFAULT.equals(nextIndex);
      case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEXED:
        return indexed != INDEXED_EDEFAULT;
      case SOA_NetworkPackage.MAVEN_REPOSITORY__ID:
        return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
      case SOA_NetworkPackage.MAVEN_REPOSITORY__INDEX_STATE:
        return indexState != INDEX_STATE_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (snapshots: ");
    result.append(snapshots);
    result.append(", lastIndexed: ");
    result.append(lastIndexed);
    result.append(", nextIndex: ");
    result.append(nextIndex);
    result.append(", indexed: ");
    result.append(indexed);
    result.append(", id: ");
    result.append(id);
    result.append(", indexState: ");
    result.append(indexState);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //MavenRepositoryImpl


