/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.*;

import java.lang.reflect.Method;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SOA_NetworkFactoryImpl extends EFactoryImpl implements SOA_NetworkFactory
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

/* begin IONA modification */
  private String defaultNamespace = "http://www.example.org/";

  public final void setDefaultNamespace(String namespace) {
    this.defaultNamespace = namespace;
  }

/* end IONA modification */
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static SOA_NetworkFactory init()
  {
    try
    {
      SOA_NetworkFactory theSOA_NetworkFactory = (SOA_NetworkFactory)EPackage.Registry.INSTANCE.getEFactory("http://com.iona.soa.model"); 
      if (theSOA_NetworkFactory != null)
      {
        return theSOA_NetworkFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new SOA_NetworkFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SOA_NetworkFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case SOA_NetworkPackage.APPLICATION: return createApplication();
      case SOA_NetworkPackage.ARTIFACT: return createArtifact();
      case SOA_NetworkPackage.STORED_QUERY: return createStoredQuery();
      case SOA_NetworkPackage.CONTAINER: return createContainer();
      case SOA_NetworkPackage.VERSIONED_PROFILE: return createVersionedProfile();
      case SOA_NetworkPackage.FOLDER: return createFolder();
      case SOA_NetworkPackage.MAVEN_REPOSITORY: return createMavenRepository();
      case SOA_NetworkPackage.INSTALLED_APPLICATION: return createInstalledApplication();
      case SOA_NetworkPackage.INSTALLED_ARTIFACT: return createInstalledArtifact();
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE: return createDeploymentProfile();
      case SOA_NetworkPackage.ARTIFACT_TYPE: return createArtifactType();
      case SOA_NetworkPackage.APPLICATION_TYPE: return createApplicationType();
      case SOA_NetworkPackage.CATEGORY: return createCategory();
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE: return createConfigurationOverride();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case SOA_NetworkPackage.INDEX_STATES:
        return createIndexStatesFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case SOA_NetworkPackage.INDEX_STATES:
        return convertIndexStatesToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Application createApplication()
  {
       	/* begin IONA modification */
    	//ApplicationImpl application = new ApplicationImpl();
    	Application application = new ApplicationImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = application.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(application, new Object[] {"Application-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = application.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(application, new Object[] {"Application"});
            Method factoryFlagSetter = application.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(application, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = application.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(application, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = application.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(application, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return application;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Artifact createArtifact()
  {
       	/* begin IONA modification */
    	//ArtifactImpl artifact = new ArtifactImpl();
    	Artifact artifact = new ArtifactImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = artifact.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(artifact, new Object[] {"Artifact-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = artifact.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(artifact, new Object[] {"Artifact"});
            Method factoryFlagSetter = artifact.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(artifact, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = artifact.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(artifact, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = artifact.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(artifact, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return artifact;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public StoredQuery createStoredQuery()
  {
       	/* begin IONA modification */
    	//StoredQueryImpl storedQuery = new StoredQueryImpl();
    	StoredQuery storedQuery = new StoredQueryImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = storedQuery.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(storedQuery, new Object[] {"StoredQuery-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = storedQuery.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(storedQuery, new Object[] {"StoredQuery"});
            Method factoryFlagSetter = storedQuery.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(storedQuery, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = storedQuery.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(storedQuery, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = storedQuery.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(storedQuery, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return storedQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Container createContainer()
  {
       	/* begin IONA modification */
    	//ContainerImpl container = new ContainerImpl();
    	Container container = new ContainerImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = container.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(container, new Object[] {"Container-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = container.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(container, new Object[] {"Container"});
            Method factoryFlagSetter = container.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(container, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = container.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(container, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = container.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(container, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return container;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionedProfile createVersionedProfile()
  {
       	/* begin IONA modification */
    	//VersionedProfileImpl versionedProfile = new VersionedProfileImpl();
    	VersionedProfile versionedProfile = new VersionedProfileImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = versionedProfile.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(versionedProfile, new Object[] {"VersionedProfile-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = versionedProfile.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(versionedProfile, new Object[] {"VersionedProfile"});
            Method factoryFlagSetter = versionedProfile.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(versionedProfile, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = versionedProfile.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(versionedProfile, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = versionedProfile.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(versionedProfile, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return versionedProfile;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Folder createFolder()
  {
       	/* begin IONA modification */
    	//FolderImpl folder = new FolderImpl();
    	Folder folder = new FolderImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = folder.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(folder, new Object[] {"Folder-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = folder.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(folder, new Object[] {"Folder"});
            Method factoryFlagSetter = folder.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(folder, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = folder.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(folder, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = folder.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(folder, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return folder;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MavenRepository createMavenRepository()
  {
       	/* begin IONA modification */
    	//MavenRepositoryImpl mavenRepository = new MavenRepositoryImpl();
    	MavenRepository mavenRepository = new MavenRepositoryImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = mavenRepository.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(mavenRepository, new Object[] {"MavenRepository-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = mavenRepository.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(mavenRepository, new Object[] {"MavenRepository"});
            Method factoryFlagSetter = mavenRepository.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(mavenRepository, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = mavenRepository.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(mavenRepository, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = mavenRepository.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(mavenRepository, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return mavenRepository;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InstalledApplication createInstalledApplication()
  {
       	/* begin IONA modification */
    	//InstalledApplicationImpl installedApplication = new InstalledApplicationImpl();
    	InstalledApplication installedApplication = new InstalledApplicationImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = installedApplication.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(installedApplication, new Object[] {"InstalledApplication-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = installedApplication.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(installedApplication, new Object[] {"InstalledApplication"});
            Method factoryFlagSetter = installedApplication.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(installedApplication, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = installedApplication.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(installedApplication, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = installedApplication.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(installedApplication, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return installedApplication;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InstalledArtifact createInstalledArtifact()
  {
       	/* begin IONA modification */
    	//InstalledArtifactImpl installedArtifact = new InstalledArtifactImpl();
    	InstalledArtifact installedArtifact = new InstalledArtifactImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = installedArtifact.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(installedArtifact, new Object[] {"InstalledArtifact-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = installedArtifact.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(installedArtifact, new Object[] {"InstalledArtifact"});
            Method factoryFlagSetter = installedArtifact.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(installedArtifact, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = installedArtifact.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(installedArtifact, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = installedArtifact.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(installedArtifact, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return installedArtifact;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DeploymentProfile createDeploymentProfile()
  {
       	/* begin IONA modification */
    	//DeploymentProfileImpl deploymentProfile = new DeploymentProfileImpl();
    	DeploymentProfile deploymentProfile = new DeploymentProfileImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = deploymentProfile.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(deploymentProfile, new Object[] {"DeploymentProfile-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = deploymentProfile.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(deploymentProfile, new Object[] {"DeploymentProfile"});
            Method factoryFlagSetter = deploymentProfile.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(deploymentProfile, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = deploymentProfile.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(deploymentProfile, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = deploymentProfile.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(deploymentProfile, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return deploymentProfile;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArtifactType createArtifactType()
  {
       	/* begin IONA modification */
    	//ArtifactTypeImpl artifactType = new ArtifactTypeImpl();
    	ArtifactType artifactType = new ArtifactTypeImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = artifactType.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(artifactType, new Object[] {"ArtifactType-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = artifactType.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(artifactType, new Object[] {"ArtifactType"});
            Method factoryFlagSetter = artifactType.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(artifactType, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = artifactType.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(artifactType, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = artifactType.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(artifactType, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return artifactType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ApplicationType createApplicationType()
  {
       	/* begin IONA modification */
    	//ApplicationTypeImpl applicationType = new ApplicationTypeImpl();
    	ApplicationType applicationType = new ApplicationTypeImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = applicationType.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(applicationType, new Object[] {"ApplicationType-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = applicationType.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(applicationType, new Object[] {"ApplicationType"});
            Method factoryFlagSetter = applicationType.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(applicationType, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = applicationType.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(applicationType, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = applicationType.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(applicationType, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return applicationType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Category createCategory()
  {
       	/* begin IONA modification */
    	//CategoryImpl category = new CategoryImpl();
    	Category category = new CategoryImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = category.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(category, new Object[] {"Category-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = category.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(category, new Object[] {"Category"});
            Method factoryFlagSetter = category.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(category, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = category.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(category, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = category.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(category, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return category;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConfigurationOverride createConfigurationOverride()
  {
       	/* begin IONA modification */
    	//ConfigurationOverrideImpl configurationOverride = new ConfigurationOverrideImpl();
    	ConfigurationOverride configurationOverride = new ConfigurationOverrideImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = configurationOverride.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(configurationOverride, new Object[] {"ConfigurationOverride-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = configurationOverride.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(configurationOverride, new Object[] {"ConfigurationOverride"});
            Method factoryFlagSetter = configurationOverride.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(configurationOverride, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = configurationOverride.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(configurationOverride, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = configurationOverride.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(configurationOverride, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return configurationOverride;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IndexStates createIndexStatesFromString(EDataType eDataType, String initialValue)
  {
    IndexStates result = IndexStates.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertIndexStatesToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SOA_NetworkPackage getSOA_NetworkPackage()
  {
    return (SOA_NetworkPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static SOA_NetworkPackage getPackage()
  {
    return SOA_NetworkPackage.eINSTANCE;
  }

} //SOA_NetworkFactoryImpl


