/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.Application;
import com.iona.soa.model.ApplicationType;
import com.iona.soa.model.Artifact;
import com.iona.soa.model.ArtifactRepository;
import com.iona.soa.model.ArtifactType;
import com.iona.soa.model.Category;
import com.iona.soa.model.ConfigurationOverride;
import com.iona.soa.model.Container;
import com.iona.soa.model.DeploymentProfile;
import com.iona.soa.model.Folder;
import com.iona.soa.model.IConfiguration;
import com.iona.soa.model.IDeploymentConstraint;
import com.iona.soa.model.IndexStates;
import com.iona.soa.model.InstalledApplication;
import com.iona.soa.model.InstalledArtifact;
import com.iona.soa.model.MavenRepository;
import com.iona.soa.model.SOA_NetworkFactory;
import com.iona.soa.model.SOA_NetworkPackage;
import com.iona.soa.model.StoredQuery;
import com.iona.soa.model.VersionedProfile;

import com.iona.soa.model.collaboration.CollaborationPackage;

import com.iona.soa.model.collaboration.impl.CollaborationPackageImpl;

import com.iona.soa.model.events.EventsPackage;

import com.iona.soa.model.events.impl.EventsPackageImpl;

import com.iona.soa.model.folder.FolderPackage;

import com.iona.soa.model.folder.impl.FolderPackageImpl;

import com.iona.soa.model.notification.NotificationPackage;

import com.iona.soa.model.notification.impl.NotificationPackageImpl;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.RepositoryPackageImpl;

import com.iona.soa.model.scheduling.SchedulingPackage;

import com.iona.soa.model.scheduling.impl.SchedulingPackageImpl;

import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.security.impl.SecurityPackageImpl;

import com.iona.soa.model.userattributes.UserAttributesPackage;

import com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SOA_NetworkPackageImpl extends EPackageImpl implements SOA_NetworkPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass applicationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass artifactEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass storedQueryEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass containerEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iConfigurationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass versionedProfileEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass folderEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass mavenRepositoryEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iDeploymentConstraintEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass installedApplicationEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass installedArtifactEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass artifactRepositoryEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass deploymentProfileEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass artifactTypeEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass applicationTypeEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass categoryEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass configurationOverrideEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum indexStatesEEnum = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see com.iona.soa.model.SOA_NetworkPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private SOA_NetworkPackageImpl()
  {
    super(eNS_URI, SOA_NetworkFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this
   * model, and for any others upon which it depends.  Simple
   * dependencies are satisfied by calling this method on all
   * dependent packages before doing anything else.  This method drives
   * initialization for interdependent packages directly, in parallel
   * with this package, itself.
   * <p>Of this package and its interdependencies, all packages which
   * have not yet been registered by their URI values are first created
   * and registered.  The packages are then initialized in two steps:
   * meta-model objects for all of the packages are created before any
   * are initialized, since one package's meta-model objects may refer to
   * those of another.
   * <p>Invocation of this method will not affect any packages that have
   * already been initialized.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static SOA_NetworkPackage init()
  {
    if (isInited) return (SOA_NetworkPackage)EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI);

    // Obtain or create and register package
    SOA_NetworkPackageImpl theSOA_NetworkPackage = (SOA_NetworkPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof SOA_NetworkPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new SOA_NetworkPackageImpl());

    isInited = true;

    // Obtain or create and register interdependencies
    RepositoryPackageImpl theRepositoryPackage = (RepositoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) instanceof RepositoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) : RepositoryPackage.eINSTANCE);
    SecurityPackageImpl theSecurityPackage = (SecurityPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) instanceof SecurityPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) : SecurityPackage.eINSTANCE);
    UserAttributesPackageImpl theUserAttributesPackage = (UserAttributesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) instanceof UserAttributesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) : UserAttributesPackage.eINSTANCE);
    EventsPackageImpl theEventsPackage = (EventsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) instanceof EventsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) : EventsPackage.eINSTANCE);
    NotificationPackageImpl theNotificationPackage = (NotificationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) instanceof NotificationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) : NotificationPackage.eINSTANCE);
    CollaborationPackageImpl theCollaborationPackage = (CollaborationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) instanceof CollaborationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) : CollaborationPackage.eINSTANCE);
    FolderPackageImpl theFolderPackage = (FolderPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) instanceof FolderPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) : FolderPackage.eINSTANCE);
    SchedulingPackageImpl theSchedulingPackage = (SchedulingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) instanceof SchedulingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) : SchedulingPackage.eINSTANCE);

    // Create package meta-data objects
    theSOA_NetworkPackage.createPackageContents();
    theRepositoryPackage.createPackageContents();
    theSecurityPackage.createPackageContents();
    theUserAttributesPackage.createPackageContents();
    theEventsPackage.createPackageContents();
    theNotificationPackage.createPackageContents();
    theCollaborationPackage.createPackageContents();
    theFolderPackage.createPackageContents();
    theSchedulingPackage.createPackageContents();

    // Initialize created meta-data
    theSOA_NetworkPackage.initializePackageContents();
    theRepositoryPackage.initializePackageContents();
    theSecurityPackage.initializePackageContents();
    theUserAttributesPackage.initializePackageContents();
    theEventsPackage.initializePackageContents();
    theNotificationPackage.initializePackageContents();
    theCollaborationPackage.initializePackageContents();
    theFolderPackage.initializePackageContents();
    theSchedulingPackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theSOA_NetworkPackage.freeze();

    return theSOA_NetworkPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getApplication()
  {
    return applicationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getApplication_Artifacts()
  {
    return (EReference)applicationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getApplication_Embedded()
  {
    return (EReference)applicationEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getApplication_Depends()
  {
    return (EReference)applicationEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getApplication_Profiles()
  {
    return (EReference)applicationEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getApplication_Type()
  {
    return (EReference)applicationEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getArtifact()
  {
    return artifactEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getArtifact_Applications()
  {
    return (EReference)artifactEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_Uri()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_FileName()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_Version()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getArtifact_Type()
  {
    return (EReference)artifactEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_RelativeLocation()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_Substitution()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_SubPrefix()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(7);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_SubPostfix()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(8);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getArtifact_Depends()
  {
    return (EReference)artifactEClass.getEStructuralFeatures().get(9);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getArtifact_FoundIn()
  {
    return (EReference)artifactEClass.getEStructuralFeatures().get(10);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifact_External()
  {
    return (EAttribute)artifactEClass.getEStructuralFeatures().get(11);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getStoredQuery()
  {
    return storedQueryEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getStoredQuery_Type()
  {
    return (EAttribute)storedQueryEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getStoredQuery_Query()
  {
    return (EAttribute)storedQueryEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getStoredQuery_Category()
  {
    return (EAttribute)storedQueryEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getContainer()
  {
    return containerEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getContainer_SupportedPackageTypes()
  {
    return (EAttribute)containerEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getContainer_Status()
  {
    return (EReference)containerEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getContainer_Applications()
  {
    return (EReference)containerEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getContainer_Artifacts()
  {
    return (EReference)containerEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getContainer_Profile()
  {
    return (EReference)containerEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getContainer_Type()
  {
    return (EAttribute)containerEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIConfiguration()
  {
    return iConfigurationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIConfiguration_Configuration()
  {
    return (EReference)iConfigurationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getVersionedProfile()
  {
    return versionedProfileEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getVersionedProfile_Applications()
  {
    return (EReference)versionedProfileEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersionedProfile_PublishNow()
  {
    return (EAttribute)versionedProfileEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getVersionedProfile_ConfigurationOverride()
  {
    return (EReference)versionedProfileEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getFolder()
  {
    return folderEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getMavenRepository()
  {
    return mavenRepositoryEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getMavenRepository_Snapshots()
  {
    return (EAttribute)mavenRepositoryEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getMavenRepository_LastIndexed()
  {
    return (EAttribute)mavenRepositoryEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getMavenRepository_NextIndex()
  {
    return (EAttribute)mavenRepositoryEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getMavenRepository_Indexed()
  {
    return (EAttribute)mavenRepositoryEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getMavenRepository_Id()
  {
    return (EAttribute)mavenRepositoryEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getMavenRepository_IndexState()
  {
    return (EAttribute)mavenRepositoryEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIDeploymentConstraint()
  {
    return iDeploymentConstraintEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIDeploymentConstraint_Constraints()
  {
    return (EReference)iDeploymentConstraintEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getInstalledApplication()
  {
    return installedApplicationEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getInstalledApplication_Artifacts()
  {
    return (EReference)installedApplicationEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getInstalledArtifact()
  {
    return installedArtifactEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getArtifactRepository()
  {
    return artifactRepositoryEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifactRepository_Url()
  {
    return (EAttribute)artifactRepositoryEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getArtifactRepository_MirrorOf()
  {
    return (EReference)artifactRepositoryEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifactRepository_OrderID()
  {
    return (EAttribute)artifactRepositoryEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifactRepository_External()
  {
    return (EAttribute)artifactRepositoryEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getDeploymentProfile()
  {
    return deploymentProfileEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDeploymentProfile_Active()
  {
    return (EReference)deploymentProfileEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDeploymentProfile_VersionTracker()
  {
    return (EReference)deploymentProfileEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDeploymentProfile_Versions()
  {
    return (EReference)deploymentProfileEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getDeploymentProfile_Current()
  {
    return (EReference)deploymentProfileEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getArtifactType()
  {
    return artifactTypeEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArtifactType_Markers()
  {
    return (EAttribute)artifactTypeEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getApplicationType()
  {
    return applicationTypeEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getCategory()
  {
    return categoryEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getConfigurationOverride()
  {
    return configurationOverrideEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getConfigurationOverride_Application()
  {
    return (EReference)configurationOverrideEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EEnum getIndexStates()
  {
    return indexStatesEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SOA_NetworkFactory getSOA_NetworkFactory()
  {
    return (SOA_NetworkFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    applicationEClass = createEClass(APPLICATION);
    createEReference(applicationEClass, APPLICATION__ARTIFACTS);
    createEReference(applicationEClass, APPLICATION__EMBEDDED);
    createEReference(applicationEClass, APPLICATION__DEPENDS);
    createEReference(applicationEClass, APPLICATION__PROFILES);
    createEReference(applicationEClass, APPLICATION__TYPE);

    artifactEClass = createEClass(ARTIFACT);
    createEReference(artifactEClass, ARTIFACT__APPLICATIONS);
    createEAttribute(artifactEClass, ARTIFACT__URI);
    createEAttribute(artifactEClass, ARTIFACT__FILE_NAME);
    createEAttribute(artifactEClass, ARTIFACT__VERSION);
    createEReference(artifactEClass, ARTIFACT__TYPE);
    createEAttribute(artifactEClass, ARTIFACT__RELATIVE_LOCATION);
    createEAttribute(artifactEClass, ARTIFACT__SUBSTITUTION);
    createEAttribute(artifactEClass, ARTIFACT__SUB_PREFIX);
    createEAttribute(artifactEClass, ARTIFACT__SUB_POSTFIX);
    createEReference(artifactEClass, ARTIFACT__DEPENDS);
    createEReference(artifactEClass, ARTIFACT__FOUND_IN);
    createEAttribute(artifactEClass, ARTIFACT__EXTERNAL);

    storedQueryEClass = createEClass(STORED_QUERY);
    createEAttribute(storedQueryEClass, STORED_QUERY__TYPE);
    createEAttribute(storedQueryEClass, STORED_QUERY__QUERY);
    createEAttribute(storedQueryEClass, STORED_QUERY__CATEGORY);

    containerEClass = createEClass(CONTAINER);
    createEAttribute(containerEClass, CONTAINER__SUPPORTED_PACKAGE_TYPES);
    createEReference(containerEClass, CONTAINER__STATUS);
    createEReference(containerEClass, CONTAINER__APPLICATIONS);
    createEReference(containerEClass, CONTAINER__ARTIFACTS);
    createEReference(containerEClass, CONTAINER__PROFILE);
    createEAttribute(containerEClass, CONTAINER__TYPE);

    iConfigurationEClass = createEClass(ICONFIGURATION);
    createEReference(iConfigurationEClass, ICONFIGURATION__CONFIGURATION);

    versionedProfileEClass = createEClass(VERSIONED_PROFILE);
    createEReference(versionedProfileEClass, VERSIONED_PROFILE__APPLICATIONS);
    createEAttribute(versionedProfileEClass, VERSIONED_PROFILE__PUBLISH_NOW);
    createEReference(versionedProfileEClass, VERSIONED_PROFILE__CONFIGURATION_OVERRIDE);

    folderEClass = createEClass(FOLDER);

    mavenRepositoryEClass = createEClass(MAVEN_REPOSITORY);
    createEAttribute(mavenRepositoryEClass, MAVEN_REPOSITORY__SNAPSHOTS);
    createEAttribute(mavenRepositoryEClass, MAVEN_REPOSITORY__LAST_INDEXED);
    createEAttribute(mavenRepositoryEClass, MAVEN_REPOSITORY__NEXT_INDEX);
    createEAttribute(mavenRepositoryEClass, MAVEN_REPOSITORY__INDEXED);
    createEAttribute(mavenRepositoryEClass, MAVEN_REPOSITORY__ID);
    createEAttribute(mavenRepositoryEClass, MAVEN_REPOSITORY__INDEX_STATE);

    iDeploymentConstraintEClass = createEClass(IDEPLOYMENT_CONSTRAINT);
    createEReference(iDeploymentConstraintEClass, IDEPLOYMENT_CONSTRAINT__CONSTRAINTS);

    installedApplicationEClass = createEClass(INSTALLED_APPLICATION);
    createEReference(installedApplicationEClass, INSTALLED_APPLICATION__ARTIFACTS);

    installedArtifactEClass = createEClass(INSTALLED_ARTIFACT);

    artifactRepositoryEClass = createEClass(ARTIFACT_REPOSITORY);
    createEAttribute(artifactRepositoryEClass, ARTIFACT_REPOSITORY__URL);
    createEReference(artifactRepositoryEClass, ARTIFACT_REPOSITORY__MIRROR_OF);
    createEAttribute(artifactRepositoryEClass, ARTIFACT_REPOSITORY__ORDER_ID);
    createEAttribute(artifactRepositoryEClass, ARTIFACT_REPOSITORY__EXTERNAL);

    deploymentProfileEClass = createEClass(DEPLOYMENT_PROFILE);
    createEReference(deploymentProfileEClass, DEPLOYMENT_PROFILE__ACTIVE);
    createEReference(deploymentProfileEClass, DEPLOYMENT_PROFILE__VERSION_TRACKER);
    createEReference(deploymentProfileEClass, DEPLOYMENT_PROFILE__VERSIONS);
    createEReference(deploymentProfileEClass, DEPLOYMENT_PROFILE__CURRENT);

    artifactTypeEClass = createEClass(ARTIFACT_TYPE);
    createEAttribute(artifactTypeEClass, ARTIFACT_TYPE__MARKERS);

    applicationTypeEClass = createEClass(APPLICATION_TYPE);

    categoryEClass = createEClass(CATEGORY);

    configurationOverrideEClass = createEClass(CONFIGURATION_OVERRIDE);
    createEReference(configurationOverrideEClass, CONFIGURATION_OVERRIDE__APPLICATION);

    // Create enums
    indexStatesEEnum = createEEnum(INDEX_STATES);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    SecurityPackage theSecurityPackage = (SecurityPackage)EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI);
    RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);
    UserAttributesPackage theUserAttributesPackage = (UserAttributesPackage)EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI);
    FolderPackage theFolderPackage = (FolderPackage)EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI);
    CollaborationPackage theCollaborationPackage = (CollaborationPackage)EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    applicationEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    applicationEClass.getESuperTypes().add(theRepositoryPackage.getIVersionedObject());
    applicationEClass.getESuperTypes().add(this.getIConfiguration());
    applicationEClass.getESuperTypes().add(theUserAttributesPackage.getIAttributes());
    applicationEClass.getESuperTypes().add(theUserAttributesPackage.getITagged());
    applicationEClass.getESuperTypes().add(theFolderPackage.getICategorizable());
    applicationEClass.getESuperTypes().add(theRepositoryPackage.getIProperties());
    applicationEClass.getESuperTypes().add(this.getIDeploymentConstraint());
    artifactEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    artifactEClass.getESuperTypes().add(this.getIConfiguration());
    artifactEClass.getESuperTypes().add(theUserAttributesPackage.getIAttributes());
    artifactEClass.getESuperTypes().add(theUserAttributesPackage.getITagged());
    artifactEClass.getESuperTypes().add(theRepositoryPackage.getIProperties());
    artifactEClass.getESuperTypes().add(theFolderPackage.getIFolderContent());
    storedQueryEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    storedQueryEClass.getESuperTypes().add(theUserAttributesPackage.getITagged());
    storedQueryEClass.getESuperTypes().add(theUserAttributesPackage.getIAttributes());
    containerEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    containerEClass.getESuperTypes().add(theUserAttributesPackage.getITagged());
    containerEClass.getESuperTypes().add(theUserAttributesPackage.getIAttributes());
    containerEClass.getESuperTypes().add(theFolderPackage.getICategorizable());
    containerEClass.getESuperTypes().add(theRepositoryPackage.getIProperties());
    iConfigurationEClass.getESuperTypes().add(theRepositoryPackage.getIPersistableObject());
    versionedProfileEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    versionedProfileEClass.getESuperTypes().add(theRepositoryPackage.getIVersionedObject());
    folderEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    folderEClass.getESuperTypes().add(theFolderPackage.getIFolder());
    folderEClass.getESuperTypes().add(theCollaborationPackage.getICollaboration());
    mavenRepositoryEClass.getESuperTypes().add(this.getArtifactRepository());
    iDeploymentConstraintEClass.getESuperTypes().add(theRepositoryPackage.getIPersistableObject());
    installedApplicationEClass.getESuperTypes().add(theRepositoryPackage.getIRepositoryObject());
    installedArtifactEClass.getESuperTypes().add(theRepositoryPackage.getIRepositoryObject());
    artifactRepositoryEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    artifactRepositoryEClass.getESuperTypes().add(theFolderPackage.getICategorizable());
    artifactRepositoryEClass.getESuperTypes().add(theUserAttributesPackage.getIAttributes());
    artifactRepositoryEClass.getESuperTypes().add(theUserAttributesPackage.getITagged());
    artifactRepositoryEClass.getESuperTypes().add(theRepositoryPackage.getIProperties());
    deploymentProfileEClass.getESuperTypes().add(theUserAttributesPackage.getIAttributes());
    deploymentProfileEClass.getESuperTypes().add(theFolderPackage.getICategorizable());
    deploymentProfileEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    deploymentProfileEClass.getESuperTypes().add(theUserAttributesPackage.getITagged());
    artifactTypeEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    applicationTypeEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    categoryEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    categoryEClass.getESuperTypes().add(theFolderPackage.getICategory());
    categoryEClass.getESuperTypes().add(theCollaborationPackage.getICollaboration());
    configurationOverrideEClass.getESuperTypes().add(this.getIConfiguration());
    configurationOverrideEClass.getESuperTypes().add(this.getIDeploymentConstraint());
    configurationOverrideEClass.getESuperTypes().add(theRepositoryPackage.getIRepositoryObject());

    // Initialize classes and features; add operations and parameters
    initEClass(applicationEClass, Application.class, "Application", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getApplication_Artifacts(), this.getArtifact(), this.getArtifact_Applications(), "artifacts", null, 0, -1, Application.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getApplication_Embedded(), this.getApplication(), null, "embedded", null, 0, -1, Application.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getApplication_Depends(), this.getApplication(), null, "depends", null, 0, -1, Application.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getApplication_Profiles(), this.getVersionedProfile(), this.getVersionedProfile_Applications(), "profiles", null, 0, -1, Application.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getApplication_Type(), this.getApplicationType(), null, "type", null, 0, 1, Application.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(artifactEClass, Artifact.class, "Artifact", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getArtifact_Applications(), this.getApplication(), this.getApplication_Artifacts(), "applications", null, 0, -1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_Uri(), theRepositoryPackage.getURI(), "uri", null, 1, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_FileName(), ecorePackage.getEString(), "fileName", null, 1, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_Version(), ecorePackage.getEString(), "version", null, 1, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getArtifact_Type(), this.getArtifactType(), null, "type", null, 0, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_RelativeLocation(), ecorePackage.getEString(), "relativeLocation", null, 0, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_Substitution(), ecorePackage.getEBoolean(), "substitution", "false", 0, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_SubPrefix(), ecorePackage.getEString(), "subPrefix", "${", 0, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_SubPostfix(), ecorePackage.getEString(), "subPostfix", "}", 0, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getArtifact_Depends(), this.getArtifact(), null, "depends", null, 0, -1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getArtifact_FoundIn(), this.getArtifactRepository(), null, "foundIn", null, 0, -1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifact_External(), ecorePackage.getEBoolean(), "external", "true", 1, 1, Artifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(storedQueryEClass, StoredQuery.class, "StoredQuery", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getStoredQuery_Type(), ecorePackage.getEString(), "type", null, 1, 1, StoredQuery.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getStoredQuery_Query(), ecorePackage.getEString(), "query", null, 1, 1, StoredQuery.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getStoredQuery_Category(), ecorePackage.getEString(), "category", null, 1, 1, StoredQuery.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(containerEClass, Container.class, "Container", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getContainer_SupportedPackageTypes(), ecorePackage.getEString(), "supportedPackageTypes", null, 0, -1, Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getContainer_Status(), theRepositoryPackage.getProperty(), null, "status", null, 0, -1, Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getContainer_Applications(), this.getInstalledApplication(), null, "applications", null, 0, -1, Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getContainer_Artifacts(), this.getInstalledArtifact(), null, "artifacts", null, 0, -1, Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getContainer_Profile(), this.getDeploymentProfile(), null, "profile", null, 0, 1, Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getContainer_Type(), ecorePackage.getEString(), "type", null, 0, 1, Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iConfigurationEClass, IConfiguration.class, "IConfiguration", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getIConfiguration_Configuration(), theRepositoryPackage.getProperty(), null, "configuration", null, 0, -1, IConfiguration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(versionedProfileEClass, VersionedProfile.class, "VersionedProfile", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getVersionedProfile_Applications(), this.getApplication(), this.getApplication_Profiles(), "applications", null, 0, -1, VersionedProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVersionedProfile_PublishNow(), ecorePackage.getEBoolean(), "publishNow", "false", 0, 1, VersionedProfile.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getVersionedProfile_ConfigurationOverride(), this.getConfigurationOverride(), null, "configurationOverride", null, 0, -1, VersionedProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(folderEClass, Folder.class, "Folder", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    initEClass(mavenRepositoryEClass, MavenRepository.class, "MavenRepository", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getMavenRepository_Snapshots(), ecorePackage.getEBoolean(), "snapshots", null, 1, 1, MavenRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getMavenRepository_LastIndexed(), theRepositoryPackage.getTimestamp(), "lastIndexed", null, 0, 1, MavenRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getMavenRepository_NextIndex(), theRepositoryPackage.getTimestamp(), "nextIndex", null, 0, 1, MavenRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getMavenRepository_Indexed(), ecorePackage.getEBoolean(), "indexed", "true", 1, 1, MavenRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getMavenRepository_Id(), ecorePackage.getEString(), "id", null, 1, 1, MavenRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getMavenRepository_IndexState(), this.getIndexStates(), "indexState", null, 1, 1, MavenRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iDeploymentConstraintEClass, IDeploymentConstraint.class, "IDeploymentConstraint", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getIDeploymentConstraint_Constraints(), theRepositoryPackage.getProperty(), null, "constraints", null, 0, -1, IDeploymentConstraint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(installedApplicationEClass, InstalledApplication.class, "InstalledApplication", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getInstalledApplication_Artifacts(), this.getInstalledArtifact(), null, "artifacts", null, 0, -1, InstalledApplication.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(installedArtifactEClass, InstalledArtifact.class, "InstalledArtifact", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    initEClass(artifactRepositoryEClass, ArtifactRepository.class, "ArtifactRepository", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getArtifactRepository_Url(), theRepositoryPackage.getURI(), "url", null, 1, 1, ArtifactRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getArtifactRepository_MirrorOf(), this.getArtifactRepository(), null, "mirrorOf", null, 0, 1, ArtifactRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifactRepository_OrderID(), ecorePackage.getEInt(), "orderID", null, 0, 1, ArtifactRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getArtifactRepository_External(), ecorePackage.getEBoolean(), "external", "true", 1, 1, ArtifactRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(deploymentProfileEClass, DeploymentProfile.class, "DeploymentProfile", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getDeploymentProfile_Active(), this.getVersionedProfile(), null, "active", null, 0, 1, DeploymentProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getDeploymentProfile_VersionTracker(), theRepositoryPackage.getVersionTracker(), null, "versionTracker", null, 1, 1, DeploymentProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getDeploymentProfile_Versions(), this.getVersionedProfile(), null, "versions", null, 0, -1, DeploymentProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getDeploymentProfile_Current(), this.getVersionedProfile(), null, "current", null, 1, 1, DeploymentProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(artifactTypeEClass, ArtifactType.class, "ArtifactType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getArtifactType_Markers(), ecorePackage.getEString(), "markers", null, 0, -1, ArtifactType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(applicationTypeEClass, ApplicationType.class, "ApplicationType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    initEClass(categoryEClass, Category.class, "Category", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    initEClass(configurationOverrideEClass, ConfigurationOverride.class, "ConfigurationOverride", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getConfigurationOverride_Application(), this.getApplication(), null, "application", null, 1, 1, ConfigurationOverride.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    // Initialize enums and add enum literals
    initEEnum(indexStatesEEnum, IndexStates.class, "IndexStates");
    addEEnumLiteral(indexStatesEEnum, IndexStates.UNINDEXED);
    addEEnumLiteral(indexStatesEEnum, IndexStates.INDEXING);
    addEEnumLiteral(indexStatesEEnum, IndexStates.READY);
    addEEnumLiteral(indexStatesEEnum, IndexStates.FAILED);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // securityHints
    createSecurityHintsAnnotations();
    // dbhints
    createDbhintsAnnotations();
  }

  /**
   * Initializes the annotations for <b>securityHints</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createSecurityHintsAnnotations()
  {
    String source = "securityHints";		
    addAnnotation
      (applicationEClass, 
       source, 
       new String[] 
       {
       "area", "Provisioning"
       });		
    addAnnotation
      (artifactEClass, 
       source, 
       new String[] 
       {
       "area", "Provisioning"
       });		
    addAnnotation
      (storedQueryEClass, 
       source, 
       new String[] 
       {
       "area", "Organisation"
       });			
    addAnnotation
      (containerEClass, 
       source, 
       new String[] 
       {
       "area", "Provisioning\r\nAgent"
       });		
    addAnnotation
      (folderEClass, 
       source, 
       new String[] 
       {
       "area", "Organisation"
       });			
    addAnnotation
      (artifactRepositoryEClass, 
       source, 
       new String[] 
       {
       "area", "Repository"
       });		
    addAnnotation
      (deploymentProfileEClass, 
       source, 
       new String[] 
       {
       "area", "Provisioning\r\nAgent"
       });		
    addAnnotation
      (artifactTypeEClass, 
       source, 
       new String[] 
       {
       "area", "Provisioning"
       });		
    addAnnotation
      (applicationTypeEClass, 
       source, 
       new String[] 
       {
       "area", "Provisioning"
       });		
    addAnnotation
      (categoryEClass, 
       source, 
       new String[] 
       {
       "area", "Organisation"
       });
  }

  /**
   * Initializes the annotations for <b>dbhints</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createDbhintsAnnotations()
  {
    String source = "dbhints";					
    addAnnotation
      (getStoredQuery_Query(), 
       source, 
       new String[] 
       {
       "type", "CLOB"
       });				
    addAnnotation
      (artifactRepositoryEClass, 
       source, 
       new String[] 
       {
       "hierarchy", "topclass"
       });					
  }

} //SOA_NetworkPackageImpl
