/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.impl;

import com.iona.soa.model.SOA_NetworkPackage;
import com.iona.soa.model.StoredQuery;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;
import com.iona.soa.model.userattributes.UserAttributeDefinition;
import com.iona.soa.model.userattributes.UserAttributeValue;
import com.iona.soa.model.userattributes.UserAttributesPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Stored Query</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getTags <em>Tags</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getQuery <em>Query</em>}</li>
 *   <li>{@link com.iona.soa.model.impl.StoredQueryImpl#getCategory <em>Category</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StoredQueryImpl extends IPersistableObjectImpl implements StoredQuery
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The cached value of the '{@link #getTags() <em>Tags</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTags()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeDefinition> tags;

  /**
   * The cached value of the '{@link #getAttributes() <em>Attributes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAttributes()
   * @generated
   * @ordered
   */
  protected EList<UserAttributeValue> attributes;

  /**
   * The default value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected static final String TYPE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected String type = TYPE_EDEFAULT;

  /**
   * The default value of the '{@link #getQuery() <em>Query</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQuery()
   * @generated
   * @ordered
   */
  protected static final String QUERY_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getQuery() <em>Query</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQuery()
   * @generated
   * @ordered
   */
  protected String query = QUERY_EDEFAULT;

  /**
   * The default value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected static final String CATEGORY_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected String category = CATEGORY_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected StoredQueryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SOA_NetworkPackage.Literals.STORED_QUERY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeDefinition> getTags() {
    autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS);
    return _basicGetTags();
  }
  
  private final EList<UserAttributeDefinition> _basicGetTags() {
    if (tags == null)
    {
      tags = new EObjectResolvingEList<UserAttributeDefinition>(UserAttributeDefinition.class, this, SOA_NetworkPackage.STORED_QUERY__TAGS);
    }
    return tags;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<UserAttributeValue> getAttributes() {
    autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES);
    return _basicGetAttributes();
  }
  
  private final EList<UserAttributeValue> _basicGetAttributes() {
    if (attributes == null)
    {
      attributes = new EObjectContainmentEList<UserAttributeValue>(UserAttributeValue.class, this, SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES);
    }
    return attributes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getType() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.STORED_QUERY__TYPE);
    return _basicGetType();
  }
  
  private final String _basicGetType() {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(String newType)
  {
    
    String oldType = type;
    type = newType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__TYPE, oldType, type));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getQuery() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.STORED_QUERY__QUERY);
    return _basicGetQuery();
  }
  
  private final String _basicGetQuery() {
    return query;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setQuery(String newQuery)
  {
    
    String oldQuery = query;
    query = newQuery;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__QUERY, oldQuery, query));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCategory() {
    autoResolveEProxy(SOA_NetworkPackage.Literals.STORED_QUERY__CATEGORY);
    return _basicGetCategory();
  }
  
  private final String _basicGetCategory() {
    return category;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCategory(String newCategory)
  {
    
    String oldCategory = category;
    category = newCategory;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SOA_NetworkPackage.STORED_QUERY__CATEGORY, oldCategory, category));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
      case SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES:
        return ((InternalEList<?>)_basicGetAttributes()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.STORED_QUERY__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SOA_NetworkPackage.STORED_QUERY__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SOA_NetworkPackage.STORED_QUERY__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SOA_NetworkPackage.STORED_QUERY__TAGS:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.ITAGGED__TAGS); }
        return _basicGetTags();
      case SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES:
      if (resolve) { autoResolveEProxy(UserAttributesPackage.Literals.IATTRIBUTES__ATTRIBUTES); }
        return _basicGetAttributes();
      case SOA_NetworkPackage.STORED_QUERY__TYPE:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.STORED_QUERY__TYPE); }
        return _basicGetType();
      case SOA_NetworkPackage.STORED_QUERY__QUERY:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.STORED_QUERY__QUERY); }
        return _basicGetQuery();
      case SOA_NetworkPackage.STORED_QUERY__CATEGORY:
      if (resolve) { autoResolveEProxy(SOA_NetworkPackage.Literals.STORED_QUERY__CATEGORY); }
        return _basicGetCategory();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.STORED_QUERY__NAME:
        setName((String)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__TAGS:
        _basicGetTags().clear();
        _basicGetTags().addAll((Collection<? extends UserAttributeDefinition>)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES:
        _basicGetAttributes().clear();
        _basicGetAttributes().addAll((Collection<? extends UserAttributeValue>)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__TYPE:
        setType((String)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__QUERY:
        setQuery((String)newValue);
        return;
      case SOA_NetworkPackage.STORED_QUERY__CATEGORY:
        setCategory((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SOA_NetworkPackage.STORED_QUERY__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SOA_NetworkPackage.STORED_QUERY__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SOA_NetworkPackage.STORED_QUERY__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SOA_NetworkPackage.STORED_QUERY__TAGS:
      _basicGetTags().clear();
      return;
    case SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES:
      _basicGetAttributes().clear();
      return;
    case SOA_NetworkPackage.STORED_QUERY__TYPE:
      setType(TYPE_EDEFAULT);
      return;
    case SOA_NetworkPackage.STORED_QUERY__QUERY:
      setQuery(QUERY_EDEFAULT);
      return;
    case SOA_NetworkPackage.STORED_QUERY__CATEGORY:
      setCategory(CATEGORY_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SOA_NetworkPackage.STORED_QUERY__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SOA_NetworkPackage.STORED_QUERY__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SOA_NetworkPackage.STORED_QUERY__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SOA_NetworkPackage.STORED_QUERY__OBJECT_CONTROL:
        return objectControl != null;
      case SOA_NetworkPackage.STORED_QUERY__TAGS:
        return tags != null && !tags.isEmpty();
      case SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES:
        return attributes != null && !attributes.isEmpty();
      case SOA_NetworkPackage.STORED_QUERY__TYPE:
        return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
      case SOA_NetworkPackage.STORED_QUERY__QUERY:
        return QUERY_EDEFAULT == null ? query != null : !QUERY_EDEFAULT.equals(query);
      case SOA_NetworkPackage.STORED_QUERY__CATEGORY:
        return CATEGORY_EDEFAULT == null ? category != null : !CATEGORY_EDEFAULT.equals(category);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == ITagged.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.STORED_QUERY__TAGS: return UserAttributesPackage.ITAGGED__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (derivedFeatureID)
      {
        case SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES: return UserAttributesPackage.IATTRIBUTES__ATTRIBUTES;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == ITagged.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.ITAGGED__TAGS: return SOA_NetworkPackage.STORED_QUERY__TAGS;
        default: return -1;
      }
    }
    if (baseClass == IAttributes.class)
    {
      switch (baseFeatureID)
      {
        case UserAttributesPackage.IATTRIBUTES__ATTRIBUTES: return SOA_NetworkPackage.STORED_QUERY__ATTRIBUTES;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(", type: ");
    result.append(type);
    result.append(", query: ");
    result.append(query);
    result.append(", category: ");
    result.append(category);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //StoredQueryImpl


