/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.notification;

import com.iona.soa.model.events.DataChangeEvent;

import com.iona.soa.model.security.IProtectedRepositoryObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Definition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.notification.NotificationDefinition#getRule <em>Rule</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.NotificationDefinition#getRecipients <em>Recipients</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.notification.NotificationPackage#getNotificationDefinition()
 * @model
 * @generated
 */
public interface NotificationDefinition extends IProtectedRepositoryObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Rule</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Rule</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Rule</em>' attribute.
   * @see #setRule(String)
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationDefinition_Rule()
   * @model required="true"
   * @generated
   */
  String getRule();


  /**
   * Sets the value of the '{@link com.iona.soa.model.notification.NotificationDefinition#getRule <em>Rule</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rule</em>' attribute.
   * @see #getRule()
   * @generated
   */
  void setRule(String value);

  /**
   * Returns the value of the '<em><b>Recipients</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Recipients</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Recipients</em>' containment reference.
   * @see #setRecipients(NotificationRecipients)
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationDefinition_Recipients()
   * @model containment="true" required="true"
   * @generated
   */
  NotificationRecipients getRecipients();


  /**
   * Sets the value of the '{@link com.iona.soa.model.notification.NotificationDefinition#getRecipients <em>Recipients</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Recipients</em>' containment reference.
   * @see #getRecipients()
   * @generated
   */
  void setRecipients(NotificationRecipients value);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @model required="true" eventRequired="true"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return com.iona.soa.model.helpers.NotificationDefinitionHelper.evaluate(this, event);'"
   * @generated
   */
  boolean evaluate(DataChangeEvent event);

} // NotificationDefinition


