/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.notification;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.security.SecurityPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.notification.NotificationFactory
 * @model kind="package"
 * @generated
 */
public interface NotificationPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "notification";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.notification";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itnotification";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  NotificationPackage eINSTANCE = com.iona.soa.model.notification.impl.NotificationPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.notification.impl.NotificationSchemeImpl <em>Scheme</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.notification.impl.NotificationSchemeImpl
   * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getNotificationScheme()
   * @generated
   */
  int NOTIFICATION_SCHEME = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Email Subject Prefix</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__EMAIL_SUBJECT_PREFIX = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Notification Definitions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME__NOTIFICATION_DEFINITIONS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Scheme</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_SCHEME_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.notification.impl.NotificationDefinitionImpl <em>Definition</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.notification.impl.NotificationDefinitionImpl
   * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getNotificationDefinition()
   * @generated
   */
  int NOTIFICATION_DEFINITION = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Rule</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__RULE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Recipients</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION__RECIPIENTS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Definition</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_DEFINITION_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.notification.impl.NotificationRecipientsImpl <em>Recipients</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.notification.impl.NotificationRecipientsImpl
   * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getNotificationRecipients()
   * @generated
   */
  int NOTIFICATION_RECIPIENTS = 2;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Users</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__USERS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Email Addresses</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Custom Recipients</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Notify Subscribers</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 3;

  /**
   * The number of structural features of the '<em>Recipients</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NOTIFICATION_RECIPIENTS_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 4;

  /**
   * The meta object id for the '{@link com.iona.soa.model.notification.impl.CustomRecipientImpl <em>Custom Recipient</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.notification.impl.CustomRecipientImpl
   * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getCustomRecipient()
   * @generated
   */
  int CUSTOM_RECIPIENT = 3;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Rule</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT__RULE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Custom Recipient</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CUSTOM_RECIPIENT_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.notification.NotificationScheme <em>Scheme</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Scheme</em>'.
   * @see com.iona.soa.model.notification.NotificationScheme
   * @generated
   */
  EClass getNotificationScheme();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.notification.NotificationScheme#getEmailSubjectPrefix <em>Email Subject Prefix</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Email Subject Prefix</em>'.
   * @see com.iona.soa.model.notification.NotificationScheme#getEmailSubjectPrefix()
   * @see #getNotificationScheme()
   * @generated
   */
  EAttribute getNotificationScheme_EmailSubjectPrefix();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.notification.NotificationScheme#getNotificationDefinitions <em>Notification Definitions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Notification Definitions</em>'.
   * @see com.iona.soa.model.notification.NotificationScheme#getNotificationDefinitions()
   * @see #getNotificationScheme()
   * @generated
   */
  EReference getNotificationScheme_NotificationDefinitions();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.notification.NotificationDefinition <em>Definition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Definition</em>'.
   * @see com.iona.soa.model.notification.NotificationDefinition
   * @generated
   */
  EClass getNotificationDefinition();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.notification.NotificationDefinition#getRule <em>Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Rule</em>'.
   * @see com.iona.soa.model.notification.NotificationDefinition#getRule()
   * @see #getNotificationDefinition()
   * @generated
   */
  EAttribute getNotificationDefinition_Rule();

  /**
   * Returns the meta object for the containment reference '{@link com.iona.soa.model.notification.NotificationDefinition#getRecipients <em>Recipients</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Recipients</em>'.
   * @see com.iona.soa.model.notification.NotificationDefinition#getRecipients()
   * @see #getNotificationDefinition()
   * @generated
   */
  EReference getNotificationDefinition_Recipients();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.notification.NotificationRecipients <em>Recipients</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Recipients</em>'.
   * @see com.iona.soa.model.notification.NotificationRecipients
   * @generated
   */
  EClass getNotificationRecipients();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.notification.NotificationRecipients#getUsers <em>Users</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Users</em>'.
   * @see com.iona.soa.model.notification.NotificationRecipients#getUsers()
   * @see #getNotificationRecipients()
   * @generated
   */
  EReference getNotificationRecipients_Users();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.notification.NotificationRecipients#getEmailAddresses <em>Email Addresses</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Email Addresses</em>'.
   * @see com.iona.soa.model.notification.NotificationRecipients#getEmailAddresses()
   * @see #getNotificationRecipients()
   * @generated
   */
  EAttribute getNotificationRecipients_EmailAddresses();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.notification.NotificationRecipients#getCustomRecipients <em>Custom Recipients</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Custom Recipients</em>'.
   * @see com.iona.soa.model.notification.NotificationRecipients#getCustomRecipients()
   * @see #getNotificationRecipients()
   * @generated
   */
  EReference getNotificationRecipients_CustomRecipients();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.notification.NotificationRecipients#isNotifySubscribers <em>Notify Subscribers</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Notify Subscribers</em>'.
   * @see com.iona.soa.model.notification.NotificationRecipients#isNotifySubscribers()
   * @see #getNotificationRecipients()
   * @generated
   */
  EAttribute getNotificationRecipients_NotifySubscribers();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.notification.CustomRecipient <em>Custom Recipient</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Custom Recipient</em>'.
   * @see com.iona.soa.model.notification.CustomRecipient
   * @generated
   */
  EClass getCustomRecipient();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.notification.CustomRecipient#getRule <em>Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Rule</em>'.
   * @see com.iona.soa.model.notification.CustomRecipient#getRule()
   * @see #getCustomRecipient()
   * @generated
   */
  EAttribute getCustomRecipient_Rule();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  NotificationFactory getNotificationFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.notification.impl.NotificationSchemeImpl <em>Scheme</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.notification.impl.NotificationSchemeImpl
     * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getNotificationScheme()
     * @generated
     */
    EClass NOTIFICATION_SCHEME = eINSTANCE.getNotificationScheme();

    /**
     * The meta object literal for the '<em><b>Email Subject Prefix</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute NOTIFICATION_SCHEME__EMAIL_SUBJECT_PREFIX = eINSTANCE.getNotificationScheme_EmailSubjectPrefix();

    /**
     * The meta object literal for the '<em><b>Notification Definitions</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NOTIFICATION_SCHEME__NOTIFICATION_DEFINITIONS = eINSTANCE.getNotificationScheme_NotificationDefinitions();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.notification.impl.NotificationDefinitionImpl <em>Definition</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.notification.impl.NotificationDefinitionImpl
     * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getNotificationDefinition()
     * @generated
     */
    EClass NOTIFICATION_DEFINITION = eINSTANCE.getNotificationDefinition();

    /**
     * The meta object literal for the '<em><b>Rule</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute NOTIFICATION_DEFINITION__RULE = eINSTANCE.getNotificationDefinition_Rule();

    /**
     * The meta object literal for the '<em><b>Recipients</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NOTIFICATION_DEFINITION__RECIPIENTS = eINSTANCE.getNotificationDefinition_Recipients();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.notification.impl.NotificationRecipientsImpl <em>Recipients</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.notification.impl.NotificationRecipientsImpl
     * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getNotificationRecipients()
     * @generated
     */
    EClass NOTIFICATION_RECIPIENTS = eINSTANCE.getNotificationRecipients();

    /**
     * The meta object literal for the '<em><b>Users</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NOTIFICATION_RECIPIENTS__USERS = eINSTANCE.getNotificationRecipients_Users();

    /**
     * The meta object literal for the '<em><b>Email Addresses</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES = eINSTANCE.getNotificationRecipients_EmailAddresses();

    /**
     * The meta object literal for the '<em><b>Custom Recipients</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS = eINSTANCE.getNotificationRecipients_CustomRecipients();

    /**
     * The meta object literal for the '<em><b>Notify Subscribers</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS = eINSTANCE.getNotificationRecipients_NotifySubscribers();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.notification.impl.CustomRecipientImpl <em>Custom Recipient</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.notification.impl.CustomRecipientImpl
     * @see com.iona.soa.model.notification.impl.NotificationPackageImpl#getCustomRecipient()
     * @generated
     */
    EClass CUSTOM_RECIPIENT = eINSTANCE.getCustomRecipient();

    /**
     * The meta object literal for the '<em><b>Rule</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CUSTOM_RECIPIENT__RULE = eINSTANCE.getCustomRecipient_Rule();

  }

} //NotificationPackage
