/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.notification;

import com.iona.soa.model.repository.IPersistableObject;

import com.iona.soa.model.security.User;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Recipients</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.notification.NotificationRecipients#getUsers <em>Users</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.NotificationRecipients#getEmailAddresses <em>Email Addresses</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.NotificationRecipients#getCustomRecipients <em>Custom Recipients</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.NotificationRecipients#isNotifySubscribers <em>Notify Subscribers</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.notification.NotificationPackage#getNotificationRecipients()
 * @model
 * @generated
 */
public interface NotificationRecipients extends IPersistableObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Users</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.User}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Users</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Users</em>' reference list.
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationRecipients_Users()
   * @model
   * @generated
   */
  EList<User> getUsers();


  /**
   * Returns the value of the '<em><b>Email Addresses</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Email Addresses</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Email Addresses</em>' attribute list.
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationRecipients_EmailAddresses()
   * @model
   * @generated
   */
  EList<String> getEmailAddresses();


  /**
   * Returns the value of the '<em><b>Custom Recipients</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.notification.CustomRecipient}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Custom Recipients</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Custom Recipients</em>' reference list.
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationRecipients_CustomRecipients()
   * @model
   * @generated
   */
  EList<CustomRecipient> getCustomRecipients();


  /**
   * Returns the value of the '<em><b>Notify Subscribers</b></em>' attribute.
   * The default value is <code>"true"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Notify Subscribers</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Notify Subscribers</em>' attribute.
   * @see #setNotifySubscribers(boolean)
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationRecipients_NotifySubscribers()
   * @model default="true"
   * @generated
   */
  boolean isNotifySubscribers();


  /**
   * Sets the value of the '{@link com.iona.soa.model.notification.NotificationRecipients#isNotifySubscribers <em>Notify Subscribers</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Notify Subscribers</em>' attribute.
   * @see #isNotifySubscribers()
   * @generated
   */
  void setNotifySubscribers(boolean value);

} // NotificationRecipients


