/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.notification;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scheme</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.notification.NotificationScheme#getEmailSubjectPrefix <em>Email Subject Prefix</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.NotificationScheme#getNotificationDefinitions <em>Notification Definitions</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.notification.NotificationPackage#getNotificationScheme()
 * @model
 * @generated
 */
public interface NotificationScheme extends IProtectedRepositoryObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Email Subject Prefix</b></em>' attribute.
   * The default value is <code>"[ARR]"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Email Subject Prefix</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Email Subject Prefix</em>' attribute.
   * @see #setEmailSubjectPrefix(String)
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationScheme_EmailSubjectPrefix()
   * @model default="[ARR]"
   * @generated
   */
  String getEmailSubjectPrefix();


  /**
   * Sets the value of the '{@link com.iona.soa.model.notification.NotificationScheme#getEmailSubjectPrefix <em>Email Subject Prefix</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Email Subject Prefix</em>' attribute.
   * @see #getEmailSubjectPrefix()
   * @generated
   */
  void setEmailSubjectPrefix(String value);

  /**
   * Returns the value of the '<em><b>Notification Definitions</b></em>' containment reference list.
   * The list contents are of type {@link com.iona.soa.model.notification.NotificationDefinition}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Notification Definitions</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Notification Definitions</em>' containment reference list.
   * @see com.iona.soa.model.notification.NotificationPackage#getNotificationScheme_NotificationDefinitions()
   * @model containment="true"
   * @generated
   */
  EList<NotificationDefinition> getNotificationDefinitions();


} // NotificationScheme


