/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.notification.impl;

import com.iona.soa.model.notification.*;

import java.lang.reflect.Method;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class NotificationFactoryImpl extends EFactoryImpl implements NotificationFactory
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

/* begin IONA modification */
  private String defaultNamespace = "http://www.example.org/";

  public final void setDefaultNamespace(String namespace) {
    this.defaultNamespace = namespace;
  }

/* end IONA modification */
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static NotificationFactory init()
  {
    try
    {
      NotificationFactory theNotificationFactory = (NotificationFactory)EPackage.Registry.INSTANCE.getEFactory("http://com.iona.soa.model.notification"); 
      if (theNotificationFactory != null)
      {
        return theNotificationFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new NotificationFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case NotificationPackage.NOTIFICATION_SCHEME: return createNotificationScheme();
      case NotificationPackage.NOTIFICATION_DEFINITION: return createNotificationDefinition();
      case NotificationPackage.NOTIFICATION_RECIPIENTS: return createNotificationRecipients();
      case NotificationPackage.CUSTOM_RECIPIENT: return createCustomRecipient();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationScheme createNotificationScheme()
  {
       	/* begin IONA modification */
    	//NotificationSchemeImpl notificationScheme = new NotificationSchemeImpl();
    	NotificationScheme notificationScheme = new NotificationSchemeImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = notificationScheme.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(notificationScheme, new Object[] {"NotificationScheme-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = notificationScheme.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(notificationScheme, new Object[] {"NotificationScheme"});
            Method factoryFlagSetter = notificationScheme.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(notificationScheme, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = notificationScheme.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(notificationScheme, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = notificationScheme.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(notificationScheme, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return notificationScheme;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationDefinition createNotificationDefinition()
  {
       	/* begin IONA modification */
    	//NotificationDefinitionImpl notificationDefinition = new NotificationDefinitionImpl();
    	NotificationDefinition notificationDefinition = new NotificationDefinitionImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = notificationDefinition.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(notificationDefinition, new Object[] {"NotificationDefinition-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = notificationDefinition.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(notificationDefinition, new Object[] {"NotificationDefinition"});
            Method factoryFlagSetter = notificationDefinition.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(notificationDefinition, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = notificationDefinition.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(notificationDefinition, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = notificationDefinition.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(notificationDefinition, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return notificationDefinition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationRecipients createNotificationRecipients()
  {
       	/* begin IONA modification */
    	//NotificationRecipientsImpl notificationRecipients = new NotificationRecipientsImpl();
    	NotificationRecipients notificationRecipients = new NotificationRecipientsImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = notificationRecipients.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(notificationRecipients, new Object[] {"NotificationRecipients-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = notificationRecipients.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(notificationRecipients, new Object[] {"NotificationRecipients"});
            Method factoryFlagSetter = notificationRecipients.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(notificationRecipients, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = notificationRecipients.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(notificationRecipients, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = notificationRecipients.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(notificationRecipients, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return notificationRecipients;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CustomRecipient createCustomRecipient()
  {
       	/* begin IONA modification */
    	//CustomRecipientImpl customRecipient = new CustomRecipientImpl();
    	CustomRecipient customRecipient = new CustomRecipientImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = customRecipient.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(customRecipient, new Object[] {"CustomRecipient-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = customRecipient.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(customRecipient, new Object[] {"CustomRecipient"});
            Method factoryFlagSetter = customRecipient.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(customRecipient, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = customRecipient.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(customRecipient, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = customRecipient.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(customRecipient, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return customRecipient;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationPackage getNotificationPackage()
  {
    return (NotificationPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static NotificationPackage getPackage()
  {
    return NotificationPackage.eINSTANCE;
  }

} //NotificationFactoryImpl


