/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.notification.impl;

import com.iona.soa.model.notification.CustomRecipient;
import com.iona.soa.model.notification.NotificationPackage;
import com.iona.soa.model.notification.NotificationRecipients;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.User;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Recipients</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.notification.impl.NotificationRecipientsImpl#getUsers <em>Users</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.impl.NotificationRecipientsImpl#getEmailAddresses <em>Email Addresses</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.impl.NotificationRecipientsImpl#getCustomRecipients <em>Custom Recipients</em>}</li>
 *   <li>{@link com.iona.soa.model.notification.impl.NotificationRecipientsImpl#isNotifySubscribers <em>Notify Subscribers</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class NotificationRecipientsImpl extends IPersistableObjectImpl implements NotificationRecipients
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached value of the '{@link #getUsers() <em>Users</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUsers()
   * @generated
   * @ordered
   */
  protected EList<User> users;

  /**
   * The cached value of the '{@link #getEmailAddresses() <em>Email Addresses</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEmailAddresses()
   * @generated
   * @ordered
   */
  protected EList<String> emailAddresses;

  /**
   * The cached value of the '{@link #getCustomRecipients() <em>Custom Recipients</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCustomRecipients()
   * @generated
   * @ordered
   */
  protected EList<CustomRecipient> customRecipients;

  /**
   * The default value of the '{@link #isNotifySubscribers() <em>Notify Subscribers</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isNotifySubscribers()
   * @generated
   * @ordered
   */
  protected static final boolean NOTIFY_SUBSCRIBERS_EDEFAULT = true;

  /**
   * The cached value of the '{@link #isNotifySubscribers() <em>Notify Subscribers</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isNotifySubscribers()
   * @generated
   * @ordered
   */
  protected boolean notifySubscribers = NOTIFY_SUBSCRIBERS_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NotificationRecipientsImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return NotificationPackage.Literals.NOTIFICATION_RECIPIENTS;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<User> getUsers() {
    autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__USERS);
    return _basicGetUsers();
  }
  
  private final EList<User> _basicGetUsers() {
    if (users == null)
    {
      users = new EObjectResolvingEList<User>(User.class, this, NotificationPackage.NOTIFICATION_RECIPIENTS__USERS);
    }
    return users;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getEmailAddresses() {
    autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES);
    return _basicGetEmailAddresses();
  }
  
  private final EList<String> _basicGetEmailAddresses() {
    if (emailAddresses == null)
    {
      emailAddresses = new EDataTypeUniqueEList<String>(String.class, this, NotificationPackage.NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES);
    }
    return emailAddresses;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<CustomRecipient> getCustomRecipients() {
    autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS);
    return _basicGetCustomRecipients();
  }
  
  private final EList<CustomRecipient> _basicGetCustomRecipients() {
    if (customRecipients == null)
    {
      customRecipients = new EObjectResolvingEList<CustomRecipient>(CustomRecipient.class, this, NotificationPackage.NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS);
    }
    return customRecipients;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isNotifySubscribers() {
    autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS);
    return _basicGetNotifySubscribers();
  }
  
  private final boolean _basicGetNotifySubscribers() {
    return notifySubscribers;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNotifySubscribers(boolean newNotifySubscribers)
  {
    
    boolean oldNotifySubscribers = notifySubscribers;
    notifySubscribers = newNotifySubscribers;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, NotificationPackage.NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS, oldNotifySubscribers, notifySubscribers));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case NotificationPackage.NOTIFICATION_RECIPIENTS__USERS:
      if (resolve) { autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__USERS); }
        return _basicGetUsers();
      case NotificationPackage.NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES:
      if (resolve) { autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES); }
        return _basicGetEmailAddresses();
      case NotificationPackage.NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS:
      if (resolve) { autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS); }
        return _basicGetCustomRecipients();
      case NotificationPackage.NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS:
      if (resolve) { autoResolveEProxy(NotificationPackage.Literals.NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS); }
        return _basicGetNotifySubscribers() ? Boolean.TRUE : Boolean.FALSE;
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case NotificationPackage.NOTIFICATION_RECIPIENTS__USERS:
        _basicGetUsers().clear();
        _basicGetUsers().addAll((Collection<? extends User>)newValue);
        return;
      case NotificationPackage.NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES:
        _basicGetEmailAddresses().clear();
        _basicGetEmailAddresses().addAll((Collection<? extends String>)newValue);
        return;
      case NotificationPackage.NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS:
        _basicGetCustomRecipients().clear();
        _basicGetCustomRecipients().addAll((Collection<? extends CustomRecipient>)newValue);
        return;
      case NotificationPackage.NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS:
        setNotifySubscribers(((Boolean)newValue).booleanValue());
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case NotificationPackage.NOTIFICATION_RECIPIENTS__USERS:
      _basicGetUsers().clear();
      return;
    case NotificationPackage.NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES:
      _basicGetEmailAddresses().clear();
      return;
    case NotificationPackage.NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS:
      _basicGetCustomRecipients().clear();
      return;
    case NotificationPackage.NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS:
      setNotifySubscribers(NOTIFY_SUBSCRIBERS_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case NotificationPackage.NOTIFICATION_RECIPIENTS__USERS:
        return users != null && !users.isEmpty();
      case NotificationPackage.NOTIFICATION_RECIPIENTS__EMAIL_ADDRESSES:
        return emailAddresses != null && !emailAddresses.isEmpty();
      case NotificationPackage.NOTIFICATION_RECIPIENTS__CUSTOM_RECIPIENTS:
        return customRecipients != null && !customRecipients.isEmpty();
      case NotificationPackage.NOTIFICATION_RECIPIENTS__NOTIFY_SUBSCRIBERS:
        return notifySubscribers != NOTIFY_SUBSCRIBERS_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (emailAddresses: ");
    result.append(emailAddresses);
    result.append(", notifySubscribers: ");
    result.append(notifySubscribers);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //NotificationRecipientsImpl


