/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.notification.util;

import com.iona.soa.model.notification.*;

import com.iona.soa.model.repository.IPersistableObject;
import com.iona.soa.model.repository.IRepositoryObject;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.notification.NotificationPackage
 * @generated
 */
public class NotificationAdapterFactory extends AdapterFactoryImpl
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static NotificationPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = NotificationPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch the delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NotificationSwitch<Adapter> modelSwitch =
    new NotificationSwitch<Adapter>()
    {
      @Override
      public Adapter caseNotificationScheme(NotificationScheme object)
      {
        return createNotificationSchemeAdapter();
      }
      @Override
      public Adapter caseNotificationDefinition(NotificationDefinition object)
      {
        return createNotificationDefinitionAdapter();
      }
      @Override
      public Adapter caseNotificationRecipients(NotificationRecipients object)
      {
        return createNotificationRecipientsAdapter();
      }
      @Override
      public Adapter caseCustomRecipient(CustomRecipient object)
      {
        return createCustomRecipientAdapter();
      }
      @Override
      public Adapter caseIPersistableObject(IPersistableObject object)
      {
        return createIPersistableObjectAdapter();
      }
      @Override
      public Adapter caseIRepositoryObject(IRepositoryObject object)
      {
        return createIRepositoryObjectAdapter();
      }
      @Override
      public Adapter caseIProtectedRepositoryObject(IProtectedRepositoryObject object)
      {
        return createIProtectedRepositoryObjectAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.notification.NotificationScheme <em>Scheme</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.notification.NotificationScheme
   * @generated
   */
  public Adapter createNotificationSchemeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.notification.NotificationDefinition <em>Definition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.notification.NotificationDefinition
   * @generated
   */
  public Adapter createNotificationDefinitionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.notification.NotificationRecipients <em>Recipients</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.notification.NotificationRecipients
   * @generated
   */
  public Adapter createNotificationRecipientsAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.notification.CustomRecipient <em>Custom Recipient</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.notification.CustomRecipient
   * @generated
   */
  public Adapter createCustomRecipientAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IPersistableObject <em>IPersistable Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IPersistableObject
   * @generated
   */
  public Adapter createIPersistableObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IRepositoryObject <em>IRepository Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IRepositoryObject
   * @generated
   */
  public Adapter createIRepositoryObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.security.IProtectedRepositoryObject <em>IProtected Repository Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.security.IProtectedRepositoryObject
   * @generated
   */
  public Adapter createIProtectedRepositoryObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //NotificationAdapterFactory
