/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.repository;

import java.sql.Timestamp;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>IPersistable Object</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.repository.IPersistableObject#getGuid <em>Guid</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.IPersistableObject#getGenerationNumber <em>Generation Number</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.IPersistableObject#isModifiable <em>Modifiable</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.IPersistableObject#isInternal <em>Internal</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.IPersistableObject#getLastEditedBy <em>Last Edited By</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.IPersistableObject#getTimestamp <em>Timestamp</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.IPersistableObject#getCreatedBy <em>Created By</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject()
 * @model abstract="true"
 *        annotation="dbhints hierarchy='subclass'"
 *        annotation="delete predicate='equals(modifiable, true)'"
 * @generated
 */
public interface IPersistableObject extends EObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Guid</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Guid</em>' attribute.
   * @see #setGuid(String)
   * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject_Guid()
   * @model id="true" required="true"
   * @generated
   */
  String getGuid();


  /**
   * Sets the value of the '{@link com.iona.soa.model.repository.IPersistableObject#getGuid <em>Guid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Guid</em>' attribute.
   * @see #getGuid()
   * @generated
   */
  void setGuid(String value);

  /**
   * Returns the value of the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Generation Number</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Generation Number</em>' attribute.
   * @see #setGenerationNumber(long)
   * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject_GenerationNumber()
   * @model required="true"
   * @generated
   */
  long getGenerationNumber();


  /**
   * Sets the value of the '{@link com.iona.soa.model.repository.IPersistableObject#getGenerationNumber <em>Generation Number</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Generation Number</em>' attribute.
   * @see #getGenerationNumber()
   * @generated
   */
  void setGenerationNumber(long value);

  /**
   * Returns the value of the '<em><b>Modifiable</b></em>' attribute.
   * The default value is <code>"true"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Modifiable</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Modifiable</em>' attribute.
   * @see #setModifiable(boolean)
   * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject_Modifiable()
   * @model default="true" required="true"
   * @generated
   */
  boolean isModifiable();


  /**
   * Sets the value of the '{@link com.iona.soa.model.repository.IPersistableObject#isModifiable <em>Modifiable</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Modifiable</em>' attribute.
   * @see #isModifiable()
   * @generated
   */
  void setModifiable(boolean value);

  /**
   * Returns the value of the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Internal</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Internal</em>' attribute.
   * @see #setInternal(boolean)
   * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject_Internal()
   * @model required="true"
   * @generated
   */
  boolean isInternal();


  /**
   * Sets the value of the '{@link com.iona.soa.model.repository.IPersistableObject#isInternal <em>Internal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Internal</em>' attribute.
   * @see #isInternal()
   * @generated
   */
  void setInternal(boolean value);

  /**
   * Returns the value of the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Last Edited By</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Last Edited By</em>' attribute.
   * @see #setLastEditedBy(String)
   * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject_LastEditedBy()
   * @model
   * @generated
   */
  String getLastEditedBy();


  /**
   * Sets the value of the '{@link com.iona.soa.model.repository.IPersistableObject#getLastEditedBy <em>Last Edited By</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Last Edited By</em>' attribute.
   * @see #getLastEditedBy()
   * @generated
   */
  void setLastEditedBy(String value);

  /**
   * Returns the value of the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Timestamp</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Timestamp</em>' attribute.
   * @see #setTimestamp(Timestamp)
   * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject_Timestamp()
   * @model dataType="com.iona.soa.model.repository.Timestamp" required="true"
   * @generated
   */
  Timestamp getTimestamp();


  /**
   * Sets the value of the '{@link com.iona.soa.model.repository.IPersistableObject#getTimestamp <em>Timestamp</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Timestamp</em>' attribute.
   * @see #getTimestamp()
   * @generated
   */
  void setTimestamp(Timestamp value);

  /**
   * Returns the value of the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Created By</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Created By</em>' attribute.
   * @see #setCreatedBy(String)
   * @see com.iona.soa.model.repository.RepositoryPackage#getIPersistableObject_CreatedBy()
   * @model
   * @generated
   */
  String getCreatedBy();


  /**
   * Sets the value of the '{@link com.iona.soa.model.repository.IPersistableObject#getCreatedBy <em>Created By</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Created By</em>' attribute.
   * @see #getCreatedBy()
   * @generated
   */
  void setCreatedBy(String value);

} // IPersistableObject


