/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.repository;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.repository.RepositoryFactory
 * @model kind="package"
 * @generated
 */
public interface RepositoryPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "repository";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.repository";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itrepo";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  RepositoryPackage eINSTANCE = com.iona.soa.model.repository.impl.RepositoryPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl <em>IPersistable Object</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.impl.IPersistableObjectImpl
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIPersistableObject()
   * @generated
   */
  int IPERSISTABLE_OBJECT = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT__GUID = 0;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT__GENERATION_NUMBER = 1;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT__MODIFIABLE = 2;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT__INTERNAL = 3;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT__LAST_EDITED_BY = 4;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT__TIMESTAMP = 5;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT__CREATED_BY = 6;

  /**
   * The number of structural features of the '<em>IPersistable Object</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPERSISTABLE_OBJECT_FEATURE_COUNT = 7;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.IRepositoryObject <em>IRepository Object</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.IRepositoryObject
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIRepositoryObject()
   * @generated
   */
  int IREPOSITORY_OBJECT = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__NAME = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__NAMESPACE = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT__DESCRIPTION = IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>IRepository Object</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IREPOSITORY_OBJECT_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.impl.PropertyImpl <em>Property</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.impl.PropertyImpl
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getProperty()
   * @generated
   */
  int PROPERTY = 2;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__NAME = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__VALUE = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Property</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.impl.IPropertiesImpl <em>IProperties</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.impl.IPropertiesImpl
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIProperties()
   * @generated
   */
  int IPROPERTIES = 3;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES__PROPERTIES = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>IProperties</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROPERTIES_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.impl.ModelMetadataImpl <em>Model Metadata</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.impl.ModelMetadataImpl
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getModelMetadata()
   * @generated
   */
  int MODEL_METADATA = 4;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__PROPERTIES = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Schema Version</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA__SCHEMA_VERSION = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Model Metadata</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_METADATA_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.impl.VersionImpl <em>Version</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.impl.VersionImpl
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getVersion()
   * @generated
   */
  int VERSION = 5;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Major</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__MAJOR = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Minor</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__MINOR = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Micro</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__MICRO = IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Nano</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__NANO = IPERSISTABLE_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Qualifier</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__QUALIFIER = IPERSISTABLE_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__DESCRIPTION = IPERSISTABLE_OBJECT_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Tracker</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__TRACKER = IPERSISTABLE_OBJECT_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>Original String</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION__ORIGINAL_STRING = IPERSISTABLE_OBJECT_FEATURE_COUNT + 7;

  /**
   * The number of structural features of the '<em>Version</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 8;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.impl.VersionTrackerImpl <em>Version Tracker</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.impl.VersionTrackerImpl
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getVersionTracker()
   * @generated
   */
  int VERSION_TRACKER = 6;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Versions</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER__VERSIONS = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Version Tracker</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VERSION_TRACKER_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.IVersionedObject <em>IVersioned Object</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.IVersionedObject
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIVersionedObject()
   * @generated
   */
  int IVERSIONED_OBJECT = 7;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Version</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT__VERSION = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>IVersioned Object</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IVERSIONED_OBJECT_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.impl.AuditEventImpl <em>Audit Event</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.impl.AuditEventImpl
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getAuditEvent()
   * @generated
   */
  int AUDIT_EVENT = 8;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__GUID = IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__GENERATION_NUMBER = IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__MODIFIABLE = IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__INTERNAL = IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__LAST_EDITED_BY = IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__TIMESTAMP = IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__CREATED_BY = IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Target Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__TARGET_GUID = IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Message</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__MESSAGE = IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Level</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT__LEVEL = IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Audit Event</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AUDIT_EVENT_FEATURE_COUNT = IPERSISTABLE_OBJECT_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link com.iona.soa.model.repository.AuditLevel <em>Audit Level</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.repository.AuditLevel
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getAuditLevel()
   * @generated
   */
  int AUDIT_LEVEL = 9;

  /**
   * The meta object id for the '<em>Timestamp</em>' data type.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see java.sql.Timestamp
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getTimestamp()
   * @generated
   */
  int TIMESTAMP = 10;

  /**
   * The meta object id for the '<em>URI</em>' data type.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see java.net.URI
   * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getURI()
   * @generated
   */
  int URI = 11;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.IRepositoryObject <em>IRepository Object</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IRepository Object</em>'.
   * @see com.iona.soa.model.repository.IRepositoryObject
   * @generated
   */
  EClass getIRepositoryObject();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IRepositoryObject#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see com.iona.soa.model.repository.IRepositoryObject#getName()
   * @see #getIRepositoryObject()
   * @generated
   */
  EAttribute getIRepositoryObject_Name();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IRepositoryObject#getNamespace <em>Namespace</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Namespace</em>'.
   * @see com.iona.soa.model.repository.IRepositoryObject#getNamespace()
   * @see #getIRepositoryObject()
   * @generated
   */
  EAttribute getIRepositoryObject_Namespace();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IRepositoryObject#getDescription <em>Description</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Description</em>'.
   * @see com.iona.soa.model.repository.IRepositoryObject#getDescription()
   * @see #getIRepositoryObject()
   * @generated
   */
  EAttribute getIRepositoryObject_Description();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.IPersistableObject <em>IPersistable Object</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IPersistable Object</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject
   * @generated
   */
  EClass getIPersistableObject();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IPersistableObject#getGuid <em>Guid</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Guid</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject#getGuid()
   * @see #getIPersistableObject()
   * @generated
   */
  EAttribute getIPersistableObject_Guid();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IPersistableObject#getGenerationNumber <em>Generation Number</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Generation Number</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject#getGenerationNumber()
   * @see #getIPersistableObject()
   * @generated
   */
  EAttribute getIPersistableObject_GenerationNumber();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IPersistableObject#isModifiable <em>Modifiable</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Modifiable</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject#isModifiable()
   * @see #getIPersistableObject()
   * @generated
   */
  EAttribute getIPersistableObject_Modifiable();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IPersistableObject#isInternal <em>Internal</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Internal</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject#isInternal()
   * @see #getIPersistableObject()
   * @generated
   */
  EAttribute getIPersistableObject_Internal();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IPersistableObject#getLastEditedBy <em>Last Edited By</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Last Edited By</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject#getLastEditedBy()
   * @see #getIPersistableObject()
   * @generated
   */
  EAttribute getIPersistableObject_LastEditedBy();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IPersistableObject#getTimestamp <em>Timestamp</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Timestamp</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject#getTimestamp()
   * @see #getIPersistableObject()
   * @generated
   */
  EAttribute getIPersistableObject_Timestamp();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.IPersistableObject#getCreatedBy <em>Created By</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Created By</em>'.
   * @see com.iona.soa.model.repository.IPersistableObject#getCreatedBy()
   * @see #getIPersistableObject()
   * @generated
   */
  EAttribute getIPersistableObject_CreatedBy();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.Property <em>Property</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Property</em>'.
   * @see com.iona.soa.model.repository.Property
   * @generated
   */
  EClass getProperty();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Property#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see com.iona.soa.model.repository.Property#getName()
   * @see #getProperty()
   * @generated
   */
  EAttribute getProperty_Name();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Property#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see com.iona.soa.model.repository.Property#getValue()
   * @see #getProperty()
   * @generated
   */
  EAttribute getProperty_Value();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.IProperties <em>IProperties</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IProperties</em>'.
   * @see com.iona.soa.model.repository.IProperties
   * @generated
   */
  EClass getIProperties();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.repository.IProperties#getProperties <em>Properties</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Properties</em>'.
   * @see com.iona.soa.model.repository.IProperties#getProperties()
   * @see #getIProperties()
   * @generated
   */
  EReference getIProperties_Properties();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.ModelMetadata <em>Model Metadata</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Model Metadata</em>'.
   * @see com.iona.soa.model.repository.ModelMetadata
   * @generated
   */
  EClass getModelMetadata();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.ModelMetadata#getSchemaVersion <em>Schema Version</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Schema Version</em>'.
   * @see com.iona.soa.model.repository.ModelMetadata#getSchemaVersion()
   * @see #getModelMetadata()
   * @generated
   */
  EAttribute getModelMetadata_SchemaVersion();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.Version <em>Version</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Version</em>'.
   * @see com.iona.soa.model.repository.Version
   * @generated
   */
  EClass getVersion();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Version#getMajor <em>Major</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Major</em>'.
   * @see com.iona.soa.model.repository.Version#getMajor()
   * @see #getVersion()
   * @generated
   */
  EAttribute getVersion_Major();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Version#getMinor <em>Minor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Minor</em>'.
   * @see com.iona.soa.model.repository.Version#getMinor()
   * @see #getVersion()
   * @generated
   */
  EAttribute getVersion_Minor();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Version#getMicro <em>Micro</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Micro</em>'.
   * @see com.iona.soa.model.repository.Version#getMicro()
   * @see #getVersion()
   * @generated
   */
  EAttribute getVersion_Micro();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Version#getNano <em>Nano</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Nano</em>'.
   * @see com.iona.soa.model.repository.Version#getNano()
   * @see #getVersion()
   * @generated
   */
  EAttribute getVersion_Nano();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Version#getQualifier <em>Qualifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Qualifier</em>'.
   * @see com.iona.soa.model.repository.Version#getQualifier()
   * @see #getVersion()
   * @generated
   */
  EAttribute getVersion_Qualifier();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Version#getDescription <em>Description</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Description</em>'.
   * @see com.iona.soa.model.repository.Version#getDescription()
   * @see #getVersion()
   * @generated
   */
  EAttribute getVersion_Description();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.repository.Version#getTracker <em>Tracker</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Tracker</em>'.
   * @see com.iona.soa.model.repository.Version#getTracker()
   * @see #getVersion()
   * @generated
   */
  EReference getVersion_Tracker();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.Version#getOriginalString <em>Original String</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Original String</em>'.
   * @see com.iona.soa.model.repository.Version#getOriginalString()
   * @see #getVersion()
   * @generated
   */
  EAttribute getVersion_OriginalString();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.VersionTracker <em>Version Tracker</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Version Tracker</em>'.
   * @see com.iona.soa.model.repository.VersionTracker
   * @generated
   */
  EClass getVersionTracker();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.repository.VersionTracker#getVersions <em>Versions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Versions</em>'.
   * @see com.iona.soa.model.repository.VersionTracker#getVersions()
   * @see #getVersionTracker()
   * @generated
   */
  EReference getVersionTracker_Versions();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.IVersionedObject <em>IVersioned Object</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IVersioned Object</em>'.
   * @see com.iona.soa.model.repository.IVersionedObject
   * @generated
   */
  EClass getIVersionedObject();

  /**
   * Returns the meta object for the containment reference '{@link com.iona.soa.model.repository.IVersionedObject#getVersion <em>Version</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Version</em>'.
   * @see com.iona.soa.model.repository.IVersionedObject#getVersion()
   * @see #getIVersionedObject()
   * @generated
   */
  EReference getIVersionedObject_Version();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.repository.AuditEvent <em>Audit Event</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Audit Event</em>'.
   * @see com.iona.soa.model.repository.AuditEvent
   * @generated
   */
  EClass getAuditEvent();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.AuditEvent#getTargetGuid <em>Target Guid</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Target Guid</em>'.
   * @see com.iona.soa.model.repository.AuditEvent#getTargetGuid()
   * @see #getAuditEvent()
   * @generated
   */
  EAttribute getAuditEvent_TargetGuid();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.AuditEvent#getMessage <em>Message</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Message</em>'.
   * @see com.iona.soa.model.repository.AuditEvent#getMessage()
   * @see #getAuditEvent()
   * @generated
   */
  EAttribute getAuditEvent_Message();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.repository.AuditEvent#getLevel <em>Level</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Level</em>'.
   * @see com.iona.soa.model.repository.AuditEvent#getLevel()
   * @see #getAuditEvent()
   * @generated
   */
  EAttribute getAuditEvent_Level();

  /**
   * Returns the meta object for enum '{@link com.iona.soa.model.repository.AuditLevel <em>Audit Level</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Audit Level</em>'.
   * @see com.iona.soa.model.repository.AuditLevel
   * @generated
   */
  EEnum getAuditLevel();

  /**
   * Returns the meta object for data type '{@link java.sql.Timestamp <em>Timestamp</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for data type '<em>Timestamp</em>'.
   * @see java.sql.Timestamp
   * @model instanceClass="java.sql.Timestamp"
   * @generated
   */
  EDataType getTimestamp();

  /**
   * Returns the meta object for data type '{@link java.net.URI <em>URI</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for data type '<em>URI</em>'.
   * @see java.net.URI
   * @model instanceClass="java.net.URI"
   *        annotation="dbhints serialization='toString'"
   * @generated
   */
  EDataType getURI();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  RepositoryFactory getRepositoryFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.IRepositoryObject <em>IRepository Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.IRepositoryObject
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIRepositoryObject()
     * @generated
     */
    EClass IREPOSITORY_OBJECT = eINSTANCE.getIRepositoryObject();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IREPOSITORY_OBJECT__NAME = eINSTANCE.getIRepositoryObject_Name();

    /**
     * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IREPOSITORY_OBJECT__NAMESPACE = eINSTANCE.getIRepositoryObject_Namespace();

    /**
     * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IREPOSITORY_OBJECT__DESCRIPTION = eINSTANCE.getIRepositoryObject_Description();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl <em>IPersistable Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.impl.IPersistableObjectImpl
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIPersistableObject()
     * @generated
     */
    EClass IPERSISTABLE_OBJECT = eINSTANCE.getIPersistableObject();

    /**
     * The meta object literal for the '<em><b>Guid</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IPERSISTABLE_OBJECT__GUID = eINSTANCE.getIPersistableObject_Guid();

    /**
     * The meta object literal for the '<em><b>Generation Number</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IPERSISTABLE_OBJECT__GENERATION_NUMBER = eINSTANCE.getIPersistableObject_GenerationNumber();

    /**
     * The meta object literal for the '<em><b>Modifiable</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IPERSISTABLE_OBJECT__MODIFIABLE = eINSTANCE.getIPersistableObject_Modifiable();

    /**
     * The meta object literal for the '<em><b>Internal</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IPERSISTABLE_OBJECT__INTERNAL = eINSTANCE.getIPersistableObject_Internal();

    /**
     * The meta object literal for the '<em><b>Last Edited By</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IPERSISTABLE_OBJECT__LAST_EDITED_BY = eINSTANCE.getIPersistableObject_LastEditedBy();

    /**
     * The meta object literal for the '<em><b>Timestamp</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IPERSISTABLE_OBJECT__TIMESTAMP = eINSTANCE.getIPersistableObject_Timestamp();

    /**
     * The meta object literal for the '<em><b>Created By</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute IPERSISTABLE_OBJECT__CREATED_BY = eINSTANCE.getIPersistableObject_CreatedBy();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.impl.PropertyImpl <em>Property</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.impl.PropertyImpl
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getProperty()
     * @generated
     */
    EClass PROPERTY = eINSTANCE.getProperty();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROPERTY__NAME = eINSTANCE.getProperty_Name();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROPERTY__VALUE = eINSTANCE.getProperty_Value();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.impl.IPropertiesImpl <em>IProperties</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.impl.IPropertiesImpl
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIProperties()
     * @generated
     */
    EClass IPROPERTIES = eINSTANCE.getIProperties();

    /**
     * The meta object literal for the '<em><b>Properties</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IPROPERTIES__PROPERTIES = eINSTANCE.getIProperties_Properties();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.impl.ModelMetadataImpl <em>Model Metadata</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.impl.ModelMetadataImpl
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getModelMetadata()
     * @generated
     */
    EClass MODEL_METADATA = eINSTANCE.getModelMetadata();

    /**
     * The meta object literal for the '<em><b>Schema Version</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MODEL_METADATA__SCHEMA_VERSION = eINSTANCE.getModelMetadata_SchemaVersion();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.impl.VersionImpl <em>Version</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.impl.VersionImpl
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getVersion()
     * @generated
     */
    EClass VERSION = eINSTANCE.getVersion();

    /**
     * The meta object literal for the '<em><b>Major</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSION__MAJOR = eINSTANCE.getVersion_Major();

    /**
     * The meta object literal for the '<em><b>Minor</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSION__MINOR = eINSTANCE.getVersion_Minor();

    /**
     * The meta object literal for the '<em><b>Micro</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSION__MICRO = eINSTANCE.getVersion_Micro();

    /**
     * The meta object literal for the '<em><b>Nano</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSION__NANO = eINSTANCE.getVersion_Nano();

    /**
     * The meta object literal for the '<em><b>Qualifier</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSION__QUALIFIER = eINSTANCE.getVersion_Qualifier();

    /**
     * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSION__DESCRIPTION = eINSTANCE.getVersion_Description();

    /**
     * The meta object literal for the '<em><b>Tracker</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference VERSION__TRACKER = eINSTANCE.getVersion_Tracker();

    /**
     * The meta object literal for the '<em><b>Original String</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VERSION__ORIGINAL_STRING = eINSTANCE.getVersion_OriginalString();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.impl.VersionTrackerImpl <em>Version Tracker</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.impl.VersionTrackerImpl
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getVersionTracker()
     * @generated
     */
    EClass VERSION_TRACKER = eINSTANCE.getVersionTracker();

    /**
     * The meta object literal for the '<em><b>Versions</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference VERSION_TRACKER__VERSIONS = eINSTANCE.getVersionTracker_Versions();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.IVersionedObject <em>IVersioned Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.IVersionedObject
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getIVersionedObject()
     * @generated
     */
    EClass IVERSIONED_OBJECT = eINSTANCE.getIVersionedObject();

    /**
     * The meta object literal for the '<em><b>Version</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IVERSIONED_OBJECT__VERSION = eINSTANCE.getIVersionedObject_Version();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.impl.AuditEventImpl <em>Audit Event</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.impl.AuditEventImpl
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getAuditEvent()
     * @generated
     */
    EClass AUDIT_EVENT = eINSTANCE.getAuditEvent();

    /**
     * The meta object literal for the '<em><b>Target Guid</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute AUDIT_EVENT__TARGET_GUID = eINSTANCE.getAuditEvent_TargetGuid();

    /**
     * The meta object literal for the '<em><b>Message</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute AUDIT_EVENT__MESSAGE = eINSTANCE.getAuditEvent_Message();

    /**
     * The meta object literal for the '<em><b>Level</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute AUDIT_EVENT__LEVEL = eINSTANCE.getAuditEvent_Level();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.repository.AuditLevel <em>Audit Level</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.repository.AuditLevel
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getAuditLevel()
     * @generated
     */
    EEnum AUDIT_LEVEL = eINSTANCE.getAuditLevel();

    /**
     * The meta object literal for the '<em>Timestamp</em>' data type.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see java.sql.Timestamp
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getTimestamp()
     * @generated
     */
    EDataType TIMESTAMP = eINSTANCE.getTimestamp();

    /**
     * The meta object literal for the '<em>URI</em>' data type.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see java.net.URI
     * @see com.iona.soa.model.repository.impl.RepositoryPackageImpl#getURI()
     * @generated
     */
    EDataType URI = eINSTANCE.getURI();

  }

} //RepositoryPackage
