/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.repository.impl;

import com.iona.soa.model.datatypes.DanglingProxyAdapter;

import com.iona.soa.model.repository.IPersistableObject;
import com.iona.soa.model.repository.RepositoryPackage;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

import java.sql.Timestamp;

import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.resource.Resource;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>IPersistable Object</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl#getGuid <em>Guid</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl#getGenerationNumber <em>Generation Number</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl#isModifiable <em>Modifiable</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl#isInternal <em>Internal</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl#getLastEditedBy <em>Last Edited By</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl#getTimestamp <em>Timestamp</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.IPersistableObjectImpl#getCreatedBy <em>Created By</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class IPersistableObjectImpl extends EObjectImpl implements IPersistableObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getGuid() <em>Guid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGuid()
   * @generated
   * @ordered
   */
  protected static final String GUID_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getGuid() <em>Guid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGuid()
   * @generated
   * @ordered
   */
  protected String guid = GUID_EDEFAULT;

  /**
   * The default value of the '{@link #getGenerationNumber() <em>Generation Number</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGenerationNumber()
   * @generated
   * @ordered
   */
  protected static final long GENERATION_NUMBER_EDEFAULT = 0L;

  /**
   * The cached value of the '{@link #getGenerationNumber() <em>Generation Number</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGenerationNumber()
   * @generated
   * @ordered
   */
  protected long generationNumber = GENERATION_NUMBER_EDEFAULT;

  /**
   * The default value of the '{@link #isModifiable() <em>Modifiable</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isModifiable()
   * @generated
   * @ordered
   */
  protected static final boolean MODIFIABLE_EDEFAULT = true;

  /**
   * The cached value of the '{@link #isModifiable() <em>Modifiable</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isModifiable()
   * @generated
   * @ordered
   */
  protected boolean modifiable = MODIFIABLE_EDEFAULT;

  /**
   * The default value of the '{@link #isInternal() <em>Internal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isInternal()
   * @generated
   * @ordered
   */
  protected static final boolean INTERNAL_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isInternal() <em>Internal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isInternal()
   * @generated
   * @ordered
   */
  protected boolean internal = INTERNAL_EDEFAULT;

  /**
   * The default value of the '{@link #getLastEditedBy() <em>Last Edited By</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLastEditedBy()
   * @generated
   * @ordered
   */
  protected static final String LAST_EDITED_BY_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getLastEditedBy() <em>Last Edited By</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLastEditedBy()
   * @generated
   * @ordered
   */
  protected String lastEditedBy = LAST_EDITED_BY_EDEFAULT;

  /**
   * The default value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimestamp()
   * @generated
   * @ordered
   */
  protected static final Timestamp TIMESTAMP_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimestamp()
   * @generated
   * @ordered
   */
  protected Timestamp timestamp = TIMESTAMP_EDEFAULT;

  /**
   * The default value of the '{@link #getCreatedBy() <em>Created By</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCreatedBy()
   * @generated
   * @ordered
   */
  protected static final String CREATED_BY_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getCreatedBy() <em>Created By</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCreatedBy()
   * @generated
   * @ordered
   */
  protected String createdBy = CREATED_BY_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IPersistableObjectImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return RepositoryPackage.Literals.IPERSISTABLE_OBJECT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getGuid() {
    autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__GUID);
    return _basicGetGuid();
  }
  
  private final String _basicGetGuid() {
    return guid;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setGuid(String newGuid)
  {
    
    String oldGuid = guid;
    guid = newGuid;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.IPERSISTABLE_OBJECT__GUID, oldGuid, guid));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public long getGenerationNumber() {
    autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__GENERATION_NUMBER);
    return _basicGetGenerationNumber();
  }
  
  private final long _basicGetGenerationNumber() {
    return generationNumber;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setGenerationNumber(long newGenerationNumber)
  {
    
    long oldGenerationNumber = generationNumber;
    generationNumber = newGenerationNumber;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER, oldGenerationNumber, generationNumber));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isModifiable() {
    autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__MODIFIABLE);
    return _basicGetModifiable();
  }
  
  private final boolean _basicGetModifiable() {
    return modifiable;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setModifiable(boolean newModifiable)
  {
    
    boolean oldModifiable = modifiable;
    modifiable = newModifiable;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE, oldModifiable, modifiable));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isInternal() {
    autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__INTERNAL);
    return _basicGetInternal();
  }
  
  private final boolean _basicGetInternal() {
    return internal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setInternal(boolean newInternal)
  {
    
    boolean oldInternal = internal;
    internal = newInternal;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL, oldInternal, internal));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLastEditedBy() {
    autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__LAST_EDITED_BY);
    return _basicGetLastEditedBy();
  }
  
  private final String _basicGetLastEditedBy() {
    return lastEditedBy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLastEditedBy(String newLastEditedBy)
  {
    
    String oldLastEditedBy = lastEditedBy;
    lastEditedBy = newLastEditedBy;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY, oldLastEditedBy, lastEditedBy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp getTimestamp() {
    autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__TIMESTAMP);
    return _basicGetTimestamp();
  }
  
  private final Timestamp _basicGetTimestamp() {
    return timestamp;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTimestamp(Timestamp newTimestamp)
  {
    
    Timestamp oldTimestamp = timestamp;
    timestamp = newTimestamp;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP, oldTimestamp, timestamp));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCreatedBy() {
    autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__CREATED_BY);
    return _basicGetCreatedBy();
  }
  
  private final String _basicGetCreatedBy() {
    return createdBy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCreatedBy(String newCreatedBy)
  {
    
    String oldCreatedBy = createdBy;
    createdBy = newCreatedBy;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY, oldCreatedBy, createdBy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case RepositoryPackage.IPERSISTABLE_OBJECT__GUID:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__GUID); }
        return _basicGetGuid();
      case RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__GENERATION_NUMBER); }
        return new Long(_basicGetGenerationNumber());
      case RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__MODIFIABLE); }
        return _basicGetModifiable() ? Boolean.TRUE : Boolean.FALSE;
      case RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__INTERNAL); }
        return _basicGetInternal() ? Boolean.TRUE : Boolean.FALSE;
      case RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__LAST_EDITED_BY); }
        return _basicGetLastEditedBy();
      case RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__TIMESTAMP); }
        return _basicGetTimestamp();
      case RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPERSISTABLE_OBJECT__CREATED_BY); }
        return _basicGetCreatedBy();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case RepositoryPackage.IPERSISTABLE_OBJECT__GUID:
        setGuid((String)newValue);
        return;
      case RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER:
        setGenerationNumber(((Long)newValue).longValue());
        return;
      case RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE:
        setModifiable(((Boolean)newValue).booleanValue());
        return;
      case RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL:
        setInternal(((Boolean)newValue).booleanValue());
        return;
      case RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY:
        setLastEditedBy((String)newValue);
        return;
      case RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP:
        setTimestamp((Timestamp)newValue);
        return;
      case RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY:
        setCreatedBy((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case RepositoryPackage.IPERSISTABLE_OBJECT__GUID:
      setGuid(GUID_EDEFAULT);
      return;
    case RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER:
      setGenerationNumber(GENERATION_NUMBER_EDEFAULT);
      return;
    case RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE:
      setModifiable(MODIFIABLE_EDEFAULT);
      return;
    case RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL:
      setInternal(INTERNAL_EDEFAULT);
      return;
    case RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY:
      setLastEditedBy(LAST_EDITED_BY_EDEFAULT);
      return;
    case RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP:
      setTimestamp(TIMESTAMP_EDEFAULT);
      return;
    case RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY:
      setCreatedBy(CREATED_BY_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case RepositoryPackage.IPERSISTABLE_OBJECT__GUID:
        return GUID_EDEFAULT == null ? guid != null : !GUID_EDEFAULT.equals(guid);
      case RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER:
        return generationNumber != GENERATION_NUMBER_EDEFAULT;
      case RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE:
        return modifiable != MODIFIABLE_EDEFAULT;
      case RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL:
        return internal != INTERNAL_EDEFAULT;
      case RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY:
        return LAST_EDITED_BY_EDEFAULT == null ? lastEditedBy != null : !LAST_EDITED_BY_EDEFAULT.equals(lastEditedBy);
      case RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP:
        return TIMESTAMP_EDEFAULT == null ? timestamp != null : !TIMESTAMP_EDEFAULT.equals(timestamp);
      case RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY:
        return CREATED_BY_EDEFAULT == null ? createdBy != null : !CREATED_BY_EDEFAULT.equals(createdBy);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (guid: ");
    result.append(guid);
    result.append(", generationNumber: ");
    result.append(generationNumber);
    result.append(", modifiable: ");
    result.append(modifiable);
    result.append(", internal: ");
    result.append(internal);
    result.append(", lastEditedBy: ");
    result.append(lastEditedBy);
    result.append(", timestamp: ");
    result.append(timestamp);
    result.append(", createdBy: ");
    result.append(createdBy);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
  @Override
  public void eSetProxyURI(org.eclipse.emf.common.util.URI uri) {
      super.eSetProxyURI(uri);
      if (uri != null) {
          String s = uri.toString();
          int idx = Math.max(s.lastIndexOf('/'), s.lastIndexOf('#'));
          if (idx >= 0 && s.length() > idx) {
              String newID = s.substring(idx + 1);
              boolean eOldDeliver = eDeliver();
              try {
                  eSetDeliver(false);
                setGuid(newID);
              } finally {
                  eSetDeliver(eOldDeliver);
              }
          }
      }
    }
/* end IONA modification */
  
  
  
  
  /* begin IONA modification*/
  
  public final void setNameFieldSetByFactory (boolean isSet) { nameFieldSetByFactory = isSet; }
  
  public final void setNsFieldSetByFactory (boolean isSet) { nsFieldSetByFactory = isSet; }
  
  /** model impl classes require a proper equals(...) method to support the current 'auto-resolving' 
   * proxy mechanism. See <code>com.iona.soa.model.util.EObjectInvocationProxy</code> for details
   * @generated
   */
  @Override
  public final boolean equals(Object obj) {
    return (obj instanceof java.lang.reflect.Proxy) ? obj.equals(this) : super.equals(obj);
  }
  
  private boolean nameFieldSetByFactory = false;
  private boolean nsFieldSetByFactory = false;

  /**
   * attempts to auto resolve the current proxy object if and when appropriate...
   * @generated
   */
  protected final void autoResolveEProxy(org.eclipse.emf.ecore.EStructuralFeature feature) {
      if (!eIsProxy()) {
          return;
      }
    
      
    // If the field is already set to a value different from the default specified 
    // in the ecore then it means that the proxy already contains a meaningful 
    // value for this feature.  Therefore there is no need to resolve yet.
    //
    // The factory code ovewrites the default value (set by the ecore) of 
    // the "name" and "namespace" fields - so we need to check these seperately.
    //
      if (eClass().getEIDAttribute().getFeatureID() == feature.getFeatureID()) {
          // We always have the ID
          return;
      } else if ("name".equals(feature.getName()) && nameFieldSetByFactory) {
      // resolve it
    } else if ("namespace".equals(feature.getName()) && nsFieldSetByFactory) {
      // resolve it
    } else if (eIsSet(feature)) {
        // this check must come after the name and namespace checks above
      return;
    }
    
    // resolve...
      Resource context = this.eResource();
      if (context == null) {
          // System.err.println("ERROR: Failed to find eResource for " + this + ", cannot resolve");
          return;
      }
  
    EObject resolvedObj = EcoreUtil.resolve(this, context);
  
    // in case the resultion didn't simply update the current object, copy all the relevant data back from the produced entity
    	// TODO - can we simply use eGet(feature, false) for all features???
    if (resolvedObj != null && resolvedObj != this) {
      String getterPrefix = "get";
      for (Method getter : this.getClass().getMethods()) {
    
        if (getter.getName().startsWith(getterPrefix)
            && !(getter.getDeclaringClass().isAssignableFrom(EObject.class)
           		|| getter.getDeclaringClass().isAssignableFrom(InternalEObject.class))) {

          // figure out the name of the related attribute
          StringBuilder sb = new StringBuilder();
          sb.append(Character.toLowerCase(getter.getName().charAt(3)));
          if (getter.getName().length() > 4) {
            sb.append(getter.getName().substring(4));
          }
          String attributeName = sb.toString().intern();

          try {
            Object[] args = null;
            Object fieldValue = getter.invoke(resolvedObj, args);
            /*
            // disable notification
            if (fieldValue instanceof EObject) {
              ((EObject)fieldValue).eSetDeliver(false);
            } else if (fieldValue instanceof Collection) {
              for (Object collectionItem : (Collection)fieldValue) {
                if (fieldValue instanceof EObject) {
                  ((EObject)collectionItem).eSetDeliver(false);
                }
              }
            }
            
            Method setter = this.getClass().getDeclaredMethod(getter.getName().replaceFirst("g", "s"),
                                                              new Class[] {getter.getReturnType()});
            setter.invoke(this, new Object[] {fieldValue});
            
            // re-enable notification
            if (fieldValue instanceof EObject) {
              ((EObject)fieldValue).eSetDeliver(true);
            } else if (fieldValue instanceof Collection) {
              for (Object collectionItem : (Collection)fieldValue) {
                if (fieldValue instanceof EObject) {
                  ((EObject)collectionItem).eSetDeliver(true);
                }
              }
            }*/

            Field field = findClassField(attributeName);
            boolean accessibility = field.isAccessible();
            field.setAccessible(true);
            field.set(this, fieldValue);
            field.setAccessible(accessibility);

          } catch (SecurityException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
          } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
          }
        }
      }

      // remove the proxy flag
      ((InternalEObject) this).eSetProxyURI(null);
    }
  }

    @Override
    public Resource eResource() {
    Resource resource = super.eResource();
    if (resource == null && this.eBasicAdapters() != null && !this.eBasicAdapters().isEmpty()) {
      		Adapter[] adapters = (Adapter[])this.eBasicAdapters().toArray();
      for (int i = 0; i < adapters.length; i++) {
          if (adapters[i] instanceof DanglingProxyAdapter) {
              resource = ((DanglingProxyAdapter)adapters[i]).eResource();
          if (((Resource.Internal)resource).isLoading()) {
              // Don't facillitate any resolution that would not 
              // previously have succeeded while loading
          			resource = null;
      			}
              break;
          }
      }
    }
    
      return resource;    
    }
    
  private Field findClassField(String targetedFieldName){
    
    if (targetedFieldName == null) {
      return null;
    }
    
    java.lang.Class class1 = this.getClass();

    while (class1 != null && !class1.equals(Object.class)) {
      try {
        return class1.getDeclaredField(targetedFieldName);
      } catch (Exception e) {
        // TODO Auto-generated catch block
      }
      class1 = class1.getSuperclass();
    }
  
    return null;
  }
  /* end IONA modification */
} //IPersistableObjectImpl


