/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.repository.impl;

import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.ModelMetadata;
import com.iona.soa.model.repository.Property;
import com.iona.soa.model.repository.RepositoryPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model Metadata</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.repository.impl.ModelMetadataImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link com.iona.soa.model.repository.impl.ModelMetadataImpl#getSchemaVersion <em>Schema Version</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ModelMetadataImpl extends IPersistableObjectImpl implements ModelMetadata
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached value of the '{@link #getProperties() <em>Properties</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperties()
   * @generated
   * @ordered
   */
  protected EList<Property> properties;

  /**
   * The default value of the '{@link #getSchemaVersion() <em>Schema Version</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSchemaVersion()
   * @generated
   * @ordered
   */
  protected static final String SCHEMA_VERSION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getSchemaVersion() <em>Schema Version</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSchemaVersion()
   * @generated
   * @ordered
   */
  protected String schemaVersion = SCHEMA_VERSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ModelMetadataImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return RepositoryPackage.Literals.MODEL_METADATA;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Property> getProperties() {
    autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES);
    return _basicGetProperties();
  }
  
  private final EList<Property> _basicGetProperties() {
    if (properties == null)
    {
      properties = new EObjectContainmentEList<Property>(Property.class, this, RepositoryPackage.MODEL_METADATA__PROPERTIES);
    }
    return properties;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSchemaVersion() {
    autoResolveEProxy(RepositoryPackage.Literals.MODEL_METADATA__SCHEMA_VERSION);
    return _basicGetSchemaVersion();
  }
  
  private final String _basicGetSchemaVersion() {
    return schemaVersion;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSchemaVersion(String newSchemaVersion)
  {
    
    String oldSchemaVersion = schemaVersion;
    schemaVersion = newSchemaVersion;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.MODEL_METADATA__SCHEMA_VERSION, oldSchemaVersion, schemaVersion));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case RepositoryPackage.MODEL_METADATA__PROPERTIES:
        return ((InternalEList<?>)_basicGetProperties()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case RepositoryPackage.MODEL_METADATA__PROPERTIES:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IPROPERTIES__PROPERTIES); }
        return _basicGetProperties();
      case RepositoryPackage.MODEL_METADATA__SCHEMA_VERSION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.MODEL_METADATA__SCHEMA_VERSION); }
        return _basicGetSchemaVersion();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case RepositoryPackage.MODEL_METADATA__PROPERTIES:
        _basicGetProperties().clear();
        _basicGetProperties().addAll((Collection<? extends Property>)newValue);
        return;
      case RepositoryPackage.MODEL_METADATA__SCHEMA_VERSION:
        setSchemaVersion((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case RepositoryPackage.MODEL_METADATA__PROPERTIES:
      _basicGetProperties().clear();
      return;
    case RepositoryPackage.MODEL_METADATA__SCHEMA_VERSION:
      setSchemaVersion(SCHEMA_VERSION_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case RepositoryPackage.MODEL_METADATA__PROPERTIES:
        return properties != null && !properties.isEmpty();
      case RepositoryPackage.MODEL_METADATA__SCHEMA_VERSION:
        return SCHEMA_VERSION_EDEFAULT == null ? schemaVersion != null : !SCHEMA_VERSION_EDEFAULT.equals(schemaVersion);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == IProperties.class)
    {
      switch (derivedFeatureID)
      {
        case RepositoryPackage.MODEL_METADATA__PROPERTIES: return RepositoryPackage.IPROPERTIES__PROPERTIES;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == IProperties.class)
    {
      switch (baseFeatureID)
      {
        case RepositoryPackage.IPROPERTIES__PROPERTIES: return RepositoryPackage.MODEL_METADATA__PROPERTIES;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (schemaVersion: ");
    result.append(schemaVersion);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //ModelMetadataImpl


