/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.repository.impl;

import com.iona.soa.model.repository.*;

import java.lang.reflect.Method;

import java.net.URI;

import java.sql.Timestamp;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RepositoryFactoryImpl extends EFactoryImpl implements RepositoryFactory
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

/* begin IONA modification */
  private String defaultNamespace = "http://www.example.org/";

  public final void setDefaultNamespace(String namespace) {
    this.defaultNamespace = namespace;
  }

/* end IONA modification */
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static RepositoryFactory init()
  {
    try
    {
      RepositoryFactory theRepositoryFactory = (RepositoryFactory)EPackage.Registry.INSTANCE.getEFactory("http://com.iona.soa.model.repository"); 
      if (theRepositoryFactory != null)
      {
        return theRepositoryFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new RepositoryFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RepositoryFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case RepositoryPackage.PROPERTY: return createProperty();
      case RepositoryPackage.MODEL_METADATA: return createModelMetadata();
      case RepositoryPackage.VERSION: return createVersion();
      case RepositoryPackage.VERSION_TRACKER: return createVersionTracker();
      case RepositoryPackage.AUDIT_EVENT: return createAuditEvent();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case RepositoryPackage.AUDIT_LEVEL:
        return createAuditLevelFromString(eDataType, initialValue);
      case RepositoryPackage.TIMESTAMP:
        return createTimestampFromString(eDataType, initialValue);
      case RepositoryPackage.URI:
        return createURIFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case RepositoryPackage.AUDIT_LEVEL:
        return convertAuditLevelToString(eDataType, instanceValue);
      case RepositoryPackage.TIMESTAMP:
        return convertTimestampToString(eDataType, instanceValue);
      case RepositoryPackage.URI:
        return convertURIToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Property createProperty()
  {
       	/* begin IONA modification */
    	//PropertyImpl property = new PropertyImpl();
    	Property property = new PropertyImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = property.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(property, new Object[] {"Property-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = property.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(property, new Object[] {"Property"});
            Method factoryFlagSetter = property.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(property, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = property.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(property, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = property.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(property, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return property;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModelMetadata createModelMetadata()
  {
       	/* begin IONA modification */
    	//ModelMetadataImpl modelMetadata = new ModelMetadataImpl();
    	ModelMetadata modelMetadata = new ModelMetadataImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = modelMetadata.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(modelMetadata, new Object[] {"ModelMetadata-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = modelMetadata.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(modelMetadata, new Object[] {"ModelMetadata"});
            Method factoryFlagSetter = modelMetadata.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(modelMetadata, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = modelMetadata.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(modelMetadata, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = modelMetadata.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(modelMetadata, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return modelMetadata;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Version createVersion()
  {
       	/* begin IONA modification */
    	//VersionImpl version = new VersionImpl();
    	Version version = new VersionImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = version.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(version, new Object[] {"Version-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = version.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(version, new Object[] {"Version"});
            Method factoryFlagSetter = version.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(version, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = version.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(version, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = version.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(version, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return version;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VersionTracker createVersionTracker()
  {
       	/* begin IONA modification */
    	//VersionTrackerImpl versionTracker = new VersionTrackerImpl();
    	VersionTracker versionTracker = new VersionTrackerImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = versionTracker.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(versionTracker, new Object[] {"VersionTracker-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = versionTracker.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(versionTracker, new Object[] {"VersionTracker"});
            Method factoryFlagSetter = versionTracker.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(versionTracker, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = versionTracker.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(versionTracker, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = versionTracker.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(versionTracker, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return versionTracker;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AuditEvent createAuditEvent()
  {
       	/* begin IONA modification */
    	//AuditEventImpl auditEvent = new AuditEventImpl();
    	AuditEvent auditEvent = new AuditEventImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = auditEvent.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(auditEvent, new Object[] {"AuditEvent-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = auditEvent.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(auditEvent, new Object[] {"AuditEvent"});
            Method factoryFlagSetter = auditEvent.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(auditEvent, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = auditEvent.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(auditEvent, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = auditEvent.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(auditEvent, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return auditEvent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AuditLevel createAuditLevelFromString(EDataType eDataType, String initialValue)
  {
    AuditLevel result = AuditLevel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertAuditLevelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp createTimestampFromString(EDataType eDataType, String initialValue)
  {
    return (Timestamp)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertTimestampToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public URI createURIFromString(EDataType eDataType, String initialValue)
  {
    return (URI)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertURIToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RepositoryPackage getRepositoryPackage()
  {
    return (RepositoryPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static RepositoryPackage getPackage()
  {
    return RepositoryPackage.eINSTANCE;
  }

} //RepositoryFactoryImpl


