/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.repository.impl;

import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.collaboration.CollaborationPackage;

import com.iona.soa.model.collaboration.impl.CollaborationPackageImpl;

import com.iona.soa.model.events.EventsPackage;

import com.iona.soa.model.events.impl.EventsPackageImpl;

import com.iona.soa.model.folder.FolderPackage;

import com.iona.soa.model.folder.impl.FolderPackageImpl;

import com.iona.soa.model.impl.SOA_NetworkPackageImpl;

import com.iona.soa.model.notification.NotificationPackage;

import com.iona.soa.model.notification.impl.NotificationPackageImpl;

import com.iona.soa.model.repository.AuditEvent;
import com.iona.soa.model.repository.AuditLevel;
import com.iona.soa.model.repository.IPersistableObject;
import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.IRepositoryObject;
import com.iona.soa.model.repository.IVersionedObject;
import com.iona.soa.model.repository.ModelMetadata;
import com.iona.soa.model.repository.Property;
import com.iona.soa.model.repository.RepositoryFactory;
import com.iona.soa.model.repository.RepositoryPackage;
import com.iona.soa.model.repository.Version;
import com.iona.soa.model.repository.VersionTracker;

import com.iona.soa.model.scheduling.SchedulingPackage;

import com.iona.soa.model.scheduling.impl.SchedulingPackageImpl;

import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.security.impl.SecurityPackageImpl;

import com.iona.soa.model.userattributes.UserAttributesPackage;

import com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl;

import java.sql.Timestamp;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RepositoryPackageImpl extends EPackageImpl implements RepositoryPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iRepositoryObjectEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iPersistableObjectEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass propertyEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iPropertiesEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass modelMetadataEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass versionEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass versionTrackerEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass iVersionedObjectEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass auditEventEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum auditLevelEEnum = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EDataType timestampEDataType = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EDataType uriEDataType = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see com.iona.soa.model.repository.RepositoryPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private RepositoryPackageImpl()
  {
    super(eNS_URI, RepositoryFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this
   * model, and for any others upon which it depends.  Simple
   * dependencies are satisfied by calling this method on all
   * dependent packages before doing anything else.  This method drives
   * initialization for interdependent packages directly, in parallel
   * with this package, itself.
   * <p>Of this package and its interdependencies, all packages which
   * have not yet been registered by their URI values are first created
   * and registered.  The packages are then initialized in two steps:
   * meta-model objects for all of the packages are created before any
   * are initialized, since one package's meta-model objects may refer to
   * those of another.
   * <p>Invocation of this method will not affect any packages that have
   * already been initialized.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static RepositoryPackage init()
  {
    if (isInited) return (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);

    // Obtain or create and register package
    RepositoryPackageImpl theRepositoryPackage = (RepositoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof RepositoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new RepositoryPackageImpl());

    isInited = true;

    // Obtain or create and register interdependencies
    SOA_NetworkPackageImpl theSOA_NetworkPackage = (SOA_NetworkPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) instanceof SOA_NetworkPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) : SOA_NetworkPackage.eINSTANCE);
    SecurityPackageImpl theSecurityPackage = (SecurityPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) instanceof SecurityPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) : SecurityPackage.eINSTANCE);
    UserAttributesPackageImpl theUserAttributesPackage = (UserAttributesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) instanceof UserAttributesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) : UserAttributesPackage.eINSTANCE);
    EventsPackageImpl theEventsPackage = (EventsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) instanceof EventsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) : EventsPackage.eINSTANCE);
    NotificationPackageImpl theNotificationPackage = (NotificationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) instanceof NotificationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) : NotificationPackage.eINSTANCE);
    CollaborationPackageImpl theCollaborationPackage = (CollaborationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) instanceof CollaborationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) : CollaborationPackage.eINSTANCE);
    FolderPackageImpl theFolderPackage = (FolderPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) instanceof FolderPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) : FolderPackage.eINSTANCE);
    SchedulingPackageImpl theSchedulingPackage = (SchedulingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) instanceof SchedulingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI) : SchedulingPackage.eINSTANCE);

    // Create package meta-data objects
    theRepositoryPackage.createPackageContents();
    theSOA_NetworkPackage.createPackageContents();
    theSecurityPackage.createPackageContents();
    theUserAttributesPackage.createPackageContents();
    theEventsPackage.createPackageContents();
    theNotificationPackage.createPackageContents();
    theCollaborationPackage.createPackageContents();
    theFolderPackage.createPackageContents();
    theSchedulingPackage.createPackageContents();

    // Initialize created meta-data
    theRepositoryPackage.initializePackageContents();
    theSOA_NetworkPackage.initializePackageContents();
    theSecurityPackage.initializePackageContents();
    theUserAttributesPackage.initializePackageContents();
    theEventsPackage.initializePackageContents();
    theNotificationPackage.initializePackageContents();
    theCollaborationPackage.initializePackageContents();
    theFolderPackage.initializePackageContents();
    theSchedulingPackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theRepositoryPackage.freeze();

    return theRepositoryPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIRepositoryObject()
  {
    return iRepositoryObjectEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIRepositoryObject_Name()
  {
    return (EAttribute)iRepositoryObjectEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIRepositoryObject_Namespace()
  {
    return (EAttribute)iRepositoryObjectEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIRepositoryObject_Description()
  {
    return (EAttribute)iRepositoryObjectEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIPersistableObject()
  {
    return iPersistableObjectEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIPersistableObject_Guid()
  {
    return (EAttribute)iPersistableObjectEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIPersistableObject_GenerationNumber()
  {
    return (EAttribute)iPersistableObjectEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIPersistableObject_Modifiable()
  {
    return (EAttribute)iPersistableObjectEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIPersistableObject_Internal()
  {
    return (EAttribute)iPersistableObjectEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIPersistableObject_LastEditedBy()
  {
    return (EAttribute)iPersistableObjectEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIPersistableObject_Timestamp()
  {
    return (EAttribute)iPersistableObjectEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIPersistableObject_CreatedBy()
  {
    return (EAttribute)iPersistableObjectEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getProperty()
  {
    return propertyEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getProperty_Name()
  {
    return (EAttribute)propertyEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getProperty_Value()
  {
    return (EAttribute)propertyEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIProperties()
  {
    return iPropertiesEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIProperties_Properties()
  {
    return (EReference)iPropertiesEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getModelMetadata()
  {
    return modelMetadataEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getModelMetadata_SchemaVersion()
  {
    return (EAttribute)modelMetadataEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getVersion()
  {
    return versionEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersion_Major()
  {
    return (EAttribute)versionEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersion_Minor()
  {
    return (EAttribute)versionEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersion_Micro()
  {
    return (EAttribute)versionEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersion_Nano()
  {
    return (EAttribute)versionEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersion_Qualifier()
  {
    return (EAttribute)versionEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersion_Description()
  {
    return (EAttribute)versionEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getVersion_Tracker()
  {
    return (EReference)versionEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getVersion_OriginalString()
  {
    return (EAttribute)versionEClass.getEStructuralFeatures().get(7);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getVersionTracker()
  {
    return versionTrackerEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getVersionTracker_Versions()
  {
    return (EReference)versionTrackerEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIVersionedObject()
  {
    return iVersionedObjectEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getIVersionedObject_Version()
  {
    return (EReference)iVersionedObjectEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getAuditEvent()
  {
    return auditEventEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAuditEvent_TargetGuid()
  {
    return (EAttribute)auditEventEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAuditEvent_Message()
  {
    return (EAttribute)auditEventEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getAuditEvent_Level()
  {
    return (EAttribute)auditEventEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EEnum getAuditLevel()
  {
    return auditLevelEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EDataType getTimestamp()
  {
    return timestampEDataType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EDataType getURI()
  {
    return uriEDataType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RepositoryFactory getRepositoryFactory()
  {
    return (RepositoryFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    iRepositoryObjectEClass = createEClass(IREPOSITORY_OBJECT);
    createEAttribute(iRepositoryObjectEClass, IREPOSITORY_OBJECT__NAME);
    createEAttribute(iRepositoryObjectEClass, IREPOSITORY_OBJECT__NAMESPACE);
    createEAttribute(iRepositoryObjectEClass, IREPOSITORY_OBJECT__DESCRIPTION);

    iPersistableObjectEClass = createEClass(IPERSISTABLE_OBJECT);
    createEAttribute(iPersistableObjectEClass, IPERSISTABLE_OBJECT__GUID);
    createEAttribute(iPersistableObjectEClass, IPERSISTABLE_OBJECT__GENERATION_NUMBER);
    createEAttribute(iPersistableObjectEClass, IPERSISTABLE_OBJECT__MODIFIABLE);
    createEAttribute(iPersistableObjectEClass, IPERSISTABLE_OBJECT__INTERNAL);
    createEAttribute(iPersistableObjectEClass, IPERSISTABLE_OBJECT__LAST_EDITED_BY);
    createEAttribute(iPersistableObjectEClass, IPERSISTABLE_OBJECT__TIMESTAMP);
    createEAttribute(iPersistableObjectEClass, IPERSISTABLE_OBJECT__CREATED_BY);

    propertyEClass = createEClass(PROPERTY);
    createEAttribute(propertyEClass, PROPERTY__NAME);
    createEAttribute(propertyEClass, PROPERTY__VALUE);

    iPropertiesEClass = createEClass(IPROPERTIES);
    createEReference(iPropertiesEClass, IPROPERTIES__PROPERTIES);

    modelMetadataEClass = createEClass(MODEL_METADATA);
    createEAttribute(modelMetadataEClass, MODEL_METADATA__SCHEMA_VERSION);

    versionEClass = createEClass(VERSION);
    createEAttribute(versionEClass, VERSION__MAJOR);
    createEAttribute(versionEClass, VERSION__MINOR);
    createEAttribute(versionEClass, VERSION__MICRO);
    createEAttribute(versionEClass, VERSION__NANO);
    createEAttribute(versionEClass, VERSION__QUALIFIER);
    createEAttribute(versionEClass, VERSION__DESCRIPTION);
    createEReference(versionEClass, VERSION__TRACKER);
    createEAttribute(versionEClass, VERSION__ORIGINAL_STRING);

    versionTrackerEClass = createEClass(VERSION_TRACKER);
    createEReference(versionTrackerEClass, VERSION_TRACKER__VERSIONS);

    iVersionedObjectEClass = createEClass(IVERSIONED_OBJECT);
    createEReference(iVersionedObjectEClass, IVERSIONED_OBJECT__VERSION);

    auditEventEClass = createEClass(AUDIT_EVENT);
    createEAttribute(auditEventEClass, AUDIT_EVENT__TARGET_GUID);
    createEAttribute(auditEventEClass, AUDIT_EVENT__MESSAGE);
    createEAttribute(auditEventEClass, AUDIT_EVENT__LEVEL);

    // Create enums
    auditLevelEEnum = createEEnum(AUDIT_LEVEL);

    // Create data types
    timestampEDataType = createEDataType(TIMESTAMP);
    uriEDataType = createEDataType(URI);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    iRepositoryObjectEClass.getESuperTypes().add(this.getIPersistableObject());
    propertyEClass.getESuperTypes().add(this.getIPersistableObject());
    iPropertiesEClass.getESuperTypes().add(this.getIPersistableObject());
    modelMetadataEClass.getESuperTypes().add(this.getIPersistableObject());
    modelMetadataEClass.getESuperTypes().add(this.getIProperties());
    versionEClass.getESuperTypes().add(this.getIPersistableObject());
    versionTrackerEClass.getESuperTypes().add(this.getIPersistableObject());
    iVersionedObjectEClass.getESuperTypes().add(this.getIPersistableObject());
    auditEventEClass.getESuperTypes().add(this.getIPersistableObject());

    // Initialize classes and features; add operations and parameters
    initEClass(iRepositoryObjectEClass, IRepositoryObject.class, "IRepositoryObject", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getIRepositoryObject_Name(), ecorePackage.getEString(), "name", null, 1, 1, IRepositoryObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIRepositoryObject_Namespace(), ecorePackage.getEString(), "namespace", null, 1, 1, IRepositoryObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIRepositoryObject_Description(), ecorePackage.getEString(), "description", null, 0, 1, IRepositoryObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iPersistableObjectEClass, IPersistableObject.class, "IPersistableObject", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getIPersistableObject_Guid(), ecorePackage.getEString(), "guid", null, 1, 1, IPersistableObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIPersistableObject_GenerationNumber(), ecorePackage.getELong(), "generationNumber", null, 1, 1, IPersistableObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIPersistableObject_Modifiable(), ecorePackage.getEBoolean(), "modifiable", "true", 1, 1, IPersistableObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIPersistableObject_Internal(), ecorePackage.getEBoolean(), "internal", null, 1, 1, IPersistableObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIPersistableObject_LastEditedBy(), ecorePackage.getEString(), "lastEditedBy", null, 0, 1, IPersistableObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIPersistableObject_Timestamp(), this.getTimestamp(), "timestamp", null, 1, 1, IPersistableObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIPersistableObject_CreatedBy(), ecorePackage.getEString(), "createdBy", null, 0, 1, IPersistableObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(propertyEClass, Property.class, "Property", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getProperty_Name(), ecorePackage.getEString(), "name", null, 1, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getProperty_Value(), ecorePackage.getEString(), "value", null, 1, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iPropertiesEClass, IProperties.class, "IProperties", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getIProperties_Properties(), this.getProperty(), null, "properties", null, 0, -1, IProperties.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(modelMetadataEClass, ModelMetadata.class, "ModelMetadata", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getModelMetadata_SchemaVersion(), ecorePackage.getEString(), "schemaVersion", null, 1, 1, ModelMetadata.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(versionEClass, Version.class, "Version", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getVersion_Major(), ecorePackage.getEIntegerObject(), "major", "0", 1, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVersion_Minor(), ecorePackage.getEIntegerObject(), "minor", null, 0, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVersion_Micro(), ecorePackage.getEIntegerObject(), "micro", null, 0, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVersion_Nano(), ecorePackage.getEIntegerObject(), "nano", null, 0, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVersion_Qualifier(), ecorePackage.getEString(), "qualifier", null, 0, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVersion_Description(), ecorePackage.getEString(), "description", null, 0, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getVersion_Tracker(), this.getVersionTracker(), this.getVersionTracker_Versions(), "tracker", null, 0, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getVersion_OriginalString(), ecorePackage.getEString(), "originalString", "", 0, 1, Version.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(versionTrackerEClass, VersionTracker.class, "VersionTracker", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getVersionTracker_Versions(), this.getVersion(), this.getVersion_Tracker(), "versions", null, 1, -1, VersionTracker.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(iVersionedObjectEClass, IVersionedObject.class, "IVersionedObject", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getIVersionedObject_Version(), this.getVersion(), null, "version", null, 0, 1, IVersionedObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(auditEventEClass, AuditEvent.class, "AuditEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getAuditEvent_TargetGuid(), ecorePackage.getEString(), "targetGuid", null, 1, 1, AuditEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getAuditEvent_Message(), ecorePackage.getEString(), "message", null, 1, 1, AuditEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getAuditEvent_Level(), this.getAuditLevel(), "level", null, 1, 1, AuditEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    // Initialize enums and add enum literals
    initEEnum(auditLevelEEnum, AuditLevel.class, "AuditLevel");
    addEEnumLiteral(auditLevelEEnum, AuditLevel.ERROR);
    addEEnumLiteral(auditLevelEEnum, AuditLevel.WARNING);
    addEEnumLiteral(auditLevelEEnum, AuditLevel.INFO);

    // Initialize data types
    initEDataType(timestampEDataType, Timestamp.class, "Timestamp", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
    initEDataType(uriEDataType, java.net.URI.class, "URI", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // dbhints
    createDbhintsAnnotations();
    // delete
    createDeleteAnnotations();
    // securityHints
    createSecurityHintsAnnotations();
  }

  /**
   * Initializes the annotations for <b>dbhints</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createDbhintsAnnotations()
  {
    String source = "dbhints";		
    addAnnotation
      (uriEDataType, 
       source, 
       new String[] 
       {
       "serialization", "toString"
       });		
    addAnnotation
      (iRepositoryObjectEClass, 
       source, 
       new String[] 
       {
       "hierarchy", "subclass"
       });		
    addAnnotation
      (getIRepositoryObject_Description(), 
       source, 
       new String[] 
       {
       "type", "CLOB"
       });		
    addAnnotation
      (iPersistableObjectEClass, 
       source, 
       new String[] 
       {
       "hierarchy", "subclass"
       });				
    addAnnotation
      (iVersionedObjectEClass, 
       source, 
       new String[] 
       {
       "hierarchy", "subclass"
       });	
  }

  /**
   * Initializes the annotations for <b>delete</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createDeleteAnnotations()
  {
    String source = "delete";						
    addAnnotation
      (iPersistableObjectEClass, 
       source, 
       new String[] 
       {
       "predicate", "equals(modifiable, true)"
       });		
    addAnnotation
      (versionEClass, 
       source, 
       new String[] 
       {
       "dependencies", "dangling_references(tracker.versions)"
       });		
  }

  /**
   * Initializes the annotations for <b>securityHints</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createSecurityHintsAnnotations()
  {
    String source = "securityHints";									
    addAnnotation
      (auditEventEClass, 
       source, 
       new String[] 
       {
       "area", "None"
       });
  }

} //RepositoryPackageImpl
