/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling;

import com.iona.soa.model.repository.IRepositoryObject;

import com.iona.soa.model.security.IProtectedRepositoryObject;
import com.iona.soa.model.security.User;

import java.sql.Timestamp;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scheduled Task</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getState <em>State</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getLastRun <em>Last Run</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getNextRun <em>Next Run</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#isSystem <em>System</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getDuration <em>Duration</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getAffectedObjects <em>Affected Objects</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getTypeID <em>Type ID</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getParameters <em>Parameters</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getAction <em>Action</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getUser <em>User</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getPassword <em>Password</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#getToken <em>Token</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.ScheduledTask#isRunNow <em>Run Now</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask()
 * @model abstract="true"
 *        annotation="dbhints hierarchy='topclass'"
 *        annotation="securityHints area='Provisioning\r\nRepository'"
 * @generated
 */
public interface ScheduledTask extends IProtectedRepositoryObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>State</b></em>' attribute.
   * The literals are from the enumeration {@link com.iona.soa.model.scheduling.TaskStates}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>State</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>State</em>' attribute.
   * @see com.iona.soa.model.scheduling.TaskStates
   * @see #setState(TaskStates)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_State()
   * @model required="true"
   * @generated
   */
  TaskStates getState();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getState <em>State</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>State</em>' attribute.
   * @see com.iona.soa.model.scheduling.TaskStates
   * @see #getState()
   * @generated
   */
  void setState(TaskStates value);

  /**
   * Returns the value of the '<em><b>Last Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Last Run</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Last Run</em>' attribute.
   * @see #setLastRun(Timestamp)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_LastRun()
   * @model dataType="com.iona.soa.model.repository.Timestamp"
   * @generated
   */
  Timestamp getLastRun();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getLastRun <em>Last Run</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Last Run</em>' attribute.
   * @see #getLastRun()
   * @generated
   */
  void setLastRun(Timestamp value);

  /**
   * Returns the value of the '<em><b>Next Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Next Run</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Next Run</em>' attribute.
   * @see #setNextRun(Timestamp)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_NextRun()
   * @model dataType="com.iona.soa.model.repository.Timestamp"
   * @generated
   */
  Timestamp getNextRun();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getNextRun <em>Next Run</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Next Run</em>' attribute.
   * @see #getNextRun()
   * @generated
   */
  void setNextRun(Timestamp value);

  /**
   * Returns the value of the '<em><b>System</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>System</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>System</em>' attribute.
   * @see #setSystem(boolean)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_System()
   * @model default="false"
   * @generated
   */
  boolean isSystem();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#isSystem <em>System</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>System</em>' attribute.
   * @see #isSystem()
   * @generated
   */
  void setSystem(boolean value);

  /**
   * Returns the value of the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Duration</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Duration</em>' attribute.
   * @see #setDuration(int)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_Duration()
   * @model
   * @generated
   */
  int getDuration();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getDuration <em>Duration</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Duration</em>' attribute.
   * @see #getDuration()
   * @generated
   */
  void setDuration(int value);

  /**
   * Returns the value of the '<em><b>Affected Objects</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.repository.IRepositoryObject}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Affected Objects</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Affected Objects</em>' reference list.
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_AffectedObjects()
   * @model
   * @generated
   */
  EList<IRepositoryObject> getAffectedObjects();


  /**
   * Returns the value of the '<em><b>Type ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type ID</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type ID</em>' attribute.
   * @see #setTypeID(String)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_TypeID()
   * @model required="true"
   * @generated
   */
  String getTypeID();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getTypeID <em>Type ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type ID</em>' attribute.
   * @see #getTypeID()
   * @generated
   */
  void setTypeID(String value);

  /**
   * Returns the value of the '<em><b>Parameters</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parameters</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parameters</em>' attribute list.
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_Parameters()
   * @model
   * @generated
   */
  EList<String> getParameters();


  /**
   * Returns the value of the '<em><b>Action</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Action</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Action</em>' attribute.
   * @see #setAction(String)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_Action()
   * @model
   * @generated
   */
  String getAction();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getAction <em>Action</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Action</em>' attribute.
   * @see #getAction()
   * @generated
   */
  void setAction(String value);

  /**
   * Returns the value of the '<em><b>User</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>User</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>User</em>' reference.
   * @see #setUser(User)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_User()
   * @model
   * @generated
   */
  User getUser();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getUser <em>User</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>User</em>' reference.
   * @see #getUser()
   * @generated
   */
  void setUser(User value);

  /**
   * Returns the value of the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Password</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Password</em>' attribute.
   * @see #setPassword(String)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_Password()
   * @model transient="true"
   * @generated
   */
  String getPassword();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getPassword <em>Password</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Password</em>' attribute.
   * @see #getPassword()
   * @generated
   */
  void setPassword(String value);

  /**
   * Returns the value of the '<em><b>Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Token</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Token</em>' attribute.
   * @see #setToken(String)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_Token()
   * @model
   * @generated
   */
  String getToken();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#getToken <em>Token</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Token</em>' attribute.
   * @see #getToken()
   * @generated
   */
  void setToken(String value);

  /**
   * Returns the value of the '<em><b>Run Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Run Now</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Run Now</em>' attribute.
   * @see #setRunNow(boolean)
   * @see com.iona.soa.model.scheduling.SchedulingPackage#getScheduledTask_RunNow()
   * @model
   * @generated
   */
  boolean isRunNow();


  /**
   * Sets the value of the '{@link com.iona.soa.model.scheduling.ScheduledTask#isRunNow <em>Run Now</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Run Now</em>' attribute.
   * @see #isRunNow()
   * @generated
   */
  void setRunNow(boolean value);

} // ScheduledTask


