/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling;

import com.iona.soa.model.security.SecurityPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.scheduling.SchedulingFactory
 * @model kind="package"
 * @generated
 */
public interface SchedulingPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "scheduling";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.scheduling";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "its";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  SchedulingPackage eINSTANCE = com.iona.soa.model.scheduling.impl.SchedulingPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl <em>Scheduled Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.impl.ScheduledTaskImpl
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getScheduledTask()
   * @generated
   */
  int SCHEDULED_TASK = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>State</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__STATE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Last Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__LAST_RUN = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Next Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__NEXT_RUN = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>System</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__SYSTEM = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__DURATION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Affected Objects</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__AFFECTED_OBJECTS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The feature id for the '<em><b>Type ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__TYPE_ID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 6;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__PARAMETERS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 7;

  /**
   * The feature id for the '<em><b>Action</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__ACTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 8;

  /**
   * The feature id for the '<em><b>User</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__USER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 9;

  /**
   * The feature id for the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__PASSWORD = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 10;

  /**
   * The feature id for the '<em><b>Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__TOKEN = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 11;

  /**
   * The feature id for the '<em><b>Run Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK__RUN_NOW = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 12;

  /**
   * The number of structural features of the '<em>Scheduled Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SCHEDULED_TASK_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 13;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.impl.DailyRepeatedTaskImpl <em>Daily Repeated Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.impl.DailyRepeatedTaskImpl
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getDailyRepeatedTask()
   * @generated
   */
  int DAILY_REPEATED_TASK = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__GUID = SCHEDULED_TASK__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__GENERATION_NUMBER = SCHEDULED_TASK__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__MODIFIABLE = SCHEDULED_TASK__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__INTERNAL = SCHEDULED_TASK__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__LAST_EDITED_BY = SCHEDULED_TASK__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__TIMESTAMP = SCHEDULED_TASK__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__CREATED_BY = SCHEDULED_TASK__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__NAME = SCHEDULED_TASK__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__NAMESPACE = SCHEDULED_TASK__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__DESCRIPTION = SCHEDULED_TASK__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__OBJECT_CONTROL = SCHEDULED_TASK__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>State</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__STATE = SCHEDULED_TASK__STATE;

  /**
   * The feature id for the '<em><b>Last Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__LAST_RUN = SCHEDULED_TASK__LAST_RUN;

  /**
   * The feature id for the '<em><b>Next Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__NEXT_RUN = SCHEDULED_TASK__NEXT_RUN;

  /**
   * The feature id for the '<em><b>System</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__SYSTEM = SCHEDULED_TASK__SYSTEM;

  /**
   * The feature id for the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__DURATION = SCHEDULED_TASK__DURATION;

  /**
   * The feature id for the '<em><b>Affected Objects</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__AFFECTED_OBJECTS = SCHEDULED_TASK__AFFECTED_OBJECTS;

  /**
   * The feature id for the '<em><b>Type ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__TYPE_ID = SCHEDULED_TASK__TYPE_ID;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__PARAMETERS = SCHEDULED_TASK__PARAMETERS;

  /**
   * The feature id for the '<em><b>Action</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__ACTION = SCHEDULED_TASK__ACTION;

  /**
   * The feature id for the '<em><b>User</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__USER = SCHEDULED_TASK__USER;

  /**
   * The feature id for the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__PASSWORD = SCHEDULED_TASK__PASSWORD;

  /**
   * The feature id for the '<em><b>Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__TOKEN = SCHEDULED_TASK__TOKEN;

  /**
   * The feature id for the '<em><b>Run Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__RUN_NOW = SCHEDULED_TASK__RUN_NOW;

  /**
   * The feature id for the '<em><b>Hour</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__HOUR = SCHEDULED_TASK_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Minute</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK__MINUTE = SCHEDULED_TASK_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Daily Repeated Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DAILY_REPEATED_TASK_FEATURE_COUNT = SCHEDULED_TASK_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.impl.OnceOffTaskImpl <em>Once Off Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.impl.OnceOffTaskImpl
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getOnceOffTask()
   * @generated
   */
  int ONCE_OFF_TASK = 2;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__GUID = SCHEDULED_TASK__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__GENERATION_NUMBER = SCHEDULED_TASK__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__MODIFIABLE = SCHEDULED_TASK__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__INTERNAL = SCHEDULED_TASK__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__LAST_EDITED_BY = SCHEDULED_TASK__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__TIMESTAMP = SCHEDULED_TASK__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__CREATED_BY = SCHEDULED_TASK__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__NAME = SCHEDULED_TASK__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__NAMESPACE = SCHEDULED_TASK__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__DESCRIPTION = SCHEDULED_TASK__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__OBJECT_CONTROL = SCHEDULED_TASK__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>State</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__STATE = SCHEDULED_TASK__STATE;

  /**
   * The feature id for the '<em><b>Last Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__LAST_RUN = SCHEDULED_TASK__LAST_RUN;

  /**
   * The feature id for the '<em><b>Next Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__NEXT_RUN = SCHEDULED_TASK__NEXT_RUN;

  /**
   * The feature id for the '<em><b>System</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__SYSTEM = SCHEDULED_TASK__SYSTEM;

  /**
   * The feature id for the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__DURATION = SCHEDULED_TASK__DURATION;

  /**
   * The feature id for the '<em><b>Affected Objects</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__AFFECTED_OBJECTS = SCHEDULED_TASK__AFFECTED_OBJECTS;

  /**
   * The feature id for the '<em><b>Type ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__TYPE_ID = SCHEDULED_TASK__TYPE_ID;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__PARAMETERS = SCHEDULED_TASK__PARAMETERS;

  /**
   * The feature id for the '<em><b>Action</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__ACTION = SCHEDULED_TASK__ACTION;

  /**
   * The feature id for the '<em><b>User</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__USER = SCHEDULED_TASK__USER;

  /**
   * The feature id for the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__PASSWORD = SCHEDULED_TASK__PASSWORD;

  /**
   * The feature id for the '<em><b>Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__TOKEN = SCHEDULED_TASK__TOKEN;

  /**
   * The feature id for the '<em><b>Run Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__RUN_NOW = SCHEDULED_TASK__RUN_NOW;

  /**
   * The feature id for the '<em><b>Schedule Date</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__SCHEDULE_DATE = SCHEDULED_TASK_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Cleanup On Completion</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK__CLEANUP_ON_COMPLETION = SCHEDULED_TASK_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Once Off Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONCE_OFF_TASK_FEATURE_COUNT = SCHEDULED_TASK_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.impl.WeeklyRepeatedTaskImpl <em>Weekly Repeated Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.impl.WeeklyRepeatedTaskImpl
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getWeeklyRepeatedTask()
   * @generated
   */
  int WEEKLY_REPEATED_TASK = 3;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__GUID = DAILY_REPEATED_TASK__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__GENERATION_NUMBER = DAILY_REPEATED_TASK__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__MODIFIABLE = DAILY_REPEATED_TASK__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__INTERNAL = DAILY_REPEATED_TASK__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__LAST_EDITED_BY = DAILY_REPEATED_TASK__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__TIMESTAMP = DAILY_REPEATED_TASK__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__CREATED_BY = DAILY_REPEATED_TASK__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__NAME = DAILY_REPEATED_TASK__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__NAMESPACE = DAILY_REPEATED_TASK__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__DESCRIPTION = DAILY_REPEATED_TASK__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__OBJECT_CONTROL = DAILY_REPEATED_TASK__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>State</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__STATE = DAILY_REPEATED_TASK__STATE;

  /**
   * The feature id for the '<em><b>Last Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__LAST_RUN = DAILY_REPEATED_TASK__LAST_RUN;

  /**
   * The feature id for the '<em><b>Next Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__NEXT_RUN = DAILY_REPEATED_TASK__NEXT_RUN;

  /**
   * The feature id for the '<em><b>System</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__SYSTEM = DAILY_REPEATED_TASK__SYSTEM;

  /**
   * The feature id for the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__DURATION = DAILY_REPEATED_TASK__DURATION;

  /**
   * The feature id for the '<em><b>Affected Objects</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__AFFECTED_OBJECTS = DAILY_REPEATED_TASK__AFFECTED_OBJECTS;

  /**
   * The feature id for the '<em><b>Type ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__TYPE_ID = DAILY_REPEATED_TASK__TYPE_ID;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__PARAMETERS = DAILY_REPEATED_TASK__PARAMETERS;

  /**
   * The feature id for the '<em><b>Action</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__ACTION = DAILY_REPEATED_TASK__ACTION;

  /**
   * The feature id for the '<em><b>User</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__USER = DAILY_REPEATED_TASK__USER;

  /**
   * The feature id for the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__PASSWORD = DAILY_REPEATED_TASK__PASSWORD;

  /**
   * The feature id for the '<em><b>Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__TOKEN = DAILY_REPEATED_TASK__TOKEN;

  /**
   * The feature id for the '<em><b>Run Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__RUN_NOW = DAILY_REPEATED_TASK__RUN_NOW;

  /**
   * The feature id for the '<em><b>Hour</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__HOUR = DAILY_REPEATED_TASK__HOUR;

  /**
   * The feature id for the '<em><b>Minute</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__MINUTE = DAILY_REPEATED_TASK__MINUTE;

  /**
   * The feature id for the '<em><b>Weekdays</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK__WEEKDAYS = DAILY_REPEATED_TASK_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Weekly Repeated Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WEEKLY_REPEATED_TASK_FEATURE_COUNT = DAILY_REPEATED_TASK_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.impl.MonthlyRepeatedTaskImpl <em>Monthly Repeated Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.impl.MonthlyRepeatedTaskImpl
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getMonthlyRepeatedTask()
   * @generated
   */
  int MONTHLY_REPEATED_TASK = 4;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__GUID = DAILY_REPEATED_TASK__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__GENERATION_NUMBER = DAILY_REPEATED_TASK__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__MODIFIABLE = DAILY_REPEATED_TASK__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__INTERNAL = DAILY_REPEATED_TASK__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__LAST_EDITED_BY = DAILY_REPEATED_TASK__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__TIMESTAMP = DAILY_REPEATED_TASK__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__CREATED_BY = DAILY_REPEATED_TASK__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__NAME = DAILY_REPEATED_TASK__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__NAMESPACE = DAILY_REPEATED_TASK__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__DESCRIPTION = DAILY_REPEATED_TASK__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__OBJECT_CONTROL = DAILY_REPEATED_TASK__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>State</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__STATE = DAILY_REPEATED_TASK__STATE;

  /**
   * The feature id for the '<em><b>Last Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__LAST_RUN = DAILY_REPEATED_TASK__LAST_RUN;

  /**
   * The feature id for the '<em><b>Next Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__NEXT_RUN = DAILY_REPEATED_TASK__NEXT_RUN;

  /**
   * The feature id for the '<em><b>System</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__SYSTEM = DAILY_REPEATED_TASK__SYSTEM;

  /**
   * The feature id for the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__DURATION = DAILY_REPEATED_TASK__DURATION;

  /**
   * The feature id for the '<em><b>Affected Objects</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__AFFECTED_OBJECTS = DAILY_REPEATED_TASK__AFFECTED_OBJECTS;

  /**
   * The feature id for the '<em><b>Type ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__TYPE_ID = DAILY_REPEATED_TASK__TYPE_ID;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__PARAMETERS = DAILY_REPEATED_TASK__PARAMETERS;

  /**
   * The feature id for the '<em><b>Action</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__ACTION = DAILY_REPEATED_TASK__ACTION;

  /**
   * The feature id for the '<em><b>User</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__USER = DAILY_REPEATED_TASK__USER;

  /**
   * The feature id for the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__PASSWORD = DAILY_REPEATED_TASK__PASSWORD;

  /**
   * The feature id for the '<em><b>Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__TOKEN = DAILY_REPEATED_TASK__TOKEN;

  /**
   * The feature id for the '<em><b>Run Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__RUN_NOW = DAILY_REPEATED_TASK__RUN_NOW;

  /**
   * The feature id for the '<em><b>Hour</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__HOUR = DAILY_REPEATED_TASK__HOUR;

  /**
   * The feature id for the '<em><b>Minute</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__MINUTE = DAILY_REPEATED_TASK__MINUTE;

  /**
   * The feature id for the '<em><b>Days</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK__DAYS = DAILY_REPEATED_TASK_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Monthly Repeated Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MONTHLY_REPEATED_TASK_FEATURE_COUNT = DAILY_REPEATED_TASK_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.impl.IntervalRepeatedTaskImpl <em>Interval Repeated Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.impl.IntervalRepeatedTaskImpl
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getIntervalRepeatedTask()
   * @generated
   */
  int INTERVAL_REPEATED_TASK = 5;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__GUID = SCHEDULED_TASK__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__GENERATION_NUMBER = SCHEDULED_TASK__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__MODIFIABLE = SCHEDULED_TASK__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__INTERNAL = SCHEDULED_TASK__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__LAST_EDITED_BY = SCHEDULED_TASK__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__TIMESTAMP = SCHEDULED_TASK__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__CREATED_BY = SCHEDULED_TASK__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__NAME = SCHEDULED_TASK__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__NAMESPACE = SCHEDULED_TASK__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__DESCRIPTION = SCHEDULED_TASK__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__OBJECT_CONTROL = SCHEDULED_TASK__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>State</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__STATE = SCHEDULED_TASK__STATE;

  /**
   * The feature id for the '<em><b>Last Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__LAST_RUN = SCHEDULED_TASK__LAST_RUN;

  /**
   * The feature id for the '<em><b>Next Run</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__NEXT_RUN = SCHEDULED_TASK__NEXT_RUN;

  /**
   * The feature id for the '<em><b>System</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__SYSTEM = SCHEDULED_TASK__SYSTEM;

  /**
   * The feature id for the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__DURATION = SCHEDULED_TASK__DURATION;

  /**
   * The feature id for the '<em><b>Affected Objects</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__AFFECTED_OBJECTS = SCHEDULED_TASK__AFFECTED_OBJECTS;

  /**
   * The feature id for the '<em><b>Type ID</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__TYPE_ID = SCHEDULED_TASK__TYPE_ID;

  /**
   * The feature id for the '<em><b>Parameters</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__PARAMETERS = SCHEDULED_TASK__PARAMETERS;

  /**
   * The feature id for the '<em><b>Action</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__ACTION = SCHEDULED_TASK__ACTION;

  /**
   * The feature id for the '<em><b>User</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__USER = SCHEDULED_TASK__USER;

  /**
   * The feature id for the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__PASSWORD = SCHEDULED_TASK__PASSWORD;

  /**
   * The feature id for the '<em><b>Token</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__TOKEN = SCHEDULED_TASK__TOKEN;

  /**
   * The feature id for the '<em><b>Run Now</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__RUN_NOW = SCHEDULED_TASK__RUN_NOW;

  /**
   * The feature id for the '<em><b>Interval</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__INTERVAL = SCHEDULED_TASK_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Time Unit</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK__TIME_UNIT = SCHEDULED_TASK_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Interval Repeated Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_REPEATED_TASK_FEATURE_COUNT = SCHEDULED_TASK_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.TaskStates <em>Task States</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.TaskStates
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getTaskStates()
   * @generated
   */
  int TASK_STATES = 6;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.Weekdays <em>Weekdays</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.Weekdays
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getWeekdays()
   * @generated
   */
  int WEEKDAYS = 7;

  /**
   * The meta object id for the '{@link com.iona.soa.model.scheduling.TimeUnits <em>Time Units</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.scheduling.TimeUnits
   * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getTimeUnits()
   * @generated
   */
  int TIME_UNITS = 8;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.scheduling.ScheduledTask <em>Scheduled Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Scheduled Task</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask
   * @generated
   */
  EClass getScheduledTask();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getState <em>State</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>State</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getState()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_State();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getLastRun <em>Last Run</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Last Run</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getLastRun()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_LastRun();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getNextRun <em>Next Run</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Next Run</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getNextRun()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_NextRun();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#isSystem <em>System</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>System</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#isSystem()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_System();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getDuration <em>Duration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Duration</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getDuration()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_Duration();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.scheduling.ScheduledTask#getAffectedObjects <em>Affected Objects</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Affected Objects</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getAffectedObjects()
   * @see #getScheduledTask()
   * @generated
   */
  EReference getScheduledTask_AffectedObjects();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getTypeID <em>Type ID</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type ID</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getTypeID()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_TypeID();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.scheduling.ScheduledTask#getParameters <em>Parameters</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Parameters</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getParameters()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_Parameters();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getAction <em>Action</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Action</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getAction()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_Action();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.scheduling.ScheduledTask#getUser <em>User</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>User</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getUser()
   * @see #getScheduledTask()
   * @generated
   */
  EReference getScheduledTask_User();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getPassword <em>Password</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Password</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getPassword()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_Password();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#getToken <em>Token</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Token</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#getToken()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_Token();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.ScheduledTask#isRunNow <em>Run Now</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Run Now</em>'.
   * @see com.iona.soa.model.scheduling.ScheduledTask#isRunNow()
   * @see #getScheduledTask()
   * @generated
   */
  EAttribute getScheduledTask_RunNow();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.scheduling.DailyRepeatedTask <em>Daily Repeated Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Daily Repeated Task</em>'.
   * @see com.iona.soa.model.scheduling.DailyRepeatedTask
   * @generated
   */
  EClass getDailyRepeatedTask();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.DailyRepeatedTask#getHour <em>Hour</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Hour</em>'.
   * @see com.iona.soa.model.scheduling.DailyRepeatedTask#getHour()
   * @see #getDailyRepeatedTask()
   * @generated
   */
  EAttribute getDailyRepeatedTask_Hour();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.DailyRepeatedTask#getMinute <em>Minute</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Minute</em>'.
   * @see com.iona.soa.model.scheduling.DailyRepeatedTask#getMinute()
   * @see #getDailyRepeatedTask()
   * @generated
   */
  EAttribute getDailyRepeatedTask_Minute();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.scheduling.OnceOffTask <em>Once Off Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Once Off Task</em>'.
   * @see com.iona.soa.model.scheduling.OnceOffTask
   * @generated
   */
  EClass getOnceOffTask();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.OnceOffTask#getScheduleDate <em>Schedule Date</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Schedule Date</em>'.
   * @see com.iona.soa.model.scheduling.OnceOffTask#getScheduleDate()
   * @see #getOnceOffTask()
   * @generated
   */
  EAttribute getOnceOffTask_ScheduleDate();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.OnceOffTask#isCleanupOnCompletion <em>Cleanup On Completion</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Cleanup On Completion</em>'.
   * @see com.iona.soa.model.scheduling.OnceOffTask#isCleanupOnCompletion()
   * @see #getOnceOffTask()
   * @generated
   */
  EAttribute getOnceOffTask_CleanupOnCompletion();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.scheduling.WeeklyRepeatedTask <em>Weekly Repeated Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Weekly Repeated Task</em>'.
   * @see com.iona.soa.model.scheduling.WeeklyRepeatedTask
   * @generated
   */
  EClass getWeeklyRepeatedTask();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.scheduling.WeeklyRepeatedTask#getWeekdays <em>Weekdays</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Weekdays</em>'.
   * @see com.iona.soa.model.scheduling.WeeklyRepeatedTask#getWeekdays()
   * @see #getWeeklyRepeatedTask()
   * @generated
   */
  EAttribute getWeeklyRepeatedTask_Weekdays();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.scheduling.MonthlyRepeatedTask <em>Monthly Repeated Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Monthly Repeated Task</em>'.
   * @see com.iona.soa.model.scheduling.MonthlyRepeatedTask
   * @generated
   */
  EClass getMonthlyRepeatedTask();

  /**
   * Returns the meta object for the attribute list '{@link com.iona.soa.model.scheduling.MonthlyRepeatedTask#getDays <em>Days</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Days</em>'.
   * @see com.iona.soa.model.scheduling.MonthlyRepeatedTask#getDays()
   * @see #getMonthlyRepeatedTask()
   * @generated
   */
  EAttribute getMonthlyRepeatedTask_Days();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.scheduling.IntervalRepeatedTask <em>Interval Repeated Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Interval Repeated Task</em>'.
   * @see com.iona.soa.model.scheduling.IntervalRepeatedTask
   * @generated
   */
  EClass getIntervalRepeatedTask();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.IntervalRepeatedTask#getInterval <em>Interval</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Interval</em>'.
   * @see com.iona.soa.model.scheduling.IntervalRepeatedTask#getInterval()
   * @see #getIntervalRepeatedTask()
   * @generated
   */
  EAttribute getIntervalRepeatedTask_Interval();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.scheduling.IntervalRepeatedTask#getTimeUnit <em>Time Unit</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Time Unit</em>'.
   * @see com.iona.soa.model.scheduling.IntervalRepeatedTask#getTimeUnit()
   * @see #getIntervalRepeatedTask()
   * @generated
   */
  EAttribute getIntervalRepeatedTask_TimeUnit();

  /**
   * Returns the meta object for enum '{@link com.iona.soa.model.scheduling.TaskStates <em>Task States</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Task States</em>'.
   * @see com.iona.soa.model.scheduling.TaskStates
   * @generated
   */
  EEnum getTaskStates();

  /**
   * Returns the meta object for enum '{@link com.iona.soa.model.scheduling.Weekdays <em>Weekdays</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Weekdays</em>'.
   * @see com.iona.soa.model.scheduling.Weekdays
   * @generated
   */
  EEnum getWeekdays();

  /**
   * Returns the meta object for enum '{@link com.iona.soa.model.scheduling.TimeUnits <em>Time Units</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Time Units</em>'.
   * @see com.iona.soa.model.scheduling.TimeUnits
   * @generated
   */
  EEnum getTimeUnits();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  SchedulingFactory getSchedulingFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl <em>Scheduled Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.impl.ScheduledTaskImpl
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getScheduledTask()
     * @generated
     */
    EClass SCHEDULED_TASK = eINSTANCE.getScheduledTask();

    /**
     * The meta object literal for the '<em><b>State</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__STATE = eINSTANCE.getScheduledTask_State();

    /**
     * The meta object literal for the '<em><b>Last Run</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__LAST_RUN = eINSTANCE.getScheduledTask_LastRun();

    /**
     * The meta object literal for the '<em><b>Next Run</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__NEXT_RUN = eINSTANCE.getScheduledTask_NextRun();

    /**
     * The meta object literal for the '<em><b>System</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__SYSTEM = eINSTANCE.getScheduledTask_System();

    /**
     * The meta object literal for the '<em><b>Duration</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__DURATION = eINSTANCE.getScheduledTask_Duration();

    /**
     * The meta object literal for the '<em><b>Affected Objects</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCHEDULED_TASK__AFFECTED_OBJECTS = eINSTANCE.getScheduledTask_AffectedObjects();

    /**
     * The meta object literal for the '<em><b>Type ID</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__TYPE_ID = eINSTANCE.getScheduledTask_TypeID();

    /**
     * The meta object literal for the '<em><b>Parameters</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__PARAMETERS = eINSTANCE.getScheduledTask_Parameters();

    /**
     * The meta object literal for the '<em><b>Action</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__ACTION = eINSTANCE.getScheduledTask_Action();

    /**
     * The meta object literal for the '<em><b>User</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SCHEDULED_TASK__USER = eINSTANCE.getScheduledTask_User();

    /**
     * The meta object literal for the '<em><b>Password</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__PASSWORD = eINSTANCE.getScheduledTask_Password();

    /**
     * The meta object literal for the '<em><b>Token</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__TOKEN = eINSTANCE.getScheduledTask_Token();

    /**
     * The meta object literal for the '<em><b>Run Now</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SCHEDULED_TASK__RUN_NOW = eINSTANCE.getScheduledTask_RunNow();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.impl.DailyRepeatedTaskImpl <em>Daily Repeated Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.impl.DailyRepeatedTaskImpl
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getDailyRepeatedTask()
     * @generated
     */
    EClass DAILY_REPEATED_TASK = eINSTANCE.getDailyRepeatedTask();

    /**
     * The meta object literal for the '<em><b>Hour</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DAILY_REPEATED_TASK__HOUR = eINSTANCE.getDailyRepeatedTask_Hour();

    /**
     * The meta object literal for the '<em><b>Minute</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DAILY_REPEATED_TASK__MINUTE = eINSTANCE.getDailyRepeatedTask_Minute();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.impl.OnceOffTaskImpl <em>Once Off Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.impl.OnceOffTaskImpl
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getOnceOffTask()
     * @generated
     */
    EClass ONCE_OFF_TASK = eINSTANCE.getOnceOffTask();

    /**
     * The meta object literal for the '<em><b>Schedule Date</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ONCE_OFF_TASK__SCHEDULE_DATE = eINSTANCE.getOnceOffTask_ScheduleDate();

    /**
     * The meta object literal for the '<em><b>Cleanup On Completion</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ONCE_OFF_TASK__CLEANUP_ON_COMPLETION = eINSTANCE.getOnceOffTask_CleanupOnCompletion();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.impl.WeeklyRepeatedTaskImpl <em>Weekly Repeated Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.impl.WeeklyRepeatedTaskImpl
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getWeeklyRepeatedTask()
     * @generated
     */
    EClass WEEKLY_REPEATED_TASK = eINSTANCE.getWeeklyRepeatedTask();

    /**
     * The meta object literal for the '<em><b>Weekdays</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute WEEKLY_REPEATED_TASK__WEEKDAYS = eINSTANCE.getWeeklyRepeatedTask_Weekdays();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.impl.MonthlyRepeatedTaskImpl <em>Monthly Repeated Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.impl.MonthlyRepeatedTaskImpl
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getMonthlyRepeatedTask()
     * @generated
     */
    EClass MONTHLY_REPEATED_TASK = eINSTANCE.getMonthlyRepeatedTask();

    /**
     * The meta object literal for the '<em><b>Days</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MONTHLY_REPEATED_TASK__DAYS = eINSTANCE.getMonthlyRepeatedTask_Days();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.impl.IntervalRepeatedTaskImpl <em>Interval Repeated Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.impl.IntervalRepeatedTaskImpl
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getIntervalRepeatedTask()
     * @generated
     */
    EClass INTERVAL_REPEATED_TASK = eINSTANCE.getIntervalRepeatedTask();

    /**
     * The meta object literal for the '<em><b>Interval</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTERVAL_REPEATED_TASK__INTERVAL = eINSTANCE.getIntervalRepeatedTask_Interval();

    /**
     * The meta object literal for the '<em><b>Time Unit</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTERVAL_REPEATED_TASK__TIME_UNIT = eINSTANCE.getIntervalRepeatedTask_TimeUnit();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.TaskStates <em>Task States</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.TaskStates
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getTaskStates()
     * @generated
     */
    EEnum TASK_STATES = eINSTANCE.getTaskStates();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.Weekdays <em>Weekdays</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.Weekdays
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getWeekdays()
     * @generated
     */
    EEnum WEEKDAYS = eINSTANCE.getWeekdays();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.scheduling.TimeUnits <em>Time Units</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.scheduling.TimeUnits
     * @see com.iona.soa.model.scheduling.impl.SchedulingPackageImpl#getTimeUnits()
     * @generated
     */
    EEnum TIME_UNITS = eINSTANCE.getTimeUnits();

  }

} //SchedulingPackage
