/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Task States</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.scheduling.SchedulingPackage#getTaskStates()
 * @model
 * @generated
 */
public enum TaskStates implements Enumerator
{
  /**
   * The '<em><b>CREATED</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CREATED_VALUE
   * @generated
   * @ordered
   */
  CREATED(0, "CREATED", "CREATED"),

  /**
   * The '<em><b>SCHEDULED</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #SCHEDULED_VALUE
   * @generated
   * @ordered
   */
  SCHEDULED(1, "SCHEDULED", "SCHEDULED"),

  /**
   * The '<em><b>RUNNING</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #RUNNING_VALUE
   * @generated
   * @ordered
   */
  RUNNING(2, "RUNNING", "RUNNING"),

  /**
   * The '<em><b>FINISHED</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #FINISHED_VALUE
   * @generated
   * @ordered
   */
  FINISHED(3, "FINISHED", "FINISHED"),

  /**
   * The '<em><b>ERROR</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ERROR_VALUE
   * @generated
   * @ordered
   */
  ERROR(4, "ERROR", "ERROR"),

  /**
   * The '<em><b>DISABLED</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #DISABLED_VALUE
   * @generated
   * @ordered
   */
  DISABLED(5, "DISABLED", "DISABLED"),

  /**
   * The '<em><b>AUTHENICATED</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #AUTHENICATED_VALUE
   * @generated
   * @ordered
   */
  AUTHENICATED(6, "AUTHENICATED", "AUTHENICATED"),

  /**
   * The '<em><b>UNAUTHENICATED</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #UNAUTHENICATED_VALUE
   * @generated
   * @ordered
   */
  UNAUTHENICATED(7, "UNAUTHENICATED", "UNAUTHENICATED"),

  /**
   * The '<em><b>UNAUTHORISED</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #UNAUTHORISED_VALUE
   * @generated
   * @ordered
   */
  UNAUTHORISED(8, "UNAUTHORISED", "UNAUTHORISED");

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The '<em><b>CREATED</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>CREATED</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #CREATED
   * @model
   * @generated
   * @ordered
   */
  public static final int CREATED_VALUE = 0;

  /**
   * The '<em><b>SCHEDULED</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>SCHEDULED</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #SCHEDULED
   * @model
   * @generated
   * @ordered
   */
  public static final int SCHEDULED_VALUE = 1;

  /**
   * The '<em><b>RUNNING</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>RUNNING</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #RUNNING
   * @model
   * @generated
   * @ordered
   */
  public static final int RUNNING_VALUE = 2;

  /**
   * The '<em><b>FINISHED</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>FINISHED</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #FINISHED
   * @model
   * @generated
   * @ordered
   */
  public static final int FINISHED_VALUE = 3;

  /**
   * The '<em><b>ERROR</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ERROR</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ERROR
   * @model
   * @generated
   * @ordered
   */
  public static final int ERROR_VALUE = 4;

  /**
   * The '<em><b>DISABLED</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>DISABLED</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #DISABLED
   * @model
   * @generated
   * @ordered
   */
  public static final int DISABLED_VALUE = 5;

  /**
   * The '<em><b>AUTHENICATED</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>AUTHENICATED</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #AUTHENICATED
   * @model
   * @generated
   * @ordered
   */
  public static final int AUTHENICATED_VALUE = 6;

  /**
   * The '<em><b>UNAUTHENICATED</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>UNAUTHENICATED</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #UNAUTHENICATED
   * @model
   * @generated
   * @ordered
   */
  public static final int UNAUTHENICATED_VALUE = 7;

  /**
   * The '<em><b>UNAUTHORISED</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>UNAUTHORISED</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #UNAUTHORISED
   * @model
   * @generated
   * @ordered
   */
  public static final int UNAUTHORISED_VALUE = 8;

  /**
   * An array of all the '<em><b>Task States</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final TaskStates[] VALUES_ARRAY =
    new TaskStates[]
    {
      CREATED,
      SCHEDULED,
      RUNNING,
      FINISHED,
      ERROR,
      DISABLED,
      AUTHENICATED,
      UNAUTHENICATED,
      UNAUTHORISED,
    };

  /**
   * A public read-only list of all the '<em><b>Task States</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<TaskStates> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Task States</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static TaskStates get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      TaskStates result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Task States</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static TaskStates getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      TaskStates result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Task States</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static TaskStates get(int value)
  {
    switch (value)
    {
      case CREATED_VALUE: return CREATED;
      case SCHEDULED_VALUE: return SCHEDULED;
      case RUNNING_VALUE: return RUNNING;
      case FINISHED_VALUE: return FINISHED;
      case ERROR_VALUE: return ERROR;
      case DISABLED_VALUE: return DISABLED;
      case AUTHENICATED_VALUE: return AUTHENICATED;
      case UNAUTHENICATED_VALUE: return UNAUTHENICATED;
      case UNAUTHORISED_VALUE: return UNAUTHORISED;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private TaskStates(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //TaskStates
