/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling.impl;

import com.iona.soa.model.scheduling.IntervalRepeatedTask;
import com.iona.soa.model.scheduling.SchedulingPackage;
import com.iona.soa.model.scheduling.TimeUnits;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interval Repeated Task</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.scheduling.impl.IntervalRepeatedTaskImpl#getInterval <em>Interval</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.IntervalRepeatedTaskImpl#getTimeUnit <em>Time Unit</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class IntervalRepeatedTaskImpl extends ScheduledTaskImpl implements IntervalRepeatedTask
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getInterval() <em>Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInterval()
   * @generated
   * @ordered
   */
  protected static final short INTERVAL_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getInterval() <em>Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInterval()
   * @generated
   * @ordered
   */
  protected short interval = INTERVAL_EDEFAULT;

  /**
   * The default value of the '{@link #getTimeUnit() <em>Time Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimeUnit()
   * @generated
   * @ordered
   */
  protected static final TimeUnits TIME_UNIT_EDEFAULT = TimeUnits.MINUTES;

  /**
   * The cached value of the '{@link #getTimeUnit() <em>Time Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimeUnit()
   * @generated
   * @ordered
   */
  protected TimeUnits timeUnit = TIME_UNIT_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IntervalRepeatedTaskImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SchedulingPackage.Literals.INTERVAL_REPEATED_TASK;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public short getInterval() {
    autoResolveEProxy(SchedulingPackage.Literals.INTERVAL_REPEATED_TASK__INTERVAL);
    return _basicGetInterval();
  }
  
  private final short _basicGetInterval() {
    return interval;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setInterval(short newInterval)
  {
    
    short oldInterval = interval;
    interval = newInterval;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.INTERVAL_REPEATED_TASK__INTERVAL, oldInterval, interval));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TimeUnits getTimeUnit() {
    autoResolveEProxy(SchedulingPackage.Literals.INTERVAL_REPEATED_TASK__TIME_UNIT);
    return _basicGetTimeUnit();
  }
  
  private final TimeUnits _basicGetTimeUnit() {
    return timeUnit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTimeUnit(TimeUnits newTimeUnit)
  {
    
    TimeUnits oldTimeUnit = timeUnit;
    timeUnit = newTimeUnit == null ? TIME_UNIT_EDEFAULT : newTimeUnit;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.INTERVAL_REPEATED_TASK__TIME_UNIT, oldTimeUnit, timeUnit));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SchedulingPackage.INTERVAL_REPEATED_TASK__INTERVAL:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.INTERVAL_REPEATED_TASK__INTERVAL); }
        return new Short(_basicGetInterval());
      case SchedulingPackage.INTERVAL_REPEATED_TASK__TIME_UNIT:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.INTERVAL_REPEATED_TASK__TIME_UNIT); }
        return _basicGetTimeUnit();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SchedulingPackage.INTERVAL_REPEATED_TASK__INTERVAL:
        setInterval(((Short)newValue).shortValue());
        return;
      case SchedulingPackage.INTERVAL_REPEATED_TASK__TIME_UNIT:
        setTimeUnit((TimeUnits)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SchedulingPackage.INTERVAL_REPEATED_TASK__INTERVAL:
      setInterval(INTERVAL_EDEFAULT);
      return;
    case SchedulingPackage.INTERVAL_REPEATED_TASK__TIME_UNIT:
      setTimeUnit(TIME_UNIT_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SchedulingPackage.INTERVAL_REPEATED_TASK__INTERVAL:
        return interval != INTERVAL_EDEFAULT;
      case SchedulingPackage.INTERVAL_REPEATED_TASK__TIME_UNIT:
        return timeUnit != TIME_UNIT_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (interval: ");
    result.append(interval);
    result.append(", timeUnit: ");
    result.append(timeUnit);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //IntervalRepeatedTaskImpl


