/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling.impl;

import com.iona.soa.model.scheduling.OnceOffTask;
import com.iona.soa.model.scheduling.SchedulingPackage;

import java.sql.Timestamp;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Once Off Task</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.scheduling.impl.OnceOffTaskImpl#getScheduleDate <em>Schedule Date</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.OnceOffTaskImpl#isCleanupOnCompletion <em>Cleanup On Completion</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class OnceOffTaskImpl extends ScheduledTaskImpl implements OnceOffTask
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getScheduleDate() <em>Schedule Date</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScheduleDate()
   * @generated
   * @ordered
   */
  protected static final Timestamp SCHEDULE_DATE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getScheduleDate() <em>Schedule Date</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScheduleDate()
   * @generated
   * @ordered
   */
  protected Timestamp scheduleDate = SCHEDULE_DATE_EDEFAULT;

  /**
   * The default value of the '{@link #isCleanupOnCompletion() <em>Cleanup On Completion</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isCleanupOnCompletion()
   * @generated
   * @ordered
   */
  protected static final boolean CLEANUP_ON_COMPLETION_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isCleanupOnCompletion() <em>Cleanup On Completion</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isCleanupOnCompletion()
   * @generated
   * @ordered
   */
  protected boolean cleanupOnCompletion = CLEANUP_ON_COMPLETION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OnceOffTaskImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SchedulingPackage.Literals.ONCE_OFF_TASK;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp getScheduleDate() {
    autoResolveEProxy(SchedulingPackage.Literals.ONCE_OFF_TASK__SCHEDULE_DATE);
    return _basicGetScheduleDate();
  }
  
  private final Timestamp _basicGetScheduleDate() {
    return scheduleDate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScheduleDate(Timestamp newScheduleDate)
  {
    
    Timestamp oldScheduleDate = scheduleDate;
    scheduleDate = newScheduleDate;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.ONCE_OFF_TASK__SCHEDULE_DATE, oldScheduleDate, scheduleDate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isCleanupOnCompletion() {
    autoResolveEProxy(SchedulingPackage.Literals.ONCE_OFF_TASK__CLEANUP_ON_COMPLETION);
    return _basicGetCleanupOnCompletion();
  }
  
  private final boolean _basicGetCleanupOnCompletion() {
    return cleanupOnCompletion;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCleanupOnCompletion(boolean newCleanupOnCompletion)
  {
    
    boolean oldCleanupOnCompletion = cleanupOnCompletion;
    cleanupOnCompletion = newCleanupOnCompletion;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.ONCE_OFF_TASK__CLEANUP_ON_COMPLETION, oldCleanupOnCompletion, cleanupOnCompletion));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SchedulingPackage.ONCE_OFF_TASK__SCHEDULE_DATE:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.ONCE_OFF_TASK__SCHEDULE_DATE); }
        return _basicGetScheduleDate();
      case SchedulingPackage.ONCE_OFF_TASK__CLEANUP_ON_COMPLETION:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.ONCE_OFF_TASK__CLEANUP_ON_COMPLETION); }
        return _basicGetCleanupOnCompletion() ? Boolean.TRUE : Boolean.FALSE;
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SchedulingPackage.ONCE_OFF_TASK__SCHEDULE_DATE:
        setScheduleDate((Timestamp)newValue);
        return;
      case SchedulingPackage.ONCE_OFF_TASK__CLEANUP_ON_COMPLETION:
        setCleanupOnCompletion(((Boolean)newValue).booleanValue());
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SchedulingPackage.ONCE_OFF_TASK__SCHEDULE_DATE:
      setScheduleDate(SCHEDULE_DATE_EDEFAULT);
      return;
    case SchedulingPackage.ONCE_OFF_TASK__CLEANUP_ON_COMPLETION:
      setCleanupOnCompletion(CLEANUP_ON_COMPLETION_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SchedulingPackage.ONCE_OFF_TASK__SCHEDULE_DATE:
        return SCHEDULE_DATE_EDEFAULT == null ? scheduleDate != null : !SCHEDULE_DATE_EDEFAULT.equals(scheduleDate);
      case SchedulingPackage.ONCE_OFF_TASK__CLEANUP_ON_COMPLETION:
        return cleanupOnCompletion != CLEANUP_ON_COMPLETION_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (scheduleDate: ");
    result.append(scheduleDate);
    result.append(", cleanupOnCompletion: ");
    result.append(cleanupOnCompletion);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //OnceOffTaskImpl


