/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling.impl;

import com.iona.soa.model.repository.IRepositoryObject;
import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.scheduling.ScheduledTask;
import com.iona.soa.model.scheduling.SchedulingPackage;
import com.iona.soa.model.scheduling.TaskStates;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.SecurityPackage;
import com.iona.soa.model.security.User;

import java.sql.Timestamp;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scheduled Task</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getObjectControl <em>Object Control</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getState <em>State</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getLastRun <em>Last Run</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getNextRun <em>Next Run</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#isSystem <em>System</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getDuration <em>Duration</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getAffectedObjects <em>Affected Objects</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getTypeID <em>Type ID</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getParameters <em>Parameters</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getAction <em>Action</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getUser <em>User</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getPassword <em>Password</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#getToken <em>Token</em>}</li>
 *   <li>{@link com.iona.soa.model.scheduling.impl.ScheduledTaskImpl#isRunNow <em>Run Now</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ScheduledTaskImpl extends IPersistableObjectImpl implements ScheduledTask
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getObjectControl() <em>Object Control</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObjectControl()
   * @generated
   * @ordered
   */
  protected ObjectPermission objectControl;

  /**
   * The default value of the '{@link #getState() <em>State</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getState()
   * @generated
   * @ordered
   */
  protected static final TaskStates STATE_EDEFAULT = TaskStates.CREATED;

  /**
   * The cached value of the '{@link #getState() <em>State</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getState()
   * @generated
   * @ordered
   */
  protected TaskStates state = STATE_EDEFAULT;

  /**
   * The default value of the '{@link #getLastRun() <em>Last Run</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLastRun()
   * @generated
   * @ordered
   */
  protected static final Timestamp LAST_RUN_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getLastRun() <em>Last Run</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLastRun()
   * @generated
   * @ordered
   */
  protected Timestamp lastRun = LAST_RUN_EDEFAULT;

  /**
   * The default value of the '{@link #getNextRun() <em>Next Run</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNextRun()
   * @generated
   * @ordered
   */
  protected static final Timestamp NEXT_RUN_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNextRun() <em>Next Run</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNextRun()
   * @generated
   * @ordered
   */
  protected Timestamp nextRun = NEXT_RUN_EDEFAULT;

  /**
   * The default value of the '{@link #isSystem() <em>System</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSystem()
   * @generated
   * @ordered
   */
  protected static final boolean SYSTEM_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isSystem() <em>System</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSystem()
   * @generated
   * @ordered
   */
  protected boolean system = SYSTEM_EDEFAULT;

  /**
   * The default value of the '{@link #getDuration() <em>Duration</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDuration()
   * @generated
   * @ordered
   */
  protected static final int DURATION_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getDuration() <em>Duration</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDuration()
   * @generated
   * @ordered
   */
  protected int duration = DURATION_EDEFAULT;

  /**
   * The cached value of the '{@link #getAffectedObjects() <em>Affected Objects</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAffectedObjects()
   * @generated
   * @ordered
   */
  protected EList<IRepositoryObject> affectedObjects;

  /**
   * The default value of the '{@link #getTypeID() <em>Type ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTypeID()
   * @generated
   * @ordered
   */
  protected static final String TYPE_ID_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getTypeID() <em>Type ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTypeID()
   * @generated
   * @ordered
   */
  protected String typeID = TYPE_ID_EDEFAULT;

  /**
   * The cached value of the '{@link #getParameters() <em>Parameters</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParameters()
   * @generated
   * @ordered
   */
  protected EList<String> parameters;

  /**
   * The default value of the '{@link #getAction() <em>Action</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAction()
   * @generated
   * @ordered
   */
  protected static final String ACTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getAction() <em>Action</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAction()
   * @generated
   * @ordered
   */
  protected String action = ACTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getUser() <em>User</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUser()
   * @generated
   * @ordered
   */
  protected User user;

  /**
   * The default value of the '{@link #getPassword() <em>Password</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPassword()
   * @generated
   * @ordered
   */
  protected static final String PASSWORD_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getPassword() <em>Password</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPassword()
   * @generated
   * @ordered
   */
  protected String password = PASSWORD_EDEFAULT;

  /**
   * The default value of the '{@link #getToken() <em>Token</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getToken()
   * @generated
   * @ordered
   */
  protected static final String TOKEN_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getToken() <em>Token</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getToken()
   * @generated
   * @ordered
   */
  protected String token = TOKEN_EDEFAULT;

  /**
   * The default value of the '{@link #isRunNow() <em>Run Now</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isRunNow()
   * @generated
   * @ordered
   */
  protected static final boolean RUN_NOW_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isRunNow() <em>Run Now</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isRunNow()
   * @generated
   * @ordered
   */
  protected boolean runNow = RUN_NOW_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ScheduledTaskImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SchedulingPackage.Literals.SCHEDULED_TASK;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission getObjectControl() {
    autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL);
    return _basicGetObjectControl();
  }
  
  private final ObjectPermission _basicGetObjectControl() {
    return objectControl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObjectControl(ObjectPermission newObjectControl, NotificationChain msgs)
  {
    ObjectPermission oldObjectControl = objectControl;
    objectControl = newObjectControl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL, oldObjectControl, newObjectControl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObjectControl(ObjectPermission newObjectControl)
  {
    
    if (newObjectControl != objectControl)
    {
      NotificationChain msgs = null;
      if (objectControl != null)
        msgs = ((InternalEObject)objectControl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL, null, msgs);
      if (newObjectControl != null)
        msgs = ((InternalEObject)newObjectControl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL, null, msgs);
      msgs = basicSetObjectControl(newObjectControl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL, newObjectControl, newObjectControl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TaskStates getState() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__STATE);
    return _basicGetState();
  }
  
  private final TaskStates _basicGetState() {
    return state;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setState(TaskStates newState)
  {
    
    TaskStates oldState = state;
    state = newState == null ? STATE_EDEFAULT : newState;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__STATE, oldState, state));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp getLastRun() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__LAST_RUN);
    return _basicGetLastRun();
  }
  
  private final Timestamp _basicGetLastRun() {
    return lastRun;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLastRun(Timestamp newLastRun)
  {
    
    Timestamp oldLastRun = lastRun;
    lastRun = newLastRun;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__LAST_RUN, oldLastRun, lastRun));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Timestamp getNextRun() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__NEXT_RUN);
    return _basicGetNextRun();
  }
  
  private final Timestamp _basicGetNextRun() {
    return nextRun;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNextRun(Timestamp newNextRun)
  {
    
    Timestamp oldNextRun = nextRun;
    nextRun = newNextRun;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__NEXT_RUN, oldNextRun, nextRun));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSystem() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__SYSTEM);
    return _basicGetSystem();
  }
  
  private final boolean _basicGetSystem() {
    return system;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSystem(boolean newSystem)
  {
    
    boolean oldSystem = system;
    system = newSystem;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__SYSTEM, oldSystem, system));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getDuration() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__DURATION);
    return _basicGetDuration();
  }
  
  private final int _basicGetDuration() {
    return duration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDuration(int newDuration)
  {
    
    int oldDuration = duration;
    duration = newDuration;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__DURATION, oldDuration, duration));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<IRepositoryObject> getAffectedObjects() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__AFFECTED_OBJECTS);
    return _basicGetAffectedObjects();
  }
  
  private final EList<IRepositoryObject> _basicGetAffectedObjects() {
    if (affectedObjects == null)
    {
      affectedObjects = new EObjectResolvingEList<IRepositoryObject>(IRepositoryObject.class, this, SchedulingPackage.SCHEDULED_TASK__AFFECTED_OBJECTS);
    }
    return affectedObjects;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTypeID() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__TYPE_ID);
    return _basicGetTypeID();
  }
  
  private final String _basicGetTypeID() {
    return typeID;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTypeID(String newTypeID)
  {
    
    String oldTypeID = typeID;
    typeID = newTypeID;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__TYPE_ID, oldTypeID, typeID));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<String> getParameters() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__PARAMETERS);
    return _basicGetParameters();
  }
  
  private final EList<String> _basicGetParameters() {
    if (parameters == null)
    {
      parameters = new EDataTypeUniqueEList<String>(String.class, this, SchedulingPackage.SCHEDULED_TASK__PARAMETERS);
    }
    return parameters;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getAction() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__ACTION);
    return _basicGetAction();
  }
  
  private final String _basicGetAction() {
    return action;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setAction(String newAction)
  {
    
    String oldAction = action;
    action = newAction;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__ACTION, oldAction, action));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public User getUser() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__USER);
    return _basicGetUser();
  }
  
  private final User _basicGetUser() {
    if (user != null && user.eIsProxy())
    {
      InternalEObject oldUser = (InternalEObject)user;
      user = (User)eResolveProxy(oldUser);
      if (user != oldUser)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, SchedulingPackage.SCHEDULED_TASK__USER, oldUser, user));
      }
    }
    return user;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public User basicGetUser()
  {
    return user;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUser(User newUser)
  {
    
    User oldUser = user;
    user = newUser;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__USER, oldUser, user));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPassword() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__PASSWORD);
    return _basicGetPassword();
  }
  
  private final String _basicGetPassword() {
    return password;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPassword(String newPassword)
  {
    
    String oldPassword = password;
    password = newPassword;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__PASSWORD, oldPassword, password));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getToken() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__TOKEN);
    return _basicGetToken();
  }
  
  private final String _basicGetToken() {
    return token;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setToken(String newToken)
  {
    
    String oldToken = token;
    token = newToken;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__TOKEN, oldToken, token));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isRunNow() {
    autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__RUN_NOW);
    return _basicGetRunNow();
  }
  
  private final boolean _basicGetRunNow() {
    return runNow;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRunNow(boolean newRunNow)
  {
    
    boolean oldRunNow = runNow;
    runNow = newRunNow;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchedulingPackage.SCHEDULED_TASK__RUN_NOW, oldRunNow, runNow));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL:
        return basicSetObjectControl(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SchedulingPackage.SCHEDULED_TASK__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SchedulingPackage.SCHEDULED_TASK__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SchedulingPackage.SCHEDULED_TASK__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL); }
        return _basicGetObjectControl();
      case SchedulingPackage.SCHEDULED_TASK__STATE:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__STATE); }
        return _basicGetState();
      case SchedulingPackage.SCHEDULED_TASK__LAST_RUN:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__LAST_RUN); }
        return _basicGetLastRun();
      case SchedulingPackage.SCHEDULED_TASK__NEXT_RUN:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__NEXT_RUN); }
        return _basicGetNextRun();
      case SchedulingPackage.SCHEDULED_TASK__SYSTEM:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__SYSTEM); }
        return _basicGetSystem() ? Boolean.TRUE : Boolean.FALSE;
      case SchedulingPackage.SCHEDULED_TASK__DURATION:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__DURATION); }
        return new Integer(_basicGetDuration());
      case SchedulingPackage.SCHEDULED_TASK__AFFECTED_OBJECTS:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__AFFECTED_OBJECTS); }
        return _basicGetAffectedObjects();
      case SchedulingPackage.SCHEDULED_TASK__TYPE_ID:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__TYPE_ID); }
        return _basicGetTypeID();
      case SchedulingPackage.SCHEDULED_TASK__PARAMETERS:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__PARAMETERS); }
        return _basicGetParameters();
      case SchedulingPackage.SCHEDULED_TASK__ACTION:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__ACTION); }
        return _basicGetAction();
      case SchedulingPackage.SCHEDULED_TASK__USER:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__USER); }
        if (resolve) return getUser();
        return _basicGetUser();
      case SchedulingPackage.SCHEDULED_TASK__PASSWORD:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__PASSWORD); }
        return _basicGetPassword();
      case SchedulingPackage.SCHEDULED_TASK__TOKEN:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__TOKEN); }
        return _basicGetToken();
      case SchedulingPackage.SCHEDULED_TASK__RUN_NOW:
      if (resolve) { autoResolveEProxy(SchedulingPackage.Literals.SCHEDULED_TASK__RUN_NOW); }
        return _basicGetRunNow() ? Boolean.TRUE : Boolean.FALSE;
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SchedulingPackage.SCHEDULED_TASK__NAME:
        setName((String)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL:
        setObjectControl((ObjectPermission)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__STATE:
        setState((TaskStates)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__LAST_RUN:
        setLastRun((Timestamp)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__NEXT_RUN:
        setNextRun((Timestamp)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__SYSTEM:
        setSystem(((Boolean)newValue).booleanValue());
        return;
      case SchedulingPackage.SCHEDULED_TASK__DURATION:
        setDuration(((Integer)newValue).intValue());
        return;
      case SchedulingPackage.SCHEDULED_TASK__AFFECTED_OBJECTS:
        _basicGetAffectedObjects().clear();
        _basicGetAffectedObjects().addAll((Collection<? extends IRepositoryObject>)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__TYPE_ID:
        setTypeID((String)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__PARAMETERS:
        _basicGetParameters().clear();
        _basicGetParameters().addAll((Collection<? extends String>)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__ACTION:
        setAction((String)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__USER:
        setUser((User)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__PASSWORD:
        setPassword((String)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__TOKEN:
        setToken((String)newValue);
        return;
      case SchedulingPackage.SCHEDULED_TASK__RUN_NOW:
        setRunNow(((Boolean)newValue).booleanValue());
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SchedulingPackage.SCHEDULED_TASK__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL:
      setObjectControl((ObjectPermission)null);
      return;
    case SchedulingPackage.SCHEDULED_TASK__STATE:
      setState(STATE_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__LAST_RUN:
      setLastRun(LAST_RUN_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__NEXT_RUN:
      setNextRun(NEXT_RUN_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__SYSTEM:
      setSystem(SYSTEM_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__DURATION:
      setDuration(DURATION_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__AFFECTED_OBJECTS:
      _basicGetAffectedObjects().clear();
      return;
    case SchedulingPackage.SCHEDULED_TASK__TYPE_ID:
      setTypeID(TYPE_ID_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__PARAMETERS:
      _basicGetParameters().clear();
      return;
    case SchedulingPackage.SCHEDULED_TASK__ACTION:
      setAction(ACTION_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__USER:
      setUser((User)null);
      return;
    case SchedulingPackage.SCHEDULED_TASK__PASSWORD:
      setPassword(PASSWORD_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__TOKEN:
      setToken(TOKEN_EDEFAULT);
      return;
    case SchedulingPackage.SCHEDULED_TASK__RUN_NOW:
      setRunNow(RUN_NOW_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SchedulingPackage.SCHEDULED_TASK__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SchedulingPackage.SCHEDULED_TASK__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SchedulingPackage.SCHEDULED_TASK__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SchedulingPackage.SCHEDULED_TASK__OBJECT_CONTROL:
        return objectControl != null;
      case SchedulingPackage.SCHEDULED_TASK__STATE:
        return state != STATE_EDEFAULT;
      case SchedulingPackage.SCHEDULED_TASK__LAST_RUN:
        return LAST_RUN_EDEFAULT == null ? lastRun != null : !LAST_RUN_EDEFAULT.equals(lastRun);
      case SchedulingPackage.SCHEDULED_TASK__NEXT_RUN:
        return NEXT_RUN_EDEFAULT == null ? nextRun != null : !NEXT_RUN_EDEFAULT.equals(nextRun);
      case SchedulingPackage.SCHEDULED_TASK__SYSTEM:
        return system != SYSTEM_EDEFAULT;
      case SchedulingPackage.SCHEDULED_TASK__DURATION:
        return duration != DURATION_EDEFAULT;
      case SchedulingPackage.SCHEDULED_TASK__AFFECTED_OBJECTS:
        return affectedObjects != null && !affectedObjects.isEmpty();
      case SchedulingPackage.SCHEDULED_TASK__TYPE_ID:
        return TYPE_ID_EDEFAULT == null ? typeID != null : !TYPE_ID_EDEFAULT.equals(typeID);
      case SchedulingPackage.SCHEDULED_TASK__PARAMETERS:
        return parameters != null && !parameters.isEmpty();
      case SchedulingPackage.SCHEDULED_TASK__ACTION:
        return ACTION_EDEFAULT == null ? action != null : !ACTION_EDEFAULT.equals(action);
      case SchedulingPackage.SCHEDULED_TASK__USER:
        return user != null;
      case SchedulingPackage.SCHEDULED_TASK__PASSWORD:
        return PASSWORD_EDEFAULT == null ? password != null : !PASSWORD_EDEFAULT.equals(password);
      case SchedulingPackage.SCHEDULED_TASK__TOKEN:
        return TOKEN_EDEFAULT == null ? token != null : !TOKEN_EDEFAULT.equals(token);
      case SchedulingPackage.SCHEDULED_TASK__RUN_NOW:
        return runNow != RUN_NOW_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(", state: ");
    result.append(state);
    result.append(", lastRun: ");
    result.append(lastRun);
    result.append(", nextRun: ");
    result.append(nextRun);
    result.append(", system: ");
    result.append(system);
    result.append(", duration: ");
    result.append(duration);
    result.append(", typeID: ");
    result.append(typeID);
    result.append(", parameters: ");
    result.append(parameters);
    result.append(", action: ");
    result.append(action);
    result.append(", password: ");
    result.append(password);
    result.append(", token: ");
    result.append(token);
    result.append(", runNow: ");
    result.append(runNow);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //ScheduledTaskImpl


