/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling.impl;

import com.iona.soa.model.scheduling.*;

import java.lang.reflect.Method;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SchedulingFactoryImpl extends EFactoryImpl implements SchedulingFactory
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

/* begin IONA modification */
  private String defaultNamespace = "http://www.example.org/";

  public final void setDefaultNamespace(String namespace) {
    this.defaultNamespace = namespace;
  }

/* end IONA modification */
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static SchedulingFactory init()
  {
    try
    {
      SchedulingFactory theSchedulingFactory = (SchedulingFactory)EPackage.Registry.INSTANCE.getEFactory("http://com.iona.soa.model.scheduling"); 
      if (theSchedulingFactory != null)
      {
        return theSchedulingFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new SchedulingFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SchedulingFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case SchedulingPackage.DAILY_REPEATED_TASK: return createDailyRepeatedTask();
      case SchedulingPackage.ONCE_OFF_TASK: return createOnceOffTask();
      case SchedulingPackage.WEEKLY_REPEATED_TASK: return createWeeklyRepeatedTask();
      case SchedulingPackage.MONTHLY_REPEATED_TASK: return createMonthlyRepeatedTask();
      case SchedulingPackage.INTERVAL_REPEATED_TASK: return createIntervalRepeatedTask();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case SchedulingPackage.TASK_STATES:
        return createTaskStatesFromString(eDataType, initialValue);
      case SchedulingPackage.WEEKDAYS:
        return createWeekdaysFromString(eDataType, initialValue);
      case SchedulingPackage.TIME_UNITS:
        return createTimeUnitsFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case SchedulingPackage.TASK_STATES:
        return convertTaskStatesToString(eDataType, instanceValue);
      case SchedulingPackage.WEEKDAYS:
        return convertWeekdaysToString(eDataType, instanceValue);
      case SchedulingPackage.TIME_UNITS:
        return convertTimeUnitsToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DailyRepeatedTask createDailyRepeatedTask()
  {
       	/* begin IONA modification */
    	//DailyRepeatedTaskImpl dailyRepeatedTask = new DailyRepeatedTaskImpl();
    	DailyRepeatedTask dailyRepeatedTask = new DailyRepeatedTaskImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = dailyRepeatedTask.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(dailyRepeatedTask, new Object[] {"DailyRepeatedTask-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = dailyRepeatedTask.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(dailyRepeatedTask, new Object[] {"DailyRepeatedTask"});
            Method factoryFlagSetter = dailyRepeatedTask.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(dailyRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = dailyRepeatedTask.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(dailyRepeatedTask, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = dailyRepeatedTask.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(dailyRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return dailyRepeatedTask;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OnceOffTask createOnceOffTask()
  {
       	/* begin IONA modification */
    	//OnceOffTaskImpl onceOffTask = new OnceOffTaskImpl();
    	OnceOffTask onceOffTask = new OnceOffTaskImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = onceOffTask.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(onceOffTask, new Object[] {"OnceOffTask-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = onceOffTask.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(onceOffTask, new Object[] {"OnceOffTask"});
            Method factoryFlagSetter = onceOffTask.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(onceOffTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = onceOffTask.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(onceOffTask, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = onceOffTask.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(onceOffTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return onceOffTask;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WeeklyRepeatedTask createWeeklyRepeatedTask()
  {
       	/* begin IONA modification */
    	//WeeklyRepeatedTaskImpl weeklyRepeatedTask = new WeeklyRepeatedTaskImpl();
    	WeeklyRepeatedTask weeklyRepeatedTask = new WeeklyRepeatedTaskImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = weeklyRepeatedTask.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(weeklyRepeatedTask, new Object[] {"WeeklyRepeatedTask-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = weeklyRepeatedTask.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(weeklyRepeatedTask, new Object[] {"WeeklyRepeatedTask"});
            Method factoryFlagSetter = weeklyRepeatedTask.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(weeklyRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = weeklyRepeatedTask.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(weeklyRepeatedTask, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = weeklyRepeatedTask.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(weeklyRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return weeklyRepeatedTask;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MonthlyRepeatedTask createMonthlyRepeatedTask()
  {
       	/* begin IONA modification */
    	//MonthlyRepeatedTaskImpl monthlyRepeatedTask = new MonthlyRepeatedTaskImpl();
    	MonthlyRepeatedTask monthlyRepeatedTask = new MonthlyRepeatedTaskImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = monthlyRepeatedTask.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(monthlyRepeatedTask, new Object[] {"MonthlyRepeatedTask-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = monthlyRepeatedTask.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(monthlyRepeatedTask, new Object[] {"MonthlyRepeatedTask"});
            Method factoryFlagSetter = monthlyRepeatedTask.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(monthlyRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = monthlyRepeatedTask.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(monthlyRepeatedTask, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = monthlyRepeatedTask.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(monthlyRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return monthlyRepeatedTask;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IntervalRepeatedTask createIntervalRepeatedTask()
  {
       	/* begin IONA modification */
    	//IntervalRepeatedTaskImpl intervalRepeatedTask = new IntervalRepeatedTaskImpl();
    	IntervalRepeatedTask intervalRepeatedTask = new IntervalRepeatedTaskImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = intervalRepeatedTask.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(intervalRepeatedTask, new Object[] {"IntervalRepeatedTask-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = intervalRepeatedTask.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(intervalRepeatedTask, new Object[] {"IntervalRepeatedTask"});
            Method factoryFlagSetter = intervalRepeatedTask.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(intervalRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = intervalRepeatedTask.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(intervalRepeatedTask, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = intervalRepeatedTask.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(intervalRepeatedTask, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return intervalRepeatedTask;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TaskStates createTaskStatesFromString(EDataType eDataType, String initialValue)
  {
    TaskStates result = TaskStates.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertTaskStatesToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Weekdays createWeekdaysFromString(EDataType eDataType, String initialValue)
  {
    Weekdays result = Weekdays.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertWeekdaysToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TimeUnits createTimeUnitsFromString(EDataType eDataType, String initialValue)
  {
    TimeUnits result = TimeUnits.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertTimeUnitsToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SchedulingPackage getSchedulingPackage()
  {
    return (SchedulingPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static SchedulingPackage getPackage()
  {
    return SchedulingPackage.eINSTANCE;
  }

} //SchedulingFactoryImpl


