/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling.impl;

import com.iona.soa.model.SOA_NetworkPackage;

import com.iona.soa.model.collaboration.CollaborationPackage;

import com.iona.soa.model.collaboration.impl.CollaborationPackageImpl;

import com.iona.soa.model.events.EventsPackage;

import com.iona.soa.model.events.impl.EventsPackageImpl;

import com.iona.soa.model.folder.FolderPackage;

import com.iona.soa.model.folder.impl.FolderPackageImpl;

import com.iona.soa.model.impl.SOA_NetworkPackageImpl;

import com.iona.soa.model.notification.NotificationPackage;

import com.iona.soa.model.notification.impl.NotificationPackageImpl;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.RepositoryPackageImpl;

import com.iona.soa.model.scheduling.DailyRepeatedTask;
import com.iona.soa.model.scheduling.IntervalRepeatedTask;
import com.iona.soa.model.scheduling.MonthlyRepeatedTask;
import com.iona.soa.model.scheduling.OnceOffTask;
import com.iona.soa.model.scheduling.ScheduledTask;
import com.iona.soa.model.scheduling.SchedulingFactory;
import com.iona.soa.model.scheduling.SchedulingPackage;
import com.iona.soa.model.scheduling.TaskStates;
import com.iona.soa.model.scheduling.TimeUnits;
import com.iona.soa.model.scheduling.Weekdays;
import com.iona.soa.model.scheduling.WeeklyRepeatedTask;

import com.iona.soa.model.security.SecurityPackage;

import com.iona.soa.model.security.impl.SecurityPackageImpl;

import com.iona.soa.model.userattributes.UserAttributesPackage;

import com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SchedulingPackageImpl extends EPackageImpl implements SchedulingPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass scheduledTaskEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass dailyRepeatedTaskEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass onceOffTaskEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass weeklyRepeatedTaskEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass monthlyRepeatedTaskEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass intervalRepeatedTaskEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum taskStatesEEnum = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum weekdaysEEnum = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EEnum timeUnitsEEnum = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see com.iona.soa.model.scheduling.SchedulingPackage#eNS_URI
   * @see #init()
   * @generated
   */
  private SchedulingPackageImpl()
  {
    super(eNS_URI, SchedulingFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this
   * model, and for any others upon which it depends.  Simple
   * dependencies are satisfied by calling this method on all
   * dependent packages before doing anything else.  This method drives
   * initialization for interdependent packages directly, in parallel
   * with this package, itself.
   * <p>Of this package and its interdependencies, all packages which
   * have not yet been registered by their URI values are first created
   * and registered.  The packages are then initialized in two steps:
   * meta-model objects for all of the packages are created before any
   * are initialized, since one package's meta-model objects may refer to
   * those of another.
   * <p>Invocation of this method will not affect any packages that have
   * already been initialized.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static SchedulingPackage init()
  {
    if (isInited) return (SchedulingPackage)EPackage.Registry.INSTANCE.getEPackage(SchedulingPackage.eNS_URI);

    // Obtain or create and register package
    SchedulingPackageImpl theSchedulingPackage = (SchedulingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof SchedulingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new SchedulingPackageImpl());

    isInited = true;

    // Obtain or create and register interdependencies
    SOA_NetworkPackageImpl theSOA_NetworkPackage = (SOA_NetworkPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) instanceof SOA_NetworkPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SOA_NetworkPackage.eNS_URI) : SOA_NetworkPackage.eINSTANCE);
    RepositoryPackageImpl theRepositoryPackage = (RepositoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) instanceof RepositoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) : RepositoryPackage.eINSTANCE);
    SecurityPackageImpl theSecurityPackage = (SecurityPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) instanceof SecurityPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI) : SecurityPackage.eINSTANCE);
    UserAttributesPackageImpl theUserAttributesPackage = (UserAttributesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) instanceof UserAttributesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UserAttributesPackage.eNS_URI) : UserAttributesPackage.eINSTANCE);
    EventsPackageImpl theEventsPackage = (EventsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) instanceof EventsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EventsPackage.eNS_URI) : EventsPackage.eINSTANCE);
    NotificationPackageImpl theNotificationPackage = (NotificationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) instanceof NotificationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(NotificationPackage.eNS_URI) : NotificationPackage.eINSTANCE);
    CollaborationPackageImpl theCollaborationPackage = (CollaborationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) instanceof CollaborationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CollaborationPackage.eNS_URI) : CollaborationPackage.eINSTANCE);
    FolderPackageImpl theFolderPackage = (FolderPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) instanceof FolderPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FolderPackage.eNS_URI) : FolderPackage.eINSTANCE);

    // Create package meta-data objects
    theSchedulingPackage.createPackageContents();
    theSOA_NetworkPackage.createPackageContents();
    theRepositoryPackage.createPackageContents();
    theSecurityPackage.createPackageContents();
    theUserAttributesPackage.createPackageContents();
    theEventsPackage.createPackageContents();
    theNotificationPackage.createPackageContents();
    theCollaborationPackage.createPackageContents();
    theFolderPackage.createPackageContents();

    // Initialize created meta-data
    theSchedulingPackage.initializePackageContents();
    theSOA_NetworkPackage.initializePackageContents();
    theRepositoryPackage.initializePackageContents();
    theSecurityPackage.initializePackageContents();
    theUserAttributesPackage.initializePackageContents();
    theEventsPackage.initializePackageContents();
    theNotificationPackage.initializePackageContents();
    theCollaborationPackage.initializePackageContents();
    theFolderPackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theSchedulingPackage.freeze();

    return theSchedulingPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getScheduledTask()
  {
    return scheduledTaskEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_State()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_LastRun()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_NextRun()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_System()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_Duration()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getScheduledTask_AffectedObjects()
  {
    return (EReference)scheduledTaskEClass.getEStructuralFeatures().get(5);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_TypeID()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(6);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_Parameters()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(7);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_Action()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(8);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getScheduledTask_User()
  {
    return (EReference)scheduledTaskEClass.getEStructuralFeatures().get(9);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_Password()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(10);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_Token()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(11);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getScheduledTask_RunNow()
  {
    return (EAttribute)scheduledTaskEClass.getEStructuralFeatures().get(12);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getDailyRepeatedTask()
  {
    return dailyRepeatedTaskEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDailyRepeatedTask_Hour()
  {
    return (EAttribute)dailyRepeatedTaskEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getDailyRepeatedTask_Minute()
  {
    return (EAttribute)dailyRepeatedTaskEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getOnceOffTask()
  {
    return onceOffTaskEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getOnceOffTask_ScheduleDate()
  {
    return (EAttribute)onceOffTaskEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getOnceOffTask_CleanupOnCompletion()
  {
    return (EAttribute)onceOffTaskEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getWeeklyRepeatedTask()
  {
    return weeklyRepeatedTaskEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getWeeklyRepeatedTask_Weekdays()
  {
    return (EAttribute)weeklyRepeatedTaskEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getMonthlyRepeatedTask()
  {
    return monthlyRepeatedTaskEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getMonthlyRepeatedTask_Days()
  {
    return (EAttribute)monthlyRepeatedTaskEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getIntervalRepeatedTask()
  {
    return intervalRepeatedTaskEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIntervalRepeatedTask_Interval()
  {
    return (EAttribute)intervalRepeatedTaskEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getIntervalRepeatedTask_TimeUnit()
  {
    return (EAttribute)intervalRepeatedTaskEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EEnum getTaskStates()
  {
    return taskStatesEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EEnum getWeekdays()
  {
    return weekdaysEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EEnum getTimeUnits()
  {
    return timeUnitsEEnum;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SchedulingFactory getSchedulingFactory()
  {
    return (SchedulingFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    scheduledTaskEClass = createEClass(SCHEDULED_TASK);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__STATE);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__LAST_RUN);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__NEXT_RUN);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__SYSTEM);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__DURATION);
    createEReference(scheduledTaskEClass, SCHEDULED_TASK__AFFECTED_OBJECTS);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__TYPE_ID);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__PARAMETERS);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__ACTION);
    createEReference(scheduledTaskEClass, SCHEDULED_TASK__USER);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__PASSWORD);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__TOKEN);
    createEAttribute(scheduledTaskEClass, SCHEDULED_TASK__RUN_NOW);

    dailyRepeatedTaskEClass = createEClass(DAILY_REPEATED_TASK);
    createEAttribute(dailyRepeatedTaskEClass, DAILY_REPEATED_TASK__HOUR);
    createEAttribute(dailyRepeatedTaskEClass, DAILY_REPEATED_TASK__MINUTE);

    onceOffTaskEClass = createEClass(ONCE_OFF_TASK);
    createEAttribute(onceOffTaskEClass, ONCE_OFF_TASK__SCHEDULE_DATE);
    createEAttribute(onceOffTaskEClass, ONCE_OFF_TASK__CLEANUP_ON_COMPLETION);

    weeklyRepeatedTaskEClass = createEClass(WEEKLY_REPEATED_TASK);
    createEAttribute(weeklyRepeatedTaskEClass, WEEKLY_REPEATED_TASK__WEEKDAYS);

    monthlyRepeatedTaskEClass = createEClass(MONTHLY_REPEATED_TASK);
    createEAttribute(monthlyRepeatedTaskEClass, MONTHLY_REPEATED_TASK__DAYS);

    intervalRepeatedTaskEClass = createEClass(INTERVAL_REPEATED_TASK);
    createEAttribute(intervalRepeatedTaskEClass, INTERVAL_REPEATED_TASK__INTERVAL);
    createEAttribute(intervalRepeatedTaskEClass, INTERVAL_REPEATED_TASK__TIME_UNIT);

    // Create enums
    taskStatesEEnum = createEEnum(TASK_STATES);
    weekdaysEEnum = createEEnum(WEEKDAYS);
    timeUnitsEEnum = createEEnum(TIME_UNITS);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Obtain other dependent packages
    SecurityPackage theSecurityPackage = (SecurityPackage)EPackage.Registry.INSTANCE.getEPackage(SecurityPackage.eNS_URI);
    RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    scheduledTaskEClass.getESuperTypes().add(theSecurityPackage.getIProtectedRepositoryObject());
    dailyRepeatedTaskEClass.getESuperTypes().add(this.getScheduledTask());
    onceOffTaskEClass.getESuperTypes().add(this.getScheduledTask());
    weeklyRepeatedTaskEClass.getESuperTypes().add(this.getDailyRepeatedTask());
    monthlyRepeatedTaskEClass.getESuperTypes().add(this.getDailyRepeatedTask());
    intervalRepeatedTaskEClass.getESuperTypes().add(this.getScheduledTask());

    // Initialize classes and features; add operations and parameters
    initEClass(scheduledTaskEClass, ScheduledTask.class, "ScheduledTask", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getScheduledTask_State(), this.getTaskStates(), "state", null, 1, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_LastRun(), theRepositoryPackage.getTimestamp(), "lastRun", null, 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_NextRun(), theRepositoryPackage.getTimestamp(), "nextRun", null, 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_System(), ecorePackage.getEBoolean(), "system", "false", 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_Duration(), ecorePackage.getEInt(), "duration", null, 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getScheduledTask_AffectedObjects(), theRepositoryPackage.getIRepositoryObject(), null, "affectedObjects", null, 0, -1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_TypeID(), ecorePackage.getEString(), "typeID", null, 1, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_Parameters(), ecorePackage.getEString(), "parameters", null, 0, -1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_Action(), ecorePackage.getEString(), "action", null, 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getScheduledTask_User(), theSecurityPackage.getUser(), null, "user", null, 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_Password(), ecorePackage.getEString(), "password", null, 0, 1, ScheduledTask.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_Token(), ecorePackage.getEString(), "token", null, 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getScheduledTask_RunNow(), ecorePackage.getEBoolean(), "runNow", null, 0, 1, ScheduledTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(dailyRepeatedTaskEClass, DailyRepeatedTask.class, "DailyRepeatedTask", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getDailyRepeatedTask_Hour(), ecorePackage.getEShort(), "hour", "-1", 1, 1, DailyRepeatedTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getDailyRepeatedTask_Minute(), ecorePackage.getEShort(), "minute", "-1", 1, 1, DailyRepeatedTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(onceOffTaskEClass, OnceOffTask.class, "OnceOffTask", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getOnceOffTask_ScheduleDate(), theRepositoryPackage.getTimestamp(), "scheduleDate", null, 1, 1, OnceOffTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getOnceOffTask_CleanupOnCompletion(), ecorePackage.getEBoolean(), "cleanupOnCompletion", null, 0, 1, OnceOffTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(weeklyRepeatedTaskEClass, WeeklyRepeatedTask.class, "WeeklyRepeatedTask", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getWeeklyRepeatedTask_Weekdays(), this.getWeekdays(), "weekdays", null, 1, -1, WeeklyRepeatedTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(monthlyRepeatedTaskEClass, MonthlyRepeatedTask.class, "MonthlyRepeatedTask", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getMonthlyRepeatedTask_Days(), ecorePackage.getEShort(), "days", null, 1, -1, MonthlyRepeatedTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(intervalRepeatedTaskEClass, IntervalRepeatedTask.class, "IntervalRepeatedTask", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getIntervalRepeatedTask_Interval(), ecorePackage.getEShort(), "interval", null, 1, 1, IntervalRepeatedTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEAttribute(getIntervalRepeatedTask_TimeUnit(), this.getTimeUnits(), "timeUnit", "MINUTES", 1, 1, IntervalRepeatedTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    // Initialize enums and add enum literals
    initEEnum(taskStatesEEnum, TaskStates.class, "TaskStates");
    addEEnumLiteral(taskStatesEEnum, TaskStates.CREATED);
    addEEnumLiteral(taskStatesEEnum, TaskStates.SCHEDULED);
    addEEnumLiteral(taskStatesEEnum, TaskStates.RUNNING);
    addEEnumLiteral(taskStatesEEnum, TaskStates.FINISHED);
    addEEnumLiteral(taskStatesEEnum, TaskStates.ERROR);
    addEEnumLiteral(taskStatesEEnum, TaskStates.DISABLED);
    addEEnumLiteral(taskStatesEEnum, TaskStates.AUTHENICATED);
    addEEnumLiteral(taskStatesEEnum, TaskStates.UNAUTHENICATED);
    addEEnumLiteral(taskStatesEEnum, TaskStates.UNAUTHORISED);

    initEEnum(weekdaysEEnum, Weekdays.class, "Weekdays");
    addEEnumLiteral(weekdaysEEnum, Weekdays.MONDAY);
    addEEnumLiteral(weekdaysEEnum, Weekdays.TUESDAY);
    addEEnumLiteral(weekdaysEEnum, Weekdays.WEDNESDAY);
    addEEnumLiteral(weekdaysEEnum, Weekdays.THURSDAY);
    addEEnumLiteral(weekdaysEEnum, Weekdays.FRIDAY);
    addEEnumLiteral(weekdaysEEnum, Weekdays.SATURDAY);
    addEEnumLiteral(weekdaysEEnum, Weekdays.SUNDAY);

    initEEnum(timeUnitsEEnum, TimeUnits.class, "TimeUnits");
    addEEnumLiteral(timeUnitsEEnum, TimeUnits.MINUTES);
    addEEnumLiteral(timeUnitsEEnum, TimeUnits.HOURS);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // dbhints
    createDbhintsAnnotations();
    // securityHints
    createSecurityHintsAnnotations();
  }

  /**
   * Initializes the annotations for <b>dbhints</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createDbhintsAnnotations()
  {
    String source = "dbhints";		
    addAnnotation
      (scheduledTaskEClass, 
       source, 
       new String[] 
       {
       "hierarchy", "topclass"
       });	
  }

  /**
   * Initializes the annotations for <b>securityHints</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createSecurityHintsAnnotations()
  {
    String source = "securityHints";			
    addAnnotation
      (scheduledTaskEClass, 
       source, 
       new String[] 
       {
       "area", "Provisioning\r\nRepository"
       });
  }

} //SchedulingPackageImpl
