/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.scheduling.util;

import com.iona.soa.model.repository.IPersistableObject;
import com.iona.soa.model.repository.IRepositoryObject;

import com.iona.soa.model.scheduling.*;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.scheduling.SchedulingPackage
 * @generated
 */
public class SchedulingSwitch<T>
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static SchedulingPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SchedulingSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = SchedulingPackage.eINSTANCE;
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  public T doSwitch(EObject theEObject)
  {
    return doSwitch(theEObject.eClass(), theEObject);
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected T doSwitch(EClass theEClass, EObject theEObject)
  {
    if (theEClass.eContainer() == modelPackage)
    {
      return doSwitch(theEClass.getClassifierID(), theEObject);
    }
    else
    {
      List<EClass> eSuperTypes = theEClass.getESuperTypes();
      return
        eSuperTypes.isEmpty() ?
          defaultCase(theEObject) :
          doSwitch(eSuperTypes.get(0), theEObject);
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected T doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case SchedulingPackage.SCHEDULED_TASK:
      {
        ScheduledTask scheduledTask = (ScheduledTask)theEObject;
        T result = caseScheduledTask(scheduledTask);
        if (result == null) result = caseIProtectedRepositoryObject(scheduledTask);
        if (result == null) result = caseIRepositoryObject(scheduledTask);
        if (result == null) result = caseIPersistableObject(scheduledTask);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SchedulingPackage.DAILY_REPEATED_TASK:
      {
        DailyRepeatedTask dailyRepeatedTask = (DailyRepeatedTask)theEObject;
        T result = caseDailyRepeatedTask(dailyRepeatedTask);
        if (result == null) result = caseScheduledTask(dailyRepeatedTask);
        if (result == null) result = caseIProtectedRepositoryObject(dailyRepeatedTask);
        if (result == null) result = caseIRepositoryObject(dailyRepeatedTask);
        if (result == null) result = caseIPersistableObject(dailyRepeatedTask);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SchedulingPackage.ONCE_OFF_TASK:
      {
        OnceOffTask onceOffTask = (OnceOffTask)theEObject;
        T result = caseOnceOffTask(onceOffTask);
        if (result == null) result = caseScheduledTask(onceOffTask);
        if (result == null) result = caseIProtectedRepositoryObject(onceOffTask);
        if (result == null) result = caseIRepositoryObject(onceOffTask);
        if (result == null) result = caseIPersistableObject(onceOffTask);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SchedulingPackage.WEEKLY_REPEATED_TASK:
      {
        WeeklyRepeatedTask weeklyRepeatedTask = (WeeklyRepeatedTask)theEObject;
        T result = caseWeeklyRepeatedTask(weeklyRepeatedTask);
        if (result == null) result = caseDailyRepeatedTask(weeklyRepeatedTask);
        if (result == null) result = caseScheduledTask(weeklyRepeatedTask);
        if (result == null) result = caseIProtectedRepositoryObject(weeklyRepeatedTask);
        if (result == null) result = caseIRepositoryObject(weeklyRepeatedTask);
        if (result == null) result = caseIPersistableObject(weeklyRepeatedTask);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SchedulingPackage.MONTHLY_REPEATED_TASK:
      {
        MonthlyRepeatedTask monthlyRepeatedTask = (MonthlyRepeatedTask)theEObject;
        T result = caseMonthlyRepeatedTask(monthlyRepeatedTask);
        if (result == null) result = caseDailyRepeatedTask(monthlyRepeatedTask);
        if (result == null) result = caseScheduledTask(monthlyRepeatedTask);
        if (result == null) result = caseIProtectedRepositoryObject(monthlyRepeatedTask);
        if (result == null) result = caseIRepositoryObject(monthlyRepeatedTask);
        if (result == null) result = caseIPersistableObject(monthlyRepeatedTask);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SchedulingPackage.INTERVAL_REPEATED_TASK:
      {
        IntervalRepeatedTask intervalRepeatedTask = (IntervalRepeatedTask)theEObject;
        T result = caseIntervalRepeatedTask(intervalRepeatedTask);
        if (result == null) result = caseScheduledTask(intervalRepeatedTask);
        if (result == null) result = caseIProtectedRepositoryObject(intervalRepeatedTask);
        if (result == null) result = caseIRepositoryObject(intervalRepeatedTask);
        if (result == null) result = caseIPersistableObject(intervalRepeatedTask);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Scheduled Task</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Scheduled Task</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseScheduledTask(ScheduledTask object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Daily Repeated Task</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Daily Repeated Task</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseDailyRepeatedTask(DailyRepeatedTask object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Once Off Task</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Once Off Task</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseOnceOffTask(OnceOffTask object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Weekly Repeated Task</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Weekly Repeated Task</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseWeeklyRepeatedTask(WeeklyRepeatedTask object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Monthly Repeated Task</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Monthly Repeated Task</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseMonthlyRepeatedTask(MonthlyRepeatedTask object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Interval Repeated Task</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Interval Repeated Task</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIntervalRepeatedTask(IntervalRepeatedTask object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IPersistable Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IPersistable Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIPersistableObject(IPersistableObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IRepository Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IRepository Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIRepositoryObject(IRepositoryObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IProtected Repository Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IProtected Repository Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIProtectedRepositoryObject(IProtectedRepositoryObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  public T defaultCase(EObject object)
  {
    return null;
  }

} //SchedulingSwitch
