/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security;

import com.iona.soa.model.repository.IPersistableObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Object Permission</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.security.ObjectPermission#getUsersRead <em>Users Read</em>}</li>
 *   <li>{@link com.iona.soa.model.security.ObjectPermission#getUsersUpdate <em>Users Update</em>}</li>
 *   <li>{@link com.iona.soa.model.security.ObjectPermission#getUsersDelete <em>Users Delete</em>}</li>
 *   <li>{@link com.iona.soa.model.security.ObjectPermission#getRolesRead <em>Roles Read</em>}</li>
 *   <li>{@link com.iona.soa.model.security.ObjectPermission#getRolesUpdate <em>Roles Update</em>}</li>
 *   <li>{@link com.iona.soa.model.security.ObjectPermission#getRolesDelete <em>Roles Delete</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.security.SecurityPackage#getObjectPermission()
 * @model
 * @generated
 */
public interface ObjectPermission extends IPersistableObject
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Users Read</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.User}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Users Read</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Users Read</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getObjectPermission_UsersRead()
   * @model
   * @generated
   */
  EList<User> getUsersRead();


  /**
   * Returns the value of the '<em><b>Users Update</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.User}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Users Update</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Users Update</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getObjectPermission_UsersUpdate()
   * @model
   * @generated
   */
  EList<User> getUsersUpdate();


  /**
   * Returns the value of the '<em><b>Users Delete</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.User}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Users Delete</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Users Delete</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getObjectPermission_UsersDelete()
   * @model
   * @generated
   */
  EList<User> getUsersDelete();


  /**
   * Returns the value of the '<em><b>Roles Read</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.Role}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Roles Read</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Roles Read</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getObjectPermission_RolesRead()
   * @model
   * @generated
   */
  EList<Role> getRolesRead();


  /**
   * Returns the value of the '<em><b>Roles Update</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.Role}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Roles Update</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Roles Update</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getObjectPermission_RolesUpdate()
   * @model
   * @generated
   */
  EList<Role> getRolesUpdate();


  /**
   * Returns the value of the '<em><b>Roles Delete</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.Role}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Roles Delete</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Roles Delete</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getObjectPermission_RolesDelete()
   * @model
   * @generated
   */
  EList<Role> getRolesDelete();


} // ObjectPermission


