/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security;

import com.iona.soa.model.folder.ICategorizable;

import com.iona.soa.model.repository.IRepositoryObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Role</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.security.Role#getCanCreate <em>Can Create</em>}</li>
 *   <li>{@link com.iona.soa.model.security.Role#getCanRead <em>Can Read</em>}</li>
 *   <li>{@link com.iona.soa.model.security.Role#getCanUpdate <em>Can Update</em>}</li>
 *   <li>{@link com.iona.soa.model.security.Role#getCanDelete <em>Can Delete</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.security.SecurityPackage#getRole()
 * @model annotation="securityHints area='Security'"
 * @generated
 */
public interface Role extends IRepositoryObject, ICategorizable
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Can Create</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.SecurityArea}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Can Create</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Can Create</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getRole_CanCreate()
   * @model
   * @generated
   */
  EList<SecurityArea> getCanCreate();


  /**
   * Returns the value of the '<em><b>Can Read</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.SecurityArea}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Can Read</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Can Read</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getRole_CanRead()
   * @model
   * @generated
   */
  EList<SecurityArea> getCanRead();


  /**
   * Returns the value of the '<em><b>Can Update</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.SecurityArea}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Can Update</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Can Update</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getRole_CanUpdate()
   * @model
   * @generated
   */
  EList<SecurityArea> getCanUpdate();


  /**
   * Returns the value of the '<em><b>Can Delete</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.SecurityArea}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Can Delete</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Can Delete</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getRole_CanDelete()
   * @model
   * @generated
   */
  EList<SecurityArea> getCanDelete();


} // Role


