/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security;

import com.iona.soa.model.repository.RepositoryPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.security.SecurityFactory
 * @model kind="package"
 * @generated
 */
public interface SecurityPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "security";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.security";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itsec";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  SecurityPackage eINSTANCE = com.iona.soa.model.security.impl.SecurityPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.security.impl.UserImpl <em>User</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.security.impl.UserImpl
   * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getUser()
   * @generated
   */
  int USER = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__GUID = RepositoryPackage.IREPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__GENERATION_NUMBER = RepositoryPackage.IREPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__MODIFIABLE = RepositoryPackage.IREPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__INTERNAL = RepositoryPackage.IREPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__LAST_EDITED_BY = RepositoryPackage.IREPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__TIMESTAMP = RepositoryPackage.IREPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__CREATED_BY = RepositoryPackage.IREPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__NAME = RepositoryPackage.IREPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__NAMESPACE = RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__DESCRIPTION = RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__CATEGORIES = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__PASSWORD = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Userid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__USERID = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Roles</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__ROLES = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Email</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER__EMAIL = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The number of structural features of the '<em>User</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_FEATURE_COUNT = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The meta object id for the '{@link com.iona.soa.model.security.impl.RoleImpl <em>Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.security.impl.RoleImpl
   * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getRole()
   * @generated
   */
  int ROLE = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__GUID = RepositoryPackage.IREPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__GENERATION_NUMBER = RepositoryPackage.IREPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__MODIFIABLE = RepositoryPackage.IREPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__INTERNAL = RepositoryPackage.IREPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__LAST_EDITED_BY = RepositoryPackage.IREPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__TIMESTAMP = RepositoryPackage.IREPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__CREATED_BY = RepositoryPackage.IREPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__NAME = RepositoryPackage.IREPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__NAMESPACE = RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__DESCRIPTION = RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Categories</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__CATEGORIES = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Can Create</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__CAN_CREATE = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Can Read</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__CAN_READ = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Can Update</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__CAN_UPDATE = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Can Delete</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__CAN_DELETE = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 4;

  /**
   * The number of structural features of the '<em>Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_FEATURE_COUNT = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 5;

  /**
   * The meta object id for the '{@link com.iona.soa.model.security.impl.ObjectPermissionImpl <em>Object Permission</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.security.impl.ObjectPermissionImpl
   * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getObjectPermission()
   * @generated
   */
  int OBJECT_PERMISSION = 2;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Users Read</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__USERS_READ = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Users Update</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__USERS_UPDATE = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Users Delete</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__USERS_DELETE = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Roles Read</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__ROLES_READ = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Roles Update</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__ROLES_UPDATE = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Roles Delete</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION__ROLES_DELETE = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 5;

  /**
   * The number of structural features of the '<em>Object Permission</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBJECT_PERMISSION_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 6;

  /**
   * The meta object id for the '{@link com.iona.soa.model.security.impl.SecurityAreaImpl <em>Area</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.security.impl.SecurityAreaImpl
   * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getSecurityArea()
   * @generated
   */
  int SECURITY_AREA = 3;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__GUID = RepositoryPackage.IREPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__GENERATION_NUMBER = RepositoryPackage.IREPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__MODIFIABLE = RepositoryPackage.IREPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__INTERNAL = RepositoryPackage.IREPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__LAST_EDITED_BY = RepositoryPackage.IREPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__TIMESTAMP = RepositoryPackage.IREPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__CREATED_BY = RepositoryPackage.IREPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__NAME = RepositoryPackage.IREPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__NAMESPACE = RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__DESCRIPTION = RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Area Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA__AREA_ID = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Area</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SECURITY_AREA_FEATURE_COUNT = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.security.IProtectedRepositoryObject <em>IProtected Repository Object</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.security.IProtectedRepositoryObject
   * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getIProtectedRepositoryObject()
   * @generated
   */
  int IPROTECTED_REPOSITORY_OBJECT = 4;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__GUID = RepositoryPackage.IREPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER = RepositoryPackage.IREPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE = RepositoryPackage.IREPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__INTERNAL = RepositoryPackage.IREPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY = RepositoryPackage.IREPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP = RepositoryPackage.IREPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__CREATED_BY = RepositoryPackage.IREPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__NAME = RepositoryPackage.IREPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__NAMESPACE = RepositoryPackage.IREPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION = RepositoryPackage.IREPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>IProtected Repository Object</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT = RepositoryPackage.IREPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.security.OperationType <em>Operation Type</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.security.OperationType
   * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getOperationType()
   * @generated
   */
  int OPERATION_TYPE = 5;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.security.User <em>User</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>User</em>'.
   * @see com.iona.soa.model.security.User
   * @generated
   */
  EClass getUser();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.security.User#getPassword <em>Password</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Password</em>'.
   * @see com.iona.soa.model.security.User#getPassword()
   * @see #getUser()
   * @generated
   */
  EAttribute getUser_Password();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.security.User#getUserid <em>Userid</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Userid</em>'.
   * @see com.iona.soa.model.security.User#getUserid()
   * @see #getUser()
   * @generated
   */
  EAttribute getUser_Userid();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.User#getRoles <em>Roles</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Roles</em>'.
   * @see com.iona.soa.model.security.User#getRoles()
   * @see #getUser()
   * @generated
   */
  EReference getUser_Roles();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.security.User#getEmail <em>Email</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Email</em>'.
   * @see com.iona.soa.model.security.User#getEmail()
   * @see #getUser()
   * @generated
   */
  EAttribute getUser_Email();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.security.Role <em>Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Role</em>'.
   * @see com.iona.soa.model.security.Role
   * @generated
   */
  EClass getRole();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.Role#getCanCreate <em>Can Create</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Can Create</em>'.
   * @see com.iona.soa.model.security.Role#getCanCreate()
   * @see #getRole()
   * @generated
   */
  EReference getRole_CanCreate();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.Role#getCanRead <em>Can Read</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Can Read</em>'.
   * @see com.iona.soa.model.security.Role#getCanRead()
   * @see #getRole()
   * @generated
   */
  EReference getRole_CanRead();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.Role#getCanUpdate <em>Can Update</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Can Update</em>'.
   * @see com.iona.soa.model.security.Role#getCanUpdate()
   * @see #getRole()
   * @generated
   */
  EReference getRole_CanUpdate();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.Role#getCanDelete <em>Can Delete</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Can Delete</em>'.
   * @see com.iona.soa.model.security.Role#getCanDelete()
   * @see #getRole()
   * @generated
   */
  EReference getRole_CanDelete();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.security.ObjectPermission <em>Object Permission</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Object Permission</em>'.
   * @see com.iona.soa.model.security.ObjectPermission
   * @generated
   */
  EClass getObjectPermission();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.ObjectPermission#getUsersRead <em>Users Read</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Users Read</em>'.
   * @see com.iona.soa.model.security.ObjectPermission#getUsersRead()
   * @see #getObjectPermission()
   * @generated
   */
  EReference getObjectPermission_UsersRead();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.ObjectPermission#getUsersUpdate <em>Users Update</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Users Update</em>'.
   * @see com.iona.soa.model.security.ObjectPermission#getUsersUpdate()
   * @see #getObjectPermission()
   * @generated
   */
  EReference getObjectPermission_UsersUpdate();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.ObjectPermission#getUsersDelete <em>Users Delete</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Users Delete</em>'.
   * @see com.iona.soa.model.security.ObjectPermission#getUsersDelete()
   * @see #getObjectPermission()
   * @generated
   */
  EReference getObjectPermission_UsersDelete();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.ObjectPermission#getRolesRead <em>Roles Read</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Roles Read</em>'.
   * @see com.iona.soa.model.security.ObjectPermission#getRolesRead()
   * @see #getObjectPermission()
   * @generated
   */
  EReference getObjectPermission_RolesRead();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.ObjectPermission#getRolesUpdate <em>Roles Update</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Roles Update</em>'.
   * @see com.iona.soa.model.security.ObjectPermission#getRolesUpdate()
   * @see #getObjectPermission()
   * @generated
   */
  EReference getObjectPermission_RolesUpdate();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.security.ObjectPermission#getRolesDelete <em>Roles Delete</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Roles Delete</em>'.
   * @see com.iona.soa.model.security.ObjectPermission#getRolesDelete()
   * @see #getObjectPermission()
   * @generated
   */
  EReference getObjectPermission_RolesDelete();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.security.SecurityArea <em>Area</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Area</em>'.
   * @see com.iona.soa.model.security.SecurityArea
   * @generated
   */
  EClass getSecurityArea();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.security.SecurityArea#getAreaId <em>Area Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Area Id</em>'.
   * @see com.iona.soa.model.security.SecurityArea#getAreaId()
   * @see #getSecurityArea()
   * @generated
   */
  EAttribute getSecurityArea_AreaId();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.security.IProtectedRepositoryObject <em>IProtected Repository Object</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IProtected Repository Object</em>'.
   * @see com.iona.soa.model.security.IProtectedRepositoryObject
   * @generated
   */
  EClass getIProtectedRepositoryObject();

  /**
   * Returns the meta object for the containment reference '{@link com.iona.soa.model.security.IProtectedRepositoryObject#getObjectControl <em>Object Control</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Object Control</em>'.
   * @see com.iona.soa.model.security.IProtectedRepositoryObject#getObjectControl()
   * @see #getIProtectedRepositoryObject()
   * @generated
   */
  EReference getIProtectedRepositoryObject_ObjectControl();

  /**
   * Returns the meta object for enum '{@link com.iona.soa.model.security.OperationType <em>Operation Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Operation Type</em>'.
   * @see com.iona.soa.model.security.OperationType
   * @generated
   */
  EEnum getOperationType();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  SecurityFactory getSecurityFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.security.impl.UserImpl <em>User</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.security.impl.UserImpl
     * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getUser()
     * @generated
     */
    EClass USER = eINSTANCE.getUser();

    /**
     * The meta object literal for the '<em><b>Password</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute USER__PASSWORD = eINSTANCE.getUser_Password();

    /**
     * The meta object literal for the '<em><b>Userid</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute USER__USERID = eINSTANCE.getUser_Userid();

    /**
     * The meta object literal for the '<em><b>Roles</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference USER__ROLES = eINSTANCE.getUser_Roles();

    /**
     * The meta object literal for the '<em><b>Email</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute USER__EMAIL = eINSTANCE.getUser_Email();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.security.impl.RoleImpl <em>Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.security.impl.RoleImpl
     * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getRole()
     * @generated
     */
    EClass ROLE = eINSTANCE.getRole();

    /**
     * The meta object literal for the '<em><b>Can Create</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE__CAN_CREATE = eINSTANCE.getRole_CanCreate();

    /**
     * The meta object literal for the '<em><b>Can Read</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE__CAN_READ = eINSTANCE.getRole_CanRead();

    /**
     * The meta object literal for the '<em><b>Can Update</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE__CAN_UPDATE = eINSTANCE.getRole_CanUpdate();

    /**
     * The meta object literal for the '<em><b>Can Delete</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE__CAN_DELETE = eINSTANCE.getRole_CanDelete();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.security.impl.ObjectPermissionImpl <em>Object Permission</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.security.impl.ObjectPermissionImpl
     * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getObjectPermission()
     * @generated
     */
    EClass OBJECT_PERMISSION = eINSTANCE.getObjectPermission();

    /**
     * The meta object literal for the '<em><b>Users Read</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBJECT_PERMISSION__USERS_READ = eINSTANCE.getObjectPermission_UsersRead();

    /**
     * The meta object literal for the '<em><b>Users Update</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBJECT_PERMISSION__USERS_UPDATE = eINSTANCE.getObjectPermission_UsersUpdate();

    /**
     * The meta object literal for the '<em><b>Users Delete</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBJECT_PERMISSION__USERS_DELETE = eINSTANCE.getObjectPermission_UsersDelete();

    /**
     * The meta object literal for the '<em><b>Roles Read</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBJECT_PERMISSION__ROLES_READ = eINSTANCE.getObjectPermission_RolesRead();

    /**
     * The meta object literal for the '<em><b>Roles Update</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBJECT_PERMISSION__ROLES_UPDATE = eINSTANCE.getObjectPermission_RolesUpdate();

    /**
     * The meta object literal for the '<em><b>Roles Delete</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBJECT_PERMISSION__ROLES_DELETE = eINSTANCE.getObjectPermission_RolesDelete();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.security.impl.SecurityAreaImpl <em>Area</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.security.impl.SecurityAreaImpl
     * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getSecurityArea()
     * @generated
     */
    EClass SECURITY_AREA = eINSTANCE.getSecurityArea();

    /**
     * The meta object literal for the '<em><b>Area Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SECURITY_AREA__AREA_ID = eINSTANCE.getSecurityArea_AreaId();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.security.IProtectedRepositoryObject <em>IProtected Repository Object</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.security.IProtectedRepositoryObject
     * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getIProtectedRepositoryObject()
     * @generated
     */
    EClass IPROTECTED_REPOSITORY_OBJECT = eINSTANCE.getIProtectedRepositoryObject();

    /**
     * The meta object literal for the '<em><b>Object Control</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL = eINSTANCE.getIProtectedRepositoryObject_ObjectControl();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.security.OperationType <em>Operation Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.security.OperationType
     * @see com.iona.soa.model.security.impl.SecurityPackageImpl#getOperationType()
     * @generated
     */
    EEnum OPERATION_TYPE = eINSTANCE.getOperationType();

  }

} //SecurityPackage
