/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security;

import com.iona.soa.model.folder.ICategorizable;

import com.iona.soa.model.repository.IRepositoryObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>User</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.iona.soa.model.security.User#getPassword <em>Password</em>}</li>
 *   <li>{@link com.iona.soa.model.security.User#getUserid <em>Userid</em>}</li>
 *   <li>{@link com.iona.soa.model.security.User#getRoles <em>Roles</em>}</li>
 *   <li>{@link com.iona.soa.model.security.User#getEmail <em>Email</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.iona.soa.model.security.SecurityPackage#getUser()
 * @model annotation="securityHints area='Security'"
 * @generated
 */
public interface User extends IRepositoryObject, ICategorizable
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * Returns the value of the '<em><b>Password</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Password</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Password</em>' attribute.
   * @see #setPassword(String)
   * @see com.iona.soa.model.security.SecurityPackage#getUser_Password()
   * @model unique="false" required="true"
   * @generated
   */
  String getPassword();


  /**
   * Sets the value of the '{@link com.iona.soa.model.security.User#getPassword <em>Password</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Password</em>' attribute.
   * @see #getPassword()
   * @generated
   */
  void setPassword(String value);

  /**
   * Returns the value of the '<em><b>Userid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Userid</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Userid</em>' attribute.
   * @see #setUserid(String)
   * @see com.iona.soa.model.security.SecurityPackage#getUser_Userid()
   * @model required="true"
   * @generated
   */
  String getUserid();


  /**
   * Sets the value of the '{@link com.iona.soa.model.security.User#getUserid <em>Userid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Userid</em>' attribute.
   * @see #getUserid()
   * @generated
   */
  void setUserid(String value);

  /**
   * Returns the value of the '<em><b>Roles</b></em>' reference list.
   * The list contents are of type {@link com.iona.soa.model.security.Role}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Roles</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Roles</em>' reference list.
   * @see com.iona.soa.model.security.SecurityPackage#getUser_Roles()
   * @model resolveProxies="false"
   * @generated
   */
  EList<Role> getRoles();


  /**
   * Returns the value of the '<em><b>Email</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Email</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Email</em>' attribute.
   * @see #setEmail(String)
   * @see com.iona.soa.model.security.SecurityPackage#getUser_Email()
   * @model
   * @generated
   */
  String getEmail();


  /**
   * Sets the value of the '{@link com.iona.soa.model.security.User#getEmail <em>Email</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Email</em>' attribute.
   * @see #getEmail()
   * @generated
   */
  void setEmail(String value);

} // User


