/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security.impl;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.ObjectPermission;
import com.iona.soa.model.security.Role;
import com.iona.soa.model.security.SecurityPackage;
import com.iona.soa.model.security.User;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Object Permission</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.security.impl.ObjectPermissionImpl#getUsersRead <em>Users Read</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.ObjectPermissionImpl#getUsersUpdate <em>Users Update</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.ObjectPermissionImpl#getUsersDelete <em>Users Delete</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.ObjectPermissionImpl#getRolesRead <em>Roles Read</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.ObjectPermissionImpl#getRolesUpdate <em>Roles Update</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.ObjectPermissionImpl#getRolesDelete <em>Roles Delete</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ObjectPermissionImpl extends IPersistableObjectImpl implements ObjectPermission
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached value of the '{@link #getUsersRead() <em>Users Read</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUsersRead()
   * @generated
   * @ordered
   */
  protected EList<User> usersRead;

  /**
   * The cached value of the '{@link #getUsersUpdate() <em>Users Update</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUsersUpdate()
   * @generated
   * @ordered
   */
  protected EList<User> usersUpdate;

  /**
   * The cached value of the '{@link #getUsersDelete() <em>Users Delete</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUsersDelete()
   * @generated
   * @ordered
   */
  protected EList<User> usersDelete;

  /**
   * The cached value of the '{@link #getRolesRead() <em>Roles Read</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRolesRead()
   * @generated
   * @ordered
   */
  protected EList<Role> rolesRead;

  /**
   * The cached value of the '{@link #getRolesUpdate() <em>Roles Update</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRolesUpdate()
   * @generated
   * @ordered
   */
  protected EList<Role> rolesUpdate;

  /**
   * The cached value of the '{@link #getRolesDelete() <em>Roles Delete</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRolesDelete()
   * @generated
   * @ordered
   */
  protected EList<Role> rolesDelete;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ObjectPermissionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SecurityPackage.Literals.OBJECT_PERMISSION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<User> getUsersRead() {
    autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__USERS_READ);
    return _basicGetUsersRead();
  }
  
  private final EList<User> _basicGetUsersRead() {
    if (usersRead == null)
    {
      usersRead = new EObjectResolvingEList<User>(User.class, this, SecurityPackage.OBJECT_PERMISSION__USERS_READ);
    }
    return usersRead;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<User> getUsersUpdate() {
    autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__USERS_UPDATE);
    return _basicGetUsersUpdate();
  }
  
  private final EList<User> _basicGetUsersUpdate() {
    if (usersUpdate == null)
    {
      usersUpdate = new EObjectResolvingEList<User>(User.class, this, SecurityPackage.OBJECT_PERMISSION__USERS_UPDATE);
    }
    return usersUpdate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<User> getUsersDelete() {
    autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__USERS_DELETE);
    return _basicGetUsersDelete();
  }
  
  private final EList<User> _basicGetUsersDelete() {
    if (usersDelete == null)
    {
      usersDelete = new EObjectResolvingEList<User>(User.class, this, SecurityPackage.OBJECT_PERMISSION__USERS_DELETE);
    }
    return usersDelete;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Role> getRolesRead() {
    autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__ROLES_READ);
    return _basicGetRolesRead();
  }
  
  private final EList<Role> _basicGetRolesRead() {
    if (rolesRead == null)
    {
      rolesRead = new EObjectResolvingEList<Role>(Role.class, this, SecurityPackage.OBJECT_PERMISSION__ROLES_READ);
    }
    return rolesRead;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Role> getRolesUpdate() {
    autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__ROLES_UPDATE);
    return _basicGetRolesUpdate();
  }
  
  private final EList<Role> _basicGetRolesUpdate() {
    if (rolesUpdate == null)
    {
      rolesUpdate = new EObjectResolvingEList<Role>(Role.class, this, SecurityPackage.OBJECT_PERMISSION__ROLES_UPDATE);
    }
    return rolesUpdate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Role> getRolesDelete() {
    autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__ROLES_DELETE);
    return _basicGetRolesDelete();
  }
  
  private final EList<Role> _basicGetRolesDelete() {
    if (rolesDelete == null)
    {
      rolesDelete = new EObjectResolvingEList<Role>(Role.class, this, SecurityPackage.OBJECT_PERMISSION__ROLES_DELETE);
    }
    return rolesDelete;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SecurityPackage.OBJECT_PERMISSION__USERS_READ:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__USERS_READ); }
        return _basicGetUsersRead();
      case SecurityPackage.OBJECT_PERMISSION__USERS_UPDATE:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__USERS_UPDATE); }
        return _basicGetUsersUpdate();
      case SecurityPackage.OBJECT_PERMISSION__USERS_DELETE:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__USERS_DELETE); }
        return _basicGetUsersDelete();
      case SecurityPackage.OBJECT_PERMISSION__ROLES_READ:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__ROLES_READ); }
        return _basicGetRolesRead();
      case SecurityPackage.OBJECT_PERMISSION__ROLES_UPDATE:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__ROLES_UPDATE); }
        return _basicGetRolesUpdate();
      case SecurityPackage.OBJECT_PERMISSION__ROLES_DELETE:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.OBJECT_PERMISSION__ROLES_DELETE); }
        return _basicGetRolesDelete();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SecurityPackage.OBJECT_PERMISSION__USERS_READ:
        _basicGetUsersRead().clear();
        _basicGetUsersRead().addAll((Collection<? extends User>)newValue);
        return;
      case SecurityPackage.OBJECT_PERMISSION__USERS_UPDATE:
        _basicGetUsersUpdate().clear();
        _basicGetUsersUpdate().addAll((Collection<? extends User>)newValue);
        return;
      case SecurityPackage.OBJECT_PERMISSION__USERS_DELETE:
        _basicGetUsersDelete().clear();
        _basicGetUsersDelete().addAll((Collection<? extends User>)newValue);
        return;
      case SecurityPackage.OBJECT_PERMISSION__ROLES_READ:
        _basicGetRolesRead().clear();
        _basicGetRolesRead().addAll((Collection<? extends Role>)newValue);
        return;
      case SecurityPackage.OBJECT_PERMISSION__ROLES_UPDATE:
        _basicGetRolesUpdate().clear();
        _basicGetRolesUpdate().addAll((Collection<? extends Role>)newValue);
        return;
      case SecurityPackage.OBJECT_PERMISSION__ROLES_DELETE:
        _basicGetRolesDelete().clear();
        _basicGetRolesDelete().addAll((Collection<? extends Role>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SecurityPackage.OBJECT_PERMISSION__USERS_READ:
      _basicGetUsersRead().clear();
      return;
    case SecurityPackage.OBJECT_PERMISSION__USERS_UPDATE:
      _basicGetUsersUpdate().clear();
      return;
    case SecurityPackage.OBJECT_PERMISSION__USERS_DELETE:
      _basicGetUsersDelete().clear();
      return;
    case SecurityPackage.OBJECT_PERMISSION__ROLES_READ:
      _basicGetRolesRead().clear();
      return;
    case SecurityPackage.OBJECT_PERMISSION__ROLES_UPDATE:
      _basicGetRolesUpdate().clear();
      return;
    case SecurityPackage.OBJECT_PERMISSION__ROLES_DELETE:
      _basicGetRolesDelete().clear();
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SecurityPackage.OBJECT_PERMISSION__USERS_READ:
        return usersRead != null && !usersRead.isEmpty();
      case SecurityPackage.OBJECT_PERMISSION__USERS_UPDATE:
        return usersUpdate != null && !usersUpdate.isEmpty();
      case SecurityPackage.OBJECT_PERMISSION__USERS_DELETE:
        return usersDelete != null && !usersDelete.isEmpty();
      case SecurityPackage.OBJECT_PERMISSION__ROLES_READ:
        return rolesRead != null && !rolesRead.isEmpty();
      case SecurityPackage.OBJECT_PERMISSION__ROLES_UPDATE:
        return rolesUpdate != null && !rolesUpdate.isEmpty();
      case SecurityPackage.OBJECT_PERMISSION__ROLES_DELETE:
        return rolesDelete != null && !rolesDelete.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ObjectPermissionImpl


