/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security.impl;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.Role;
import com.iona.soa.model.security.SecurityArea;
import com.iona.soa.model.security.SecurityPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Role</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getCategories <em>Categories</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getCanCreate <em>Can Create</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getCanRead <em>Can Read</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getCanUpdate <em>Can Update</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.RoleImpl#getCanDelete <em>Can Delete</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RoleImpl extends IPersistableObjectImpl implements Role
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getCategories() <em>Categories</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategories()
   * @generated
   * @ordered
   */
  protected EList<ICategory> categories;

  /**
   * The cached value of the '{@link #getCanCreate() <em>Can Create</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCanCreate()
   * @generated
   * @ordered
   */
  protected EList<SecurityArea> canCreate;

  /**
   * The cached value of the '{@link #getCanRead() <em>Can Read</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCanRead()
   * @generated
   * @ordered
   */
  protected EList<SecurityArea> canRead;

  /**
   * The cached value of the '{@link #getCanUpdate() <em>Can Update</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCanUpdate()
   * @generated
   * @ordered
   */
  protected EList<SecurityArea> canUpdate;

  /**
   * The cached value of the '{@link #getCanDelete() <em>Can Delete</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCanDelete()
   * @generated
   * @ordered
   */
  protected EList<SecurityArea> canDelete;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SecurityPackage.Literals.ROLE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.ROLE__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.ROLE__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.ROLE__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ICategory> getCategories() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES);
    return _basicGetCategories();
  }
  
  private final EList<ICategory> _basicGetCategories() {
    if (categories == null)
    {
      categories = new EObjectWithInverseResolvingEList.ManyInverse<ICategory>(ICategory.class, this, SecurityPackage.ROLE__CATEGORIES, FolderPackage.ICATEGORY__CONTENT);
    }
    return categories;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SecurityArea> getCanCreate() {
    autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_CREATE);
    return _basicGetCanCreate();
  }
  
  private final EList<SecurityArea> _basicGetCanCreate() {
    if (canCreate == null)
    {
      canCreate = new EObjectResolvingEList<SecurityArea>(SecurityArea.class, this, SecurityPackage.ROLE__CAN_CREATE);
    }
    return canCreate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SecurityArea> getCanRead() {
    autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_READ);
    return _basicGetCanRead();
  }
  
  private final EList<SecurityArea> _basicGetCanRead() {
    if (canRead == null)
    {
      canRead = new EObjectResolvingEList<SecurityArea>(SecurityArea.class, this, SecurityPackage.ROLE__CAN_READ);
    }
    return canRead;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SecurityArea> getCanUpdate() {
    autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_UPDATE);
    return _basicGetCanUpdate();
  }
  
  private final EList<SecurityArea> _basicGetCanUpdate() {
    if (canUpdate == null)
    {
      canUpdate = new EObjectResolvingEList<SecurityArea>(SecurityArea.class, this, SecurityPackage.ROLE__CAN_UPDATE);
    }
    return canUpdate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SecurityArea> getCanDelete() {
    autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_DELETE);
    return _basicGetCanDelete();
  }
  
  private final EList<SecurityArea> _basicGetCanDelete() {
    if (canDelete == null)
    {
      canDelete = new EObjectResolvingEList<SecurityArea>(SecurityArea.class, this, SecurityPackage.ROLE__CAN_DELETE);
    }
    return canDelete;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SecurityPackage.ROLE__CATEGORIES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetCategories()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SecurityPackage.ROLE__CATEGORIES:
        return ((InternalEList<?>)_basicGetCategories()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SecurityPackage.ROLE__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SecurityPackage.ROLE__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SecurityPackage.ROLE__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SecurityPackage.ROLE__CATEGORIES:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES); }
        return _basicGetCategories();
      case SecurityPackage.ROLE__CAN_CREATE:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_CREATE); }
        return _basicGetCanCreate();
      case SecurityPackage.ROLE__CAN_READ:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_READ); }
        return _basicGetCanRead();
      case SecurityPackage.ROLE__CAN_UPDATE:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_UPDATE); }
        return _basicGetCanUpdate();
      case SecurityPackage.ROLE__CAN_DELETE:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.ROLE__CAN_DELETE); }
        return _basicGetCanDelete();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SecurityPackage.ROLE__NAME:
        setName((String)newValue);
        return;
      case SecurityPackage.ROLE__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SecurityPackage.ROLE__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SecurityPackage.ROLE__CATEGORIES:
        _basicGetCategories().clear();
        _basicGetCategories().addAll((Collection<? extends ICategory>)newValue);
        return;
      case SecurityPackage.ROLE__CAN_CREATE:
        _basicGetCanCreate().clear();
        _basicGetCanCreate().addAll((Collection<? extends SecurityArea>)newValue);
        return;
      case SecurityPackage.ROLE__CAN_READ:
        _basicGetCanRead().clear();
        _basicGetCanRead().addAll((Collection<? extends SecurityArea>)newValue);
        return;
      case SecurityPackage.ROLE__CAN_UPDATE:
        _basicGetCanUpdate().clear();
        _basicGetCanUpdate().addAll((Collection<? extends SecurityArea>)newValue);
        return;
      case SecurityPackage.ROLE__CAN_DELETE:
        _basicGetCanDelete().clear();
        _basicGetCanDelete().addAll((Collection<? extends SecurityArea>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SecurityPackage.ROLE__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SecurityPackage.ROLE__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SecurityPackage.ROLE__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SecurityPackage.ROLE__CATEGORIES:
      _basicGetCategories().clear();
      return;
    case SecurityPackage.ROLE__CAN_CREATE:
      _basicGetCanCreate().clear();
      return;
    case SecurityPackage.ROLE__CAN_READ:
      _basicGetCanRead().clear();
      return;
    case SecurityPackage.ROLE__CAN_UPDATE:
      _basicGetCanUpdate().clear();
      return;
    case SecurityPackage.ROLE__CAN_DELETE:
      _basicGetCanDelete().clear();
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SecurityPackage.ROLE__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SecurityPackage.ROLE__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SecurityPackage.ROLE__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SecurityPackage.ROLE__CATEGORIES:
        return categories != null && !categories.isEmpty();
      case SecurityPackage.ROLE__CAN_CREATE:
        return canCreate != null && !canCreate.isEmpty();
      case SecurityPackage.ROLE__CAN_READ:
        return canRead != null && !canRead.isEmpty();
      case SecurityPackage.ROLE__CAN_UPDATE:
        return canUpdate != null && !canUpdate.isEmpty();
      case SecurityPackage.ROLE__CAN_DELETE:
        return canDelete != null && !canDelete.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (derivedFeatureID)
      {
        case SecurityPackage.ROLE__CATEGORIES: return FolderPackage.ICATEGORIZABLE__CATEGORIES;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.ICATEGORIZABLE__CATEGORIES: return SecurityPackage.ROLE__CATEGORIES;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //RoleImpl


