/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security.impl;

import com.iona.soa.model.security.*;

import java.lang.reflect.Method;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SecurityFactoryImpl extends EFactoryImpl implements SecurityFactory
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

/* begin IONA modification */
  private String defaultNamespace = "http://www.example.org/";

  public final void setDefaultNamespace(String namespace) {
    this.defaultNamespace = namespace;
  }

/* end IONA modification */
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static SecurityFactory init()
  {
    try
    {
      SecurityFactory theSecurityFactory = (SecurityFactory)EPackage.Registry.INSTANCE.getEFactory("http://com.iona.soa.model.security"); 
      if (theSecurityFactory != null)
      {
        return theSecurityFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new SecurityFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SecurityFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case SecurityPackage.USER: return createUser();
      case SecurityPackage.ROLE: return createRole();
      case SecurityPackage.OBJECT_PERMISSION: return createObjectPermission();
      case SecurityPackage.SECURITY_AREA: return createSecurityArea();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case SecurityPackage.OPERATION_TYPE:
        return createOperationTypeFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case SecurityPackage.OPERATION_TYPE:
        return convertOperationTypeToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public User createUser()
  {
       	/* begin IONA modification */
    	//UserImpl user = new UserImpl();
    	User user = new UserImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = user.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(user, new Object[] {"User-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = user.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(user, new Object[] {"User"});
            Method factoryFlagSetter = user.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(user, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = user.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(user, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = user.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(user, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return user;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Role createRole()
  {
       	/* begin IONA modification */
    	//RoleImpl role = new RoleImpl();
    	Role role = new RoleImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = role.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(role, new Object[] {"Role-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = role.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(role, new Object[] {"Role"});
            Method factoryFlagSetter = role.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(role, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = role.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(role, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = role.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(role, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return role;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObjectPermission createObjectPermission()
  {
       	/* begin IONA modification */
    	//ObjectPermissionImpl objectPermission = new ObjectPermissionImpl();
    	ObjectPermission objectPermission = new ObjectPermissionImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = objectPermission.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(objectPermission, new Object[] {"ObjectPermission-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = objectPermission.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(objectPermission, new Object[] {"ObjectPermission"});
            Method factoryFlagSetter = objectPermission.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(objectPermission, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = objectPermission.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(objectPermission, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = objectPermission.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(objectPermission, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return objectPermission;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SecurityArea createSecurityArea()
  {
       	/* begin IONA modification */
    	//SecurityAreaImpl securityArea = new SecurityAreaImpl();
    	SecurityArea securityArea = new SecurityAreaImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = securityArea.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(securityArea, new Object[] {"SecurityArea-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = securityArea.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(securityArea, new Object[] {"SecurityArea"});
            Method factoryFlagSetter = securityArea.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(securityArea, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = securityArea.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(securityArea, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = securityArea.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(securityArea, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return securityArea;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OperationType createOperationTypeFromString(EDataType eDataType, String initialValue)
  {
    OperationType result = OperationType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertOperationTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SecurityPackage getSecurityPackage()
  {
    return (SecurityPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static SecurityPackage getPackage()
  {
    return SecurityPackage.eINSTANCE;
  }

} //SecurityFactoryImpl


