/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.security.impl;

import com.iona.soa.model.folder.FolderPackage;
import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.repository.impl.IPersistableObjectImpl;

import com.iona.soa.model.security.Role;
import com.iona.soa.model.security.SecurityPackage;
import com.iona.soa.model.security.User;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>User</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getNamespace <em>Namespace</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getCategories <em>Categories</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getPassword <em>Password</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getUserid <em>Userid</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getRoles <em>Roles</em>}</li>
 *   <li>{@link com.iona.soa.model.security.impl.UserImpl#getEmail <em>Email</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class UserImpl extends IPersistableObjectImpl implements User
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected static final String NAMESPACE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNamespace()
   * @generated
   * @ordered
   */
  protected String namespace = NAMESPACE_EDEFAULT;

  /**
   * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected static final String DESCRIPTION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescription()
   * @generated
   * @ordered
   */
  protected String description = DESCRIPTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getCategories() <em>Categories</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategories()
   * @generated
   * @ordered
   */
  protected EList<ICategory> categories;

  /**
   * The default value of the '{@link #getPassword() <em>Password</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPassword()
   * @generated
   * @ordered
   */
  protected static final String PASSWORD_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getPassword() <em>Password</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPassword()
   * @generated
   * @ordered
   */
  protected String password = PASSWORD_EDEFAULT;

  /**
   * The default value of the '{@link #getUserid() <em>Userid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserid()
   * @generated
   * @ordered
   */
  protected static final String USERID_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getUserid() <em>Userid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUserid()
   * @generated
   * @ordered
   */
  protected String userid = USERID_EDEFAULT;

  /**
   * The cached value of the '{@link #getRoles() <em>Roles</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRoles()
   * @generated
   * @ordered
   */
  protected EList<Role> roles;

  /**
   * The default value of the '{@link #getEmail() <em>Email</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEmail()
   * @generated
   * @ordered
   */
  protected static final String EMAIL_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getEmail() <em>Email</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEmail()
   * @generated
   * @ordered
   */
  protected String email = EMAIL_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected UserImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SecurityPackage.Literals.USER;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME);
    return _basicGetName();
  }
  
  private final String _basicGetName() {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
  
    /* begin IONA modification*/
    setNameFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.USER__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getNamespace() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE);
    return _basicGetNamespace();
  }
  
  private final String _basicGetNamespace() {
    return namespace;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNamespace(String newNamespace)
  {
  
    /* begin IONA modification*/
    setNsFieldSetByFactory(false);
    /* end IONA modification*/
    
    String oldNamespace = namespace;
    namespace = newNamespace;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.USER__NAMESPACE, oldNamespace, namespace));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDescription() {
    autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION);
    return _basicGetDescription();
  }
  
  private final String _basicGetDescription() {
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescription(String newDescription)
  {
    
    String oldDescription = description;
    description = newDescription;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.USER__DESCRIPTION, oldDescription, description));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ICategory> getCategories() {
    autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES);
    return _basicGetCategories();
  }
  
  private final EList<ICategory> _basicGetCategories() {
    if (categories == null)
    {
      categories = new EObjectWithInverseResolvingEList.ManyInverse<ICategory>(ICategory.class, this, SecurityPackage.USER__CATEGORIES, FolderPackage.ICATEGORY__CONTENT);
    }
    return categories;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPassword() {
    autoResolveEProxy(SecurityPackage.Literals.USER__PASSWORD);
    return _basicGetPassword();
  }
  
  private final String _basicGetPassword() {
    return password;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPassword(String newPassword)
  {
    
    String oldPassword = password;
    password = newPassword;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.USER__PASSWORD, oldPassword, password));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUserid() {
    autoResolveEProxy(SecurityPackage.Literals.USER__USERID);
    return _basicGetUserid();
  }
  
  private final String _basicGetUserid() {
    return userid;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUserid(String newUserid)
  {
    
    String oldUserid = userid;
    userid = newUserid;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.USER__USERID, oldUserid, userid));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Role> getRoles() {
    autoResolveEProxy(SecurityPackage.Literals.USER__ROLES);
    return _basicGetRoles();
  }
  
  private final EList<Role> _basicGetRoles() {
    if (roles == null)
    {
      roles = new EObjectEList<Role>(Role.class, this, SecurityPackage.USER__ROLES);
    }
    return roles;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getEmail() {
    autoResolveEProxy(SecurityPackage.Literals.USER__EMAIL);
    return _basicGetEmail();
  }
  
  private final String _basicGetEmail() {
    return email;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEmail(String newEmail)
  {
    
    String oldEmail = email;
    email = newEmail;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SecurityPackage.USER__EMAIL, oldEmail, email));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SecurityPackage.USER__CATEGORIES:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)_basicGetCategories()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SecurityPackage.USER__CATEGORIES:
        return ((InternalEList<?>)_basicGetCategories()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SecurityPackage.USER__NAME:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAME); }
        return _basicGetName();
      case SecurityPackage.USER__NAMESPACE:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__NAMESPACE); }
        return _basicGetNamespace();
      case SecurityPackage.USER__DESCRIPTION:
      if (resolve) { autoResolveEProxy(RepositoryPackage.Literals.IREPOSITORY_OBJECT__DESCRIPTION); }
        return _basicGetDescription();
      case SecurityPackage.USER__CATEGORIES:
      if (resolve) { autoResolveEProxy(FolderPackage.Literals.ICATEGORIZABLE__CATEGORIES); }
        return _basicGetCategories();
      case SecurityPackage.USER__PASSWORD:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.USER__PASSWORD); }
        return _basicGetPassword();
      case SecurityPackage.USER__USERID:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.USER__USERID); }
        return _basicGetUserid();
      case SecurityPackage.USER__ROLES:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.USER__ROLES); }
        return _basicGetRoles();
      case SecurityPackage.USER__EMAIL:
      if (resolve) { autoResolveEProxy(SecurityPackage.Literals.USER__EMAIL); }
        return _basicGetEmail();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SecurityPackage.USER__NAME:
        setName((String)newValue);
        return;
      case SecurityPackage.USER__NAMESPACE:
        setNamespace((String)newValue);
        return;
      case SecurityPackage.USER__DESCRIPTION:
        setDescription((String)newValue);
        return;
      case SecurityPackage.USER__CATEGORIES:
        _basicGetCategories().clear();
        _basicGetCategories().addAll((Collection<? extends ICategory>)newValue);
        return;
      case SecurityPackage.USER__PASSWORD:
        setPassword((String)newValue);
        return;
      case SecurityPackage.USER__USERID:
        setUserid((String)newValue);
        return;
      case SecurityPackage.USER__ROLES:
        _basicGetRoles().clear();
        _basicGetRoles().addAll((Collection<? extends Role>)newValue);
        return;
      case SecurityPackage.USER__EMAIL:
        setEmail((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
@Override
public void eUnset(int featureID)
{
  switch (featureID)
  {
    case SecurityPackage.USER__NAME:
      setName(NAME_EDEFAULT);
      return;
    case SecurityPackage.USER__NAMESPACE:
      setNamespace(NAMESPACE_EDEFAULT);
      return;
    case SecurityPackage.USER__DESCRIPTION:
      setDescription(DESCRIPTION_EDEFAULT);
      return;
    case SecurityPackage.USER__CATEGORIES:
      _basicGetCategories().clear();
      return;
    case SecurityPackage.USER__PASSWORD:
      setPassword(PASSWORD_EDEFAULT);
      return;
    case SecurityPackage.USER__USERID:
      setUserid(USERID_EDEFAULT);
      return;
    case SecurityPackage.USER__ROLES:
      _basicGetRoles().clear();
      return;
    case SecurityPackage.USER__EMAIL:
      setEmail(EMAIL_EDEFAULT);
      return;
  }
  super.eUnset(featureID);
}
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SecurityPackage.USER__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case SecurityPackage.USER__NAMESPACE:
        return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
      case SecurityPackage.USER__DESCRIPTION:
        return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
      case SecurityPackage.USER__CATEGORIES:
        return categories != null && !categories.isEmpty();
      case SecurityPackage.USER__PASSWORD:
        return PASSWORD_EDEFAULT == null ? password != null : !PASSWORD_EDEFAULT.equals(password);
      case SecurityPackage.USER__USERID:
        return USERID_EDEFAULT == null ? userid != null : !USERID_EDEFAULT.equals(userid);
      case SecurityPackage.USER__ROLES:
        return roles != null && !roles.isEmpty();
      case SecurityPackage.USER__EMAIL:
        return EMAIL_EDEFAULT == null ? email != null : !EMAIL_EDEFAULT.equals(email);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (derivedFeatureID)
      {
        case SecurityPackage.USER__CATEGORIES: return FolderPackage.ICATEGORIZABLE__CATEGORIES;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == ICategorizable.class)
    {
      switch (baseFeatureID)
      {
        case FolderPackage.ICATEGORIZABLE__CATEGORIES: return SecurityPackage.USER__CATEGORIES;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", namespace: ");
    result.append(namespace);
    result.append(", description: ");
    result.append(description);
    result.append(", password: ");
    result.append(password);
    result.append(", userid: ");
    result.append(userid);
    result.append(", email: ");
    result.append(email);
    result.append(')');
    return result.toString();
  }

/* begin IONA modification, makes sure the ID attribute is the same as the ID in the proxy, but this is only done for entities that define an ID feature */
/* end IONA modification */

} //UserImpl


