/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.userattributes;

import com.iona.soa.model.repository.RepositoryPackage;

import com.iona.soa.model.security.SecurityPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.userattributes.UserAttributesFactory
 * @model kind="package"
 * @generated
 */
public interface UserAttributesPackage extends EPackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String copyright = "IONA Technologies 2005-2008";

  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "userattributes";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://com.iona.soa.model.userattributes";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "itua";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  UserAttributesPackage eINSTANCE = com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl.init();

  /**
   * The meta object id for the '{@link com.iona.soa.model.userattributes.impl.UserAttributeDefinitionImpl <em>User Attribute Definition</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.userattributes.impl.UserAttributeDefinitionImpl
   * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getUserAttributeDefinition()
   * @generated
   */
  int USER_ATTRIBUTE_DEFINITION = 0;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The number of structural features of the '<em>User Attribute Definition</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DEFINITION_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link com.iona.soa.model.userattributes.Dictionary <em>Dictionary</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.userattributes.Dictionary
   * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getDictionary()
   * @generated
   */
  int DICTIONARY = 1;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__GUID = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__GENERATION_NUMBER = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__MODIFIABLE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__INTERNAL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__LAST_EDITED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__TIMESTAMP = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__CREATED_BY = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__NAME = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__NAMESPACE = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__DESCRIPTION = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__OBJECT_CONTROL = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Attribute Defs</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY__ATTRIBUTE_DEFS = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Dictionary</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DICTIONARY_FEATURE_COUNT = SecurityPackage.IPROTECTED_REPOSITORY_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.userattributes.ITagged <em>ITagged</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.userattributes.ITagged
   * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getITagged()
   * @generated
   */
  int ITAGGED = 2;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Tags</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED__TAGS = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>ITagged</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ITAGGED_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.userattributes.impl.UserAttributeValueImpl <em>User Attribute Value</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.userattributes.impl.UserAttributeValueImpl
   * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getUserAttributeValue()
   * @generated
   */
  int USER_ATTRIBUTE_VALUE = 3;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__VALUE = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Definition</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE__DEFINITION = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>User Attribute Value</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_VALUE_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link com.iona.soa.model.userattributes.IAttributes <em>IAttributes</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.userattributes.IAttributes
   * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getIAttributes()
   * @generated
   */
  int IATTRIBUTES = 4;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__GUID = RepositoryPackage.IPERSISTABLE_OBJECT__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__GENERATION_NUMBER = RepositoryPackage.IPERSISTABLE_OBJECT__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__MODIFIABLE = RepositoryPackage.IPERSISTABLE_OBJECT__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__INTERNAL = RepositoryPackage.IPERSISTABLE_OBJECT__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__LAST_EDITED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__TIMESTAMP = RepositoryPackage.IPERSISTABLE_OBJECT__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__CREATED_BY = RepositoryPackage.IPERSISTABLE_OBJECT__CREATED_BY;

  /**
   * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES__ATTRIBUTES = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>IAttributes</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IATTRIBUTES_FEATURE_COUNT = RepositoryPackage.IPERSISTABLE_OBJECT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.iona.soa.model.userattributes.impl.TagDictionaryImpl <em>Tag Dictionary</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.userattributes.impl.TagDictionaryImpl
   * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getTagDictionary()
   * @generated
   */
  int TAG_DICTIONARY = 5;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__GUID = DICTIONARY__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__GENERATION_NUMBER = DICTIONARY__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__MODIFIABLE = DICTIONARY__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__INTERNAL = DICTIONARY__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__LAST_EDITED_BY = DICTIONARY__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__TIMESTAMP = DICTIONARY__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__CREATED_BY = DICTIONARY__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__NAME = DICTIONARY__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__NAMESPACE = DICTIONARY__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__DESCRIPTION = DICTIONARY__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__OBJECT_CONTROL = DICTIONARY__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Attribute Defs</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY__ATTRIBUTE_DEFS = DICTIONARY__ATTRIBUTE_DEFS;

  /**
   * The number of structural features of the '<em>Tag Dictionary</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TAG_DICTIONARY_FEATURE_COUNT = DICTIONARY_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link com.iona.soa.model.userattributes.impl.UserAttributeDictionaryImpl <em>User Attribute Dictionary</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.iona.soa.model.userattributes.impl.UserAttributeDictionaryImpl
   * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getUserAttributeDictionary()
   * @generated
   */
  int USER_ATTRIBUTE_DICTIONARY = 6;

  /**
   * The feature id for the '<em><b>Guid</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__GUID = DICTIONARY__GUID;

  /**
   * The feature id for the '<em><b>Generation Number</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__GENERATION_NUMBER = DICTIONARY__GENERATION_NUMBER;

  /**
   * The feature id for the '<em><b>Modifiable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__MODIFIABLE = DICTIONARY__MODIFIABLE;

  /**
   * The feature id for the '<em><b>Internal</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__INTERNAL = DICTIONARY__INTERNAL;

  /**
   * The feature id for the '<em><b>Last Edited By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__LAST_EDITED_BY = DICTIONARY__LAST_EDITED_BY;

  /**
   * The feature id for the '<em><b>Timestamp</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__TIMESTAMP = DICTIONARY__TIMESTAMP;

  /**
   * The feature id for the '<em><b>Created By</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__CREATED_BY = DICTIONARY__CREATED_BY;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__NAME = DICTIONARY__NAME;

  /**
   * The feature id for the '<em><b>Namespace</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__NAMESPACE = DICTIONARY__NAMESPACE;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__DESCRIPTION = DICTIONARY__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Object Control</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__OBJECT_CONTROL = DICTIONARY__OBJECT_CONTROL;

  /**
   * The feature id for the '<em><b>Attribute Defs</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY__ATTRIBUTE_DEFS = DICTIONARY__ATTRIBUTE_DEFS;

  /**
   * The number of structural features of the '<em>User Attribute Dictionary</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USER_ATTRIBUTE_DICTIONARY_FEATURE_COUNT = DICTIONARY_FEATURE_COUNT + 0;


  /**
   * Returns the meta object for class '{@link com.iona.soa.model.userattributes.UserAttributeDefinition <em>User Attribute Definition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>User Attribute Definition</em>'.
   * @see com.iona.soa.model.userattributes.UserAttributeDefinition
   * @generated
   */
  EClass getUserAttributeDefinition();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.userattributes.Dictionary <em>Dictionary</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Dictionary</em>'.
   * @see com.iona.soa.model.userattributes.Dictionary
   * @generated
   */
  EClass getDictionary();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.userattributes.Dictionary#getAttributeDefs <em>Attribute Defs</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Attribute Defs</em>'.
   * @see com.iona.soa.model.userattributes.Dictionary#getAttributeDefs()
   * @see #getDictionary()
   * @generated
   */
  EReference getDictionary_AttributeDefs();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.userattributes.ITagged <em>ITagged</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>ITagged</em>'.
   * @see com.iona.soa.model.userattributes.ITagged
   * @generated
   */
  EClass getITagged();

  /**
   * Returns the meta object for the reference list '{@link com.iona.soa.model.userattributes.ITagged#getTags <em>Tags</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Tags</em>'.
   * @see com.iona.soa.model.userattributes.ITagged#getTags()
   * @see #getITagged()
   * @generated
   */
  EReference getITagged_Tags();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.userattributes.UserAttributeValue <em>User Attribute Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>User Attribute Value</em>'.
   * @see com.iona.soa.model.userattributes.UserAttributeValue
   * @generated
   */
  EClass getUserAttributeValue();

  /**
   * Returns the meta object for the attribute '{@link com.iona.soa.model.userattributes.UserAttributeValue#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see com.iona.soa.model.userattributes.UserAttributeValue#getValue()
   * @see #getUserAttributeValue()
   * @generated
   */
  EAttribute getUserAttributeValue_Value();

  /**
   * Returns the meta object for the reference '{@link com.iona.soa.model.userattributes.UserAttributeValue#getDefinition <em>Definition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Definition</em>'.
   * @see com.iona.soa.model.userattributes.UserAttributeValue#getDefinition()
   * @see #getUserAttributeValue()
   * @generated
   */
  EReference getUserAttributeValue_Definition();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.userattributes.IAttributes <em>IAttributes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>IAttributes</em>'.
   * @see com.iona.soa.model.userattributes.IAttributes
   * @generated
   */
  EClass getIAttributes();

  /**
   * Returns the meta object for the containment reference list '{@link com.iona.soa.model.userattributes.IAttributes#getAttributes <em>Attributes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Attributes</em>'.
   * @see com.iona.soa.model.userattributes.IAttributes#getAttributes()
   * @see #getIAttributes()
   * @generated
   */
  EReference getIAttributes_Attributes();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.userattributes.TagDictionary <em>Tag Dictionary</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Tag Dictionary</em>'.
   * @see com.iona.soa.model.userattributes.TagDictionary
   * @generated
   */
  EClass getTagDictionary();

  /**
   * Returns the meta object for class '{@link com.iona.soa.model.userattributes.UserAttributeDictionary <em>User Attribute Dictionary</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>User Attribute Dictionary</em>'.
   * @see com.iona.soa.model.userattributes.UserAttributeDictionary
   * @generated
   */
  EClass getUserAttributeDictionary();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  UserAttributesFactory getUserAttributesFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.iona.soa.model.userattributes.impl.UserAttributeDefinitionImpl <em>User Attribute Definition</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.userattributes.impl.UserAttributeDefinitionImpl
     * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getUserAttributeDefinition()
     * @generated
     */
    EClass USER_ATTRIBUTE_DEFINITION = eINSTANCE.getUserAttributeDefinition();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.userattributes.Dictionary <em>Dictionary</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.userattributes.Dictionary
     * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getDictionary()
     * @generated
     */
    EClass DICTIONARY = eINSTANCE.getDictionary();

    /**
     * The meta object literal for the '<em><b>Attribute Defs</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DICTIONARY__ATTRIBUTE_DEFS = eINSTANCE.getDictionary_AttributeDefs();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.userattributes.ITagged <em>ITagged</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.userattributes.ITagged
     * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getITagged()
     * @generated
     */
    EClass ITAGGED = eINSTANCE.getITagged();

    /**
     * The meta object literal for the '<em><b>Tags</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ITAGGED__TAGS = eINSTANCE.getITagged_Tags();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.userattributes.impl.UserAttributeValueImpl <em>User Attribute Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.userattributes.impl.UserAttributeValueImpl
     * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getUserAttributeValue()
     * @generated
     */
    EClass USER_ATTRIBUTE_VALUE = eINSTANCE.getUserAttributeValue();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute USER_ATTRIBUTE_VALUE__VALUE = eINSTANCE.getUserAttributeValue_Value();

    /**
     * The meta object literal for the '<em><b>Definition</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference USER_ATTRIBUTE_VALUE__DEFINITION = eINSTANCE.getUserAttributeValue_Definition();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.userattributes.IAttributes <em>IAttributes</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.userattributes.IAttributes
     * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getIAttributes()
     * @generated
     */
    EClass IATTRIBUTES = eINSTANCE.getIAttributes();

    /**
     * The meta object literal for the '<em><b>Attributes</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IATTRIBUTES__ATTRIBUTES = eINSTANCE.getIAttributes_Attributes();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.userattributes.impl.TagDictionaryImpl <em>Tag Dictionary</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.userattributes.impl.TagDictionaryImpl
     * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getTagDictionary()
     * @generated
     */
    EClass TAG_DICTIONARY = eINSTANCE.getTagDictionary();

    /**
     * The meta object literal for the '{@link com.iona.soa.model.userattributes.impl.UserAttributeDictionaryImpl <em>User Attribute Dictionary</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.iona.soa.model.userattributes.impl.UserAttributeDictionaryImpl
     * @see com.iona.soa.model.userattributes.impl.UserAttributesPackageImpl#getUserAttributeDictionary()
     * @generated
     */
    EClass USER_ATTRIBUTE_DICTIONARY = eINSTANCE.getUserAttributeDictionary();

  }

} //UserAttributesPackage
