/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.userattributes.impl;

import com.iona.soa.model.userattributes.*;

import java.lang.reflect.Method;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class UserAttributesFactoryImpl extends EFactoryImpl implements UserAttributesFactory
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

/* begin IONA modification */
  private String defaultNamespace = "http://www.example.org/";

  public final void setDefaultNamespace(String namespace) {
    this.defaultNamespace = namespace;
  }

/* end IONA modification */
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static UserAttributesFactory init()
  {
    try
    {
      UserAttributesFactory theUserAttributesFactory = (UserAttributesFactory)EPackage.Registry.INSTANCE.getEFactory("http://com.iona.soa.model.userattributes"); 
      if (theUserAttributesFactory != null)
      {
        return theUserAttributesFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new UserAttributesFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UserAttributesFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case UserAttributesPackage.USER_ATTRIBUTE_DEFINITION: return createUserAttributeDefinition();
      case UserAttributesPackage.USER_ATTRIBUTE_VALUE: return createUserAttributeValue();
      case UserAttributesPackage.TAG_DICTIONARY: return createTagDictionary();
      case UserAttributesPackage.USER_ATTRIBUTE_DICTIONARY: return createUserAttributeDictionary();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UserAttributeDefinition createUserAttributeDefinition()
  {
       	/* begin IONA modification */
    	//UserAttributeDefinitionImpl userAttributeDefinition = new UserAttributeDefinitionImpl();
    	UserAttributeDefinition userAttributeDefinition = new UserAttributeDefinitionImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = userAttributeDefinition.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(userAttributeDefinition, new Object[] {"UserAttributeDefinition-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = userAttributeDefinition.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(userAttributeDefinition, new Object[] {"UserAttributeDefinition"});
            Method factoryFlagSetter = userAttributeDefinition.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(userAttributeDefinition, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = userAttributeDefinition.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(userAttributeDefinition, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = userAttributeDefinition.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(userAttributeDefinition, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return userAttributeDefinition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UserAttributeValue createUserAttributeValue()
  {
       	/* begin IONA modification */
    	//UserAttributeValueImpl userAttributeValue = new UserAttributeValueImpl();
    	UserAttributeValue userAttributeValue = new UserAttributeValueImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = userAttributeValue.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(userAttributeValue, new Object[] {"UserAttributeValue-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = userAttributeValue.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(userAttributeValue, new Object[] {"UserAttributeValue"});
            Method factoryFlagSetter = userAttributeValue.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(userAttributeValue, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = userAttributeValue.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(userAttributeValue, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = userAttributeValue.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(userAttributeValue, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return userAttributeValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TagDictionary createTagDictionary()
  {
       	/* begin IONA modification */
    	//TagDictionaryImpl tagDictionary = new TagDictionaryImpl();
    	TagDictionary tagDictionary = new TagDictionaryImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = tagDictionary.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(tagDictionary, new Object[] {"TagDictionary-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = tagDictionary.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(tagDictionary, new Object[] {"TagDictionary"});
            Method factoryFlagSetter = tagDictionary.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(tagDictionary, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = tagDictionary.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(tagDictionary, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = tagDictionary.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(tagDictionary, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return tagDictionary;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UserAttributeDictionary createUserAttributeDictionary()
  {
       	/* begin IONA modification */
    	//UserAttributeDictionaryImpl userAttributeDictionary = new UserAttributeDictionaryImpl();
    	UserAttributeDictionary userAttributeDictionary = new UserAttributeDictionaryImpl();
        try {
            /* If this class has a setGuid() method, the assign a UUID to it */	
            Method guidSetter = userAttributeDictionary.getClass().getMethod("setGuid", new Class[] {String.class});
            guidSetter.invoke(userAttributeDictionary, new Object[] {"UserAttributeDictionary-" + java.util.UUID.randomUUID().toString()});
        } catch (Exception ignored) {
        	// do nothing
        }

        try {
            Method nameSetter = userAttributeDictionary.getClass().getMethod("setName", new Class[] {String.class});
            nameSetter.invoke(userAttributeDictionary, new Object[] {"UserAttributeDictionary"});
            Method factoryFlagSetter = userAttributeDictionary.getClass().getMethod("setNameFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(userAttributeDictionary, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }

      try {
            Method nsSetter = userAttributeDictionary.getClass().getMethod("setNamespace", new Class[] {String.class});
            nsSetter.invoke(userAttributeDictionary, new Object[] {defaultNamespace});	
            Method factoryFlagSetter = userAttributeDictionary.getClass().getMethod("setNsFieldSetByFactory", boolean.class);
            factoryFlagSetter.invoke(userAttributeDictionary, new Object[] {true});
        } catch (Exception ignored) {
        	// do nothing
        }	
    	/* end IONA modification */
    return userAttributeDictionary;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UserAttributesPackage getUserAttributesPackage()
  {
    return (UserAttributesPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static UserAttributesPackage getPackage()
  {
    return UserAttributesPackage.eINSTANCE;
  }

} //UserAttributesFactoryImpl


