/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.userattributes.util;

import com.iona.soa.model.repository.IPersistableObject;
import com.iona.soa.model.repository.IRepositoryObject;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.userattributes.UserAttributesPackage
 * @generated
 */
public class UserAttributesAdapterFactory extends AdapterFactoryImpl
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static UserAttributesPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UserAttributesAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = UserAttributesPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch the delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected UserAttributesSwitch<Adapter> modelSwitch =
    new UserAttributesSwitch<Adapter>()
    {
      @Override
      public Adapter caseUserAttributeDefinition(UserAttributeDefinition object)
      {
        return createUserAttributeDefinitionAdapter();
      }
      @Override
      public Adapter caseDictionary(Dictionary object)
      {
        return createDictionaryAdapter();
      }
      @Override
      public Adapter caseITagged(ITagged object)
      {
        return createITaggedAdapter();
      }
      @Override
      public Adapter caseUserAttributeValue(UserAttributeValue object)
      {
        return createUserAttributeValueAdapter();
      }
      @Override
      public Adapter caseIAttributes(IAttributes object)
      {
        return createIAttributesAdapter();
      }
      @Override
      public Adapter caseTagDictionary(TagDictionary object)
      {
        return createTagDictionaryAdapter();
      }
      @Override
      public Adapter caseUserAttributeDictionary(UserAttributeDictionary object)
      {
        return createUserAttributeDictionaryAdapter();
      }
      @Override
      public Adapter caseIPersistableObject(IPersistableObject object)
      {
        return createIPersistableObjectAdapter();
      }
      @Override
      public Adapter caseIRepositoryObject(IRepositoryObject object)
      {
        return createIRepositoryObjectAdapter();
      }
      @Override
      public Adapter caseIProtectedRepositoryObject(IProtectedRepositoryObject object)
      {
        return createIProtectedRepositoryObjectAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.UserAttributeDefinition <em>User Attribute Definition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.UserAttributeDefinition
   * @generated
   */
  public Adapter createUserAttributeDefinitionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.Dictionary <em>Dictionary</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.Dictionary
   * @generated
   */
  public Adapter createDictionaryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.ITagged <em>ITagged</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.ITagged
   * @generated
   */
  public Adapter createITaggedAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.UserAttributeValue <em>User Attribute Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.UserAttributeValue
   * @generated
   */
  public Adapter createUserAttributeValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.IAttributes <em>IAttributes</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.IAttributes
   * @generated
   */
  public Adapter createIAttributesAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.TagDictionary <em>Tag Dictionary</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.TagDictionary
   * @generated
   */
  public Adapter createTagDictionaryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.UserAttributeDictionary <em>User Attribute Dictionary</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.UserAttributeDictionary
   * @generated
   */
  public Adapter createUserAttributeDictionaryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IPersistableObject <em>IPersistable Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IPersistableObject
   * @generated
   */
  public Adapter createIPersistableObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IRepositoryObject <em>IRepository Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IRepositoryObject
   * @generated
   */
  public Adapter createIRepositoryObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.security.IProtectedRepositoryObject <em>IProtected Repository Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.security.IProtectedRepositoryObject
   * @generated
   */
  public Adapter createIProtectedRepositoryObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //UserAttributesAdapterFactory
