/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.util;

import com.iona.soa.model.*;

import com.iona.soa.model.collaboration.ICollaboration;

import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;
import com.iona.soa.model.folder.IFolder;
import com.iona.soa.model.folder.IFolderContent;

import com.iona.soa.model.repository.IPersistableObject;
import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.IRepositoryObject;
import com.iona.soa.model.repository.IVersionedObject;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.SOA_NetworkPackage
 * @generated
 */
public class SOA_NetworkAdapterFactory extends AdapterFactoryImpl
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static SOA_NetworkPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SOA_NetworkAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = SOA_NetworkPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch the delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SOA_NetworkSwitch<Adapter> modelSwitch =
    new SOA_NetworkSwitch<Adapter>()
    {
      @Override
      public Adapter caseApplication(Application object)
      {
        return createApplicationAdapter();
      }
      @Override
      public Adapter caseArtifact(Artifact object)
      {
        return createArtifactAdapter();
      }
      @Override
      public Adapter caseStoredQuery(StoredQuery object)
      {
        return createStoredQueryAdapter();
      }
      @Override
      public Adapter caseContainer(Container object)
      {
        return createContainerAdapter();
      }
      @Override
      public Adapter caseIConfiguration(IConfiguration object)
      {
        return createIConfigurationAdapter();
      }
      @Override
      public Adapter caseVersionedProfile(VersionedProfile object)
      {
        return createVersionedProfileAdapter();
      }
      @Override
      public Adapter caseFolder(Folder object)
      {
        return createFolderAdapter();
      }
      @Override
      public Adapter caseMavenRepository(MavenRepository object)
      {
        return createMavenRepositoryAdapter();
      }
      @Override
      public Adapter caseIDeploymentConstraint(IDeploymentConstraint object)
      {
        return createIDeploymentConstraintAdapter();
      }
      @Override
      public Adapter caseInstalledApplication(InstalledApplication object)
      {
        return createInstalledApplicationAdapter();
      }
      @Override
      public Adapter caseInstalledArtifact(InstalledArtifact object)
      {
        return createInstalledArtifactAdapter();
      }
      @Override
      public Adapter caseArtifactRepository(ArtifactRepository object)
      {
        return createArtifactRepositoryAdapter();
      }
      @Override
      public Adapter caseDeploymentProfile(DeploymentProfile object)
      {
        return createDeploymentProfileAdapter();
      }
      @Override
      public Adapter caseArtifactType(ArtifactType object)
      {
        return createArtifactTypeAdapter();
      }
      @Override
      public Adapter caseApplicationType(ApplicationType object)
      {
        return createApplicationTypeAdapter();
      }
      @Override
      public Adapter caseCategory(Category object)
      {
        return createCategoryAdapter();
      }
      @Override
      public Adapter caseConfigurationOverride(ConfigurationOverride object)
      {
        return createConfigurationOverrideAdapter();
      }
      @Override
      public Adapter caseIPersistableObject(IPersistableObject object)
      {
        return createIPersistableObjectAdapter();
      }
      @Override
      public Adapter caseIRepositoryObject(IRepositoryObject object)
      {
        return createIRepositoryObjectAdapter();
      }
      @Override
      public Adapter caseIProtectedRepositoryObject(IProtectedRepositoryObject object)
      {
        return createIProtectedRepositoryObjectAdapter();
      }
      @Override
      public Adapter caseIVersionedObject(IVersionedObject object)
      {
        return createIVersionedObjectAdapter();
      }
      @Override
      public Adapter caseIAttributes(IAttributes object)
      {
        return createIAttributesAdapter();
      }
      @Override
      public Adapter caseITagged(ITagged object)
      {
        return createITaggedAdapter();
      }
      @Override
      public Adapter caseICategorizable(ICategorizable object)
      {
        return createICategorizableAdapter();
      }
      @Override
      public Adapter caseIProperties(IProperties object)
      {
        return createIPropertiesAdapter();
      }
      @Override
      public Adapter caseIFolderContent(IFolderContent object)
      {
        return createIFolderContentAdapter();
      }
      @Override
      public Adapter caseIFolder(IFolder object)
      {
        return createIFolderAdapter();
      }
      @Override
      public Adapter caseICollaboration(ICollaboration object)
      {
        return createICollaborationAdapter();
      }
      @Override
      public Adapter caseICategory(ICategory object)
      {
        return createICategoryAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.Application <em>Application</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.Application
   * @generated
   */
  public Adapter createApplicationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.Artifact <em>Artifact</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.Artifact
   * @generated
   */
  public Adapter createArtifactAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.StoredQuery <em>Stored Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.StoredQuery
   * @generated
   */
  public Adapter createStoredQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.Container <em>Container</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.Container
   * @generated
   */
  public Adapter createContainerAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.IConfiguration <em>IConfiguration</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.IConfiguration
   * @generated
   */
  public Adapter createIConfigurationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.VersionedProfile <em>Versioned Profile</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.VersionedProfile
   * @generated
   */
  public Adapter createVersionedProfileAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.Folder <em>Folder</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.Folder
   * @generated
   */
  public Adapter createFolderAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.MavenRepository <em>Maven Repository</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.MavenRepository
   * @generated
   */
  public Adapter createMavenRepositoryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.IDeploymentConstraint <em>IDeployment Constraint</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.IDeploymentConstraint
   * @generated
   */
  public Adapter createIDeploymentConstraintAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.InstalledApplication <em>Installed Application</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.InstalledApplication
   * @generated
   */
  public Adapter createInstalledApplicationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.InstalledArtifact <em>Installed Artifact</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.InstalledArtifact
   * @generated
   */
  public Adapter createInstalledArtifactAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.ArtifactRepository <em>Artifact Repository</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.ArtifactRepository
   * @generated
   */
  public Adapter createArtifactRepositoryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.DeploymentProfile <em>Deployment Profile</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.DeploymentProfile
   * @generated
   */
  public Adapter createDeploymentProfileAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.ArtifactType <em>Artifact Type</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.ArtifactType
   * @generated
   */
  public Adapter createArtifactTypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.ApplicationType <em>Application Type</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.ApplicationType
   * @generated
   */
  public Adapter createApplicationTypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.Category <em>Category</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.Category
   * @generated
   */
  public Adapter createCategoryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.ConfigurationOverride <em>Configuration Override</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.ConfigurationOverride
   * @generated
   */
  public Adapter createConfigurationOverrideAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IPersistableObject <em>IPersistable Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IPersistableObject
   * @generated
   */
  public Adapter createIPersistableObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IRepositoryObject <em>IRepository Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IRepositoryObject
   * @generated
   */
  public Adapter createIRepositoryObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.security.IProtectedRepositoryObject <em>IProtected Repository Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.security.IProtectedRepositoryObject
   * @generated
   */
  public Adapter createIProtectedRepositoryObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IVersionedObject <em>IVersioned Object</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IVersionedObject
   * @generated
   */
  public Adapter createIVersionedObjectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.IAttributes <em>IAttributes</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.IAttributes
   * @generated
   */
  public Adapter createIAttributesAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.userattributes.ITagged <em>ITagged</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.userattributes.ITagged
   * @generated
   */
  public Adapter createITaggedAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.folder.ICategorizable <em>ICategorizable</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.folder.ICategorizable
   * @generated
   */
  public Adapter createICategorizableAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.repository.IProperties <em>IProperties</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.repository.IProperties
   * @generated
   */
  public Adapter createIPropertiesAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.folder.IFolderContent <em>IFolder Content</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.folder.IFolderContent
   * @generated
   */
  public Adapter createIFolderContentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.folder.IFolder <em>IFolder</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.folder.IFolder
   * @generated
   */
  public Adapter createIFolderAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.collaboration.ICollaboration <em>ICollaboration</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.collaboration.ICollaboration
   * @generated
   */
  public Adapter createICollaborationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.iona.soa.model.folder.ICategory <em>ICategory</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.iona.soa.model.folder.ICategory
   * @generated
   */
  public Adapter createICategoryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //SOA_NetworkAdapterFactory
