/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * IONA Technologies 2005-2008
 *
 * $Id$
 */
package com.iona.soa.model.util;

import com.iona.soa.model.*;

import com.iona.soa.model.collaboration.ICollaboration;

import com.iona.soa.model.folder.ICategorizable;
import com.iona.soa.model.folder.ICategory;
import com.iona.soa.model.folder.IFolder;
import com.iona.soa.model.folder.IFolderContent;

import com.iona.soa.model.repository.IPersistableObject;
import com.iona.soa.model.repository.IProperties;
import com.iona.soa.model.repository.IRepositoryObject;
import com.iona.soa.model.repository.IVersionedObject;

import com.iona.soa.model.security.IProtectedRepositoryObject;

import com.iona.soa.model.userattributes.IAttributes;
import com.iona.soa.model.userattributes.ITagged;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.iona.soa.model.SOA_NetworkPackage
 * @generated
 */
public class SOA_NetworkSwitch<T>
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final String copyright = "IONA Technologies 2005-2008";

  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static SOA_NetworkPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SOA_NetworkSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = SOA_NetworkPackage.eINSTANCE;
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  public T doSwitch(EObject theEObject)
  {
    return doSwitch(theEObject.eClass(), theEObject);
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected T doSwitch(EClass theEClass, EObject theEObject)
  {
    if (theEClass.eContainer() == modelPackage)
    {
      return doSwitch(theEClass.getClassifierID(), theEObject);
    }
    else
    {
      List<EClass> eSuperTypes = theEClass.getESuperTypes();
      return
        eSuperTypes.isEmpty() ?
          defaultCase(theEObject) :
          doSwitch(eSuperTypes.get(0), theEObject);
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected T doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case SOA_NetworkPackage.APPLICATION:
      {
        Application application = (Application)theEObject;
        T result = caseApplication(application);
        if (result == null) result = caseIProtectedRepositoryObject(application);
        if (result == null) result = caseIVersionedObject(application);
        if (result == null) result = caseIConfiguration(application);
        if (result == null) result = caseIAttributes(application);
        if (result == null) result = caseITagged(application);
        if (result == null) result = caseICategorizable(application);
        if (result == null) result = caseIProperties(application);
        if (result == null) result = caseIDeploymentConstraint(application);
        if (result == null) result = caseIRepositoryObject(application);
        if (result == null) result = caseIPersistableObject(application);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.ARTIFACT:
      {
        Artifact artifact = (Artifact)theEObject;
        T result = caseArtifact(artifact);
        if (result == null) result = caseIProtectedRepositoryObject(artifact);
        if (result == null) result = caseIConfiguration(artifact);
        if (result == null) result = caseIAttributes(artifact);
        if (result == null) result = caseITagged(artifact);
        if (result == null) result = caseIProperties(artifact);
        if (result == null) result = caseIFolderContent(artifact);
        if (result == null) result = caseIRepositoryObject(artifact);
        if (result == null) result = caseIPersistableObject(artifact);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.STORED_QUERY:
      {
        StoredQuery storedQuery = (StoredQuery)theEObject;
        T result = caseStoredQuery(storedQuery);
        if (result == null) result = caseIProtectedRepositoryObject(storedQuery);
        if (result == null) result = caseITagged(storedQuery);
        if (result == null) result = caseIAttributes(storedQuery);
        if (result == null) result = caseIRepositoryObject(storedQuery);
        if (result == null) result = caseIPersistableObject(storedQuery);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.CONTAINER:
      {
        Container container = (Container)theEObject;
        T result = caseContainer(container);
        if (result == null) result = caseIProtectedRepositoryObject(container);
        if (result == null) result = caseITagged(container);
        if (result == null) result = caseIAttributes(container);
        if (result == null) result = caseICategorizable(container);
        if (result == null) result = caseIProperties(container);
        if (result == null) result = caseIRepositoryObject(container);
        if (result == null) result = caseIPersistableObject(container);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.ICONFIGURATION:
      {
        IConfiguration iConfiguration = (IConfiguration)theEObject;
        T result = caseIConfiguration(iConfiguration);
        if (result == null) result = caseIPersistableObject(iConfiguration);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.VERSIONED_PROFILE:
      {
        VersionedProfile versionedProfile = (VersionedProfile)theEObject;
        T result = caseVersionedProfile(versionedProfile);
        if (result == null) result = caseIProtectedRepositoryObject(versionedProfile);
        if (result == null) result = caseIVersionedObject(versionedProfile);
        if (result == null) result = caseIRepositoryObject(versionedProfile);
        if (result == null) result = caseIPersistableObject(versionedProfile);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.FOLDER:
      {
        Folder folder = (Folder)theEObject;
        T result = caseFolder(folder);
        if (result == null) result = caseIProtectedRepositoryObject(folder);
        if (result == null) result = caseIFolder(folder);
        if (result == null) result = caseICollaboration(folder);
        if (result == null) result = caseIRepositoryObject(folder);
        if (result == null) result = caseIPersistableObject(folder);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.MAVEN_REPOSITORY:
      {
        MavenRepository mavenRepository = (MavenRepository)theEObject;
        T result = caseMavenRepository(mavenRepository);
        if (result == null) result = caseArtifactRepository(mavenRepository);
        if (result == null) result = caseIProtectedRepositoryObject(mavenRepository);
        if (result == null) result = caseICategorizable(mavenRepository);
        if (result == null) result = caseIAttributes(mavenRepository);
        if (result == null) result = caseITagged(mavenRepository);
        if (result == null) result = caseIProperties(mavenRepository);
        if (result == null) result = caseIRepositoryObject(mavenRepository);
        if (result == null) result = caseIPersistableObject(mavenRepository);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.IDEPLOYMENT_CONSTRAINT:
      {
        IDeploymentConstraint iDeploymentConstraint = (IDeploymentConstraint)theEObject;
        T result = caseIDeploymentConstraint(iDeploymentConstraint);
        if (result == null) result = caseIPersistableObject(iDeploymentConstraint);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.INSTALLED_APPLICATION:
      {
        InstalledApplication installedApplication = (InstalledApplication)theEObject;
        T result = caseInstalledApplication(installedApplication);
        if (result == null) result = caseIRepositoryObject(installedApplication);
        if (result == null) result = caseIPersistableObject(installedApplication);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.INSTALLED_ARTIFACT:
      {
        InstalledArtifact installedArtifact = (InstalledArtifact)theEObject;
        T result = caseInstalledArtifact(installedArtifact);
        if (result == null) result = caseIRepositoryObject(installedArtifact);
        if (result == null) result = caseIPersistableObject(installedArtifact);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.ARTIFACT_REPOSITORY:
      {
        ArtifactRepository artifactRepository = (ArtifactRepository)theEObject;
        T result = caseArtifactRepository(artifactRepository);
        if (result == null) result = caseIProtectedRepositoryObject(artifactRepository);
        if (result == null) result = caseICategorizable(artifactRepository);
        if (result == null) result = caseIAttributes(artifactRepository);
        if (result == null) result = caseITagged(artifactRepository);
        if (result == null) result = caseIProperties(artifactRepository);
        if (result == null) result = caseIRepositoryObject(artifactRepository);
        if (result == null) result = caseIPersistableObject(artifactRepository);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.DEPLOYMENT_PROFILE:
      {
        DeploymentProfile deploymentProfile = (DeploymentProfile)theEObject;
        T result = caseDeploymentProfile(deploymentProfile);
        if (result == null) result = caseIAttributes(deploymentProfile);
        if (result == null) result = caseICategorizable(deploymentProfile);
        if (result == null) result = caseIProtectedRepositoryObject(deploymentProfile);
        if (result == null) result = caseITagged(deploymentProfile);
        if (result == null) result = caseIPersistableObject(deploymentProfile);
        if (result == null) result = caseIRepositoryObject(deploymentProfile);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.ARTIFACT_TYPE:
      {
        ArtifactType artifactType = (ArtifactType)theEObject;
        T result = caseArtifactType(artifactType);
        if (result == null) result = caseIProtectedRepositoryObject(artifactType);
        if (result == null) result = caseIRepositoryObject(artifactType);
        if (result == null) result = caseIPersistableObject(artifactType);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.APPLICATION_TYPE:
      {
        ApplicationType applicationType = (ApplicationType)theEObject;
        T result = caseApplicationType(applicationType);
        if (result == null) result = caseIProtectedRepositoryObject(applicationType);
        if (result == null) result = caseIRepositoryObject(applicationType);
        if (result == null) result = caseIPersistableObject(applicationType);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.CATEGORY:
      {
        Category category = (Category)theEObject;
        T result = caseCategory(category);
        if (result == null) result = caseIProtectedRepositoryObject(category);
        if (result == null) result = caseICategory(category);
        if (result == null) result = caseICollaboration(category);
        if (result == null) result = caseIRepositoryObject(category);
        if (result == null) result = caseIPersistableObject(category);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case SOA_NetworkPackage.CONFIGURATION_OVERRIDE:
      {
        ConfigurationOverride configurationOverride = (ConfigurationOverride)theEObject;
        T result = caseConfigurationOverride(configurationOverride);
        if (result == null) result = caseIConfiguration(configurationOverride);
        if (result == null) result = caseIDeploymentConstraint(configurationOverride);
        if (result == null) result = caseIRepositoryObject(configurationOverride);
        if (result == null) result = caseIPersistableObject(configurationOverride);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Application</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Application</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseApplication(Application object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Artifact</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Artifact</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseArtifact(Artifact object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Stored Query</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Stored Query</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseStoredQuery(StoredQuery object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Container</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Container</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseContainer(Container object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IConfiguration</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IConfiguration</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIConfiguration(IConfiguration object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Versioned Profile</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Versioned Profile</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseVersionedProfile(VersionedProfile object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Folder</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Folder</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseFolder(Folder object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Maven Repository</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Maven Repository</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseMavenRepository(MavenRepository object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IDeployment Constraint</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IDeployment Constraint</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIDeploymentConstraint(IDeploymentConstraint object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Installed Application</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Installed Application</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseInstalledApplication(InstalledApplication object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Installed Artifact</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Installed Artifact</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseInstalledArtifact(InstalledArtifact object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Artifact Repository</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Artifact Repository</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseArtifactRepository(ArtifactRepository object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Deployment Profile</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Deployment Profile</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseDeploymentProfile(DeploymentProfile object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Artifact Type</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Artifact Type</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseArtifactType(ArtifactType object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Application Type</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Application Type</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseApplicationType(ApplicationType object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Category</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Category</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseCategory(Category object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>Configuration Override</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>Configuration Override</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseConfigurationOverride(ConfigurationOverride object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IPersistable Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IPersistable Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIPersistableObject(IPersistableObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IRepository Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IRepository Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIRepositoryObject(IRepositoryObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IProtected Repository Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IProtected Repository Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIProtectedRepositoryObject(IProtectedRepositoryObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IVersioned Object</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IVersioned Object</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIVersionedObject(IVersionedObject object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IAttributes</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IAttributes</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIAttributes(IAttributes object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>ITagged</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>ITagged</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseITagged(ITagged object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>ICategorizable</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>ICategorizable</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseICategorizable(ICategorizable object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IProperties</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IProperties</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIProperties(IProperties object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IFolder Content</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IFolder Content</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIFolderContent(IFolderContent object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>IFolder</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>IFolder</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseIFolder(IFolder object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>ICollaboration</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>ICollaboration</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseICollaboration(ICollaboration object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>ICategory</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>ICategory</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseICategory(ICategory object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  public T defaultCase(EObject object)
  {
    return null;
  }

} //SOA_NetworkSwitch
