/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.soa.model.datatypes;

import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.ecore.resource.Resource;

/**
 * Adapter class that attaches additional information to a 
 * "dangling proxy", namely an EObject proxy with no container.
 * 
 * TODO - investigate use of eSetDirectResource instead
 */
public class DanglingProxyAdapter extends AdapterImpl {
    
    private final Resource resource;
    
    public DanglingProxyAdapter(Resource resource) {
        this.resource = resource;
    }
    
    /**
     * Special implementation of eResource() for an EObject that
     * cannot find it via the normal eResource() implementation. 
     * The standard implementation either knows the resource or asks
     * its container for it.  
     * @return the Resource of the target object
     */
    public Resource eResource() {
        return resource;
    }
}
