/**
 * Copyright (C) [2009]  Progress Software Corporation.
 * FUSE DEPOT 1.0
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.iona.repository.util.i18n;

public class UncheckedException extends java.lang.RuntimeException {
    
    private static final long serialVersionUID = 1L;
    private final Message message;

    public UncheckedException(Message message) {
        this.message = message;
    }

    public UncheckedException(Message message, Throwable cause) {
        super(cause);
        this.message = message;
    }

    public UncheckedException(Throwable cause) {
        super(cause);
        message = null;
    }

    public String getMessage() {
        return message == null ? null : message.toString();
    }

    public Message getI18nMessage() {
        return message;
    }
}
